/* ASLPRINT.C is part of the MEGATRAVELER (c) character generation */
/* program written by Greg Svenson. It prints out the resulting character. */

#include <stdio.h>

void printhim();
void discover();
void getline();
void pension();
void getbranch();
void getrankp();
void flyerrank();
void sailorank();
void diplomatrank();
void aslspacerank();
void aslmltryrank();
void aslmgmtrank();
void aslpiratrank();
void aslteachrank();
void prntstuf();

extern void prntskil();
extern void anykey();
extern void clrscr();
extern void prntrace();
extern void prntsex();
extern void loan();

#include "chargen.h"

void printhim()  
{
  printf("Here is a review of your characters skills.\n");
  prntskil(1);
  anykey();
  clrscr();
  printf("                         Character Description\n");        
  printf("\nName: _________________________ ");
  printf("    ");
  prntrace();
  printf(" ");
  prntsex();
  printf("\n");    
  printf(" str dex end int ");
  printf("edu "); 
  printf("soc"); 
  printf(" Home World: star port = %c\n", starport);
  printf("  %2d  %2d  %2d  %2d  %2d  %2d            ", 
    str, dex, end, intl, edu, soc);
  printf("      size = %s\n", size_descr);
  printf("         age: %2d                    ", age);
  printf("atmosphere = %s\n", atmos_descr);
  printf("apparent age: %2d                    ", appearent_age);
  printf("     hydro = %s\n", hydro_descr);
  printf("                                    ");
  printf("population = %s\n", pop_descr);              
  printf("                                    ");
  printf("       law = %s\n", law_descr);
  printf("                                    ");
  printf("government = %s\n", gov_descr);
  printf("                                    ");
  printf("  tech lvl = %s\n", tech_descr);
  printf("Career: %s", career);
  if (line != 0) getline();
  if (branch != 0) getbranch();
  if (medic != 0 && careernbr != DOCTOR) { 
    printf(" medic");
  }
  if (rank != 0 || careernbr == MERCHANT) {
    printf("\n");
    getrankp();
  }
  if (terms >= 5) pension();
  printf("\nSkills:\n");
  prntskil(2);
  printf("\nProperty:               Credits: %ld", credits);
  prntstuf();
}


void pension()
{
  printf("     Pension: %d", (terms * 2000));
}


void getbranch()
{
  if (office == "") return;
  printf(" %s ", office);
  if (careernbr <= MARINE) printf("branch");
  else printf("office");
}


void getrankp()
{
  if (careernbr == SCIENTIST || careernbr == DOCTOR || careernbr == BELTER) {
      rank = (terms / 2) + 1;
      if (col > 0) rankeo = 'O';
      if (med_sch > 0 || grad_sch > 0) rank++;
  }
  printf("  Rank: %c%d ", rankeo, rank);
  switch (careernbr) {
    case ARMY: aslmltryrank(); break;
    case NAVY: aslspacerank(); break;
    case FLYER: flyerrank(); break;
    case SAILOR: sailorank(); break;
    case DOCTOR: break;
    case DIPLOMAT: diplomatrank(); break;
    case SCIENTIST: break;
    case BELTER: break;
    case PIRATE: aslpiratrank(); break;
    case MANAGEMENT: aslmgmtrank(); break;
    case WANDERER: break; /*wander/loner*/
    case ARTIST: break; /*artist*/
    case TECHY: break; /*techy*/
    case TEACHER: aslteachrank(); break;
    case ASSASSIN: break; /*assassin*/
    case OUTCAST: break; /*outcast*/
    default: printf("rank?"); break;
  }
}


void flyerrank()
{
  switch (rank) {
    case 0: printf("airman"); break;
    case 1: printf("Pilot"); break;
    case 2: printf("Flight Leader"); break;
    case 3: printf("Squadron Leader"); break;
    case 4: printf("Staff Major"); break;
    case 5: printf("Group Leader"); break;
    case 6: printf("Air Marshal"); break;
  }
}


void sailorank()
{
  switch (rank) {
    case 0: printf("enlisted"); break; 
    case 1: printf("Ensign"); break;
    case 2: printf("Lieutenant"); break;
    case 3: printf("Lieutenant Commander"); break;
    case 4: printf("Commander"); break;
    case 5: printf("Captain"); break;
    case 6: printf("Admiral"); break;
  }
}


void diplomatrank()
{
  switch (rank) {
    case 1: printf("3rd Secretary"); break;
    case 2: printf("2nd Secretary"); break;
    case 3: printf("1st Secretary"); break;
    case 4: printf("Counselor"); break;
    case 5: printf("Minister"); break;
    case 6: printf("Ambassador"); break;
  }
}


void aslspacerank()
{
  switch (rank) {
    case 1: printf("Intendent"); break;
    case 2: printf("Lieutenant"); break;
    case 3: printf("Senior Lt"); break;
    case 4: {
      if (sex == 1) {
	printf("Commandant Lt");
      } else {
	printf("Executive Lt");
      }
      break;
    }
    case 5: {
      if (sex == 1) {
	printf("Captain");
      } else {
	printf("Executive");
      }
      break;
    }
    case 6: {
      if (sex == 1) {
	printf("Admiral");
      } else {
	printf("Chief of Staff");
      }
      break;
    }
    default: printf("deckhand"); break;
  }
}


void aslmltryrank()
{
  switch (rank) {
    case 1: printf("Cadet"); break;
    case 2: printf("Lieutenant"); break;
    case 3: printf("Captain"); break;
    case 4: {
      if (sex == 1) {
	printf("Commandant");
      } else {
	printf("Executive");
      }
      break;
    }
    case 5: {
      if (sex == 1) {
	printf("Sr Commandant");
      } else {
	printf("Sr Executive");
      }
      break;
    }
    case 6: {
      if (sex == 1) {
	printf("General");
      } else {
	printf("Chief of Staff");
      }
      break;
    }
    default: printf("enlisted"); break;
  }
}


void aslmgmtrank()
{
  switch (rank) {
    case 1: printf("Administrator"); break;
    case 2: printf("Supervisor"); break;
    case 3: printf("Manager"); break;
    case 4: printf("Executive"); break;
    case 5: printf("Officer"); break;
    case 6: printf("Director"); break;
    default: printf("clerk"); break;
  }
}


void aslpiratrank()
{
  switch (rank) {
    case 0: printf("swabbie"); break;
    case 1: printf("Soldier"); break;
    case 2: printf("Warrior"); break;
    case 3: printf("Veteran"); break;
    case 4: printf("Lieutenant"); break;
    default: printf("Commandant"); break;
  }
}


void aslteachrank()
{
  switch (rank) {
    case 0: printf("aide"); break;
    case 1: printf("3rd Counsel"); break;
    case 2: printf("2nd Counsel"); break;
    case 3: printf("1st Counsel"); break;
    case 4: printf("Lead Counsel"); break;
    case 5: printf("Master"); break;
    case 6: printf("Head Master"); break;
  }
}


void prntstuf()
{
  printf("\n");
  if (ship > 0) {
      if (careernbr == SCIENTIST) printf("Lab Ship");
      if (careernbr == MANAGEMENT) printf("Free Trader");
      if (careernbr == BELTER) printf("Surveyor"); 
      if (careernbr == PIRATE) printf("Escort"); 
      loan();
  }
  if (km_land != 0) printf("%ld sq km of land, ", km_land);
  if (blue_blood != 0) printf("Corporation worth %d MCr, ", blue_blood);
  if (kit > 0) {
    switch (careernbr)
	{
	case DOCTOR: printf("Medical Instruments"); break;
	default: printf("Voucher"); break;
    }
    if (kitval > 0) printf(" (value %d)", kitval);
    if (kit > 1) printf("x%d", kit);
    printf(", ");
  }
  if (weapons > 0) {
    printf("Weapon");
    if (weapons > 1) printf("x%d", weapons);
    printf(", ");
  }
  printf("\n");
  if (tas > 0) printf("Travellers Aid Society, ");
  if (hipsg > 0) {
    printf("High Passage");
    if (hipsg > 1) printf("x%d", hipsg);
    printf(", ");
  }
  if (midpsg > 0) {
    printf("Middle Passage");
    if (midpsg > 1) printf("x%d", midpsg);
    printf(", ");
  }
  if (lopsg > 0) {
    printf("Low Passage");
    if (lopsg > 1) printf("x%d", lopsg);
    printf(", ");
  }
}
