/* ASLSKILL.C is part of the MegaTraveller (C) character generation */
/* program. It is used to select an Aslan characters skills. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "chargen.h"

extern void addskill(int skill, int skl_val);
extern int getsel_int(int min, int max);
extern int d2();
extern int d3();
extern int d4();
extern int d5();
extern int d6();
extern int d7();
extern int d8();
extern void sci(int skl_val);
extern void bumpedu();
extern void bumpstr();
extern void bumpend();
extern void bumpintl();
extern int fag(int skl_val);
extern int animal(int skl_val);
extern void independ(int skl_val);
extern void gc(int skl_val);
extern int getecon();
extern int pickecon();
extern int swexpl(int choice, int skl_val);
extern int swgunr(int skl_val);
extern int swmm(int skl_val);
extern void gunner(int skl_val);
extern int getst();
extern int pickst();
extern int gettech();
extern int picktech();
extern void airc(int skl_val);
extern void boats(int skl_val);

void aslgc(int amount);
int aslgetgc();
int aslswgc(int choice);
int aslpickgc();
void aslacad(int amount);
int aslgetacad(int amount);
int aslswacad(int choice, int amount);
int aslpickacad(int amount);
void aslanimal(int amount);
int aslgetanim();
int aslswanim(int choice);
int aslpickanim();
void aslcmbtsupt(int amount);
int aslgetcs(int amount);
int aslpickcs(int amount);
int aslswcs(int choice, int amount);
void aslenv(int amount);
int aslgetenv(int amount);
int aslswenv(int choice, int amount);
int aslpickenv(int amount);
void aslecon(int amount);
void aslexplore(int amount);
int aslgetexpl(int amount);
int aslpickexpl(int amount);
void aslgunner(int amount);
int aslpickgunr();
int aslgetgunr();
void aslinbrn(int amount);
int aslgetinb();
int aslswinb(int choice);
int aslpickinb();
void aslinterp(int amount);
int aslgetint();
int aslswint(int choice);
int aslpickint();
void aslmilmed(int amount);
int aslgetmm();
int aslpickmm();
void aslmc(int amount);
int aslgetmc(int amount);
int aslswmc(int choice, int amount);
int aslpickmc(int amount);
void aslmentl(int amount);
int aslgetmen();
int aslpickmen();
void aslspace(int amount);
int aslgetspace();
int aslpickspace();
int aslswspace(int choice);
void aslsc(int amount);
int aslgetsc(int amount);
int aslswsc(int choice, int amount);
int aslpicksc(int amount);
void aslst(int amount);
void aslspclcmbt(int amount);
int aslgetspcl();
int aslpickspcl();
int aslswspcl(int choice);
void asltechl(int amount);
void aslvhcl(int amount);
int aslgetvhcl(int amount);
int aslpickvhcl(int amount);
int aslswvhcl(int choice, int amount);
void aslvc(int amount);
int aslgetvice();
int aslswvc(int choice);
int aslpickvice();

void aslgc(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetgc();
  } else {
    if (pick == 1) {
      skill = aslpickgc();
    } else {
      skill = GUNCMBT;
    }
  }
  addskill(skill, amount);
}


int aslgetgc()
{
  int  choice;

  choice = d4();
  return aslswgc(choice);
}


int aslswgc(int choice)
{
  switch (choice) {
    case 1: return HANDGUN;
    case 2: return LASERWEAP;  
    case 3: return NEURALWEAP;
    case 4: return RIFLMAN;
  }
  return 0;
}


int aslpickgc()
{
  int choice;

  printf("You have the following cascade options for the Gun Combat\n");
  printf("cascade skill.\n\n");
  printf("   1. hand guns\n   2. laser weapons\n");
  printf("   3. neural weapons\n   4. rifleman\n");
  choice = getsel_int(1, 4);
  return aslswgc(choice);
}


void aslacad(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetacad(amount);
  } else {
    if (pick == 1) {
      skill = aslpickacad(amount);
    } else {
      skill = ACADEMIC;
    }
  }
  addskill(skill, amount);
}


int aslgetacad(int amount)
{
  int  choice;

  choice = d6();
  if (sex == 1 && choice >= 5) return aslgetacad(amount);
  return aslswacad(choice, amount);
}


int aslswacad(int choice, int amount)
{
  switch (choice) {
    case 2: return TRADITION;
    case 3: return LINGUISTICS;  
    case 4: return PERSUASION;
    case 5: sci(amount); return 0;
    case 6: return ADMIN;
    default: bumpedu(); return 0;
  }
}


int aslpickacad(int amount)
{
  int choice;

  printf("You have the following options for the Academic\n");
  printf("cascade skill.\n\n");
  printf("   1. edu + 1\n\n");
  printf("   2. history\n   3. linguistics\n   4. persuasion\n");
  if (sex == 2) printf("   5. science*\n   6. administration\n\n");
  choice = getsel_int(1, 6);
  if (sex == 1 && choice >= 5) {
    printf("Wrong - try again!\n");
    return aslpickacad(amount);
  }
  return aslswacad(choice, amount);
}


void aslanimal(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetanim();
  } else {
    if (pick == 1) {
      skill = aslpickanim();
    } else {
      skill = ANIMALS;
    }
  }
  addskill(skill, amount);
}


int aslgetanim()
{
  int  choice;

  if (sex == 1) choice = d3();
  else choice = d2() + 2;
  return aslswanim(choice);
}


int aslswanim(int choice)
{
  switch (choice) {
    case 1: return GUARDBEAST;
    case 2: return FALCONRY;
    case 3: return EQUESTRIAN;
    default: return HERDING;
  }
}


int aslpickanim()
{
  int choice;

  printf("You have the following options for the Animal Handling\n");
  printf("cascade skill.\n\n");
  if (sex == 1) printf("   1. hunting/guard beasts\n   2. equestrian\n");
  printf("   3. equestrian\n");
  if (sex == 2) printf("   4. herding\n\n");
  choice = getsel_int(1, 4);
  if ((sex == 2 && choice <= 2) || (sex == 1 && choice == 4)) {
    printf("Wrong - try again!\n");
    return aslpickanim();
  }
  return aslswanim(choice);
}


void aslcmbtsupt(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetcs(amount);
  } else {
    if (pick == 1) {
      skill = aslpickcs(amount);
    } else {
      skill = CMBTSUPT;
    }
  }
  addskill(skill, amount);
}


int aslgetcs(int amount)
{
  int  choice;

  choice = d5();
  return aslswcs(choice, amount);
}


int aslpickcs(int amount)
{
  int  choice;

  printf("You have the following options for the Combat Support\n");
  printf("cascade skill.\n\n");
  printf("   1. combat engineering\n   2. demolitions\n   3. FA gunnery*\n");
  printf("   4. forward observer\n   5. heavy weapons\n\n");
  choice = getsel_int(1, 5);
  return aslswcs(choice, amount);
}


int aslswcs(int choice, int amount)
{
  switch (choice) {
    case 1: return CMBTENGR;
    case 2: return DEMOLITIONS;
    case 3: return fag(amount);  
    case 4: return FORWARDOBS;
    case 5: return HEAVYWEAP;
  }
  return 0;
}


void aslenv(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetenv(amount);
  } else {
    if (pick == 1) {
      skill = aslpickenv(amount);
    } else {
      skill = ENVIRON;
    }
  }
  addskill(skill, amount);
}


int aslgetenv(int amount)
{
  int  choice;

  if (sex == 2) choice = d6() + 2;
  else choice = d8();
  return aslswenv(choice, amount);
}


int aslswenv(int choice, int amount)
{
  switch (choice) {
    case 1: return HUNTING;
    case 2: return STEALTH;
    case 3: return HUNTING;  
    case 4: return RECON;
    case 5: return PERSWEAP;
    case 6: animal(amount); return 0;
    case 7: return HIGHG;
    default: return SURVIVAL;
  }
}


int aslpickenv(int amount)
{
  int choice;

  printf("You have the following options for the Environment\n");
  printf("cascade skill.\n\n");
  if (sex == 1) printf("   1. hunting\n   2. stealth\n");
  printf("   3. hunting\n   4. recon\n   5. personal weapons\n");
  printf("   6. animal*\n   7. high grav environ\n   8. survival\n\n");
  choice = getsel_int(1, 8);
  if (sex == 2 && choice <= 2) {
    printf("Wrong - try again!\n");
    return aslpickenv(amount);
  }
  return aslswenv(choice, amount);
}


void aslecon(int amount)
{
  int  skill;

  if (sex == 1) {
    independ(1);
    return;
  }
  if (pick == 2 || pick == 4) {
    skill = getecon();
  } else {
    if (pick == 1) {
      skill = pickecon();
    } else {
      skill = ECONOMIC;
    }
  }
  addskill(skill, amount);
}


void aslexplore(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetexpl(amount);
  } else {
    if (pick == 1) {
      skill = aslpickexpl(amount);
    } else {
      skill = EXPLORATORY;
    }
  }
  addskill(skill, amount);
}


int aslgetexpl(int amount)
{
  int  choice;

  choice = d5();
  if (sex == 1 && choice >= 2) choice++;
  if (sex == 2) choice++;
  return swexpl(choice, amount);
}


int aslpickexpl(int amount)
{
  int  choice;

  printf("You have the following options for the Exploratory\n");
  printf("cascade skill.\n\n");
  if (sex == 1) printf("   1. pilot\n");
  else printf("   1. sensor ops\n");
  printf("   2. survey\n   3. survival\n   4. vacc suit\n   5. vehicle*\n\n");
  choice = getsel_int(1, 5);
  if (sex == 1 && choice >= 2) choice++;
  if (sex == 2) choice++;
  return swexpl(choice, amount);
}


void aslgunner(int amount)
{
  int  skill;

  if (sex == 2) skill = SCREENS;
  else if (pick == 2 || pick == 4) {
    skill = aslgetgunr();
  } else {
    if (pick == 1) {
      skill = aslpickgunr();
    } else {
      skill = GUNNERY;
    }
  }
  addskill(skill, amount);
}


int aslpickgunr()
{
  int  choice;

  printf("You have the following options for the Gunnery\n");
  printf("cascade skill.\n\n");
  printf("   1. spinal weapons\n   2. turret weapons\n");
  choice = getsel_int(1, 2);
  choice++;
  return swgunr(choice);
}


int aslgetgunr()
{
  int  choice;

  choice = d2() + 1;
  return swgunr(choice);
}


void aslinbrn(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetinb();
  } else {
    if (pick == 1)  {
      skill = aslpickinb();
    } else {
      skill = INBORN;
    }
  }
  addskill(skill, amount);
}


int aslgetinb()
{
  int  choice;

  if (sex == 2) choice = d4();
  else {
    choice = d5();
    if (choice >= 4) choice++;
  }
  return aslswinb(choice);
}


int aslswinb(int choice)
{
  switch (choice) {
    case 1: return ARTISAN;
    case 2: return CAROUSING;
    case 3: return INSTRUCTION;
    case 4: return HANDYMAN;
    case 5: return TACTICS;
    default: return LEADER;
  }
}


int aslpickinb()
{
  int  choice;

  printf("You have the following options for the Inborn\n");
  printf("cascade skill.\n\n");
  printf("   1. artisan\n   2. carousing\n   3. instruction\n");
  if (sex == 2) {
    printf("   4. jack of all trades\n");
  } else {
    printf("   4. tactics\n   5. leader\n");
  }
  choice = getsel_int(1, 5);
  if (sex == 2 && choice > 4) {
    printf("Wrong - try again!\n");
    return aslpickinb();
  }
  if (sex == 1 && choice >= 4) choice++;
  return aslswinb(choice);
}


void aslinterp(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetint();
  } else {
    if (pick == 1) {
      skill = aslpickint();
    } else {
      skill = INTERPERS;
    }
  }
  addskill(skill, amount);
}


int aslgetint()
{
  int  choice;

  if (sex == 2) choice = d6();
  else choice = d4();
  return aslswint(choice);
}


int aslswint(int choice)
{
  switch (choice) {
    case 1: return TOLERANCE;
    case 2: return INTERVIEW;
    case 3: return LIAISON;
    case 4: return LINGUISTICS;
    case 5: return ADMIN;
    default: return STEWARD;
  }
}


int aslpickint()
{
  int  choice;

  printf("You have the following options for the Interpersonal\n");
  printf("cascade skill.\n\n");
  printf("   1. tolerance\n   2. interview\n   3. liaison\n");
  printf("   4. linguistics\n");
  if (sex == 2) printf("   5. administration\n   6. steward\n");
  choice = getsel_int(1, 6);
  if (sex == 1 && choice >= 5) {
    printf("Wrong - try again!\n");
    return aslpickint();
  }
  return aslswint(choice);
}


void aslmilmed(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetmm();
  } else {
    if (pick == 1) {
      skill = aslpickmm();
    } else {
      skill = MIL_MED;
    }
  }
  addskill(skill, amount);
}


int aslgetmm()
{
  int  choice;

  if (sex == 1) choice = d2() + 2;
  else choice = d4();
  return swmm(choice);
}


int aslpickmm()
{
  int  choice;

  printf("You have the following options for the Military Medical\n");
  printf("cascade skill.\n\n");
  if (sex == 2) printf("   1. forensics\n   2. medical\n");
  printf("   3. recon\n   4. survival\n");
  choice = getsel_int(1, 4);
  if (sex == 1 && choice <= 2) {
    printf("Wrong - try again!\n");
    return aslpickmm();
  }
  return swmm(choice);
}


void aslmc(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetmc(amount);
  } else {
    if (pick == 1) {
      skill = aslpickmc(amount);
    } else {
      skill = MIXED_CMBT;
    }
  }
  addskill(skill, amount);
}


int aslgetmc(int amount)
{
  int  choice;

  choice = d5();
  return aslswmc(choice, amount);
}


int aslswmc(int choice, int amount)
{
  switch (choice) {
    case 1: return DEWCLAW;
    case 2: return PERSWEAP;
    case 3: gc(amount); return 0;
    case 4: bumpstr(); return 0;
    default: bumpend(); return 0;
  }
}


int aslpickmc(int amount)
{
  int  choice;

  printf("You have the following options for the Mixed Combat\n");
  printf("cascade skill.\n\n");
  printf("   1. dewclaw\n   2. personal weapons\n   3. gun combat*\n");
  printf("   4. add 1 to strength\n   5. add 1 to endurance\n\n");
  choice = getsel_int(1, 5);
  return aslswmc(choice, amount);
}


void aslmentl(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetmen();
  } else {
    if (pick == 1) {
      skill = aslpickmen();
    } else {
      skill = MENTAL;
    }
  }
  addskill(skill, amount);
}


int aslgetmen()
{
  int  choice;

  choice = d3();
  if (choice == 1) bumpintl();
  if (choice == 2) bumpedu();
  if (choice == 3) return(MEDITATION);
  return 0;
}


int aslpickmen()
{
  int  choice;

  printf("You have the following options for the Mental cascade skill.\n\n");
  printf("   1. add 1 to intelligence\n   2. add 1 to education\n   3. meditation\n");
  choice = getsel_int(1, 3);
  if (choice == 1) bumpintl();
  if (choice == 2) bumpedu();
  if (choice == 3) return(MEDITATION);
  return 0;
}


void aslspace(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetspace();
  } else {
    if (pick == 1) {
      skill = aslpickspace();
    } else {
      skill = SPACE;
    }
  }
  addskill(skill, amount);
}


int aslgetspace()
{
  int  choice;

  if (sex == 2) {
    choice = d5();
    if (choice >= 4) choice += 2;
  } else choice = d4() + 3;
  return aslswspace(choice);
}


int aslswspace(int choice)
{
  switch (choice) {
    case 1: return ENGINEERING;
    case 2: return NAVIGATION;
    case 3: return SENSOROPS;
    case 4: return PILOT;
    case 5: return SHIPBOAT;
    case 6: return NOGRAV;
    default: return VACCSUIT;
  }
}


int aslpickspace()
{
  int  choice;

  printf("You have the following options for the Space\n");
  printf("cascade skill.\n\n");
  if (sex == 2) printf("   1. engineering\n   2. navigation\n   3. sensor ops\n");
  if (sex == 1) printf("   4. pilot\n   5. ship's boat\n");
  printf("   6. zero-g environment\n   7. vacc suit\n");
  choice = getsel_int(1, 7);
  if ((sex == 2 && (choice == 4 || choice == 5))
    || (sex == 1 && choice <= 3)) {
    printf("Wrong - try again!\n");
    return aslpickspace();
  }
  return aslswspace(choice);
}


void aslsc(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetsc(amount);
  } else {
    if (pick == 1) {
      skill = aslpicksc(amount);
    } else {
      skill = SPACCMBT;
    }
  }
  addskill(skill, amount);
}


int aslgetsc(int amount)
{
  int  choice;

  if (sex == 1) choice = d3();
  else choice = d2() + 2;
  return aslswsc(choice, amount);
}


int aslswsc(int choice, int amount)
{
  switch (choice) {
    case 1: gunner(amount); return 0;
    case 2: return SHIPTAC;  
    case 3: return TACTICS;
    case 4: return SENSOROPS;
  }
  return 0;
}


int aslpicksc(int amount)
{
  int  choice;

  printf("You have the following options for the Space Combat\n");
  printf("cascade skill.\n\n");
  if (sex == 1) printf("   1. gunnery*\n   2. ship tactics\n   3. tactics\n");
  if (sex == 2) printf("   1. tactics\n   2. sensor ops\n");
  choice = getsel_int(1, 3);
  if (sex == 2 && choice == 3) {
    printf("Wrong - try again!\n");
    return aslpicksc(amount);
  }
  if (sex == 2) choice += 2;
  return aslswsc(choice, amount);
}


void aslst(int amount)
{
  int  skill;

  if (sex == 1) skill = VACCSUIT;
  else {
    if (pick == 2 || pick == 4) {
      skill = getst();
    } else {
      if (pick == 1) {
        skill = pickst();
      } else {
        skill = SPACTECH;
      }
    }
  }
  addskill(skill, amount);
}


void aslspclcmbt(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetspcl();
  } else {
    if (pick == 1) {
      skill = aslpickspcl();
    } else {
      skill = SPCLCMBT;
    }
  }
  addskill(skill, amount);
}


int aslgetspcl()
{
  int  choice;

  if (sex == 1) choice = d8();
  else choice = d5();
  return aslswspcl(choice);
}


int aslswspcl(int choice)
{
  switch (choice) {
    case 1: return SURVIVAL;
    case 2: return GRAVBELT;
    case 3: return HIENERGYWEAP;
    case 4: return HIGHG;
    case 5: return NOGRAV;
    case 6: return STEALTH;
    case 7: return BATTLEDRESS;
    case 8: return CMBTRIFLMAN;
  }
  return 0;
}


int aslpickspcl()
{
  int  choice;

  printf("\nYou have the following options for the Special Combat\n");
  printf("cascade skill.\n\n");
  printf("   1. survival\n   2. grav belt\n   3. high energy weapons\n");
  printf("   4. high gravity environment\n   5. zero gravity environment\n\n");
  if (sex == 1) printf("   6. stealth\n   7. battle dress\n   8. combat rifleman\n");
  choice = getsel_int(1, 8);
  if (sex == 2 && choice >= 6) {
    printf("Wrong - try again!\n");
    return aslpickspcl();
  }
  return aslswspcl(choice);
}


void asltechl(int amount)
{
  int  skill;

  if (sex == 1) {
    bumpedu();
    skill = 0;
  } else {
    if (pick == 2 || pick == 4) {
      skill = gettech();
    } else {
      if (sex != 1 && pick == 1) {
        skill = picktech();
      } else {
        skill = TECHNICAL;
      }
    }
  }
  addskill(skill, amount);
}


void aslvhcl(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetvhcl(amount);
  } else {
    if (pick == 1) {
      skill = aslpickvhcl(amount);
    } else {
      skill = VEHICLE;
    }
  }
  addskill(skill, amount);
}


int aslgetvhcl(int amount)
{
  int  choice;

  if (sex == 1) choice = d7();
  return aslswvhcl(choice, amount);
}


int aslswvhcl(int choice, int amount)
{
  switch (choice) {
    case 1: return GRAVBELT;
    case 2: return WHEELEDVHCL;
    case 3: airc(amount); return 0;
    case 4: return GRAVVHCL;
    case 5: return SHIPBOAT;
    case 6: return TRACKEDVHCL;
    case 7: boats(amount);return 0;
  }
  return 0;
}


int aslpickvhcl(int amount)
{
  int  choice;

  printf("You have the following options for the Vehicle\n");
  printf("cascade skill.\n\n");
  printf("   1. grav belt\n   2. wheeled vehicle\n");
  if (sex == 1) {
    printf("   3. aircraft*\n   4. grav vehicle\n   5. ship's boat\n");
    printf("   6. tracked vehicle\n   7. water craft*\n");
  }
  choice = getsel_int(1, 7);
  if (sex == 2 && choice > 2) {
    printf("Wrong - try again!\n");
    return aslpickvhcl(amount);
  }
  return aslswvhcl(choice, amount);
}


void aslvc(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = aslgetvice();
  } else {
    if (pick == 1) {
      skill = aslpickvice();
    } else {
      skill = VICE;
    }
  }
  addskill(skill, amount);
}


int aslgetvice()
{
  int  choice;

  if (sex == 2) choice = d5();
  else choice = d3();
  return aslswvc(choice);
}


int aslswvc(int choice)
{
  switch (choice) {
    case 1: return DISGUISE;
    case 2: return INTRUSION;
    case 3: return STREETWISE;
    case 4: return BRIBERY;
    case 5: return FORGERY;
  }
  return 0;
}


int aslpickvice()
{
  int  choice;

  printf("You have the following options for the Vice\n");
  printf("cascade skill.\n\n");
  printf("   1. disguise\n   2. intrusion\n   3. streetwise\n");
  if (sex == 2) printf("   4. bribery\n   5. forgery\n");
  choice = getsel_int(1, 5);
  if (sex == 1 && choice > 3) {
    printf("Wrong - try again!\n");
    return aslpickvice();
  }
  return aslswvc(choice);
}
