/* ASLSPACE.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void aslspacer();
void aslspaceoff();
void spacemot(int term);
void spacebene();
void spaceskills(int skills);
void spcoffmot(int term);
void spcoffbene();
void spcoffskills(int skills);

extern int asl_spec_duty(int need_nbr);
extern int asl_surv(int need_nbr, int upp_type, int upp_val);
extern int reenlist(int need_nbr);
extern int aslmotrolls();
extern void addskill(int skill, int skl_val);
extern int asl_comm(int need_nbr, int upp_val, int adj_val);
extern int asl_promo(int need_nbr, int upp_val, int adj_val);
extern int asl_mot();
extern char getche_mot();
extern int asl_cash();
extern int asl_beneroll();
extern void airc(int skl_val);
extern void bumpedu();
extern void bumpsoc();
extern void bumpintl();
extern void bumpstr();
extern void bumpdex();
extern void independ();
extern int aslpicktable();
extern int d6();
extern int aslsklroll();
extern void aslmc(int skl_val);
extern void land();
extern void aslmentl(int skl_val);
extern void aslexplore(int skl_val);
extern void aslmilmed(int skl_val);
extern void aslgc(int skl_val);
extern void asltechl(int skl_val);
extern void aslspace(int skl_val);
extern void aslvhcl(int skl_val);
extern void aslsc(int skl_val);
extern void aslinterp(int skl_val);
extern void aslinbrn(int skl_val);
extern void aslst(int skl_val);
extern void physicl(int skl_val);
//extern int find_skl(int skill);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_lopsg();

#include "chargen.h"

void aslspacer()
{
  int  skills, newterm;
  
  newterm = 0;
  while (newterm != 1)
  {
    skills = asl_spec_duty(6);
    if (sex == 1) newterm = asl_surv(7, intl, 7);
    else newterm = asl_surv(7, intl, 8);
    if (newterm == 0) 
	{
      if (terms == 1) skills += 3;
      else skills += 2;
      if (sex == 1) skills += asl_comm(11, soc, 9);
      else skills += asl_comm(10, soc, 6);
      if (rankeo == 'O') newterm = 1;
    }
    if (skills != 0) spaceskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0) newterm = reenlist(5);
  }
  if (rankeo == 'O')
  {
    if (soc < 9) soc = 9;
    aslspaceoff();
    return;
  }
  spacemot(aslmotrolls());
  if (sex == 1 && soc >= 9) addskill(LEADER, 1);
}


void aslspaceoff()
{
  int  skills, newterm;
  
  newterm = 0;
  if (sex == 2) addskill(ADMIN, 1);
  else addskill(LEADER, 1);
  while (newterm != 1)
  {
    skills = asl_spec_duty(4);
    if (sex == 1) newterm = asl_surv(8, intl, 8);
    else newterm = asl_surv(7, intl, 8);
    if (newterm == 0)
	{
      if (terms == 1) skills += 3;
      else skills += 2;
      if (sex == 1) skills += asl_promo(11, edu, 8);
      else skills += asl_promo(7, intl, 8);
    }
    if (skills != 0) spcoffskills(skills);
    printf("That competes this term!\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  spcoffmot(aslmotrolls());
  if (sex == 1 && soc >= 9) addskill(LEADER, 1);
}


void spacemot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      roll = asl_cash();
      cash--;
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 500; break;
        case 2: amt = 1000; break;
        case 3: amt = 1000; break;
        case 4: amt = 5000; break;
        case 5: amt = 5000; break;
        case 6: amt = 10000; break;
        default: amt = 20000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        spacebene();
    }
  }
  if (sex == 1) credits = credits / 2;
  while (term > 0)
  {
    spacebene();
    term--;
  }
}


void spacebene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpintl(); break;
    case 3: bumpedu(); break;
    case 4: mot_weapon(); break;
    case 5: addskill(PERSWEAP, 1); break;
    case 6: mot_midpsg(); break;
    case 7: bumpsoc(); break;
    case 8: land(); break;
  }
}


void spaceskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    if (table == 1) {
      roll = aslsklroll(roll);
      switch (roll) {
        case 1: independ(1); break;
        case 2: bumpstr(); break;
        case 3: bumpdex(); break;
        case 4: physicl(1); break;
        case 5: aslmentl(1); break;
        case 6: addskill(ADMIN, 1); break;
      }
    }
    if (table == 2) {
      roll = aslsklroll(roll);
      switch (roll) {
        case 1: aslsc(1); break;
        case 2: addskill(VACCSUIT, 1); break;
        case 3: aslmc(1); break;
        case 4: aslgc(1); break;
        case 5: aslgc(1); break;
        case 6: aslinterp(1); break;
      }
   }
    if (table == 3) {
      if (sex == 2) {
        switch (roll) {
          case 1: addskill(COMPUTER, 1); break;
          case 2: addskill(MECHANICAL, 1); break;
          case 3: aslspace(1); break;
          case 4: aslinbrn(1); break;
          case 5: asltechl(1); break;
          case 6: aslmilmed(1); break;
        }
      } else {
        switch (roll) {
          case 1: aslsc(1); break;
          case 2: aslvhcl(1); break;
          case 3: aslspace(1); break;
          case 4: aslspace(1); break;
          case 5: aslinterp(1); break;
          case 6: aslinbrn(1); break;
        }
      }
    }
    skills--;
  }
}


void spcoffmot(int term)
{
  int  cash, roll;
  char choice;
  
  cash = asl_mot();
  while ((term > 0) && (cash > 0)) {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c') {
      roll = asl_cash();
      cash--;
      term--;
      switch (roll) {
        case 1: credits += 1000; break;
        case 2: credits += 5000; break;
        case 3: credits += 5000; break;
        case 4: credits += 10000; break;
        case 5: credits += 20000; break;
        case 6: credits += 20000; break;
        default: credits += 50000; break;
      }
    } else {
        term--;
        spcoffbene();
    }
  }
  if (sex == 1) credits = credits / 2;
  while (term > 0) {
    spcoffbene();
    term--;
  }
}


void spcoffbene()
{
  int roll;

  roll = asl_beneroll();
  switch (roll) {
    case 1: midpsg++; break;
    case 2: bumpintl(); break;
    case 3: bumpedu(); bumpedu(); break;
    case 4: weapons++; break;
    case 5: addskill(INDEPENDENCE, 1); break;
    case 6: midpsg++; break;
    case 7: bumpsoc(); break;
    case 8: land(); break;
  }
}


void spcoffskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = aslpicktable();
    roll = d6();
    if (table == 1) {
      roll = aslsklroll(roll);
      switch (roll) {
        case 1: independ(1); break;
        case 2: bumpstr(); break;
        case 3: bumpdex(); break;
        case 4: physicl(1); break;
        case 5: aslmentl(1); break;
        case 6: aslspace(1); break;
      }
    }
    if (table == 2) {
      roll = aslsklroll(roll);
      switch (roll) {
        case 1: aslspace(1); break;
        case 2: addskill(VACCSUIT, 1); break;
        case 3: aslmc(1); break;
        case 4: aslmc(1); break;
        case 5: aslgc(1); break;
        case 6: aslst(1); break;
      }
   }
    if (table == 3) {
      if (sex == 2) {
        switch (roll) {
          case 1: addskill(COMPUTER, 1); break;
          case 2: addskill(TOLERANCE, 1); break;
          case 3: aslspace(1); break;
          case 4: aslinbrn(1); break;
          case 5: asltechl(1); break;
          case 6: aslmilmed(1); break;
        }
      } else {
        switch (roll) {
          case 1: aslsc(1); break;
          case 2: aslspace(1); break;
          case 3: addskill(LEADER, 1); break;
          case 4: addskill(TOLERANCE, 1); break;
          case 5: aslexplore(1); break;
          case 6: aslinterp(1); break;
        }
      }
    }
    skills--;
  }
}
