/* CASCADES.C is part of the MegaTraveller (C) character generation */
/* program. It is used to select the characters cascade skills. */

#include <stdio.h>
#include <stdlib.h>

#include "chargen.h"

void cascades();
void gc(int amount);
int getgc();
int gc_mos();
int swgc(int choice);
int pickgc();
void airc(int amount);
int getairc();
int airc_mos();
int swairc(int choice);
int pickairc();
void acad(int amount);
int getacad(int amount);
int swacad(int choice, int amount);
int pickacad(int amount);
void animal(int amount);
int getanim();
int anim_mos();
int swanim(int choice);
int pickanim();
void archaic(int amount);
int getaw();
int aw_mos();
int swaw(int choice);
int pickaw();
void arts(int amount);
int getarts();
int arts_mos();
int swarts(int choice);
int pickarts();
void artillery(int amount);
int getarty(int amount);
int swarty(int choice, int amount);
int pickarty();
void bc(int amount);
int getbc();
int bc_mos();
int swbc(int choice);
int pickbc();
void pc(int amount);
int getpc();
int pc_mos();
int swpc(int choice);
int pickpc();
void cmbtsupt(int amount);
int getcs();
int swcs(int choice);
int pickcs();
void influ(int amount);
int getinflu();
int swinflu(int choice);
int pickinflu();
void infiltrate(int amount);
int getinfil();
int swinfil(int choice);
int pickinfil();
void invest(int amount);
int getinvest();
int swinvest(int choice);
int pickinvest();
void spacvhcl(int amount);
int getsv();
int swsv(int choice);
int picksv();
void env(int amount);
int get_env(int amount);
int swenv(int choice, int amount);
int pickenv(int amount);
void econ(int amount);
int getecon();
int swecon(int choice);
int pickecon();
void explore(int amount);
int getexpl(int amount);
int swexpl(int choice, int amount);
int pickexpl(int amount);
void fag(int amount);
int getfag();
int swfag(int choice);
int pickfag();
void gunner(int amount);
int getgunr();
int swgunr(int choice);
int pickgunr();
void hc(int amount);
int gethc(int amount);
int swhc(int choice, int amount);
int pickhc(int amount);
void inbrn(int amount);
int getinb();
int swinb(int choice);
int pickinb();
void interp(int amount);
int getint();
int swint(int choice);
int pickint();
void milmed(int amount);
int getmm();
int swmm(int choice);
int pickmm();
void mc(int amount);
int getmc(int amount);
int swmc(int choice, int amount);
int pickmc(int amount);
void mentl(int amount);
int getmen();
int pickmen();
void physicl(int amount);
int getphy();
int swphy(int choice);
int pickphy();
void sci(int amount);
int getsci();
int swsci(int choice);
int picksci();
void spac(int amount);
int getspace();
int swspace(int choice);
int pickspace();
void scrnt(int amount);
void spacecmbt(int amount);
int getsc(int amount);
int swsc(int choice, int amount);
int picksc(int amount);
void spacetech(int amount);
int getst();
int swst(int choice);
int pickst();
void special(int amount);
int getspcl(int amount);
int swspcl(int choice, int amount);
int pickspcl(int amount);
void techl(int amount);
int gettech();
int swtech(int choice);
int picktech();
void iris_tech(int amount);
int getitech();
int switech(int choice);
int pickitech();
void vhcl(int amount);
int getvhcl(int amount);
int vhcl_mos();
int swvhcl(int choice, int amount);
int pickvhcl(int amount);
void vc(int amount);
int getvc();
int swvc(int choice);
int pickvc();
void weapon();
void boats(int amount);
int getboat();
int boat_mos();
int swboat(int choice);
int pickboat();

extern void prtselin();
extern void addskill(int code, int amount);
extern int chk_skl(int skill, int value);
extern int find_skl(int skill);
extern void dispskil(int sequ, int skl_nbr);
extern void anykey();
extern int getsel_bigint(int min, int max);
extern int d2();
extern int d3();
extern int d4();
extern int d5();
extern int d6();
extern int d7();
extern int d8();
extern int d9();
extern int d11();
extern int d12();
extern int getsel_int(int min, int max);
extern void printskill(int skill);
extern void bumpdex();
extern void bumpedu();
extern void bumpstr();
extern void bumpend();
extern void bumpintl();
extern void bumpsoc();
extern void bumppsi();
extern void psitalents(int tryit);
extern void altcareertbl();

void cascades()
{
	int choice;

	printf("\nIn the skills selection process you can pick what you want\n");
	printf("or they can be selected randomly. This holds for both the choice\n");
	printf("of tables and for cascade skill choices.\n\n");
	printf("   1. pick tables and cascades (immediately)\n");
	printf("   2. pick tables while cascades are random\n");
	printf("   3. pick cascades (later) while tables are random\n");
	printf("   4. go totally random\n");
	choice = getsel_int(1, 4);
	pick = choice;
}


void gc(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getgc();
	else
		if (pick == 1)
			skill = pickgc();
		else
			skill = GUNCMBT;
	addskill(skill, amount);
}


int getgc()
{
	int  choice;

	if (tech < TLIND && ((col % 10) != 1 && careernbr >= SAILOR
		&& careernbr != TECHNOPRIEST))
		return EARLYFIREARMS;
	if ((choice = gc_mos()) > 0)
		return choice;
	if (careernbr != IRIS && race != KKREE)
		choice = d6();
	else
		choice = d7();
	if (tech < TLEXTSTEL && choice == 6)
		choice = 4;
	if ((tech < TLEARSTEL && tech > TLPREIND) || (tech == TLPREIND && (col % 10) != 1
		&& careernbr != TECHNOPRIEST && careernbr >= SAILOR))
	{
		if (choice == 4)
			choice = 1;
		if (choice == 5)
			choice = 2;
	}
	return swgc(choice);
}


int gc_mos()
{
	if (find_skl(CMBTRIFLMAN) >= 0)
		return CMBTRIFLMAN;
	if (find_skl(NEURALWEAP) >= 0)
		return NEURALWEAP;
	if (find_skl(ENERGYWEAP) >= 0)
		return ENERGYWEAP;
	if (find_skl(LASERWEAP) >= 0)
		return LASERWEAP;
	if (find_skl(SUBMG) >= 0)
		return SUBMG;
	if (find_skl(RIFLMAN) >= 0)
		return RIFLMAN;
	if (find_skl(HANDGUN) >= 0)
		return HANDGUN;
	return 0;
}

int swgc(int choice)
{
	switch (choice)
	{
		case 1: return HANDGUN;
	    case 2: return RIFLMAN;
		case 3: return SUBMG;
	    case 4: return ENERGYWEAP;
		case 5: return LASERWEAP;  
	    case 6: return NEURALWEAP;
		case 7: return CMBTRIFLMAN;
	}
	return -1;
}


int pickgc()
{
	int choice, max;

	if (tech < TLIND && (col % 10) != 1 && careernbr != TECHNOPRIEST)
		return EARLYFIREARMS;
	printf("You have the following options for the Gun Combat\n");
	printf("cascade skill.\n\n");
	dispskil(1, HANDGUN);
	dispskil(2, RIFLMAN);
	dispskil(3, SUBMG);
	max = 3;
	if ((tech >= TLEARSTEL) || (tech == TLPREIND && ((col % 10) == 1
		|| careernbr == TECHNOPRIEST || careernbr < SAILOR)))
	{
		dispskil(4, ENERGYWEAP);
		max = 4;
	}
	if ((tech >= TLEARSTEL) || (tech == TLPREIND && ((col % 10) == 1
		|| careernbr == TECHNOPRIEST || careernbr < SAILOR)))
	{
		dispskil(5, LASERWEAP);
		max = 5;
	}
	if (tech >= TLEXTSTEL)
	{
		dispskil(6, NEURALWEAP);
		max = 6;
	}
	if (careernbr == IRIS || race == KKREE)
	{
		dispskil(7, CMBTRIFLMAN);
		max = 7;
	}
	choice = getsel_int(1, max);
	return swgc(choice);
}


void airc(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getairc();
	else
		if (pick == 1)
			skill = pickairc();
		else
			skill = AIRCRAFT;
	addskill(skill, amount);
}


int getairc()
{
	int  choice;

	if ((choice = airc_mos()) > 0)
		return choice;
	choice = d4();
	if (tech == TLIND && choice > 2)
		choice -= 2;
	return swairc(choice);
}


int airc_mos()
{
	if (find_skl(BALLOONS) >= 0)
		return BALLOONS;
	if (find_skl(PROPAIR) >= 0)
		return PROPAIR;
	if (find_skl(JETAIR) >= 0)
		return JETAIR;
	if (find_skl(HELICOPTER) >= 0)
		return HELICOPTER;
	return 0;
}


int swairc(int choice)
{
	switch (choice)
	{
		case 1: return BALLOONS;  
	    case 2: return PROPAIR;
		case 3: return JETAIR;
		default: return HELICOPTER;
	}
}


int pickairc()
{
	int choice, max;

	printf("You have the following options for the Aircraft\n");
	printf("cascade skill.\n\n");
	dispskil(1, BALLOONS);
	dispskil(2, PROPAIR);
	max = 2;
	if (tech >= TLPRESTEL || (tech == 1 && (col % 10) == 1
		|| careernbr == TECHNOPRIEST || careernbr < SAILOR))
	{
		dispskil(3, JETAIR);
		dispskil(4, HELICOPTER);
		max = 4;
	}
	choice = getsel_int(1, max);
	return swairc(choice);
}


void acad(int amount)
{
	int  skill;

	if (race == TIRRILS)
		skill = MATH;
	else
		if (pick == 2 || pick == 4)
			skill = getacad(amount);
		else
			if (pick == 1)
				skill = pickacad(amount);
			else
				skill = ACADEMIC;
	addskill(skill, amount);
}


int getacad(int amount)
{
	int  choice;

	choice = d6();
	return swacad(choice, amount);
}


int swacad(int choice, int amount)
{
	switch (choice)
	{
		case 1: return ADMIN;
	    case 2: return HISTORY;
		case 3: return LINGUISTICS;  
	    case 4: return PERSUASION;
		case 5: sci(amount); return 0;
		default: bumpedu(); return 0;
	}
}


int pickacad(int amount)
{
	int choice;

	printf("You have the following options for the Academic\n");
	printf("cascade skill.\n\n");
	dispskil(1, ADMIN);
	dispskil(2, HISTORY);
	dispskil(3, LINGUISTICS);
	dispskil(4, PERSUASION);
	dispskil(5, SCIENCE);
	printf("   6. edu + 1\n");
	choice = getsel_int(1, 6);
	return swacad(choice, amount);
}


void animal(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getanim();
	else
		if (pick == 1)
			skill = pickanim();
		else
			skill = ANIMALS;
	addskill(skill, amount);
}


int getanim()
{
	int  choice;

	if ((choice = anim_mos()) > 0)
		return choice;
	choice = d3();
	return swanim(choice);
}


int anim_mos()
{
	if (find_skl(EQUESTRIAN) >= 0)
		return EQUESTRIAN;
	if (find_skl(GUARDBEAST) >= 0)
		return GUARDBEAST;
	if (find_skl(HERDING) >= 0)
		return HERDING;
	return 0;
}


int swanim(int choice)
{
	switch (choice)
	{
		case 1: return GUARDBEAST;
	    case 2: return HERDING;
		default: return EQUESTRIAN;
	}
}


int pickanim()
{
	int choice, max;

	printf("You have the following options for the Animal\n");
	printf("cascade skill.\n\n");
	dispskil(1, GUARDBEAST);
	dispskil(2, HERDING);
	max = 2;
	if (race != DOLPHINS)
	{
		dispskil(3, EQUESTRIAN);
		max = 3;
	}
	choice = getsel_int(1, max);
	return swanim(choice);
}


void archaic(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getaw();
	else
		if (pick == 1)
			skill = pickaw();
		else
			skill = ARCHAICWEAP;
	addskill(skill, amount);
}


int getaw()
{
	int  choice;

	if ((choice = aw_mos()) > 0)
		return choice;
	choice = d7();
	return swaw(choice);
}


int aw_mos()
{
	if (find_skl(EARLYFIREARMS) >= 0)
		return EARLYFIREARMS;
	if (find_skl(CROSSBW) >= 0)
		return CROSSBW;
	if (find_skl(BOW) >= 0)
		return BOW;
	if (find_skl(SLING) >= 0)
		return SLING;
	if (find_skl(BLOWGUN) >= 0)
		return BLOWGUN;
	if (find_skl(BOLA) >= 0)
		return BOLA;
	if (find_skl(BOOMERANG) >= 0)
		return BOOMERANG;
	return 0;
}


int swaw(int choice)
{
  switch (choice)
  {
    case 1: return BLOWGUN;
    case 2: return BOLA;
    case 3: return BOOMERANG;  
    case 4: return BOW;
    case 5: return CROSSBW;
    case 6: return EARLYFIREARMS;
    default: return SLING;
  }
}


int pickaw()
{
	int choice;

	printf("You have the following options for the Archaic Weapons\n");
	printf("cascade skill.\n\n");
	dispskil(1, BLOWGUN);
	dispskil(2, BOLA);
	dispskil(3, BOOMERANG);
	dispskil(4, BOW);
	dispskil(5, CROSSBW);
	dispskil(6, EARLYFIREARMS);
	dispskil(7, SLING);
	choice = getsel_int(1, 7);
	return swaw(choice);
}


void arts(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getarts();
	else
		if (pick == 1)
			skill = pickarts();
		else
			skill = ARTSY;
	addskill(skill, amount);
}


int getarts()
{
	int  choice;

	if ((choice = arts_mos()) > 0)
		return choice;
	choice = d4();
	if (race == HIVER && choice > 1)
		choice  = d4();
	return swarts(choice);
}


int arts_mos()
{
	if (find_skl(ACTING) >= 0)
		return ACTING;
	if (find_skl(DANCE) >= 0)
		return DANCE;
	if (find_skl(MUSIC) >= 0)
		return MUSIC;
	if (find_skl(SONG) >= 0)
		return SONG;
	return 0;
}


int swarts(int choice)
{
	switch (choice)
	{
		case 1: return ACTING;
		case 2: return DANCE;
	    case 3: return MUSIC;
		default: return SONG;
	}
}


int pickarts()
{
	int choice;

	printf("You have the following options for the Arts\n");
	printf("cascade skill.\n\n");
	dispskil(1, ACTING);
	dispskil(2, DANCE);
	dispskil(3, MUSIC);
	dispskil(4, SONG);
	choice = getsel_int(1, 4);
	return swarts(choice);
}


void artillery(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getarty(amount);
	else
		if (pick == 1)
			skill = pickarty(amount);
		else
			skill = ARTILLERY;
	addskill(skill, amount);
}


int getarty(int amount)
{
	int  choice;

	if (race == HIVER)
		choice = d4();
	else
		choice = d3();
	return swarty(choice, amount);
}


int swarty(int choice, int amount)
{
	switch (choice)
	{
		case 1: return FORWARDOBS;
	    case 2: return HEAVYWEAP;
		case 3: fag(amount); return (0);
		default: return ROBOTOPS;
	}
}


int pickarty(int amount)
{
	int choice, max;

	printf("You have the following options for the Artillery\n");
	printf("cascade skill.\n\n");
	dispskil(1, FORWARDOBS);
	dispskil(2, HEAVYWEAP);
	dispskil(3, FAGUNNERY);
	max = 3;
	if (race == HIVER)
	{
		dispskil(4, ROBOTOPS);
		max = 4;
	}
	choice = getsel_int(1, max);
	return swarty(choice, amount);
}


void bc(int amount)
{
	int  skill, roll;

	if (race == GITHIASKIO)
	{
		addskill(POLEARM, amount);
		return;
	}
	if (careernbr == MARINE)
	{
		roll = d12();
		if (roll < 12)
		{
			addskill(LARGEBLAD, amount);
			return;
		}
	}
	if (pick == 2 || pick == 4)
		skill = getbc();
	else
		if (pick == 1)
			skill = pickbc();
		else
			skill = BLADCMBT;
	addskill(skill, amount);
}


int getbc()
{
	int  choice;

	if ((choice = bc_mos()) > 0)
		return choice;
	choice = d6();
	return swbc(choice);
}


int bc_mos()
{
	if (find_skl(FOIL) >= 0)
		return FOIL;
	if (find_skl(LARGEBLAD) >= 0)
		return LARGEBLAD;
	if (find_skl(POLEARM) >= 0)
		return POLEARM;
	if (find_skl(SMALLBLAD) >= 0)
		return SMALLBLAD;
	if (find_skl(AXE) >= 0)
		return AXE;
	if (find_skl(CUDGEL) >= 0)
		return CUDGEL;
	return 0;
}


int swbc(int choice)
{
	switch (choice)
	{
		case 1: return AXE;
	    case 2: return CUDGEL;
		case 3: return FOIL;  
	    case 4: return LARGEBLAD;
		case 5: return POLEARM;  
		default: return SMALLBLAD;
	}
}


int pickbc()
{
	int choice;

	printf("You have the following options for the Blade Combat\n");
	printf("cascade skill.\n\n");
	dispskil(1, AXE);
	dispskil(2, CUDGEL);
	dispskil(3, FOIL);
	dispskil(4, LARGEBLAD);
	dispskil(5, POLEARM);
	dispskil(6, SMALLBLAD);
	choice = getsel_int(1, 6);
	return swbc(choice);
}


void pc(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getpc();
	else
		if (pick == 1)
			skill = pickpc();
		else
			skill = PERSONALCMBT;
	addskill(skill, amount);
}


int getpc()
{
	int  choice;

	if ((choice = pc_mos()) > 0)
		return choice;
	choice = d4();
	if (race == HIVER && choice > 1)
		choice = d4();
	return swpc(choice);
}


int pc_mos()
{
	if (find_skl(MARTIALARTS) >= 0)
		return MARTIALARTS;
	if (find_skl(LARGEBLAD) >= 0)
		return LARGEBLAD;
	if (find_skl(POLEARM) >= 0)
		return POLEARM;
	if (find_skl(SMALLBLAD) >= 0)
		return SMALLBLAD;
	return 0;
}


int swpc(int choice)
{
	switch (choice)
	{
		case 1: return MARTIALARTS;
	    case 2: return SMALLBLAD;
		case 3: return LARGEBLAD;
		case 4: return POLEARM;  
	}
	return -1;
}


int pickpc()
{
	int choice;

	printf("You have the following options for the Personal Combat\n");
	printf("cascade skill.\n\n");
	dispskil(1, BRAWLING);
	dispskil(2, SMALLBLAD);
	dispskil(3, LARGEBLAD);
	dispskil(4, POLEARM);
	choice = getsel_int(1, 4);
	return swpc(choice);
}


void cmbtsupt(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getcs();
	else
		if (pick == 1)
			skill = pickcs();
		else
			skill = CMBTSUPT;
	addskill(skill, amount);
}


int getcs()
{
	int  choice;

	choice = d3();
	return swcs(choice);
}


int swcs(int choice)
{
	switch (choice)
	{
		case 1: return BATTLEDRESS;
	    case 2: return FORWARDOBS;
		case 3: return HEAVYWEAP;
	}
	return -1;
}


int pickcs()
{
	int choice;

	printf("You have the following options for the Combat Support\n");
	printf("Systems cascade skill.\n\n");
	dispskil(1, BATTLEDRESS);
	dispskil(2, FORWARDOBS);   
	dispskil(3, HEAVYWEAP);
	choice = getsel_int(1, 3);
	return swcs(choice);
}


void influ(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getinflu();
	else
		if (pick == 1)
			skill = pickinflu();
		else
			skill = INFLUENCE;
	addskill(skill, amount);
}


int getinflu()
{
	int  choice;

	choice = d4();
	if (race == NEWT)
		choice = (d6() + 1) / 2;
	return swinflu(choice);
}


int swinflu(int choice)
{
	switch (choice)
	{
		case 1: return PERSUASION;
		case 2: return LIAISON;
	    case 3: return CAROUSING;
		case 4: return STREETWISE;  
	}
	return -1;
}


int pickinflu()
{
	int choice, max;

	printf("You have the following options for the Influence cascade skill.\n\n");
	dispskil(1, PERSUASION);
	dispskil(2, LIAISON);
	dispskil(3, CAROUSING);
	max = 3;
	if (race != NEWT)
	{
		dispskil(4, STREETWISE);
		max = 4;
	}
	choice = getsel_int(1, max);
	return swinflu(choice);
}


void infiltrate(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getinfil();
	else
	    if (pick == 1)
			skill = pickinfil();
		else
			skill = INFILTRATION;
	addskill(skill, amount);
}


int getinfil()
{
	int  choice;

	choice = d4();
	if (race == HIVER && choice == 2)
		choice = d4();
	return swinfil(choice);
}


int swinfil(int choice)
{
	switch (choice)
	{
	    case 1: return INTRUSION;
		case 2: return STEALTH;
	    case 3: return RECON;
		case 4: return HUNTING;  
	}
	return -1;
}


int pickinfil()
{
	int choice;

	printf("You have the following options for the Infiltration cascade skill.\n\n");
	dispskil(1, INTRUSION);
	dispskil(2, STEALTH);
	dispskil(3, RECON);
	dispskil(4, HUNTING);
	choice = getsel_int(1, 4);
	return swinfil(choice);
}


void invest(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getinvest();
	else
		if (pick == 1)
			skill = pickinvest();
		else
		skill = INVESTIGATION;
	addskill(skill, amount);
}


int getinvest()
{
	int  choice;

	choice = d3();
	return swinvest(choice);
}


int swinvest(int choice)
{
	switch (choice)
	{
		case 1: return INTERVIEW;
		case 2: return INTERROGATE;
		case 3: return FORENSIC;
	}
	return -1;
}


int pickinvest()
{
	int choice;

	printf("You have the following options for the Investigation cascade skill.\n\n");
	dispskil(1, INTERVIEW);
	dispskil(2, INTERROGATE);
	dispskil(3, FORENSIC);
	choice = getsel_int(1, 3);
	return swinvest(choice);
}


void spacvhcl(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getsv();
	else
		if (pick == 1)
			skill = picksv();
		else
			skill = SPACVHCL;
	addskill(skill, amount);
}


int getsv()
{
	int  choice;

	choice = d4();
	return swsv(choice);
}


int swsv(int choice)
{
	switch (choice)
	{
		case 1: return PILOT;
	    case 2: return NAVIGATION;
		case 3: return SHIPBOAT;
		case 4: return VACCSUIT;  
	}
	return -1;
}


int picksv()
{
	int choice;

	printf("You have the following options for the Space Vehicle cascade skill.\n\n");
	dispskil(1, PILOT);
	dispskil(2, NAVIGATION);
	dispskil(3, SHIPBOAT);
	dispskil(4, VACCSUIT);
	printf("\n");
	choice = getsel_int(1, 4);
	return swsv(choice);
}


void env(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = get_env(amount);
	else
		if (pick == 1)
			skill = pickenv(amount);
		else
			skill = ENVIRON;
	addskill(skill, amount);
}


int get_env(int amount)
{
	int choice;

	choice = d6();
	if (race == HIVER && choice == 2)
		choice = d6();
	return swenv(choice, amount);
}


int swenv(int choice, int amount)
{
	switch (choice)
	{
		case 1: animal(amount); return 0;
	    case 2: archaic(amount); return 0;
		case 3: return HUNTING;  
	    case 4: return RECON;
		case 5: return STEALTH;
		default: return SURVIVAL;
	}
}


int pickenv(int amount)
{
	int choice;

	printf("You have the following options for the Environment\n");
	printf("cascade skill.\n\n");
	dispskil(1, ANIMALS);
	dispskil(2, ARCHAICWEAP);
	dispskil(3, HUNTING);
	dispskil(4, RECON);
	dispskil(5, STEALTH);
	dispskil(6, SURVIVAL);
	choice = getsel_int(1, 6);
	return swenv(choice, amount);
}


void econ(int amount)
{
	int  skill;

	if (race == TIRRILS)
		skill = WALDOOPS;
	else
		if (pick == 2 || pick == 4)
			skill = getecon();
		else
			if (pick == 1)
				skill = pickecon();
			else
				skill = ECONOMIC;
	addskill(skill, amount);
}


int getecon()
{
	int  choice;

	if (race == DOLPHINS)
		choice = 1;
	else
		if (race == VARGR)
			choice = d6();
		else
			choice = d4();
	return swecon(choice);
}


int swecon(int choice)
{
	switch (choice)
	{
		case 1: return ADMIN;
	    case 2: return BROKER;
		case 3: return LEGAL;  
	    case 4: return TRADER;
		default: return SCROUNGE;
	}
	return -1;
}


int pickecon()
{
	int choice, max;

	if (race == DOLPHINS)
		return swecon(1);
	printf("You have the following options for the Economic\n");
	printf("cascade skill.\n\n");
	dispskil(1, ADMIN);
	dispskil(2, BROKER);
	dispskil(3, LEGAL);
	dispskil(4, TRADER);
	max = 4;
	if (race == VARGR)
	{
		dispskil(5, SCROUNGE);
		max = 5;
	}
	choice = getsel_int(1, max);
	return swecon(choice);
}


void explore(amount)
int  amount;
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getexpl(amount);
	else
		if (pick == 1)
			skill = pickexpl(amount);
		else
			skill = EXPLORATORY;
	addskill(skill, amount);
}


int getexpl(amount)
int amount;
{
	int  choice;

	choice = d6();
	return swexpl(choice, amount);
}


int swexpl(choice, amount)
int choice, amount;
{
	switch (choice)
	{
		case 1: return PILOT;
	    case 2: return SENSOROPS;
		case 3: return SURVEY;
	    case 4: return SURVIVAL;
		case 5: return VACCSUIT;
	    default:
		{
			if (race == TIRRILS)
				return FLYING;
			else
			{
				vhcl(amount);
				return 0;
			}
		}
	}
}


int pickexpl(amount)
int amount;
{
	int  choice;

	printf("You have the following options for the Exploratory\n");
	printf("cascade skill.\n\n");
	dispskil(1, PILOT);
	dispskil(2, SENSOROPS);
	dispskil(3, SURVEY);
	dispskil(4, SURVIVAL);
	dispskil(5, VACCSUIT);
	if (race == TIRRILS)
		dispskil(6, FLYING);
	else
		dispskil(6, VEHICLE);
	choice = getsel_int(1, 6);
	return swexpl(choice, amount);
}


void fag(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getfag();
	else
		if (pick == 1)
			skill = pickfag();
		else
			skill = FAGUNNERY;
	addskill(skill, amount);
}


int getfag()
{
	int  choice;

	choice = d4();
	return swfag(choice);
}


int swfag(int choice)
{
	switch (choice)
	{
		case 1: return HIENERGYWEAP;
	    case 2: return MASSDRIVER;
		case 3: return MESONGUN;  
	    default: return MORTARHOW;
	}
}


int pickfag()
{
	int  choice;

	printf("You have the following options for the Field Artillery Gunnery\n");
	printf("cascade skill.\n\n");
	dispskil(1, HIENERGYWEAP);
	dispskil(2, MASSDRIVER);
	dispskil(3, MESONGUN);
	dispskil(4, MORTARHOW);
	choice = getsel_int(1, 4);
	return swfag(choice);
}


void gunner(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getgunr();
	else
	    if (pick == 1)
			skill = pickgunr();
		else
			skill = GUNNERY;
	addskill(skill, amount);
}


int pickgunr()
{
	int  choice;

	printf("You have the following options for the Gunnery\n");
	printf("cascade skill.\n\n");
	dispskil(1, SCREENS);
	dispskil(2, SPINALWEAP);
	dispskil(3, TURRETWEAP);
	choice = getsel_int(1, 3);
	return swgunr(choice);
}


int swgunr(int choice)
{
	switch (choice)
	{
		case 1: return SCREENS;
	    case 2: return SPINALWEAP;
		default: return TURRETWEAP;
	}
}


int getgunr()
{
	int  choice;

	choice = d3();
	return swgunr(choice);
}


void hc(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = gethc(amount);
	else
		if (pick == 1)
			skill = pickhc(amount);
		else
			skill = HANDCMBT;
	addskill(skill, amount);
}


int gethc(int amount)
{
	int  choice;

	choice = d4();
	return swhc(choice, amount);
}


int swhc(int choice, int amount)
{
	switch (choice)
	{
		case 1: bc(amount); return 0;
		case 2: return BRAWLING;
	    case 3: bumpend(); return 0;  
		default: bumpstr(); return 0;
	}
}


int pickhc(int amount)
{
	int  choice;

	printf("You have the following options for the Hand Combat\n");
	printf("cascade skill.\n\n");
	dispskil(1, BLADCMBT);
	dispskil(2, BRAWLING);
	printf("   3. add 1 to endurance\n");
	printf("   4. add 1 to strength\n");
	choice = getsel_int(1, 4);
	return swhc(choice, amount);
}


void inbrn(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getinb();
	else
		if (pick == 1)
			skill = pickinb();
		else
			skill = INBORN;
	addskill(skill, amount);
}


int getinb()
{
	int  choice;

	choice = d6();
	return swinb(choice);
}


int swinb(int choice)
{
	switch (choice)
	{
		case 1: return ARTISAN;
	    case 2: return CAROUSING;
		case 3: return INSTRUCTION;
	    case 4: return HANDYMAN;
		case 5: return TACTICS;
	    default: return LEADER;
	}
}


int pickinb()
{
	int  choice;

	printf("You have the following options for the Inborn\n");
	printf("cascade skill.\n\n");
	dispskil(1, ARTISAN);
	dispskil(2, CAROUSING);
	dispskil(3, INSTRUCTION);
	dispskil(4, HANDYMAN);
	dispskil(5, TACTICS);
	dispskil(6, LEADER);
	choice = getsel_int(1, 6);
	return swinb(choice);
}


void interp(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getint();
	else
		if (pick == 1)
			skill = pickint();
		else
			skill = INTERPERS;
	addskill(skill, amount);
}


int getint()
{
	int  choice;

	choice = d5();
	if (race == LLELLEWYLOLY || race == ASLAN)
		choice = d6();
	if (race == HIVER && choice == 5)
		choice = d5();
	return swint(choice);
}


int swint(int choice)
{
	switch (choice)
	{
		case 1: return ADMIN;
	    case 2: return INTERVIEW;
		case 3: return LIAISON;
	    case 4: return LINGUISTICS;
		case 5: return STEWARD;
		default: return TOLERANCE;
	}
}


int pickint()
{
	int  choice, max;

	printf("You have the following options for the Interpersonal\n");
	printf("cascade skill.\n\n");
	dispskil(1, ADMIN);
	dispskil(2, INTERVIEW);
	dispskil(3, LIAISON);
	dispskil(4, LINGUISTICS);
	dispskil(5, STEWARD);
	max = 5;
	if (race == LLELLEWYLOLY || race == ASLAN)
	{
		dispskil(6, TOLERANCE);
		max = 6;
	}
	choice = getsel_int(1, max);
	return swint(choice);
}


void milmed(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getmm();
	else
		if (pick == 1)
			skill = pickmm();
		else
			skill = MIL_MED;
	addskill(skill, amount);
}


int getmm()
{
	int  choice;

	choice = d4();
	return swmm(choice);
}


int swmm(int choice)
{
	switch (choice)
	{
		case 1: return FORENSIC;
	    case 2: return MEDICAL;
		case 3: return RECON;
		default: return SURVIVAL;
	}
}


int pickmm()
{
	int  choice;

	printf("You have the following options for the Military Medical\n");
	printf("cascade skill.\n\n");
	dispskil(1, FORENSIC);
	dispskil(2, MEDICAL);
	dispskil(3, RECON);
	dispskil(4, SURVIVAL);
	choice = getsel_int(1, 4);
	return swmm(choice);
}


void mc(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getmc(amount);
	else
		if (pick == 1)
			skill = pickmc(amount);
		else
			skill = MIXED_CMBT;
	addskill(skill, amount);
}


int getmc(int amount)
{
	int  choice;

	choice = d5();
	return swmc(choice, amount);
}


int swmc(int choice, int amount)
{
	switch (choice)
	{
		case 1: return BRAWLING;
	    case 2: bc(amount); return 0;
		case 3: gc(amount); return 0;
	    case 4: bumpstr(); return 0;
		default: bumpend(); return 0;
	}
}


int pickmc(int amount)
{
	int  choice;

	printf("You have the following options for the Mixed Combat\n");
	printf("cascade skill.\n\n");
	dispskil(1, BRAWLING);
	dispskil(2, BLADCMBT);
	dispskil(3, GUNCMBT);
	printf("   4. add 1 to strength\n   5. add 1 to endurance\n");
	choice = getsel_int(1, 5);
	return swmc(choice, amount);
}


void mentl(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getmen();
	else
		if (pick == 1)
			skill = pickmen();
		else
			skill = MENTAL;
	if (skill != 0)
		addskill(skill, amount);
}


int getmen()
{
	int  choice;

	if (race == JONKEREEN || race == KKREE)
		choice = d3();
	else
		choice = d2();
	if (choice == 1)
		bumpintl();
	else
		if (choice == 2)
			bumpedu();
		else
			return(ENCLOSURE);
	return 0;
}


int pickmen()
{
	int  choice, max;

	printf("You have the following options for the Mental\n");
	printf("cascade skill.\n\n");
	printf("   1. add 1 to intelligence\n   2. add 1 to education\n");
	max = 2;
	if (race == JONKEREEN || race == KKREE)
	{
		dispskil(3, ENCLOSURE);
		max = 3;
	}
	choice = getsel_int(1, max);
	if (choice == 1)
		bumpintl();
	else
		if (choice == 3)
			return(ENCLOSURE);
		else
			bumpedu();
	return 0;
}


void physicl(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getphy();
	else
		if (pick == 1)
			skill = pickphy();
		else
			skill = PHYSICAL;
	addskill(skill, amount);
}


int getphy()
{
	int  choice;

	choice = d3();
	return swphy(choice);
}


int swphy(int choice)
{
	switch (choice)
	{
		case 1:
			{
				if (race == DOLPHINS)
					addskill(WALDOOPS, 1);
				else
					bumpdex();
				break;
            }
		case 2: bumpend(); break;
		default: bumpstr(); break;
	}
	return 0;
}


int pickphy()
{
	int  choice;

	printf("You have the following options for the Physical\n");
	printf("cascade skill.\n\n");
	if (race == DOLPHINS)
		dispskil(1, WALDOOPS);
	else
		printf("   1. add 1 to dexterity");
	printf("\n   2. add 1 to endurance\n   3. add 1 to strength\n");
	choice = getsel_int(1, 3);
	return swphy(choice);
}


void sci(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getsci();
	else
		if (pick == 1)
			skill = picksci();
		else
			skill = SCIENCE;
	addskill(skill, amount);
}


int getsci()
{
	int  choice;

	choice = d7();
	return swsci(choice);
}


int swsci(int choice)
{
	switch (choice)
	{
		case 1: return BIOLOGY;
	    case 2: return CHEMISTRY;
		case 3: return GENETICS;
	    case 4: return FORENSIC;
		case 5: return MEDICAL;
	    case 6: return PHYSICS;
		default: return ROBOTICS;
	}
}


int picksci()
{
	int  choice;

	printf("You have the following options for the Science\n");
	printf("cascade skill.\n\n");
	dispskil(1, BIOLOGY);
	dispskil(2, CHEMISTRY);
	dispskil(3, GENETICS);
	dispskil(4, FORENSIC);
	dispskil(5, MEDICAL);
	dispskil(6, PHYSICS);
	dispskil(7, ROBOTICS);
	choice = getsel_int(1, 7);
	return swsci(choice);
}


void spac(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getspace();
	else
		if (pick == 1)
			skill = pickspace();
		else
			skill = SPACE;
	addskill(skill, amount);
}


int getspace()
{
	int  choice;

	choice = d6();
	return swspace(choice);
}


int swspace(int choice)
{
	switch (choice)
	{
		case 1: return ENGINEERING;
	    case 2: return NAVIGATION;
		case 3: return PILOT;
	    case 4: return SENSOROPS;
		case 5: return SHIPBOAT;
		default: return VACCSUIT;
	}
}


int pickspace()
{
	int  choice;

	printf("You have the following options for the Space\n");
	printf("cascade skill.\n\n");
	dispskil(1, ENGINEERING);
	dispskil(2, NAVIGATION);
	dispskil(3, PILOT);
	dispskil(4, SENSOROPS);
	dispskil(5, SHIPBOAT);
	dispskil(6, VACCSUIT);
	choice = getsel_int(1, 6);
	return swspace(choice);
}


void scrnt(int amount)
{
	addskill(SCRNTECH, amount);
}


void spacecmbt(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getsc(amount);
	else
		if (pick == 1)
			skill = picksc(amount);
		else
			skill = SPACCMBT;
	addskill(skill, amount);
}


int getsc(int amount)
{
	int  choice;

	choice = d4();
	return swsc(choice, amount);
}


int swsc(int choice, int amount)
{
	switch (choice)
	{
		case 1: gunner(amount); return 0;
	    case 2: return SENSOROPS;
		case 3: return SHIPTAC;  
		default: return TACTICS;
	}
}


int picksc(int amount)
{
	int  choice;

	printf("You have the following options for the Space Combat\n");
	printf("cascade skill.\n\n");
	dispskil(1, GUNNERY);
	dispskil(2, SENSOROPS);
	dispskil(3, SHIPTAC);
	dispskil(4, TACTICS);
	choice = getsel_int(1, 4);
	return swsc(choice, amount);
}


void spacetech(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getst();
	else
		if (pick == 1)
			skill = pickst();
		else
			skill = SPACTECH;
	addskill(skill, amount);
}


int pickst()
{
	int  choice;

	printf("You have the following options for the Space Technology\n");
	printf("cascade skill.\n\n");
	dispskil(1, COMMO);
	dispskil(2, COMPUTER);
	dispskil(3, ENGINEERING);
	dispskil(4, GRAVITICS);
	dispskil(5, VACCSUIT);
	choice = getsel_int(1, 5);
	return swst(choice);
}


int swst(int choice)
{
	switch (choice)
	{
		case 1: return COMMO;
	    case 2: return COMPUTER;
		case 3: return ENGINEERING;
	    case 4: return GRAVITICS;
		default: return VACCSUIT;
	}
}


int getst()
{
	int  choice;

	choice = d5();
	return swst(choice);
}


void special(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getspcl(amount);
	else
		if (pick == 1)
			skill = pickspcl(amount);
		else
			skill = SPCLCMBT;
	addskill(skill, amount);
}


int getspcl(int amount)
{
	int  choice;

	choice = d11();
	return swspcl(choice, amount);
}


int swspcl(int choice, int amount)
{
	switch (choice)
	{
		case 1: return BATTLEDRESS;
	    case 2: return CMBTENGR;
		case 3: return CMBTRIFLMAN;
	    case 4: return DEMOLITIONS;
		case 5: fag(amount); return 0;
	    case 6: return FORWARDOBS;
		case 7: return GRAVBELT;
	    case 8: return HIENERGYWEAP;
		case 9: return HEAVYWEAP;
	    case 10: return STEALTH;
		default: return NOGRAV;
	}
}


int pickspcl(int amount)
{
	int  choice;

	anykey();
	printf("\nYou have the following options for the Special Combat\n");
	printf("cascade skill.\n\n");
	dispskil(1, BATTLEDRESS);
	dispskil(2, CMBTENGR);
	dispskil(3, CMBTRIFLMAN);
	dispskil(4, DEMOLITIONS);
	dispskil(5, FAGUNNERY);
	dispskil(6, FORWARDOBS);
	dispskil(7, GRAVBELT);
	dispskil(8, HIENERGYWEAP);
	dispskil(9, HEAVYWEAP);
	dispskil(10, STEALTH);
	dispskil(11, NOGRAV);
	choice = getsel_bigint(1, 11);
	return swspcl(choice, amount);
}


void techl(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = gettech();
	else
		if (pick == 1)
			skill = picktech();
		else
		skill = TECHNICAL;
	addskill(skill, amount);
}


int gettech()
{
	int  choice;

	choice = d6();
	return swtech(choice);
}


int swtech(int choice)
{
	switch (choice)
	{
		case 1: return COMMO;
	    case 2: return COMPUTER;
		case 3: return ELECTRONICS;
	    case 4: return GRAVITICS;
		case 5: return ROBOTOPS;
		default: return SENSOROPS;
	}
}


int picktech()
{
	int  choice;

	printf("You have the following options for the Technical\n");
	printf("cascade skill.\n\n");
	dispskil(1, COMMO);
	dispskil(2, COMPUTER);
	dispskil(3, ELECTRONICS);
	dispskil(4, GRAVITICS);
	dispskil(5, ROBOTOPS);
	dispskil(6, SENSOROPS);
	choice = getsel_int(1, 6);
	return swtech(choice);
}


void iris_tech(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getitech();
	else
		if (pick == 1)
			skill = pickitech();
		else
			skill = TECHNICAL;
	addskill(skill, amount);
}


int getitech()
{
	int  choice;

	choice = d6();
	return switech(choice);
}


int switech(int choice)
{
	switch (choice)
	{
		case 1: return COMMO;
	    case 2: return COMPUTER;
		case 3: return ELECTRONICS;
	    case 4: return HANDYMAN;
		case 5: return MEDICAL;
		default: return SENSOROPS;
	}
}


int pickitech()
{
	int  choice;

	printf("You have the following options for the IRIS Technical cascade skill.\n\n");
	dispskil(1, COMMO);
	dispskil(2, COMPUTER);
	dispskil(3, ELECTRONICS);
	dispskil(4, HANDYMAN);
	dispskil(5, MEDICAL);
	dispskil(6, SENSOROPS);
	choice = getsel_int(1, 6);
	return switech(choice);
}


void vhcl(int amount)
{
	int  skill;

	if (race == TIRRILS)
		skill = FLYING;
	else
		if (pick == 2 || pick == 4)
			skill = getvhcl(amount);
		else
			if (pick == 1)
				skill = pickvhcl(amount);
			else
				skill = VEHICLE;
	addskill(skill, amount);
}


int getvhcl(int amount)
{
	int  choice;

	if ((choice = vhcl_mos()) > 0)
		return choice;
	if (tech <= TLPRESTEL || (tech == TLPREIND && (col % 10) != 1
		&& careernbr != TECHNOPRIEST && careernbr >= SAILOR))
		return 4;
	if (race == DOLPHINS)
		choice = d8();
	else
		choice = d7();
	if (tech < TLPRESTEL || (tech == TLPREIND && (col % 10) != 1 && careernbr != TECHNOPRIEST
		&& careernbr >= SAILOR) && choice > 4)
		choice -= 3;
	if (tech < TLEARSTEL || (tech == TLPREIND && (col % 10) != 1 && careernbr != TECHNOPRIEST
		&& careernbr >= SAILOR) && choice > 5)
		choice -= 2;
	return swvhcl(choice, amount);
}


int vhcl_mos()
{
	if (find_skl(GRAVVHCL) >= 0)
		return GRAVVHCL;
	if (find_skl(TRACKEDVHCL) >= 0)
		return TRACKEDVHCL;
	if (find_skl(WHEELEDVHCL) >= 0)
		return WHEELEDVHCL;
	return 0;
}


int swvhcl(int choice, int amount)
{
	switch (choice)
	{
		case 1: boats(amount); return 0;
	    case 2: return TRACKEDVHCL;
		case 3: return WHEELEDVHCL;
	    case 4: airc(amount); return 0;
		case 5: return SHIPBOAT;
	    case 6: return GRAVVHCL;
		case 7: return GRAVBELT;
		case 8: return TEESUIT;
		default: return EQUESTRIAN;
	}
}


int pickvhcl(int amount)
{
	int  choice, max;

	printf("You have the following options for the Vehicle\n");
	printf("cascade skill.\n\n");
	dispskil(1, BOATS);
	if (tech >= TLIND || (tech == TLPREIND && (col % 10) == 1 || careernbr == TECHNOPRIEST
		|| careernbr < SAILOR))
	{
		dispskil(2, TRACKEDVHCL);
		dispskil(3, WHEELEDVHCL);
		dispskil(4, AIRCRAFT);
		max = 4;
	}
	if (tech >= TLPRESTEL || (tech == TLPREIND && (col % 10) == 1
		|| careernbr == TECHNOPRIEST || careernbr < SAILOR))
	{
		dispskil(5, SHIPBOAT);
		max = 5;
	}
	if (tech >= TLPRESTEL || (tech == TLPREIND && (col % 10) == 1
		|| careernbr == TECHNOPRIEST || careernbr < SAILOR))
	{
		dispskil(6, GRAVVHCL);
		dispskil(7, GRAVBELT);
		max = 7;
	}
	if (race == DOLPHINS) 
	{
		dispskil(8, TEESUIT);
		max = 8;
	}
	choice = getsel_int(1, max);
	return swvhcl(choice, amount);
}


void vc(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getvc();
	else
		if (pick == 1)
			skill = pickvc();
		else
			skill = VICE;
	addskill(skill, amount);
}


int getvc()
{
	int  choice;

	choice = d6();
	if (race == VARGR)
		choice = d8();
	if (race == DOLPHINS)
		choice = d4();
	if (race == NEWT)
		choice = d2();
	if (race == HIVER && (choice == 2 || choice == 3 || choice == 5))
		choice = d6();
	return swvc(choice);
}


int swvc(int choice)
{
	switch (choice)
	{
		case 1: return DISGUISE;
	    case 2: return INTRUSION;
		case 3: return FORGERY;
	    case 4: return STREETWISE;
		case 5: return BRIBERY;
	    case 6: return GAMBLING;
		default: return SCROUNGE;
	}
	return -1;
}


int pickvc()
{
	int  choice, max;

	printf("You have the following options for the Vice\n");
	printf("cascade skill.\n\n");
	dispskil(1, DISGUISE);
	dispskil(2, INTRUSION);
	max = 2;
	if (race != NEWT)
	{
		dispskil(3, FORGERY);
		dispskil(4, STREETWISE);
		max = 4;
	}
	if (race != DOLPHINS && race != NEWT)
	{
		dispskil(5, BRIBERY);
		dispskil(6, GAMBLING);
		max = 6;
	}
	if (race == VARGR)
	{
		dispskil(7, SCROUNGE);
		max = 7;
	}
	choice = getsel_int(1, max);
	return swvc(choice);
}


void weapt(amount)
int amount;
{
	addskill(WEAPTECH, amount);
}


void weapon()
{
	int choice;

	printf("You have the option to gain a weapon skill. What kind do you\n");
	printf("want?\n");
	dispskil(1, BLADCMBT);
	dispskil(2, GUNCMBT);
	choice = getsel_int(1, 2);
	switch (choice)
	{
		case 1: bc(1); break;
		case 2: gc(1); break;
	}
}


void boats(int amount)
{
	int  skill;

	if (pick == 2 || pick == 4)
		skill = getboat();
	else
		if (pick == 1)
			skill = pickboat();
		else
			skill = BOATS;
	addskill(skill, amount);
}


int getboat()
{
	int  choice;

	if ((choice = boat_mos()) > 0)
		return choice;
	if (sex == 2)
		choice = d4();
	else
		choice = d3();
	if (choice == 4 && (tech < TLPRESTEL || atmos < ATMTHN)
		|| (tech == TLPREIND && (col % 10) != 1 && careernbr != TECHNOPRIEST))
		choice = 1;
	if ((choice == 3 || choice == 2) 
		&& (tech == TLPREIND && (col % 10) != 1 && careernbr != TECHNOPRIEST)
		|| tech >= TLEARSTEL || hydro < HYDDRY)
		choice = 1;
	return swboat(choice);
}


int boat_mos()
{
	if (find_skl(HOVERCRAFT) >= 0)
		return HOVERCRAFT;
	if (find_skl(SUBMARINE) >= 0)
		return SUBMARINE;
	if (find_skl(LARGEBOAT) >= 0)
		return LARGEBOAT;
	if (find_skl(SMALLBOAT) >= 0)
		return SMALLBOAT;
	return 0;
}


int swboat(int choice)
{
	switch (choice)
	{
		case 1: return SMALLBOAT;
	    case 2: return LARGEBOAT;
		case 3: return SUBMARINE;
		case 4: return HOVERCRAFT;
	}
	return -1;
}


int pickboat()
{
	int  choice, options, max;

	options = 0;
	max = 0;
	printf("You have the following options for the Water Craft\n");
	printf("cascade skill.\n\n");
	if (tech <= TLPRESTEL && hydro >= HYDDRY)
	{
		dispskil(1, SMALLBOAT);
		options++;
		max = 1;
	}   
	if (tech >= TLIND && tech <= TLPRESTEL && hydro >= HYDDRY
		|| (tech == TLPREIND && ((col % 10) == 1 || careernbr == TECHNOPRIEST)))
	{
		dispskil(2, LARGEBOAT);
		dispskil(3, SUBMARINE);
		options += 2;
		max = 3;
	}
	if (tech >= TLPRESTEL && atmos >= ATMTHN
		|| (tech == TLPREIND && ((col % 10) == 1 || careernbr == TECHNOPRIEST)))
	{
		dispskil(4, HOVERCRAFT);
		options++;
		max = 4;
	}
	if (options <= 1 && max <= 1)
		return swboat(1);
	if (options == 1 && max == 4)
		return swboat(4);
	choice = getsel_int(1, max);
	return swboat(choice);
}