/* CGADV.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

#include "chargen.h"

int survive(int roll, int adjust);
int nv_adj();
int nv_cmd();
void decor_type();
void decorate(int adjust);
int bp_decor(int roll, int need_nbr);
int bp_skill(int roll);
int bp_skill1(int roll, int need_nbr);
int bp_spcl_duty(int roll);
int bp_cm(int roll);
void court_martial();
int bp_cm_sentence(int roll);
void bp_cmbt();
void nv_spcl_sch();
void nv_gun_sch();
void nv_engr_sch();
void nv_intl_sch();
void nv_cmd_col();
void nv_staff_col();
void merc_cmd_col();
void merc_staff_col();
void merc_rcrtng();
void merc_prot_frcs();
void merc_intl_sch();
void prtgrad();
void prtflt();
void prtsch();
void getline();
void awards();
void cmd_clstr();
void commend();
void discover();
void prtspcldty(int spcldutynbr);
int prtfinalspcldty(int spcldutynbr, int spcldutycnt);
void gotspcldty(int spcldutynbr);
void instructor(int spcldutynbr);

extern int bp_adj(int roll, int need_nbr);
extern int d6();
extern int d12();
extern int get_bigint();
extern char getche_y_n();
extern void addskill(int skill, int skl_val);
extern int find_skl(int skill);
extern void spac(int skl_val);
extern void spacetech(int skl_val);
extern void gunner();
extern void gc(int skl_val);
extern void acad(int skl_val);
extern void vc(int skl_val);
extern void bp_add(int amt);
extern int chk_skl(int skill, int value);

int  aide, nv_anag, nv_cross[10];
int  nv_promo, command, combat;
int  assignment;

int survive(int roll, int adjust)
{
	if (roll != 2 && adjust != 0)
		roll += adjust;
	if (surv == 0)
		printf("Survival is automatic.\n");
	else
		printf("Survival requires a %d, your modified roll %d.\n", surv, roll);
	if (brownie_points > 0 && roll < surv)
		roll = bp_adj(roll, surv);
	if (roll == surv)
	{
		purple++;
		printf("You were wounded"); 
		if (careernbr <= SAILOR || (careernbr >= IRIS && careernbr <= SPACEGUARD)) 
			printf(" and earned a purple heart!\n");
		else
			printf(".\n");
	}
	if (roll >= surv)
		printf("You survived.\n");
	if (roll < surv)
	{
		printf("You did not survive!");
		if (careernbr <= SAILOR || (careernbr >= IRIS && careernbr <= SPACEGUARD))
		{
			purple++;
			printf(" You earned a purple heart.");
		}
		printf("\n");
		return 1;
	}
	return 0;
}


int nv_adj()
{
	int  nbr;

	if (surv == 0)
		return 0;
	if (pick == 4)
		return 0;
	printf("You have the option to adjust your survival roll/");
	decor_type();
	printf(" roll.\nPlease enter the adjustment you want (0 = no adjustment)\n");
	printf("for your survival roll, negative numbers help ");
	decor_type();
	printf(" roll.\n");
	printf("survival = %d ", surv);
	decor_type();
	printf(" = %d", decor);
	nbr = get_bigint();
	return nbr;
}


int nv_cmd()
{
	int  roll;
	char choice;

	if (rankeo == 'E')
		return 0;
	if (aide == 1)
	{
		printf("As an Admirals Aide you have the option to take a command\n");
	    printf("assignment this year automaticly. Do you want to?");
		choice = getche_y_n();
	    if (choice == 'Y' || choice == 'y')
		{
			aide = 0;
			return 1;
		}
	}
	roll = d12();
	if (rank <= 2)
		roll--;
	if (rank <= 4)
		roll--;
	if (intl <= 7)
		roll--;
	if (edu <= 7)
		roll--;
	if (roll >= (6 + branch))
		return 1;
	return 0;
}


void decor_type()
{
	if (careernbr == SCIENTIST)
		printf("discovery");
	else
		if (careernbr == BELTER)
			printf("strike");
		else
			printf("decorations");
}


void decorate(int adjust)
{
	int roll, medallevel;

	if (decor != 0)
	{
		roll = d12();
		if (adjust != 0) roll -= adjust;
		if (race == ZHODANI || race == DARRIAN)
		{
			if (roll < decor) roll = bp_decor(roll, 0);
			if (roll >= decor)
			{
				medallevel = roll - decor;
				if (medallevel == 0)
					medallevel = 1;
				if (medallevel > 10)
					medallevel = 10;
				zhomedal[medallevel]++;
				printf("You received the Hero Medal %d Class!\n", medallevel);
				if (medallevel < 4)
					bp_add(1);
				else
					if (medallevel < 7)
						bp_add(2);
					else
						bp_add(3);
		    }
			else
			{
				if (roll <= (decor - 6) && adjust > 0)
				{
					roll = bp_cm(roll);
					court_martial();
				}
			}
			return;
		}
	    if (roll < (decor + 6))
			roll = bp_decor(roll, 6);
	    if (roll >= (decor + 6))
		{
			seh++;
			printf("You received the SEH!\n");
			bp_add(3);
	    }
		else
		{
			if (roll < (decor + 3))
				roll = bp_decor(roll, 3);
			if (roll >= (decor + 3))
			{
				mcg++;
				printf("You received the MCG!\n");
				bp_add(2);
			}
			else
			{
				if (roll < decor)
					roll = bp_decor(roll, 0);
				if (roll >= decor)
				{  
					mcuf++;
					printf("You received the MCUF!\n");
					bp_add(1);
				}
				else
					if (roll <= (decor - 6) && adjust > 0)
					{
						roll = bp_cm(roll);
						court_martial();
					}
			}
		}
	}
}


int bp_decor(int roll, int need_nbr)
{
	int nbr;

	if (brownie_points >= 1)
		nbr = 1;
	else
		nbr = 0;
	if ((roll + nbr) < (decor + need_nbr))
		return roll;
	brownie_points -= (decor + need_nbr - roll);
	printf("You used %d brownie points to get your ", (decor + need_nbr - roll));
	decor_type();
	printf(".\n");
	return (decor + need_nbr);
}


int bp_skill1(int roll, int need_nbr)
{
	int nbr;

	if (roll >= need_nbr) return roll;
	if (brownie_points >= 3)
		nbr = 1;
	else
		nbr = 0;
	if ((roll + nbr) < (need_nbr)) return roll;
	brownie_points -= nbr;
	printf("You used %d brownie points to get your skill.\n", nbr);
	return (need_nbr);
}


int bp_skill(int roll)
{
	int nbr;

	if (brownie_points >= 3)
		nbr = 1;
	else
		nbr = 0;
	if ((roll + nbr) < skil)
		return (roll);
	brownie_points -= (skil - roll);
	printf("You used %d brownie points to get your skill.\n", (skil - roll));
	return (skil);
}


int bp_spcl_duty(int roll)
{
	int nbr, goal;

	if (brownie_points >= 3)
		nbr = 1;
	else
		nbr = 0;
	if (roll == 2 && nbr == 1 && careernbr == MERCHANT)
	{
		brownie_points--;
		printf("You used 1 brownie point to avoid a transfer down.\n");
		return(3);
	}
	goal = 11;
	if (careernbr == MERCHANT) goal = 12;
	if (roll >= goal) return (roll);
	if ((roll + nbr) < goal) return (roll);
	brownie_points -= nbr;
	printf("You used %d brownie point to get special duty.\n", nbr);
	return (goal);
}


int bp_cm(int roll)
{
	if ((roll + brownie_points) < (decor - 5))
		return roll;
	brownie_points -= (decor - 5 - roll);
	printf("You used %d brownie points to avoid a Court Martial.\n", (decor - 5 - roll));
	return (decor - 5);
}


void court_martial()
{
	int roll;
  
	if (rankeo == 'O')
	{
		roll = d12() + find_skl(ADMIN);
		if (roll < 10 && brownie_points > 0)
			roll = bp_adj(roll, 10);
		if (roll >= 10)
		{
			printf("You were charged with cowardice, but were found not guilty.\n");
			return;
		}
	}
	printf("You were court martialed!\n");
	roll = d6();
	if (rankeo == 'E' && rank >= 7)
		roll++;
	if (combat == 1)
		roll += 2;
	if (assignment == 1)
		roll -= 2;
	if (rankeo == 'O' && rank >= 7)
		roll--;
	if (command == 1)
		roll += 2;
	if (roll > 0 && brownie_points > 0)
		roll = bp_cm_sentence(roll);
	if (roll < 0)
	{
		printf("Your case was dismissed.\n");
		return;
	}
	if (roll <= 1)
	{
		printf("You were reprimanded.\n");
		if (roll == 0)
			promo--;
		else 
			promo -= 3;
		return;
	}
	if (roll == 2)
	{
		printf("You were demoted one rank.\n");
		rank--;
	}
	if (roll == 3)
	{
		printf("You were demoted two ranks.\n");
		rank -= 2;
	}
	if (roll == 4)
	{
		roll = d6();
		printf("You were demoted two ranks and served %d months in jail.\n", roll);
		rank -= 2;
		age++;
		if (nv_anag == 0)
			appearent_age++;
	}
	if (rank < 1)
		rank = 1;
	if (roll <= 4)
		return;
	if (roll <= 7)
	{
		if (roll == 5)
			roll = d6();
		else
			roll = d12();
		printf("You served %d years in jail and received a dishonorable discharge.\n", roll);
		age += roll;
		appearent_age += roll;
		terms -= 3;
		if (terms < 0)
			terms = 0;
		surv = 14;
		return;
	}
	printf("You received the death penalty. However, you managed to escape.\n");
	terms = 0;
	surv = 14;
	if (roll <= 9)
	{
		printf("There is a 10,000 Cr reward for your capture.\n");
		return;
	}
	roll = d6();
	printf("During your escape you killed %d guards. There is a 100,000 Cr\n", roll);
	printf("price on your head.\n");
	return;
}


int bp_cm_sentence(int roll)
{
	if (brownie_points > roll)
	{
		printf("You used %d brownie points to reduce your sentence.\n", roll);
		brownie_points -= roll;
		return 0;
	}
	roll -= brownie_points;
	printf("You used %d brownie points to reduce your sentence.\n", brownie_points);
	brownie_points = 0;
	return roll;
}


void nv_spcl_sch()
{
	int roll;

	gotspcldty(SPECIALISTSCH);
	roll = d6();
	if ((intl + edu) >= 16)
	{
		switch (roll)
		{
			case 1: addskill(MEDICAL, 1); break;
			case 2: addskill(COMPUTER, 1); break;
			case 3: addskill(LIAISON, 1); break;
			case 4: spacetech(1); break;
			case 5: spac(1); break;
			case 6: acad(1); break;
		}
	}
	else
	{
		switch (roll)
		{
			case 1: addskill(COMMO, 1); break;
			case 2: addskill(MECHANICAL, 1); break;
			case 3: addskill(SHIPBOAT, 1); break;
			case 4: addskill(ELECTRONICS, 1); break;
			case 5: addskill(ENGINEERING, 1); break;
			case 6: addskill(GRAVITICS, 1); break;
		}
	}
}


void nv_gun_sch()
{
	int i, roll;

	gotspcldty(GUNNERYSCH);
	if (special_duty[GUNNERYSCH] > 1)
	{
		if ((chk_skl(SCREENS, 4) == 1) || (chk_skl(SPINALWEAP, 4) == 1) 
			|| (chk_skl(TURRETWEAP, 4) == 1))
		{
			instructor(GUNNERYSCH);
			return;
		}
	}
	for (i = 1; i <= 4; i++)
	{
		roll = bp_skill1(d6(), 5);
		if (roll >= 5)
			gunner(1);
	}
}


void nv_engr_sch()
{
	int roll;

	gotspcldty(ENGINEERINGSCH);
	if (special_duty[ENGINEERINGSCH] > 1)
	{
		if ((chk_skl(MECHANICAL, 4) == 1) || (chk_skl(ELECTRONICS, 4) == 1) 
			|| (chk_skl(GRAVITICS, 4) == 1) || (chk_skl(ENGINEERING, 4) == 1))
		{
			instructor(ENGINEERINGSCH);
			return;
		}
	}
	if (race != HIVER)
	{
		roll = bp_skill1(d6(), 5);
		if (roll >= 5)
			addskill(MECHANICAL, 1);
	}
	roll = bp_skill1(d6(), 5);
	if (roll >= 5)
		addskill(ELECTRONICS, 1);
	roll = bp_skill1(d6(), 5);
	if (roll >= 5)
		addskill(GRAVITICS, 1);
	roll = bp_skill1(d6(), 5);
	if (roll >= 5)
		addskill(ENGINEERING, 1);
}


void nv_intl_sch()
{
	int roll;

	gotspcldty(INTELLIGENCESCH);
	if (special_duty[INTELLIGENCESCH] > 1)
	{
		if ((chk_skl(FORGERY, 4) == 1) || (chk_skl(BRIBERY, 4) == 1) 
			|| (chk_skl(STREETWISE, 4) == 1) || (chk_skl(INTERROGATE, 4) == 1)
			|| (chk_skl(ENERGYWEAP, 4) == 1) || (chk_skl(LASERWEAP, 4) == 1)
			|| (chk_skl(RIFLMAN, 4) == 1) || (chk_skl(CMBTRIFLMAN, 4) == 1)
			|| (chk_skl(NEURALWEAP, 4) == 1)
			|| (chk_skl(HANDGUN, 4) == 1) || (chk_skl(SUBMG, 4) == 1))
		{
			instructor(INTELLIGENCESCH);
			return;
		}
	}
	roll = bp_skill1(d6(), 4);
	if (roll >= 4 && race != HIVER || (race == HIVER && roll >= 6))
		addskill(FORGERY, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4 && race != HIVER || (race == HIVER && roll >= 6))
		gc(1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4 && race != DOLPHINS && race != HIVER || (race == HIVER && roll >= 6))
		addskill(BRIBERY, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(STREETWISE, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(INTERROGATE, 1);
}


void nv_cmd_col()
{
	int roll;

	gotspcldty(COMMANDCOL);
	if (special_duty[COMMANDCOL] > 1)
	{
		if ((chk_skl(ADMIN, 4) == 1) || (chk_skl(FLEETTAC, 4) == 1) 
			|| (chk_skl(SHIPTAC, 4) == 1) || (chk_skl(LEADER, 4) == 1)
			|| (chk_skl(TACTICS, 4) == 1))
		{
			instructor(COMMANDCOL);
			return;
		}
	}
	if (tech >= TLEARSTEL)
	{
		roll = bp_skill1(d6(), 4);
		if (roll >= 4)
			addskill(SHIPTAC, 1);
		roll = bp_skill1(d6(), 4);
		if (roll >= 4)
			addskill(FLEETTAC, 1);
	}
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(LEADER, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(ADMIN, 1);
	if (careernbr == FLYER)
	{
		roll = bp_skill1(d6(), 4);
		if (roll >= 4)
			addskill(TACTICS, 1);
	}
}


void nv_staff_col()
{
	int roll;

	gotspcldty(STAFFCOL);
	if (special_duty[STAFFCOL] > 1)
	{
		if ((chk_skl(ADMIN, 4) == 1) || (chk_skl(FLEETTAC, 4) == 1) 
			|| (chk_skl(TACTICS, 4) == 1) || (chk_skl(LIAISON, 4) == 1)
			|| (chk_skl(COMPUTER, 4) == 1) || (chk_skl(ROBOTOPS, 4) == 1))
		{
			instructor(STAFFCOL);
			return;
		}
	}
	if (tech >= TLEARSTEL)
	{
		roll = bp_skill1(d6(), 4);
		if (roll >= 4)
			addskill(FLEETTAC, 1);
	}
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(ADMIN, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(LIAISON, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(COMPUTER, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
	{
		if (careernbr == FLYER)
			addskill(TACTICS, 1);
		else
			addskill(ROBOTOPS, 1);
	}
}


void merc_cmd_col()
{
	int roll;

	gotspcldty(COMMANDCOL);
	if (special_duty[COMMANDCOL] > 1)
	{
		if ((chk_skl(TACTICS, 4) == 1) || (chk_skl(LEADER, 4) == 1) 
			|| (chk_skl(RECON, 4) == 1))
		{
			instructor(COMMANDCOL);
			return;
		}
	}
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(TACTICS, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(LEADER, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(RECON, 1);
}


void merc_staff_col()
{
	int roll;

	gotspcldty(STAFFCOL);
	if (special_duty[STAFFCOL] > 1)
	{
		if ((chk_skl(ADMIN, 4) == 1) || (chk_skl(CMBTENGR, 4) == 1) 
			|| (chk_skl(COMPUTER, 4) == 1) || (chk_skl(ROBOTOPS, 4) == 1))
		{
			instructor(STAFFCOL);
			return;
		}
	}
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(ADMIN, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(CMBTENGR, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(COMPUTER, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(ROBOTOPS, 1);
}


void merc_rcrtng()
{
	gotspcldty(RECRUITINGDUTY);
	addskill(RECRUITING, 1);
}


void merc_prot_frcs()
{
  int roll;

	gotspcldty(PROTECTEDFORCES);
	if (special_duty[PROTECTEDFORCES] > 1)
	{
		if ((chk_skl(VACCSUIT, 4) == 1) || (chk_skl(NOGRAV, 4) == 1) 
			|| (chk_skl(HIGHG, 4) == 1))
		{
			instructor(PROTECTEDFORCES);
			return;
		}
	}
	roll = bp_skill1(d6(), 3);
	if (roll >= 3) addskill(VACCSUIT, 1);
	roll = bp_skill1(d6(), 3);
	if (roll >= 3) addskill(NOGRAV, 1);
	roll = bp_skill1(d6(), 3);
	if (roll >= 3) addskill(HIGHG, 1);
}


void merc_intl_sch()
{
	int roll;

	gotspcldty(INTELLIGENCESCH);
	if (special_duty[INTELLIGENCESCH] > 1)
	{
		if ((chk_skl(FORGERY, 4) == 1) || (chk_skl(BRIBERY, 4) == 1) 
			|| (chk_skl(DISGUISE, 4) == 1) || (chk_skl(INTRUSION, 4) == 1)
		    || (chk_skl(GAMBLING, 4) == 1) || (chk_skl(SCROUNGE, 4) == 1) 
			|| (chk_skl(STREETWISE, 4) == 1) || (chk_skl(INTERROGATE, 4) == 1))
		{
			instructor(INTELLIGENCESCH);
			return;
		}
	}
	roll = bp_skill1(d6(), 4);
	if (roll >= 4) addskill(FORGERY, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4) vc(1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4 || race != DOLPHINS) addskill(BRIBERY, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4) addskill(STREETWISE, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4) addskill(INTERROGATE, 1);
}


void prtgrad()
{
	if (med_sch >= GRADUATED)
	{
		if (race == HIVER)
			printf("Medical/Bio Educ. grad  ");
		else
			printf("Medical School graduate ");
		if (med_sch == HONORS)
			printf("honors      ");
		else
			printf("            ");
	}
	else
	{
		if (grad_sch >= GRADUATED)
		{
			if (race == HIVER)
				printf("Advanced Education grad  ");
			else
				printf("Graduate School graduate ");
			if (grad_sch == HONORS)
				printf("honors     ");
			else
				printf("           ");
		}
		else
		{
			if (tech_acd >= GRADUATED)
			{
				printf("Technical Academy grad ");
				if (tech_acd == HONORS)
					printf("honors       ");
				else
					printf("             ");
			}
			else
				if (law_sch >= GRADUATED)
				{
					printf("Law School grad ");
					if (law_sch == HONORS)
						printf("honors              ");
					else
						printf("                    ");
				}
				else
					printf("                                    ");
		}
	}
}


void prtflt()
{
	if (flt_sch >= GRADUATED)
	{
		printf("Flight school graduate ");
		if (flt_sch == HONORS)
			printf("with honors  ");
		else
			printf("             ");
	}
	else
	    printf("                                    ");
}


void prtsch()
{
	if (race == HIVER)
	{
		switch (col % 10)
		{
		case 1: printf("Technical Educ  "); break;
		case 2: printf("General Educ    "); break;
		case 4: printf("Military Educ   "); break;
		default: printf("                "); break;
		}
	}
	else
	{
		switch (col % 10)
		{
			case 1: printf("Tech School"); break;
			case 2: printf("University "); break;
			case 3: printf("Merchant academy"); break;
		    case 4: printf("Military academy"); break;
			case 5: printf("Naval academy   "); break;
			case 6: printf("Air academy     "); break;
			case 7: printf("PreInd Univ     "); break;
			case 8: printf("PreInd Tech Univ"); break;
			default: printf("           "); break;
		}
	}
	if (col > 10)
		printf(" honors");
	else
		printf("       ");
	if (col > 0)
		printf(" grad");
	else
		printf("     ");
	if ((col % 10) <= 2 && race != HIVER)
	{
		if (otc == 1)
			printf(" OTC ");
		else 
			if (otc == 2)
				printf(" NOTC");
			else 
				if (otc == 5)
					printf(" AOTC");
				else
					printf("     ");
	}
	printf("         ");
}


void getline()
{
	if (careernbr == MERCHANT)
	{
		switch (line)
		{
			case 1: printf(" Megacorp"); break;
			case 2: printf(" Sector-wide line"); break;
			case 3: printf(" Subsector-wide line"); break;
			case 4: printf(" Interface line"); break;
			case 5: printf(" Fledgling line"); break;
			case 6: printf(" Free Trader"); break;
		}
	}
	if (careernbr == SCOUT)
	{
		switch (line)
		{
			case 1: printf(" Field"); break;
			case 2: printf(" Bureaucracy"); break;
		}
	}
	if (careernbr == FLYER && race == IMPERIAL)
	{
		switch (line)
		{
			case 1: printf(" Imperial"); break;
			default: printf(" World"); break;
		}
		printf(" COACC");
	}
	if (careernbr == ARMY && race == ZHODANI && line == 1)
		printf(" Guards");
	if (careernbr == NAVY)
	{
		switch (line)
		{
			case 1:
			{
				if (race == DARRIAN)
					printf(" Confederation Navy");
				else
				    if (race == IMPERIAL)
						printf(" Imperial Navy");
					else
						if (race == ZHODANI)
							printf(" Consular Navy");
						else
							if (race == HHKAR)
								printf(" Protectorate Navy");
							else
								printf(" Navy");
				break;
			}
			case 2: 
			{
				if (race == DARRIAN)
					printf(" Planetary Navy");
				else
				    if (race == ZHODANI)
						printf(" Regional Navy");
					else
						printf(" Reserve Fleet"); 
				break;
			}
			case 3: printf(" System Squadron"); break;
		}
	}
	if (careernbr == BELTER)
		printf(" %s", office);
}


void awards()
{
	int i, hits;

	printf("\nAwards: ");
	if (race == ZHODANI || race == DARRIAN)
	{
		hits = 0;
		printf("Hero Medals: ");
		for (i = 1; i < 11; i++)
		{
			if (zhomedal[i] < 1)
				continue;
			printf("%d", i);
			if (i == 1)
				printf("st");
			if (i == 2)
				printf("nd");
			if (i == 3)
				printf("rd");
			if (i >= 4)
				printf("th");
			printf(" Class");
			if (zhomedal[i] > 1)
				printf("x%d", zhomedal[i]);
			hits++;
			printf(", ");
		}
		if (hits > 0 && race == ZHODANI && rankeo == 'O' && rank > 0)
			tas++;
		if (hits == 0)
			printf("none, ");
	}
	else
	{
		if (seh >= 1)
		{
			printf("SEH");
			if (seh > 1)
				printf("x%d", seh);
			printf(", ");
		}
		if (mcg >= 1)
		{
			printf("MCG");
			if (mcg > 1)
				printf("x%d", mcg);
		    printf(", ");
		}
		if (mcuf >= 1)
		{
		    printf("MCUF");
			if (mcuf > 1)
				printf("x%d", mcuf);
		    printf(", ");
		}
	}
	cmd_clstr();
}


void cmd_clstr()
{
	if (purple >= 1)
	{
		if (race == ZHODANI)
			printf("Wound Badge");
		else
			printf("Purple Heart");
		if (purple > 1)
			printf("sx%d", purple);
		printf(", ");
	}
	if (cmd >= 1)
	{
		printf("Command Cluster");
		if (cmd > 1)
			printf("sx%d", cmd);
		printf(", ");
	}
	if (cmbt >= 1)
	{
		printf("Combat Ribbon");
		if (cmbt > 1)
			printf("sx%d", cmbt);
		printf(", ");
	}
	if (careernbr == FLYER && flt_sch > 0)
	{
		if (flt_sch == 1)
			printf("Pilot Wings");
	    if (flt_sch == 2)
			printf("Senior Pilot Wings");
		if (flt_sch == 3)
			printf("Command Pilot Wings");
		printf(", ");
	}
}


void commend()
{
	printf("\nCommendations: ");
	if (mcuf >= 1)
	{
		printf("minor");
		if (mcuf > 1)
			printf("x%d", mcuf);
		printf(", ");
	}
}


void discover()
{
	printf("\nDiscoveries: ");
	if (seh >= 1)
	{
		printf("breakthrough");
		if (seh > 1)
			printf("x%d", seh);
		printf(", ");
	}
	if (mcg >= 1)
	{
		printf("major");
		if (mcg > 1)
			printf("x%d", mcg);
		printf(", ");
	}
	if (mcuf >= 1)
	{
		printf("minor");
		if (mcuf > 1)
			printf("x%d", mcuf);
	    printf(", ");
	}
}


void bp_cmbt()
{
	brownie_points--;
	printf("You used 1 brownie point to get a combat assignment.\n");
}


int prtfinalspcldty(int spcldutynbr, int spcldutycnt)
{
	int instr, stud, retn;

	if (spcldutycnt < 1) return 0;
	instr = spcldutycnt / 10;
	stud = spcldutycnt % 10;
	retn = 1;
	prtspcldty(spcldutynbr);
	if (stud > 1) printf("x%d", stud);
	if (instr > 0)
	{
		printf(" (Instructor");
		if (instr > 1) printf("x%d", instr);
		printf(")");
		retn = 2;
	}
	printf(", ");
	return retn;
}


void prtspcldty(int spcldutynbr)
{
	switch (spcldutynbr)
	{
		case SPECIALISTSCH: printf("Specialist School"); break;
		case COMMANDOSCH: printf("Commando School"); break;
		case PROTECTEDFORCES: printf("Protected Forces"); break;
		case RECRUITINGDUTY: printf("Recruiting Duty"); break;
		case OCS: printf("OCS"); break;
		case INTELLIGENCESCH: printf("Intelligence School"); break;
		case COMMANDCOL: printf("Command College"); break;
		case STAFFCOL: printf("Staff College"); break;
		case ATTACHE: printf("Attache"); break;
		case AIDE: printf("Aide"); break;
		case GUNNERYSCH: printf("Gunnery School"); break;
		case ENGINEERINGSCH: printf("Engineering School"); break;
		case SECURITYTRNG: printf("Security Training"); break;
		case TRADESTATION: printf("Trade Station"); break;
		case HELMTRNG: printf("Helm Training"); break;
		case DRIVETRNG: printf("Drive Training"); break;
		case STEWARDTRNG: printf("Steward Training"); break;
		case DECKSCH: printf("Deck School"); break;
		case PURSERSCH: printf("Purser School"); break;
		case BUSINESSSCH: printf("Business School"); break;
		case SPECIALMIS: printf("Special Mission"); break;
		case WARMIS: printf("War Mission"); break;
		case THOUGHTPOLICESCH: printf("Thought Police School"); break;
		case ADVAIRCMBTSCH: printf("Adv Air Combat School"); break;
		case SPACESCH: printf("Space School"); break;
		case FORWARDOBSSCH: printf("Forward Obs School"); break;
		case BASEDEFENSESCH: printf("Base Defense School"); break;
		case AIRCREWSCH: printf("Air Crew School"); break;
		case TECHSCH: printf("Technical School"); break;
		case PSIINST: printf("Psionic Instutite"); break;
		case INTERDICTIONPROBE: printf("Interdiction Probe"); break;
		case BLACKPROGRAM: printf("Black Program"); break;
		case RESEARCHSTN: printf("Research Station"); break;
		case HOSTILEENV: printf("Hostile Environment"); break;
		case GRANT: printf("Grant"); break;
		case PRISON:
			{
				if (race == DROYNE) printf("Skirmish School");
				else printf("Prison");
				break;
			}
		case INFILTRATEGRP:
			{
				if (race == DROYNE) printf("Orbital Assault School");
				else printf("Infiltrate Opposing Group");
				break;
			}
		case MUTINY:
			{
				if (race == KKREE) printf("Cavalry School");
				else printf("Mutiny");
				break;
			}
		case SABOTAGE: printf("Sabotage Ship"); break;
		case SHIPHEIST: printf("Ship Heist"); break;
		case RIGHTHAND: printf("Right-Hand Being"); break;
		case MEDICALSCH: printf("Medical School"); break;
		case NAVALSTUDIES: printf("Naval Studies"); break;
		case INTERROGATORSCH: printf("Interrigator Shcool"); break;
		default: printf("Unknown spcl duty"); break;
	}
}


void gotspcldty(int spcldutynbr)
{
	special_duty[spcldutynbr]++;
	if (spcldutynbr != PRISON) bp_add(1);
	printf("You got ");
	prtspcldty(spcldutynbr);
	printf(".\n");
}


void instructor(int spcldutynbr)
{
	printf("You were an instructor.\n");
	addskill(INSTRUCTION, 1);
	special_duty[spcldutynbr] += 10;
}
