/* CGMISC.C MegaTraveller (c) character generation misc routines */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/*
#ifndef APPLE_CC
#include <conio.h>
#endif
*/

#include "chargen.h"

void gotlawyer();
void gotbelter();
void gotnoble();
void gotsolsec();
void gotarmy();
void gotnavy();
void gotmarines();
void gotscouts();
void gotflyer();
void gotsailor();
void gotparty();
void gotcop();
void gotdoc();
void gotdiplomat();
void gotbureaucrat();
void gotscient();
void gotmerch();
void gotrogue();
void gothunter();
void gotbarbarian();
void gotpirate();
void gotleader();
void gottechy();
int reenlist(int need_nbr);
int bp_reenl(int roll, int nbr);
void spec_skl();
int anag();
void aging(int anags);
void adv_aging(int anags);
void agedex(int d);
void agestr(int s);
void ageend(int e);
void ageintl(int i);
int basic_spec_duty(int neednbr);
int basic_surv(int neednbr, int modifier, int mod_needs);
int basic_comm(int neednbr, int modifier, int mod_needs);
int basic_promo(int neednbr, int modifier, int mod_needs);
int basic_mot();
int basic_cash();
int basic_bene();
int bp_adj(int roll, int nbr);
int bp_mot(int roll);
int getche_int();
int getsel_int(int minval, int maxval);
char getche_y_n();
char getche_mot();
int specskl(int skl);
int get_bigint();
int getsel_bigint(int minval, int maxval);
void anykey();
void clrscr();
void psigame();
void psiwon(char talentname[15]);
void psilost(char talentname[15]);
void psiinst();
void bp_add(int amt);
void failed();
void disp_skill_table(char table_name[20], int skill_entries[7], int amount);
int ask_adj_asgn(int roll);
void mot_cash(int amt);
void mot_lopsg();
void mot_midpsg();
void mot_hipsg();
void mot_weapon();
void mot_nada();
void mot_ship();
void mot_tas();
void mot_forensickit();
void mot_voucher();
void mot_medkit();
void mot_handcomp();
void mot_techtool();
void mot_recorder();
void mot_letter();
void mot_watch();
void mot_equipment();

extern int d6();
extern int d12();
extern int d18();
extern void prntupp();
extern void getrank();
extern void prntskil(int end);
extern void printskill(int skill);
extern void bumpsoc();
extern void bumppsi();
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern void mc(int skl_val);
extern void bc(int skl_val);
extern void interp(int skl_val);
extern void explore(int skl_val);
extern void econ(int skl_val);
extern void psitraining();
extern void dispskil(int sequ, int skl_nbr);
extern void resolve_skill(int skillnbr, int amount);
extern void gotspcldty(int spcldutynbr);
extern void loan();

void gotlawyer()
{
	careernbr = LAWYER;
	strncpy(career,"Attorney",9);
}


void gotbelter()
{
	strncpy(career,"Belter",7);
	careernbr = BELTER;
}


void gotnoble()
{
	careernbr = NOBLE;
	strncpy(career,"Noble",6);
}


void gotsolsec()
{
	careernbr = IRIS;
	strncpy(career,"SolSec",7);
}


void gotarmy()
{
	if (race == ITHKLUR)
		strncpy(career,"Ground Support",15);
	else
		strncpy(career,"Army",5);
	careernbr = ARMY;
	if (branch != 0)
		return;
	if (med_sch > 0)
		branch = 5;
	if ((col % 10) == 1 || tech_acd > 0)
		branch = 6;
	if (flt_sch > 0)
		branch = 2;
}


void gotnavy()
{
	strncpy(career,"Navy",5);
	careernbr = NAVY;
	if (branch != 0)
		return;
	if (med_sch > 0)
		branch = 5;
	if ((col % 10) == 1 || tech_acd > 0)
		branch = 4;
	if (flt_sch > 0)
		branch = 2;
	if (race == LLAMIYA)
		branch = 4;
}


void gotmarines()
{
	if (careernbr == 0)
	{
		if (race == ITHKLUR)
			strncpy(career,"Strike Force",13);
		else
			strncpy(career,"Marines",8);
		careernbr = MARINE;
	}
	else
		alt_career = MARINE;
	if (branch != 0)
		return;
	if (med_sch > 0)
		branch = 5;
	if ((col % 10) == 1 || tech_acd > 0)
		branch = 6;
	if (flt_sch > 0)
		branch = 2;
}


void gotscouts()
{
	careernbr = SCOUT;
	if (race == ITHKLUR)
		strncpy(career,"Explorer",9);
	else
		strncpy(career,"Scouts",7);
	if ((col % 10) == 1 || tech_acd > 0)
		branch = 6;
}


void gotflyer()
{
	careernbr = FLYER;
	if (race == ITHKLUR)
		strncpy(career,"Aviator",9);
	else
		strncpy(career,"Flyer",6);
}


void gotsailor()
{
	careernbr = SAILOR;
	if (race == ITHKLUR)
		strncpy(career,"Wet Navy",9);
	else
		strncpy(career,"Sailor",7);
}


void gotparty()
{
	strncpy(career,"Party",6);
	careernbr = PARTY;
}


void gotcop()
{
	careernbr = COP;
	if (race == ITHKLUR)
		strncpy(career,"Security",9);
	else
		strncpy(career,"Police",7);
}


void gotdoc()
{
	careernbr = DOCTOR;
	if (race == ITHKLUR)
		strncpy(career,"Medicine",9);
	else
		strncpy(career,"Doctor",7);
}


void gotdiplomat()
{
    careernbr = DIPLOMAT;
    strncpy(career,"Diplomat",9);
}


void gotbureaucrat()
{
    careernbr = BUREAUCRAT;
    strncpy(career,"Bureaucrat",11);
}


void gotscient()
{
	careernbr = SCIENTIST;
	strncpy(career,"Scientist",10);
}


void gotmerch()
{
	careernbr = MERCHANT;
	if (race == ITHKLUR)
		strncpy(career,"Trader",7);
	else
		strncpy(career,"Merchant",9);
	if (med_sch > 0)
		branch = 3;
	if ((col % 10) == 1 || tech_acd > 0)
		branch = 2;
	if (flt_sch > 0)
		branch = 1;
}


void gotrogue()
{
	careernbr = ROGUE;
	if (race == ITHKLUR)
		strncpy(career,"Athlete",8);
	else
		strncpy(career,"Rogue",6);
}


void gothunter()
{
	careernbr = HUNTER;
	strncpy(career,"Hunter",7);
}


void gotbarbarian()
{
	careernbr = BARBARIAN;
	strncpy(career,"Barbarian",10);
}


void gotpirate()
{
	strncpy(career,"Pirate",7);
	careernbr = PIRATE;
}


void gotleader()
{
	strncpy(career,"Leader",7);
	careernbr = PARTY;
}


void gottechy()
{
	strncpy(career,"Technician",11);
	careernbr = TECHY;
	if (race == DROYNE)
		soc = 4;
}


int reenlist(int need_nbr)
{
	int  roll;
	char choice;

	terms++;
	printf("Term %d ends. ", terms);
    bp_add(1);
	if (race == ZHODANI && soc >= 10 && psigames == 0)
		psigame();
	if (race == IMPERIAL && pop >= POPHI && psi == 0)
		psiinst();
	if (terms == 1 && race == VILANI)
		spec_skl();
	if (terms >= 5 && race == TIRRILS)
		return 1;
	prntupp();
	if (rank != 0 || careernbr == MERCHANT)
		getrank();
	prntskil(0);
	if (str < 1 || dex < 1 || end < 1 || intl < 1)
	{
		printf("\nAn attribute has gone below 1. It is time to muster out.\n");
		return 1;
	}
	if ((totalskill > intl * 3) && (totalskill > (intl + edu)))
	{
		printf("\nYou have too many skill points (%d). It is time to start playing.\n", totalskill);
		return 1;
	}
	roll = d12();
	if (roll == 12)
	{
		printf("\nYou were forced to reenlist.\n");
		return 0;
	}
	printf("\nDo you want to reenlist for another term (need %d)? You are %d.",
		need_nbr, age);
	choice = getche_y_n();
	if (choice == 'Y' || choice == 'y')
	{
		if (roll < need_nbr && brownie_points > 0)
		{
			roll = bp_reenl(roll, need_nbr);
		}
		if (roll < need_nbr)
		{
			printf("You failed your reenlistment.\n");
			return 1;
		}
		return 0;
	}
	if (terms >= 5)
	{
		gambler = 1;    // allow pension
		printf("You have retired with a pension.\n");
	}
	else
	{
		printf("You have ended your career.\n");
	}
	return 1;
}


int bp_reenl(int roll, int nbr)
{
	if (roll >= nbr)
		return roll;
	if ((roll + brownie_points) >= nbr)
	{
		brownie_points -= (nbr - roll);
		printf("You used %d brownie points to make your reenlistment.\n", 
			(nbr - roll));
		roll = nbr;
	}
	return roll;
}


void spec_skl()
{
	int choice, i;

	printf("\nYou must now choose your career specialty.\n\n");
	i = 0;
	while (i < skillcount)
	{
		printf("   %d. ", i);
		printskill(skillcode[i]);
	    printf("\n");
		i++;
	}
	choice = getsel_bigint(0, skillcount);
	spec_skill = skillcode[choice];
	printf("You chose to specialize in ");
	printskill(spec_skill);
	printf(".\n");
}


int anag()
{
	int  roll;
	char choice;

	printf("Do you want to do anagathics this term?");
	choice = getche_y_n();
	if (choice == 'N' || choice == 'n')
		return 0;
	anagathics++;
	roll = d12();
	if (starport == 'A')
		roll += 3;
	if (starport == 'B')
		roll += 2;
	if (starport == 'C')
		roll++;
	if (tech == TLHISTEL)
		roll += 3;
	if (tech == TLAVGSTEL)
		roll += 2;
	if (tech == TLEARSTEL)
		roll++;
	if (roll >= 12)
		return 1;
	return 0;
}


void aging(int anags)
{
	if (anags == 0)
		appearent_age += 4;
	adv_aging(anags);
}

void adv_aging(int anags)	
{
	int dm, s, d, e, i;

	if (race == VEGAN || race == LLAMIYA)
		return;
	if (appearent_age < 34 || (race == TIRRILS && appearent_age < 10))
		return;
	if (appearent_age < 50)
	{
		s = e = 8;
	    d = 7;
		i = 0;
	}
	else
		if (appearent_age < 66)
		{
			s = e = 9;
			d = 8;
			i = 0;
		}
		else
			s = e = d = i = 9;
	if (race == TIRRILS)
	{
		if (appearent_age < 14)
		{
			s = 8;
			e = d = i = 0;
		}
		else
		{
			if (appearent_age < 18)
			{
				s = d = 8;
				i = e = 0;
			}
			else
			{
				s = e = d = 8;
				i = 0;
			}
		}
	}
	if (race == VILANI && blue_blood > 10)
	{
		dm = blue_blood - 10;
		if (s > 0)
			s += dm;
		if (e > 0)
			e += dm;
		if (d > 0)
			d += dm;
		if (i > 0)
			i += dm;
	}
	if (anags == 1)
	{
		if (dex > str && dex > end)
			agedex(d);
		else
		{
			if (str >= dex && str > end)
				agestr(s);
			else 
				ageend(e);
		}
		if (i > 0)
			ageintl(i);
	}
	else
	{
		agestr(s);
	    agedex(d);
		ageend(e);
		ageintl(i);
	}
}


void agedex(int d)
{
	int roll;

	roll = d12();
	if (roll >= d)
		return;
	dex--;
	if (appearent_age >= 66)
		dex--;
	return;
}


void agestr(int s)
{
	int roll;

	roll = d12();
	if (roll >= s)
		return;
	str--;
	if (appearent_age >= 66 || (race == TIRRILS && age >= 22))
		str--;
	return;
}


void ageend(int e)
{
	int roll;

	roll = d12();
	if (roll >= e)
		return;
	end--;
	if (appearent_age >= 66)
		end--;
	return;
}


void ageintl(int i)
{
	int roll;

	roll = d12();
	if (roll >= i)
		return;
	intl--;
	if (appearent_age >= 66)
		intl--;
	return;
}


int basic_spec_duty(int neednbr) // returns skills for term (1 plust any for special duty)
{
	int roll;

	roll = d12();
	if (brownie_points > 0 && roll == (neednbr - 1))
		roll = bp_adj(roll, neednbr);
	if (brownie_points > 0 && roll == (neednbr + 3))
		roll = bp_adj(roll, (neednbr + 4));
	if (roll >= neednbr)
	{
		printf("You were given special duties (rolled %d, needed a %d)!\n", roll, neednbr);
		if (roll >= (neednbr + 4))
			return 3; // 1 skill plus 2 for special duty
		return 2; // 1 skill plus 1 for special duty
	}
	return 1; // 1 skill plus 0 for special duty
}


int basic_surv(int neednbr, int modifier, int mod_needs)
{
	int roll, anaguser;

	roll = d12();
	if (mod_needs == 0)
		roll += modifier;
	else
		if (modifier >= mod_needs)
			roll += 2;
	anaguser = anag();
	if (anaguser >= 1)
		roll--;
	if (neednbr == 0)
		printf("Survival is automatic. ");
	else
		printf("Survival requires a %d, your modified roll %d. ", neednbr, roll);
	if (brownie_points > 0 && roll < neednbr)
		roll = bp_adj(roll, neednbr);
	if (roll >= neednbr)
	{
		age += 4;
		aging(anaguser);
		printf("You survived.\n");
	}
	else
	{
		age += 2;
		if (anaguser == 0)
			appearent_age += 2;
		printf("You did not survive!\n");
		return 1;
	}
	if (str <= 0 || dex <= 0 || end <= 0 || intl <= 0)
	{
		printf("You retired due to old age!\n");
		return 1;
	}
	return 0;
}


int basic_comm(int neednbr, int modifier, int mod_needs)
{
	int roll, retval;

	retval = 1;
	if (terms == 1 || neednbr == 0)
		retval++;
	if (race == LLAMIYA)
		return(retval);
	if (rankeo == 'E' && drafted == 0 && neednbr > 0)
	{
		roll = d12();
		if (modifier >= mod_needs)
			roll++;
	    printf("A commission requires a %d, your modified roll %d. ", neednbr, roll);
		if (brownie_points > 0 && roll < neednbr && (race != ZHODANI
			|| (race == ZHODANI && soc < 10)))
			roll = bp_adj(roll, neednbr);
	    if (roll >= neednbr || (race == ZHODANI && soc >= 10))
		{
			printf("You received a commission!\n");
			rankeo = 'O';
			rank = 1;
			retval++;
			if (roll >= (neednbr + 4))
				retval++;
			if (careernbr == NOBLE)
			{
				if (race == ASLAN)
					bumpsoc(); 
				else
					rank = soc - 10;
			}
			if (careernbr == MARINE && (race == VILANI || race == ASLAN))
				addskill(HANDGUN, 1);
			if (careernbr == ARMY && race == ASLAN)
				mc(1);
			if (careernbr == PIRATE && race == ASLAN)
				addskill(SHIPBOAT, 1);
			if (race == ZHODANI && careernbr == ARMY)
				addskill(SUBMG, 1);
			if (careernbr == JOURNALIST)
				addskill(INTERVIEW, 1);
		}
	}
	drafted = 0;
	return retval;
}


int basic_promo(int neednbr, int modifier, int mod_needs)
{
	int roll, retval;

	retval = 0;
	if ((rankeo == 'O' && (rank < 6 || ((careernbr <= SCOUT ||
		careernbr == MERCHANT) && rank < 10))) || (rankeo == 'E' &&
		((careernbr <= SCOUT || careernbr == MERCHANT) && rank < 10)))
	{
		if (terms < 5 && rank >= 4 && careernbr == MANAGEMENT)
		{
			;
		}
		else
		{
			roll = d12();
			if (modifier >= mod_needs)
				roll++;
			if (race == ZHODANI && careernbr < MERCHANT && soc >= 10)
				roll += 3;
			printf("A promotion requires a %d, you rolled %d.\n", neednbr, roll);
			if (brownie_points > 0 && roll < neednbr)
				roll = bp_adj(roll, neednbr);
			if (roll >= neednbr)
			{
				retval++;
				rank++;
				printf("You received a promotion to ");
				getrank();
				if (careernbr == SAILOR && rank == 2)
					addskill(LARGEBOAT, 1);
				if (careernbr == COP)
				{
					if (rank == 4)
						addskill(INTERROGATE, 1);
					if (rank == 5)
						addskill(ADMIN, 1);
					if (rank == 6)
						addskill(LIAISON, 1);
				}
				if (careernbr == BARBARIAN)
				{
					if (rank == 2)
						bc(1);
					if (rank == 5)
						addskill(LEADER, 1);
				}
				if (careernbr == JOURNALIST && rank == 5)
					addskill(ADMIN, 1);
				if (careernbr == PIRATE && race != ASLAN && rank == 4)
					addskill(PILOT, 1);
				if (careernbr == ARMY && race == VILANI && rank == 6)
					interp(1);
				if (careernbr == MARINE && race == VILANI && rank >= 5)
					bumpsoc();
				if (careernbr == NAVY && race == ASLAN && rank == 5)
					bumpsoc();
				if (careernbr == BUREAUCRAT && race == ASLAN && rank == 4)
					addskill(INTERVIEW, 1);
				if (careernbr == MERCHANT && race == ASLAN && rank == 4)
					addskill(PILOT, 1);
				if (careernbr == MERCHANT && race == VILANI)
				{
					if (rank == 3)
						explore(1);
					if (rank == 4)
						econ(1);
				}
				if (careernbr == PARTY && race == VILANI && rank == 5)
					addskill(LEADER, 1);
				if (race == ZHODANI)
				{
					if (careernbr == NAVY)
					{
						if (rank == 2)
							addskill(LEADER, 1);
						if (rank == 6)
							bumpsoc();
					}
					if (careernbr == MERCHANT)
					{
						if (rank == 3)
							addskill(ENGINEERING, 1);
						if (rank == 4)
							addskill(PILOT, 1);
					}
					if (careernbr == ZHOGOVT && rank == 4)
						bumpsoc();
				}
				if (roll >= (neednbr + 4))
					retval++;
			}
		}
	}
	return retval;
}


int basic_mot()
{
	printf("You are being mustered out.\n");
	if (anagathics >= 1)
		return 2;
	return 3;
}


int basic_cash()
{
	int roll;
  
	roll = d6();
	if (gambler != 0 || 
		((race == VILANI) && (soc > 8 || alt_career == TECHY || alt_career == TEACHER)))
		roll++;
	if (careernbr == BELTER)
	{
		if (line == 1)
			roll--;
		if (line == 3)
			roll++;
	}
	if (brownie_points > 0)
		roll = bp_mot(roll);
	return roll;
}


int basic_bene()
{
	int roll;

	roll = d6();
	if (rank >= 5  
		|| (race == VILANI && (soc > 8 || (chk_skl(HANDYMAN, 1) > 0))) 
		|| (race == ASLAN && (chk_skl(HANDYMAN, 1) > 0))) 
		roll++;
	if (brownie_points > 0)
		roll = bp_mot(roll);
	return (roll);
}


int bp_adj(int roll, int nbr)
{
	if (roll >= nbr || brownie_points < 1)
		return roll;
	if ((roll + brownie_points) >= nbr)
	{
		brownie_points -= (nbr - roll);
		printf("You used %d brownie points to keep your career going.\n",
			(nbr - roll));
		roll = nbr;
	}
	return roll;
}


int bp_mot(int roll)
{
	int nbr, max;
  
	if (race == ASLAN && sex == 1)
		max = 8;
	else
		max = 7;
	printf("You rolled a %d on the muster out tables. You have %d brownie\n",
		roll, brownie_points);
	printf("points left. How many do you want to apply to this roll?");
	nbr = getche_int();
	if (nbr < 0 || nbr > brownie_points)
	{
		printf("Wrong - try again!\n");
		return bp_mot(roll);
	}
	if ((roll + nbr) > max)
	{
		printf("It does you no good to use more than %d (%d is the max roll).\n",
			(max - roll), max);
		printf("Wrong - try again!\n");
		return bp_mot(roll);
	}
	brownie_points -= nbr;
	return (roll + nbr);
}


void bp_add(int amt)
{
	brownie_points += amt;
	printf("You gained %d brownie points. You now have %d.", amt, brownie_points);
	anykey();
}


int getche_int()
{
//#ifdef UNIX
	int ch;
//#endif
	int choice;

	printf("\n->");
	/*
#ifndef APPLE_CC
	choice = getche();
#endif
*/
//#ifdef UNIX
	while ((ch=getchar()) != '\n')
	{
		choice=ch;
	}
//#endif
	printf("\n");
	if ((iscntrl(choice)) != 0)
	{
		if (choice == 13)
			choice = '0';
		else
			if (choice == 27)
				exit(-1);
	}
	if ((isdigit(choice)) != 0)
		choice -= 48;
	else
	{
		printf("Please enter a number - try again!");
		return getche_int();
	}
	return choice;
}


int getsel_int(int minval, int maxval)
{
	int choice;

	printf("\nPlease enter your selection.");
	choice = getche_int();
	if (choice < minval || choice > maxval)
	{
		printf("Value is outside of range - try again!");
	    return getsel_int(minval, maxval);
	}
	return choice;
}


char getche_y_n()
{
//#ifdef UNIX
	int ch;
//#endif
	char choice;

	printf("\nEnter Y or N.\n->");
	/*
#ifndef APPLE_CC
	choice = getche();
#endif
*/
//#ifdef UNIX
	while ((ch=getchar()) != '\n')
	{
		choice=ch;
	}
//#endif
	printf("\n");
	if (iscntrl(choice) != 0)
	{
		if (choice == 13)
		{
			choice = 'N';
			printf("I assume that meant no\n");
		}
		else
		{
			if (choice == 27)
				exit(-1);
		}
	}
	if (choice == 'N' || choice == 'n' || choice == 'Y' || choice == 'y')
		return choice;
	printf("Please enter Y for yes or N for no - try again!");
	return getche_y_n();
}


char getche_mot()
{
//#ifdef UNIX
	int ch;
//#endif
	char choice;

	printf("Do you want to use the cash or benefits table? (c/b)\n->");
	/*
#ifndef APPLE_CC
	choice = getche();
#endif
*/
//#ifdef UNIX
	while ((ch=getchar()) != '\n') {
	choice=ch;
	}
//#endif
	printf("\n");
	if (iscntrl(choice) != 0)
	{
		if (choice == 13)
		{
			choice = 'B';
			printf("I assume that meant benefits\n");
		}
		else
			if (choice == 27)
				exit(-1);
	}
	if (choice == 'C' || choice == 'c' || choice == 'B' || choice == 'b')
		return choice;
	printf("Please enter C for cash or B for benefits - try again!");
	return getche_mot();
}


int specskl(int skl)
{
	if (skl >= 2 && spec_skill != 0)
	{
		skl -= 2;
	    addskill(spec_skill, 1);
		printf("Increasing your specialty skill. ");
	}
	return (skl);
}


int get_bigint()
{
	unsigned i;
	char choice[8];

	printf("\n->");
	fgets(choice,7,stdin);
	if (choice[strlen(choice) - 1] == '\n')
		choice[strlen(choice) - 1] = '\0';
	if (iscntrl(choice[0]) != 0)
	{
		if (choice == '\0')
		{
			choice[0] = '0';
			choice[1] = '\0';
		}
		else
			if (choice[0] == 0x1b)
				exit(-1);
	}
  /* printf("entered string %s (length %d)\n", choice, strlen(choice)); */
	for (i = 0; i < strlen(choice); i++)
	{
		if ((isdigit(choice[i])) != 0) /* printf("digit %c", choice[i]) */;
		else
		{
			if (i == 0 && choice[i] == '-') /* printf("sign %c", choice[i]) */;
			else
			{
		/* printf("neither %c", choice[i]); */
				printf("Please enter a number - try again!");
				return get_bigint();
			}
		}
	}
	i = atoi(choice);
/*  printf(" entered int %d\n", i); */
	return i;
}


int getsel_bigint(int minval, int maxval)
{
	int choice;

	printf("\nPlease enter your selection.");
	choice = get_bigint();
	if (choice < minval || choice > maxval)
	{
		printf("Value is outside of range - try again!");
		return getsel_bigint(minval, maxval);
	}
	return choice;
}


void anykey()
{
	printf("\nPress any key to continue\n");
	/*
#ifndef APPLE_CC
	getch();
#endif
*/
//#ifdef UNIX
	getchar();
//#endif
}

void clrscr()
{
	int i;
	for (i = 0; i < 24; i++)
		printf("\n");
}

int psiwins, psiloses;

void psigame()
{
	char choice;

	printf("Do you wish to participate in The Psionic Games?");
	choice = getche_y_n();
	if (choice == 'N' || choice == 'n')
		return;
	if (d18() >= psi)
	{
		printf("You did not qualify for the games.\n");
		psigames--;
		return;
	}
	psigames++;
	psiwins = psiloses = 0;
	printf("You qualified for The Psionic Games.\n");
	basic_surv(0, 0, 0);
	if (telepath > 0)
		if (d18() > psi)
			psilost("Telepathy");
		else
			psiwon("Telepathy");
	if (clair > 0)
		if (d18() > psi)
			psilost("Clairvoyance");
		else
			psiwon("Clairvoyance");
	if (telekin > 0)
		if (d18() > psi)
			psilost("Telekinesis");
		else
			psiwon("Telekinesis");
	if (aware > 0)
		if (d18() > psi)
			psilost("Awareness");
		else
			psiwon("Awareness");
	if (teleport > 0)
		if (d18() > psi)
			psilost("Teleportation");
		else
			psiwon("Teleportation");
	if (psispecial > 0)
		if (d18() > psi)
			psilost("Special");
		else
			psiwon("Special");
	if ((d12() + psiwins - psiloses) >= 12)
	{
		psiwon("Final");
		soc = 11;
		printf("Congratulations, you are now a Noble!\n");
		bumppsi();
		psigames++;
	}
	else
		psilost("Final");
	for ( ;psiwins > 0; psiwins--)
		bumppsi();
}


void psiwon(char talentname[15])
{
	printf("You won the %s competition!\n", talentname);
	psiwins++;
}


void psilost(char talentname[15])
{
	printf("You lost the %s competition.\n", talentname);
	psiloses++;
}


void psiinst()
{
	char choice;
	int roll, years;

	if (psi > 0) return;
	if (psi_interest == 0)
	{
		printf("Are you interested in Psionics?");
		choice = getche_y_n();
		if (choice == 'n' || choice == 'N')
		{
			psi_interest = 1;
			return;
		}
	}
	psi_interest = 2;
	printf("Would you like to try to find a Psionic Institute?");
	choice = getche_y_n();
	if (choice == 'n' || choice == 'N')
		return;
	roll = d12();
	if (roll < 11)
		roll = bp_adj(roll, 11);
	if (roll < 11)
	{
		printf("You failed to find a Psionic Institute.\n");
		return;
	}
	gotspcldty(PSIINST);
	psitraining();
	if (psi > 0)
	{
		roll = ((telepath + clair + telekin + aware + teleport + psispecial) * psi) + 5;
		printf("You spent %d months getting your psionic skills up to snuff.\n", roll);
		years = roll / 12;
		if ((roll % 12) > 5)
			years++;
		age += years;
		appearent_age += years;
	}
}


void failed()
{
	printf("\nYou failed your enlistment!\n");
}


void disp_skill_table(char table_name[20], int skill_entries[7], int amount)
{
	int i, roll, adjustment, min, max;
	
	roll = d6();
	if (brownie_points > 0 && pick == 1)
	{
		max = 6 - roll;
		if (max > brownie_points) max = brownie_points;
		min = 1 - roll;
		if (min < (brownie_points * -1)) min = brownie_points * -1;
		printf("Here is the %s skill table.\n", table_name);
		for (i = 0; i < 5; i++)
			dispskil((i+1), skill_entries[i]);
		printf("\nYou rolled a %d. You have %d brownie points.\n",
			roll, brownie_points);
		printf("If you want to adjust your roll enter a positive or\n");
		printf("negative number to alter the roll.\n");
		adjustment = getsel_bigint(min, max);
		roll += adjustment;
		if (adjustment < 0) adjustment = adjustment * -1;
		if (adjustment != 0)
		{
			brownie_points -= adjustment;
			printf("You used %d brownie point to get the skill you wanted.\n");
		}
	}
	resolve_skill(skill_entries[roll - 1], amount);
}


int ask_adj_asgn(int roll)
{
	int adjustment, min, max;
	char choice;
	
	printf("You rolled %d for you assignment. You have %d brownie points.\n", roll, brownie_points);
	printf("Would you like to adjust your roll?");
	choice = getche_y_n();
	if (choice == 'n' || choice == 'N')
		return roll;
	min = 2 - roll;
	if ((min * -1) > brownie_points) min = brownie_points * -1;
	max = 12 - roll;
	if (max > brownie_points) max = brownie_points;
	printf("Enter the value you wish to adjust your roll by.\n");
	adjustment = getsel_bigint(min , max);
	roll += adjustment;
	if (adjustment < 1) adjustment = adjustment * -1;
	brownie_points -= adjustment;
	printf("You used %d brownie points to adjust your assignment roll.\n", adjustment);
	return roll;
}


void mot_cash(int amt)
{
	credits += amt;
	printf("Got %d cr for %d total.\n", amt, credits);
    return;
}


void mot_lopsg()
{
	lopsg++;
	printf("Got Low Passage.\n");
    return;
}


void mot_midpsg()
{
	midpsg++;
	printf("Got Middle Passage.\n");
    return;
}


void mot_hipsg()
{
	hipsg++;
	printf("Got High Passage.\n");
    return;
}


void mot_weapon()
{
	weapons++;
	printf("Got a weapon.\n");
    return;
}


void mot_voucher()
{
	kit++;
	kitval = 0;
	printf("Got a voucher.\n");
    return;
}

void mot_nada()
{
	printf("Got nothing.\n");
    return;
}


void mot_ship()
{
	ship++;
	printf("Got a ship");
	loan();
	printf("\n");
    return;
}


void mot_tas()
{
	tas++;
	printf("Got Traveller's Aide Society membership.\n");
	return;
}


void mot_forensickit()
{
	kit++;
	kitval += 9000;
	printf("Got a forensic kit worth %d cr.\n", kitval);
}


void mot_medkit()
{
	kit++;
	kitval += 5000;
	printf("Got a medical kit worth %d cr.\n", kitval);
}


void mot_letter()
{
	kit++;
	printf("Got a Letter of Marque.\n");
}


void mot_recorder()
{
	kit++;
	kitval += 1000;
	printf("Got a recorder worth %d cr.\n", kitval);
}


void mot_handcomp()
{
	tas++;
	printf("Got a hand computer.\n");
	return;
}



void mot_techtool()
{
	kit++;
	kitval += 5000;
	printf("Got technical tools worth %d cr.\n", kitval);
}


void mot_watch()
{
	int roll;

	kit++;
	roll = d12();
	if (roll < 7)
		kitval += 50;
	else
		kitval += (d12() * 100);
	printf("Got a watch, now worth %d cr.\n", kitval);
}


void mot_equipment()
{	
	kit++;
	kitval += (d12() * 1000);
	printf("Got scientific equipment worth %d.\n", kitval);
}
