/* CGPRINT.C is part of the MEGATRAVELER (c) character generation */
/* program written by Greg Svenson. It prints out the resulting character. */

#include <stdio.h>

#include "chargen.h"

int printskill(int s);
void dropskil(int maxskillpoints);
void prntskil(int end);
void getrank();
void prntchar();
void loan();
void disp_special_duty();

extern void printhim();
extern void getrankp();
extern int getsel_bigint(int min, int max);
extern char getche_y_n();
extern int prtfinalspcldty(int spcldutynbr, int count);

void prntchar()
{
	printhim();
	if (brownie_points > 0) printf("Remaining BP: %d\n", brownie_points);
}
   

void getrank()
{
	getrankp();
	printf("\n");
}
   

void prntskil(int end)
{
	int s, sc, maxskillpoints;
	char choice;
  
	if (race == DROYNE)
		maxskillpoints = intl * 3;
	else
		maxskillpoints = intl + edu;
	sc = s = 0;
	totalskill = 0;
	if ((race == ZHODANI && soc >= 10) || (race != ZHODANI && psi > 0))
	{
		printf("Psi - %d, ", psi);
		s++;
	}
	else
		if (psi > 0)
		{
			printf("(Psi - %d), ", psi);
			s++;
		}
	while (sc < skillcount) 
	{
		printskill(skillcode[sc]);
		printf(" - %d, ", skillrating[sc]);
		if ((s % 4) == 3)
			printf("\n");
		if (skillcode[sc] < ADDSTR)
			totalskill += skillrating[sc];
		s++;
		sc++;
	}
	if (end < 2)
		printf("\nYou currently have %d skills. Your characters maximum is %d skills.\n",
			totalskill, maxskillpoints);
	if (end == 1 && totalskill > maxskillpoints)
	{
		printf("You must reduce your total skills by %d.\n", (totalskill - maxskillpoints));
		printf("\nDo you want to use the Maximum Skills rule (intelligence + education)?");
		choice = getche_y_n();
		if (choice == 'N' || choice == 'n')
			return;
		dropskil(maxskillpoints);
	}
}


void dropskil(int maxskillpoints)
{
	int choice, i, column;

	while (totalskill > maxskillpoints)
	{
		printf("Which skill do you wish to lower? (%d to go)\n", totalskill - maxskillpoints);
		i = 0;
		while (i < skillcount)
		{
			if (skillcode[i] < ADDSTR)
			{
				if (skillcount > 18)
				{
					if ((i % 2) == 0)
					{
						printf("   %d. ", i);
						if (i > 9) column = 11;
						else column = 10;
						column += printskill(skillcode[i]);
						printf(" - %d", skillrating[i]);
						if (skillrating[i] > 9) column++;
						while (column < 35)
						{
							column++;
							printf(" ");
						}
					}
					else
					{
						printf("   %d. ", i);
						printskill(skillcode[i]);
						printf(" - %d\n", skillrating[i]);
					}
				}
				else
				{
					printf("   %d. ", i);
					printskill(skillcode[i]);
					printf(" - %d\n", skillrating[i]);
				}
			}
			i++;
		}
		choice = getsel_bigint(0, skillcount);
		if (skillrating[choice] > 0)
		{
			printskill(skillcode[choice]);
			printf(" dropped by one.\n");
			skillrating[choice]--;
			totalskill--;
		}
		else
			printf("Wrong - you must pick from the skills that are not already zero.\n");
	}
}


int printskill(int s)
{
  int size;

  size = 0;
  switch (s)
  {
    case  ADMIN: printf("Admin"); size = 5; break;
    case  ADVCMBTRIFL: printf("Adv Cmbt Rifle"); size = 14; break;
    case  ARTISAN: printf("Artisan"); size = 7; break;
    case  ASSULTRIFL: printf("Assult Rifle"); size = 12; break;
    case  ATV: printf("ATV"); size = 3; break;
    case  AUTOCANNON: printf("Auto Cannon"); size = 11; break;
    case  AUTORIFL: printf("Auto Rifle"); size = 10; break;
    case  AXE: printf("Axe"); size = 3; break;
    case  BATTLEAX: printf("Battle Axe"); size = 10; break;
    case  BATTLEDRESS: printf("Battle Dress"); size = 10; break;
    case  BAYONET: printf("Bayonet"); size = 7; break;
    case  BIOLOGY: printf("Biology"); size = 7; break;
    case  BLADE: printf("Blade"); size = 5; break;
    case  BLOWGUN: printf("Blowgun"); size = 7; break;
    case  BODYPISTL: printf("Body Pistol"); size = 11; break;
    case  BOLA: printf("Bola"); size = 4; break;
    case  BOOMERANG: printf("Boomerang"); size = 9; break;
    case  BOW: printf("Bow"); size = 3; break;
    case  BRAWLING:
		{
		    if (race == ASLAN)
			{
				printf("Personal Weap");
				size = 13;
			}
		    else
				if (race == VARGR)
				{
					printf("Infighting");
					size = 10;
				}
			    else
					if (race == KKREE)
					{
						printf("Close Combat");
						size = 12;
					}
					else
						if (careernbr == IRIS)
						{
							printf("Martial Arts");
							size = 12;
						}
					    else
							if (race == DROYNE)
							{
								printf("Unarmed Combat");
								size = 14;
							}
							else
								if (race == DOLPHINS)
								{
									printf("Underwater Cmbt");
									size = 15;
								}
							    else
								{
									printf("Brawling");
									size = 8;
								}
		    break;
  		}
	case  BRIBERY: printf("Bribery"); size = 7; break;
    case  BROADSWORD: printf("Broad Sword"); size = 11; break;
    case  BROKER: printf("Broker"); size = 6; break;
    case  CARBINE: printf("Carbine"); size = 7; break;
    case  CAROUSING: printf("Carousing"); size = 9; break;
    case  CHEMISTRY: printf("Chemistry"); size = 9; break;
    case  CMBTENGR: printf("Cmbt Engineer"); size = 13; break; 
    case  CMBTRIFLMAN: printf("Cmbt Rifleman"); size = 13; break;
    case  COMMO: printf("Commo"); size = 5; break;
    case  COMPUTER: printf("Computer"); size = 8; break;
    case  CROSSBW: printf("Crossbow"); size = 8; break;
    case  CUDGEL: printf("Cudgel"); size = 6; break;
    case  CUTLASS: printf("Cutlass"); size = 7; break;
    case  DAGGER: printf("Dagger"); size = 6; break;
    case  DEMOLITIONS: printf("Demolitions"); size = 11; break;
    case  DISGUISE: printf("Disguise"); size = 9; break;
    case  EARLYFIREARMS: printf("Early Firearms"); size = 14; break;
    case  ELECTRONICS: printf("Electronics"); size = 11; break;
    case  ENERGYWEAP: printf("Energy Weap"); size = 11; break;
    case  ENGINEERING: printf("Engineering"); size = 11; break;
    case  EQUESTRIAN: printf("Equestrian"); size = 10; break;
    case  FLEETTAC: printf("Fleet Tactics"); size = 13; break;
    case  FOIL: printf("Foil"); size = 4; break;
    case  FORENSIC: printf("Forensics"); size = 9; break;
    case  FORGERY: printf("Forgery"); size = 7; break;
    case  FORWARDOBS: printf("Forward Obs"); size = 11; break;
    case  FUSIONGUN: printf("Fusion Gun"); size = 10; break;
    case  GAMBLING: printf("Gambling"); size = 8; break;
    case  GAUSSRIFL: printf("Gauss Rifle"); size = 11; break;
    case  GENETICS: printf("Genetics"); size = 8; break;
    case  GRAVBELT:
		{
			if (race == HHKAR)
			{
				printf("Magnetic Belt");
				size = 13; 
			}
			else
			{
				printf("Grav Belt");
				size = 9; 
			}
			break;
		}
    case  GRAVVHCL:
		{
			if (race == HHKAR)
			{
				printf("Magnetic Vehicle");
				size = 16;
			}
			else
			{
				printf("Grav Vehicle");
				size = 12;
			}
			break;
		}
    case  GRAVITICS:
		{
			if (race == HHKAR)
			{
				printf("Magnetics");
				size = 9; 
			}
			else
			{
				printf("Gravitics");
				size = 9;
			}
			break;
		}
    case  GRENLAUNCHER: printf("Gren Launcher"); size = 13; break;
    case  GUARDBEAST: printf("Guard/Hunt Beast"); size = 16; break;
    case  HALBERD: printf("Halberd"); size = 7; break;
    case  HANDAX: printf("Hand Axe"); size = 8; break;
    case  HANDGUN: printf("Handgun"); size = 7; break;
    case  HEAVYWEAP: printf("Heavy Weap"); size = 10; break;
    case  HELICOPTER: printf("Helicopter"); size = 10; break;
    case  HERDING: printf("Herding"); size = 7; break;
    case  HIENERGYWEAP: printf("High Energy Weap"); size = 16; break;
    case  HIGHG: printf("High-G"); size = 6; break;
    case  HISTORY: printf("History"); size = 7; break;
    case  HOVERCRAFT: printf("Hovercraft"); size = 10; break;
    case  HUNTING: printf("Hunting"); size = 7; break;
    case  INSTRUCTION: printf("Instruction"); size = 11; break;
    case  INTERROGATE: printf("Interrogation"); size = 13; break;
    case  INTERVIEW: printf("Interview"); size = 9; break;
    case  INTRUSION: printf("Intrusion"); size = 9; break;
    case  HANDYMAN: printf("Jack-o-Trades"); size = 13; break;
    case  JETAIR: printf("Jet Aircraft"); size = 12; break;
    case  LARGEBLAD: printf("Long Blade"); size = 10; break;
    case  LARGEBOAT: printf("Large Boat"); size = 10; break;
    case  LASERPISTL: printf("Laser Pistol"); size = 12; break;
    case  LASERRIFL: printf("Laser Rifle"); size = 11; break;
    case  LASERWEAP: printf("Laser Weap"); size = 10; break;
    case  LEADER: printf("Leadership"); size = 10; break;
    case  LEGAL: printf("Legal"); size = 5; break;
    case  LIAISON: printf("Liaison"); size = 7; break;
    case  LTASSULTGUN: printf("Lt Assult Gun"); size = 13; break;
    case  BALLOONS: printf("Lighter than Air"); size = 15; break;
    case  LINGUISTICS: printf("Linguistics"); size = 11; break;
    case  MACHINEGUN: printf("Machinegun"); size = 10; break;
    case  MASSDRIVER: printf("Mass Drivers"); size = 12; break;
    case  MECHANICAL: printf("Mechanical"); size = 10; break;
    case  MEDICAL: printf("Medical"); size = 7; break;
    case  MESONGUN: printf("Meson Gun"); size = 9; break;
    case  MORTARHOW: printf("Mortars/Howitzers"); size = 17; break;
    case  NAVALARCH: printf("Naval Architect"); size = 15; break;
    case  NAVIGATION: printf("Navigation"); size = 10; break;
    case  NEURALPISTL: printf("Neural Pistol"); size = 13; break;
    case  NEURALRIFL: printf("Neural Rifle"); size = 12; break;
    case  NEURALWEAP: printf("Neural Weap"); size = 11; break;
    case  PERSUASION:
		{
			if (race == DROYNE)
			{
				printf("Appeal");
				size = 6;
			}
			else
			{
				printf("Persuasion");
				size = 10;
			}
			break;
		}
    case  PHYSICS: printf("Physics"); size = 7; break;
    case  PIKE: printf("Pike"); size = 4; break;
    case  PILOT: printf("Pilot"); size = 5; break;
    case  PISTOL: printf("Pistol"); size = 6; break;
    case  PLASMAGUN: printf("Plasma Gun"); size = 10; break;
    case  POLEARM: printf("Polearm"); size = 7; break;
    case  PROPAIR: printf("Prop Aircraft"); size = 13; break;
    case  PROSPECTING: printf("Prospecting"); size = 11; break;
    case  RECON: printf("Recon"); size = 5; break;
    case  RECRUITING: printf("Recruiting"); size = 10; break;
    case  REVOLVER: printf("Revolver"); size = 8; break;
    case  RIFLE: printf("Rifle"); size = 5; break;
    case  RIFLMAN: printf("Rifleman"); size = 8; break;
    case  ROBOTOPS: printf("Robot Ops"); size = 9; break;
    case  ROBOTICS: printf("Robotics"); size = 8; break;
    case  SENSOROPS: printf("Sensor Ops"); size = 10; break;
    case  SCREENS: printf("Screens"); size = 7; break;
    case  SHIPTAC: printf("Ship Tactics"); size = 12; break;
    case  SHIPBOAT: printf("Ships Boat"); size = 10; break;
    case  SLING: printf("Sling"); size = 5; break;
    case  SMALLBLAD: printf("Small Blade"); size = 11; break;
    case  SMALLBOAT: printf("Small Boat"); size = 10; break;
    case  SNUBPISTL: printf("Snub Pistol"); size = 11; break;
    case  SPEAR: printf("Spear"); size = 5; break;
    case  SPINALWEAP: printf("Spinal Weap"); size = 11; break;
    case  STEALTH: printf("Stealth"); size = 7; break;
    case  STEWARD: printf("Steward"); size = 7; break;
    case  STREETWISE: printf("Streetwise"); size = 10; break;
    case  SUBMG: printf("SubMG"); size = 5; break;
    case  SURVEY: printf("Survey"); size = 6; break;
    case  SURVIVAL: printf("Survival"); size = 8; break;
    case  SWORD: printf("Sword"); size = 5; break;
    case  TACTICS: printf("Tactics"); size = 7; break;
    case  TRADER: printf("Trader"); size = 6; break;
    case  TRACKEDVHCL: printf("Tracked Vehicle"); size = 15; break;
    case  TURRETWEAP: printf("Turret Weap"); size = 11; break;
    case  VACCSUIT:
		{
			if (race == DOLPHINS)
			{
				printf("Tee Suit");
				size = 8;
			}
			else
			{
				printf("Vacc Suit");
				size = 9; 
			}
			break;
		}
    case  VFRGAUSSGUN: printf("VFR Gauss Gun"); size = 13; break;
    case  WHEELEDVHCL: printf("Wheeled Vehicle"); size = 15; break;
    case  NOGRAV: printf("Zero-G"); size = 6; break;
    case  ARCHAEOLOGY: printf("Archaeology"); size = 11; break;
    case  ASTRONOMY: printf("Astronomy"); size = 9; break;
    case  CRYONICS: printf("Cryonics"); size = 8; break;
    case  MATH: printf("Mathematics"); size = 11; break;
    case  METEOROLOGY: printf("Meteorology"); size = 11; break;
    case  SOPHONTOLOGY: printf("Sophontology"); size = 12; break;
    case  PSYCHOLOGY: printf("Psychology"); size = 10; break;
    case  SOCIOLOGY: printf("Sociology"); size = 9; break;
    case  THEOLOGY: printf("Theology"); size = 8; break;
    case  GEOLOGY: printf("Geology"); size = 7; break;
    case  DEWCLAW: printf("Dewclaw"); size = 7; break;
    case  INDEPENDENCE: printf("Independence"); size = 12; break;
    case  MEDITATION: printf("Meditation"); size = 10; break;
    case  TOLERANCE: printf("Tolerance"); size = 9; break;
    case  TRADITION: printf("Tradition"); size = 9; break;
    case  FALCONRY: printf("Falconry"); size = 8; break;
    case  SUBMARINE: printf("Submarine"); size = 9; break;
    case  SCROUNGE: printf("Scrounge"); size = 8; break;
    case  ENCLOSURE: printf("Enclosure"); size = 9; break;
    case  DIVERSION: printf("Diversion"); size = 9; break;
    case  FLYING: printf("Flying"); size = 6; break;
    case  PREDICTION: printf("Prediction"); size = 10; break;
    case  MANIPULATION: printf("Manipulation"); size = 12; break;
    case  SIGNLANG: printf("Sign Language"); size = 13; break;
    case  TRANSLATOR: printf("Translator"); size = 10; break;
    case  ORDNANCE: printf("Ordnance"); size = 8; break;
    case  MAINTENANCE: printf("Maintenance"); size = 11; break;
    case  WALDOOPS: printf("Waldo Ops"); size = 9; break;
    case  RESEARCH: printf("Research"); size = 8; break;
    case  PERCEPTION: printf("Perception"); size = 10; break;
    case  CONCEALMENT: printf("Concealment"); size = 11; break;
	case  ACTING: printf("Acting"); size = 6; break;
	case  ARTS: printf("Paint/Sculpture"); size = 15; break;
	case  DANCE: printf("Dance"); size = 5; break;
	case  MUSIC: printf("Music"); size = 5; break;
	case  SONG: printf("Song"); size = 4; break;
	case  NVCOMM: printf("Non-Verbal Comm"); size = 15; break;
	case  PSIONICS: printf("Psionics"); size = 8; break;
	case  SWIMMING: printf("Swimming"); size = 8; break;
	case  FARMING: printf("Farming"); size = 7; break;
    case  TELEPATHY: printf("Telepathy"); size = 9; break;
    case  CLAIRVOYANCE: printf("Clairvoyance"); size = 12; break;
    case  TELEKINESIS: printf("Telekinesis"); size = 11; break;
    case  AWARENESS: printf("Awareness"); size = 9; break;
    case  TELEPORTATION: printf("Teleportation"); size = 13; break;
    case  INVISIBILITY: printf("Invisibility"); size = 12; break;
    case  TRAIN: printf("Train"); size = 5; break;
    case  HOME: printf("Home"); size = 4; break;
    case  LINK: printf("Link"); size = 4; break;
    case  INWARDEYE: printf("Inward Eye"); size = 10; break;
    case  REJUVENATION: printf("Rejuvenation"); size = 12; break;
	case  PSISPCL: printf("Special Psi"); size = 11; break;
    case  ACADEMIC: printf("Academic*"); size = 9; break;
    case  AIRCRAFT: printf("Aircraft*"); size = 9; break;
    case  ANIMALS: printf("Animals*"); size = 8; break;
    case  ARCHAICWEAP: printf("Archaic Weapons*"); size = 16; break;
    case  BLADCMBT: printf("Blade Combat*"); size = 13; break;
    case  ECONOMIC: printf("Economic*"); size = 9; break;
    case  ENVIRON: printf("Environ*"); size = 8; break;
    case  EXPLORATORY: printf("Exploratory*"); size = 12; break;
    case  FAGUNNERY: printf("FA Gunnery*"); size = 11; break;
    case  GUNCMBT: printf("Gun Cmbt*"); size = 9; break;
    case  GUNNERY: printf("Gunnery*"); size = 8; break;
    case  HANDCMBT: printf("Hand Cmbt*"); size = 10; break;
    case  INBORN: printf("Inborn*"); size = 7; break;
    case  INTERPERS: printf("Interpers*"); size = 10; break;
    case  MENTAL: printf("Mental*"); size = 7; break;
    case  PHYSICAL: printf("Physical*"); size = 9; break;
    case  SCIENCE: printf("Science*"); size = 8; break;
    case  SPACE: printf("Space*"); size = 6; break;
    case  SPACCMBT: printf("Space Cmbt*"); size = 11; break;
    case  SPACTECH: printf("Space Tech*"); size = 11; break;
    case  SPCLCMBT: printf("Special Cmbt*"); size = 13; break;
    case  TECHNICAL: printf("Technical*"); size = 10; break;
    case  VEHICLE: printf("Vehicle*"); size = 8; break;
    case  VICE: printf("Vice*"); size = 5; break;
    case  MIXED_CMBT: printf("Mixed Cmbt*"); size = 11; break;
    case  MIL_MED: printf("Military Medicine*"); size = 18; break;
    case  SCRNTECH: printf("Screen Tech*"); size = 12; break;
    case  WEAPTECH: printf("Weapons Tech*"); size = 13; break;
    case  BOATS: printf("Boats*"); size = 6; break;
    case  CMBTSUPT: printf("Combat Support*"); size = 15; break;
    case  INFLUENCE: printf("Influence*"); size = 10; break;
    case  INFILTRATION: printf("Infiltration*"); size = 13; break;
    case  INVESTIGATION: printf("Investigation*"); size = 14; break;
    case  PERSONALCMBT: printf("Personal Combat*"); size = 16; break;
    case  SPACVHCL: printf("Space Vehicle*"); size = 14; break;
    case  ARTSY: printf("Arts*"); size = 5; break;
    case  ARTILLERY: printf("Artillery*"); size = 10; break;
    case  ADDSTR: printf("Add 1 to Str"); size = 12; break;
    case  ADDDEX: printf("Add 1 to Dex"); size = 12; break;
    case  ADDEND: printf("Add 1 to Con"); size = 12; break;
    case  ADDINT: printf("Add 1 to Int"); size = 12; break;
    case  ADDEDU: printf("Add 1 to Edu"); size = 12; break;
    case  ADDSOC: printf("Add 1 to Soc"); size = 12; break;
    case  ADDPSI: printf("Add 1 to Psi"); size = 12; break;
    default: printf("Unknown(%d)", s); size = 11; break;
  }
  return size;
}


void loan()
{
	printf(" (");
	switch (ship)
	{
		case 0: printf("no"); break;
	    case 1: printf("40"); break;
		case 2: printf("30"); break;
	    case 3: printf("20"); break;
		case 4: printf("10"); break;
		default: printf("paid off"); break;
	}
	if (ship <= 4)
		printf(" year loan");
	printf("), ");
}


void disp_special_duty()
{
	int i, cnt;

	printf("\nSpecial Duty: ");
	cnt = 1;
	for (i = 1; i < 45; i++)
	{
		cnt += prtfinalspcldty(i, special_duty[i]);
		if (cnt >= 4)
		{
			printf("\n");
			cnt = 0;
		}
	}
}