/* CGSci.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void sci_branch(int branch_nbr);
void sci_duty();
int hard_mos();
int life_mos();
int appl_mos();
int soc_mos();
int sci_do_year();
void discovery(int adjust);
int sci_asgn();
void sci_gen_skl();
void sci_duty_tbl();
void sci_pick_tbl();
void sci_life();
void interd_tbl();
void hostile_tbl();
void lab_tbl();
void admin_tbl();
void field_tbl();
void black_tbl();
void psi_ins_tbl();
void soc_sci();
void hard_sci();
void appl_sci();
void life_sci();

extern int anag();
extern int survive(int roll, int adjust);
extern int bp_decor(int roll, int adjust);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d3();
extern int d6();
extern int d7();
extern int d8();
extern int d9();
extern int d12();
extern int d12plus();
extern int nv_adj();
extern int bp_skill(int roll);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern void altcareertbl();
extern int getsel_int(int min, int max);
extern void bumpdex();
extern void bumpend();
extern void bumpsoc();
extern void bumpedu();
extern void bumpstr();
extern void bumpintl();
extern void weapt(int skl_val);
extern void scrnt(int skl_val);
extern void vhcl(int skl_val);
extern void gc(int skl_val);
extern void psitraining();
extern void zhopsiedu();
extern void bp_add(int amt);
extern void gotspcldty(int spcldutynbr);
extern int ask_adj_asgn(int roll);

#include "chargen.h"

int  sci_anag, duty;

void sci_branch(int branch_nbr)
{
  switch (branch_nbr)
  {
    case 1: strncpy(office,"University", 11); break;
    case 2: strncpy(office,"Government", 11); break; 
    case 3: strncpy(office,"Private", 8); break; 
    case 4: strncpy(office,"Corporate", 10); break; 
    case 5: strncpy(office,"Interdiction Probe", 18); break; 
    case 6: strncpy(office,"Black Program", 14); break; 
    case 7: strncpy(office,"Research Station", 17); break; 
    case 8: strncpy(office,"Hostile Environs", 17); break; 
    case 9: strncpy(office,"Grant", 6); break;
    case 10: strncpy(office,"Psionics Institute", 19); break;
    default: strncpy(office,"unemployed", 11); break;
  }
}


void sci_duty()
{
  switch (duty)
  {
    case 1: strncpy(disp_duty,"Laboratory", 11); break;
    case 2: strncpy(disp_duty,"Administration", 15); break; 
    case 3: strncpy(disp_duty,"Field", 6); break; 
    default: strncpy(disp_duty,"No", 3); break;
  }
  printf("You got %s duty. ", disp_duty);
}


int hard_mos()
{
  int qual;

  qual = chk_skl(ASTRONOMY, 1);
  if (qual == 0) qual = chk_skl(CHEMISTRY, 1);
  if (qual == 0) qual = chk_skl(GEOLOGY, 1);
  if (qual == 0) qual = chk_skl(MATH, 1);
  if (qual == 0) qual = chk_skl(PHYSICS, 1);
  if (qual == 0) qual = chk_skl(METEOROLOGY, 1);
  if (qual != 0) return 1;
  return 0;
}


int life_mos()
{
  int qual;

  qual = chk_skl(SOPHONTOLOGY, 1);
  if (qual == 0) qual = chk_skl(GENETICS, 1);
  if (qual == 0) qual = chk_skl(BIOLOGY, 1);
  if (qual == 0) qual = chk_skl(CRYONICS, 1);
  if (qual == 0) qual = chk_skl(MEDICAL, 1);
  if (qual != 0) return 1;
  return 0;
}


int soc_mos()
{
  int qual;

  qual = chk_skl(ARCHAEOLOGY, 1);
  if (qual == 0) qual = chk_skl(LINGUISTICS, 1);
  if (qual == 0) qual = chk_skl(HISTORY, 1);
  if (qual == 0) qual = chk_skl(PSYCHOLOGY, 1);
  if (qual == 0) qual = chk_skl(SOCIOLOGY, 1);
  if (qual == 0) qual = chk_skl(THEOLOGY, 1);
  if (qual != 0) return 1;
  return 0;
}


int appl_mos()
{
  int qual;

  qual = chk_skl(ELECTRONICS, 1);
  if (qual == 0) qual = chk_skl(COMPUTER, 1);
  if (qual == 0) qual = chk_skl(ENGINEERING, 1);
  if (qual == 0) qual = chk_skl(GRAVITICS, 1);
  if (qual == 0) qual = chk_skl(MECHANICAL, 1);
  if (qual == 0) qual = chk_skl(ROBOTICS, 1);
  if (qual == 0) qual = chk_skl(COMMO, 1);
  if (qual != 0) return 1;
  return 0;
}


int sci_do_year()
{
	int   adjust, roll;
  
	age++;
	if (sci_anag == 0)
		appearent_age++;
	assignment = sci_asgn();
	sci_branch(assignment);
	if (surv > 0 && intl >= 10)
		surv--;
	adjust = nv_adj();
	discovery(adjust);
	if (skil > 0)
	{
		roll = d12();
	    if (roll < skil)
			roll = bp_skill(roll);
		if (roll >= (skil + 4))
			if (spec_skill != 0)
			{
				printf("Increasing your specialty skill. ");
				addskill(spec_skill, 1);
			}
			else
			{
				sci_gen_skl();
				sci_gen_skl();
			}
		else
			if (roll >= skil)
				sci_gen_skl();
	}
	roll = d12();
	return survive(roll, adjust);
}


void discovery(int adjust)
{
	int roll;

	if (decor == 0)
		return;
	roll = d12();
	if (adjust != 0)
		roll -= adjust;
	if (col <= 0)
		roll -= 2;
	if (roll < (decor + 5))
		roll = bp_decor(roll, 5);
	if (roll >= (decor + 5))
	{
		seh++;
		printf("You made a breakthrough discovery!\n");
		bp_add(3);
	}
	else
	{
		if (roll < (decor + 3))
			roll = bp_decor(roll, 3);
		if (roll >= (decor + 3))
		{
			mcg++;
			printf("You made a major discovery!\n");
			bp_add(2);
		}
		else
		{
			if (roll < decor)
				roll = bp_decor(roll, 0);
			if (roll >= decor)
			{  
				mcuf++;
				printf("You made a minor discovery\n");
				bp_add(1);
			}
		}
	}
}


int sci_asgn()
{
  int roll;

  roll = d6();
  if (roll > 3 && assignment > 0 && assignment < 5)
  {
    printf("You were allowed to repeat your last assignment (%s - %s).\n", office, disp_duty);
    return assignment;
  }
  duty = 0;
  roll = d12();
  if (pick <= 2 && brownie_points > 0)
	  roll = ask_adj_asgn(roll);
  else
  {
	  if (brownie_points > 3)
	  {
		  if (roll == 3 || roll == 10)
		  {
		    roll++;
		    brownie_points--;
		    printf("You used 1 brownie point to get a better job.\n");
		  }
		  if (roll == 2)
		  {
		    roll += 2;
		    brownie_points -= 2;
		    printf("You used 2 brownie points to get a job.\n");
		  }
	  }
  }
  if (roll <= 3)
  {
	sci_duty();
    printf("You were unemployed this year.\n");
    skil = 0;
    decor = 0;
    surv = 0;
    return 0;
  }
  duty = d3();
  sci_duty();
  if (roll <= 10)
    printf("You were employed ");
  if (roll == 4 || roll == 10)
  {
    printf("at a University.\n");
    switch (duty)
	{
      case 1: skil = 9; surv = 3; decor = 7; break;
      case 2: skil = 8; surv = 0; decor = 0; break;
      case 3: skil = 7; surv = 4; decor = 8; break;
    }
    return 1;
  }
  if (roll == 5 || roll == 9)
  {
    printf("by the Government.\n");
    switch (duty)
	{
      case 1: skil = 9; surv = 3; decor = 7; break;
      case 2: skil = 8; surv = 0; decor = 0; break;
      case 3: skil = 7; surv = 4; decor = 8; break;
    }
    return 2;
  }
  if (roll == 6 || roll == 8)
  {
    printf("Privately.\n");
    switch (duty)
	{
      case 1: skil = 7; surv = 4; decor = 8; break;
      case 2: skil = 8; surv = 0; decor = 0; break;
      case 3: skil = 7; surv = 4; decor = 8; break;
    }
    return 3;
  }
  if (roll == 7)
  {
    printf("by a Corporation.\n");
    switch (duty)
	{
      case 1: skil = 7; surv = 4; decor = 8; break;
      case 2: skil = 8; surv = 0; decor = 0; break;
      case 3: skil = 7; surv = 4; decor = 9; break;
    }
    return 4;
  }
  roll = d6();
  if (roll == 1)
  {
    gotspcldty(PSIINST);
    switch (duty)
	{
      case 1: skil = 7; surv = 4; decor = 8; break;
      case 2: skil = 8; surv = 0; decor = 0; break;
      case 3: skil = 7; surv = 5; decor = 7; break;
    }
    return 10;
  }
  if (roll == 2)
  {
    gotspcldty(INTERDICTIONPROBE);
    switch (duty)
	{
      case 1: skil = 6; surv = 5; decor = 8; break;
      case 2: skil = 7; surv = 3; decor = 0; break;
      case 3: skil = 6; surv = 5; decor = 8; break;
    }
    return 5;
  }
  if (roll == 3)
  {
    gotspcldty(BLACKPROGRAM);
    switch (duty)
	{
      case 1: skil = 7; surv = 4; decor = 7; break;
      case 2: skil = 8; surv = 0; decor = 0; break;
      case 3: skil = 7; surv = 4; decor = 7; break;
    }
    return 6;
  }
  if (roll == 4)
  {
    gotspcldty(RESEARCHSTN);
    bumpsoc();
    switch (duty)
	{
      case 1: skil = 7; surv = 5; decor = 6; break;
      case 2: skil = 8; surv = 3; decor = 0; break;
      case 3: skil = 7; surv = 5; decor = 6; break;
    }
    return 7;
  }
  if (roll == 5)
  {
    gotspcldty(HOSTILEENV);
    switch (duty)
	{
      case 1: skil = 7; surv = 5; decor = 7; break;
      case 2: skil = 8; surv = 3; decor = 0; break;
      case 3: skil = 7; surv = 5; decor = 7; break;
    }
    return 8;
  }
  gotspcldty(GRANT);
  skil = 9;
  decor = 8;
  surv = 3;
  return 9;
}


void sci_gen_skl()
{
  int roll, gotone;

  gotone = 0;
  if (careernbr == IRIS)
  {
    duty = d3();
    assignment = d9();
  }
  if (pick <= 2)
  {
    sci_pick_tbl();
    return;
  }
  while (gotone == 0)
  {
    roll = d9();
	if (roll == 9) roll = 7;
	if (roll == 8)
	{
		if (alt_career == 0)
			roll = 7;
	}
    if (roll == 1)
	{
      sci_life();
      gotone = 1;
    }
    if (roll == 2 && duty != 0)
	{
      sci_duty_tbl();
      gotone = 1;
    }
    if (roll == 3 && hard_mos() > 0)
	{
      hard_sci();
      gotone = 1;
    }
    if (roll == 4 && life_mos() > 0)
	{
      life_sci();
      gotone = 1;
    }
    if (roll == 5 && soc_mos() > 0)
	{
      soc_sci();
      gotone = 1;
    }
    if (roll == 6 && appl_mos() > 0)
	{
      appl_sci();
      gotone = 1;
    }
    if (roll == 7 && assignment == 5)
	{
      interd_tbl();
      gotone = 1;
    }
    if (roll == 7 && assignment == 6)
	{
      black_tbl();
      gotone = 1;
    }
    if (roll == 7 && assignment == 8)
	{
      hostile_tbl();
      gotone = 1;
    }
    if (roll == 7 && assignment == 10)
	{
      psi_ins_tbl();
      gotone = 1;
    }
    if (roll == 8)
	{
      altcareertbl();
      gotone = 1;
    }
  }
}


void sci_duty_tbl()
{
  if (duty == 1) lab_tbl();
  else
	  if (duty == 2) admin_tbl();
	  else field_tbl();
}


void sci_pick_tbl()
{
  int choice, max;

  max = 2;
  printf("\nPlease select the table you wish to use for your new skill.\n");
  printf("\n   1. scientists life\n");   
  if (duty > 0)
  {
    printf("   2. The table for %s\n", disp_duty); 
  }
  if (hard_mos() > 0)
  {
	  printf("   3. hard science\n");
	  max = 3;
  }
  if (life_mos() > 0)
  {
	  printf("   4. life science\n");
	  max = 4;
  }
  if (soc_mos() > 0)
  {
	  printf("   5. social science\n");
	  max = 5;
  }
  if (appl_mos() > 0)
  {
	  printf("   6. applied science\n");
	  max = 6;
  }
  if (assignment == 5)
  {
	  printf("   7. interdiction table\n");
	  max = 7;
  }
  if (assignment == 6)
  {
	  printf("   7. black program table\n");
	  max = 7;
  }
  if (assignment == 8)
  {
	  printf("   7. hostile environment table\n");
	  max = 7;
  }
  if (assignment == 10)
  {
	  printf("   7. Psi Institute table\n");
	  max = 7;
  }
  if (alt_career == LANDGUARD)
  {
	  printf("   8. home guard army table\n");
	  max = 8;
  }
  if (alt_career == SPACEGUARD)
  {
	  printf("   8. home guard navy table\n");
	  max = 8;
  }
  if (race == ZHODANI && soc >= 10)
  {
	  printf("   8. Noble/Intendent education\n");
	  max = 8;
  }
  choice = getsel_int(1, max);
  if ((hard_mos() == 0 && choice == 3) ||
    (life_mos() == 0 && choice == 4) ||
    (soc_mos() == 0 && choice == 5) ||
    (appl_mos() == 0 && choice == 6) ||
    ((assignment < 5 || assignment == 7 || assignment == 9) && choice == 7))
  {
      printf("Wrong - try again!\n");
      sci_pick_tbl();
      return;
  }
  switch (choice)
  {
    case 1: sci_life(); break;
    case 2: sci_duty_tbl(); break;
    case 3: hard_sci(); break;
    case 4: life_sci(); break;
    case 5: soc_sci(); break;
    case 6: appl_sci(); break;
    case 7:
		{
	      if (assignment == 5) interd_tbl();
		  if (assignment == 6) black_tbl();
		  if (assignment == 8) hostile_tbl();
		  if (assignment == 10) psi_ins_tbl();
	    }
		  break;
    case 8: 
		{
			if (race == ZHODANI && soc >= 10) zhopsiedu();
			else altcareertbl();
		}
		break;
  }
}


void sci_life()
{
  int  roll;

  roll = d7();
  switch (roll)
  {
        case 1: bumpstr(); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: bumpintl(); break;
        case 5: bumpedu(); break;
        case 6: addskill(CAROUSING, 1); break;
        case 7: addskill(INSTRUCTION, 1); break;
  }
}


void interd_tbl()
{
	int  roll;

	roll = d7();
	if (race == HIVER && roll == 7)
		roll = d7();
	switch (roll)
	{
        case 1: bumpend(); break;
        case 2: addskill(RECON, 1); break;
        case 3: addskill(SURVEY, 1); break;
        case 4: addskill(SURVIVAL, 1); break;
        case 5: addskill(STREETWISE, 1); break;
        case 6: vhcl(1); break;
        case 7: gc(1); break;
	}
}


void psi_ins_tbl()
{
	int  roll;

	roll = d7();
	if (race == HIVER && (roll == 3 || roll == 4))
		roll = d7();
	switch (roll)
	{
        case 1: addskill(PSIONICS, 1); break;
        case 2: addskill(RECRUITING, 1); break;
        case 3: addskill(BRIBERY, 1); break;
        case 4: addskill(FORGERY, 1); break;
        case 5: addskill(STREETWISE, 1); break;
        case 6: addskill(BRAWLING, 1); break;
        case 7: addskill(LIAISON, 1); break;
	}
	if (chk_skl(PSIONICS, 2) > 0) 
		psitraining();
}


void black_tbl()
{
	int  roll;

	roll = d7();
	switch (roll)
	{
		case 1: addskill(NAVALARCH, 1); break;
		case 2: addskill(TACTICS, 1); break;
		case 3: addskill(COMPUTER, 1); break;
		case 4: addskill(ADMIN, 1); break;
		case 5: weapt(1); break;
		case 6: scrnt(1); break;
		case 7: bumpsoc(); break;
	}
}


void hostile_tbl()
{
  int  roll;

  roll = d7();
  switch (roll)
  {
        case 1: bumpstr(); break;
        case 2: bumpend(); break;
        case 3: addskill(SHIPBOAT, 1); break;
        case 4: addskill(SURVIVAL, 1); break;
        case 5: addskill(VACCSUIT, 1); break;
        case 6: vhcl(1); break;
        case 7: addskill(NOGRAV, 1); break;
  }
}


void lab_tbl()
{
  int  roll;

  roll = d7();
  switch (roll)
  {
        case 1: bumpintl(); break;
        case 2: bumpedu(); break;
        case 3: addskill(COMPUTER, 1); break;
        case 4: addskill(ADMIN, 1); break;
        case 5: addskill(ROBOTOPS, 1); break;
        case 6: vhcl(1); break;
        case 7: addskill(SENSOROPS, 1); break;
  }
}


void admin_tbl()
{
	int  roll;

	roll = d7();
	if (race == DOLPHINS && (roll == 3 || roll == 4 || roll == 7))
		roll -= 2;
	if (race == HIVER && (roll == 3 || roll == 4))
		roll = d7();
	switch (roll)
	{
        case 1: addskill(COMPUTER, 1); break;
        case 2: addskill(ADMIN, 1); break;
        case 3: addskill(FORGERY, 1); break;
        case 4: addskill(BRIBERY, 1); break;
        case 5: addskill(LIAISON, 1); break;
        case 6: addskill(RECRUITING, 1); break;
        case 7: addskill(BROKER, 1); break;
	}
}


void field_tbl()
{
	int  roll;

	roll = d7();
	if (race == HIVER && roll == 4)
		roll = d7();
	switch (roll)
	{
        case 1: bumpstr(); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: gc(1); break;
        case 5: addskill(SURVIVAL, 1); break;
        case 6: vhcl(1); break;
        case 7: addskill(SURVEY, 1); break;
	}
}


void hard_sci()
{
  int  roll;

  roll = d6();
  switch (roll)
  {
        case 1: addskill(ASTRONOMY, 1); break;
        case 2: addskill(CHEMISTRY, 1); break;
        case 3: addskill(GEOLOGY, 1); break;
        case 4: addskill(MATH, 1); break;
        case 5: addskill(PHYSICS, 1); break;
        case 6: addskill(METEOROLOGY, 1); break;
  }
}


void life_sci()
{
  int  roll;

  roll = d6();
  switch (roll)
  {
        case 1: addskill(SOPHONTOLOGY, 1); break;
        case 2: addskill(GENETICS, 1); break;
        case 3: addskill(CRYONICS, 1); break;
        case 4: addskill(BIOLOGY, 1); break;
        case 5: addskill(MEDICAL, 1); break;
        case 6: addskill(BIOLOGY, 1); break;
  }
}


void soc_sci()
{
  int  roll;

  roll = d6();
  switch (roll)
  {
        case 1: addskill(ARCHAEOLOGY, 1); break;
        case 2: addskill(LINGUISTICS, 1); break;
        case 3: addskill(HISTORY, 1); break;
        case 4: addskill(PSYCHOLOGY, 1); break;
        case 5: addskill(SOCIOLOGY, 1); break;
        case 6: addskill(THEOLOGY, 1); break;
  }
}


void appl_sci()
{
  int  roll;

  roll = d7();
  switch (roll)
  {
        case 1: addskill(COMPUTER, 1); break;
        case 2: addskill(COMMO, 1); break;
        case 3: addskill(ELECTRONICS, 1); break;
        case 4: addskill(ENGINEERING, 1); break;
        case 5: addskill(GRAVITICS, 1); break;
        case 6: addskill(MECHANICAL, 1); break;
        case 7: addskill(ROBOTICS, 1); break;
  }
}