/* CGSKILL.C is part of the MegaTraveller (C) character generation */
/* program. It is used to select the characters skills. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "chargen.h"

void prtselin();
void dfltech();
void dfltcareer();
void addskill(int code, int amount);
int chk_skl(int skill, int value);
int find_skl(int skill);
int picktable();
void zhopsiedu();
void zhopsimerc();
void zhopsinavy();
void zhopsiguard();
void zhopsiother();
void gottelepath();
void gotteleport();
void gottelekin();
void gotclair();
void gotaware();
void dispskil(int sequ, int skl_nbr);
void resolve_skill(int skillnbr, int amount);
 
extern void weapon();
extern void techl(int amount);
extern void spac(int amount);
extern void env(int amount);
extern void arts(int amount);
extern void archaic(int amount);
extern void interp(int amount);
extern void bc(int amount);
extern void gc(int amount);
extern void mc(int amount);
extern void explore(int amount);
extern void airc(int amount);
extern void printskill(int skill);
extern int d6();
extern int getsel_int(int min, int max);
extern void bumpdex();
extern void bumpedu();
extern void bumpstr();
extern void bumpend();
extern void bumpintl();
extern void bumpsoc();
extern void bumppsi();
extern void psitalents(int tryit);
extern void altcareertbl();
extern void acad(int amount);
extern void animal(int amount);
extern void artillery(int amount);
extern void pc(int amount);
extern void cmbtsupt(int amount);
extern void influ(int amount);
extern void infiltrate(int amount);
extern void invest(int amount);
extern void spacvhcl(int amount);
extern void econ(int amount);
extern void fag(int amount);
extern void gunner(int amount);
extern void hc(int amount);
extern void inbrn(int amount);
extern void milmed(int amount);
extern void mc(int amount);
extern void mentl(int amount);
extern void physicl(int amount);
extern void sci(int amount);
extern void scrnt(int amount);
extern void spacecmbt(int amount);
extern void spacetech(int amount);
extern void special(int amount);
extern void iris_tech(int amount);
extern void vhcl(int amount);
extern void vc(int amount);
extern void boats(int amount);

void prtselin()
{
  printf("\nPlease enter your selection:\n->");
}


void dfltech()
{
	int choice;
  
	if (race == KKREE)
		return;
	printf("Tech & race default skills: ");
	if (race == JONKEREEN)
		addskill(SURVIVAL, 1);
	if (race == ITHKLUR)
	{
		addskill(GUARDBEAST, 0);
		addskill(ARTS, 1);
		addskill(ACTING, 0);
		addskill(HUNTING, 0);
		addskill(SWIMMING, 0);
	}
	if (race == SUERRAT)
	{
		printf("What is your background?\n\n");
		printf("   1. troglodyte\n   2. astronaut\n");
		choice = getsel_int(1,2);
		if (choice == 1)
		{
			addskill(PROSPECTING, 1);
			blue_blood += 10;
		}
		else
		{
			spac(1);
			blue_blood += 20;
		}
	}
	if (race == DOLPHINS)
	{
		addskill(WALDOOPS, 1);
		addskill(TEESUIT, 1);
	}
	else
	{
		if (race == TIRRILS)
			addskill(WALDOOPS, 0);
		else
		{
			if (tech >= TLIND && tech <= TLEARSTEL)
				addskill(WHEELEDVHCL, 0);
			if (tech >= TLAVGSTEL)
				addskill(GRAVVHCL, 0);
		}
	}
	if (tech >= TLEARSTEL)
		addskill(COMPUTER, 0);
}


void dfltcareer()
{
	if (race == KKREE)
		return;
	printf("Career default skills: ");
	switch (careernbr)
	{
		case ARMY: addskill(CMBTRIFLMAN, 1); break;
	    case NAVY: gc(0); addskill(VACCSUIT, 0); break;
		case MARINE:
			{
				addskill(VACCSUIT, 0);
				if (race == SOLOMANI)
					addskill(CMBTRIFLMAN, 1);
				else
				{
					gc(0); 
					if (race == VARGR)
						mc(1);
					else
						addskill(LARGEBLAD, 1);
				}
				break;
			}
		case SCOUT:
			{
				gc(0);
				addskill(VACCSUIT, 0);
				if (race == VARGR)
					explore(1);
				else
					addskill(PILOT, 1);
				break;
			}
		case FLYER: gc(0); addskill(VACCSUIT, 0); airc(1); break;
		case SAILOR: gc(0); addskill(SMALLBOAT, 1); break;
	    case COP: gc(0); addskill(STREETWISE, 1); break;
		case DOCTOR: gc(0); addskill(MEDICAL, 1); break;
	    case DIPLOMAT: gc(0); addskill(LIAISON, 1); break;
		case BUREAUCRAT: gc(0); if (race == VARGR) addskill(ADMIN, 1); break;
	    case SCIENTIST: gc(0); if (race != HLANSSAI) techl(1); break;
		case NOBLE:
			{
				if (race == VARGR)
					bumpsoc();
				else
					if (race == ZHODANI)
						addskill(ADMIN, 1);
					else
						gc(0);
				break;
			}
		case MERCHANT:
			{
				gc(0);
				addskill(VACCSUIT, 0);
				if (race == SOLOMANI)
					spac(1);
				break;
			}
	    case BELTER: gc(0); addskill(VACCSUIT, 1); break;
		case PIRATE: gc(0); addskill(VACCSUIT, 0); addskill(BRAWLING, 1); break;
	    case ROGUE: gc(0); addskill(STREETWISE, 1); break;
		case HUNTER: gc(0); addskill(HUNTING, 1); break;
	    case BARBARIAN:
			{
				if (race == VARGR)
					env(1);
				else
					addskill(LARGEBLAD, 1);
				break;
			}
		case WANDERER:
			{
				if (race == VARGR)
					mc(0);
				else gc(0);
				break;
			}
	    case FARMER:
			{
				if (race != ZHODANI && race != KKREE)
				{
					if (race == GIRUGKAGH)
						addskill(LINGUISTICS, 1);
					else
					{
						addskill(FARMING, 1);
						gc(0);
					}
				}
				break;
			}
	    case JOURNALIST: gc(0); break;
		case ENTERTAINER: arts(1); gc(0); break;
	    case TECHNOPRIEST: addskill(ACTING, 1); archaic(0); break;
		case TECHY: addskill(COMPUTER, 1); techl(1); break;
	    case PARTY:
			{
				gc(0);
				if (race == VARGR)
					addskill(RECRUITING, 1);
				else
					interp(1);
				break;
			}
		case ZHOGUARD: bc(1); if (soc >= 11) bumppsi(); gc(0); break;
		default: gc(0); break;
	}
}


void addskill(int code, int amount)
{
	int num, maxskillpoints;

	if (code == 0)
		return;
	if (amount > 2)
		amount = 1;
	if (amount < 0)
		amount = 0;
	if (race == KKREE || race == JONKEREEN)
	{
		if (code == VACCSUIT || code == HELICOPTER
			|| code == BALLOONS || code == JETAIR
			|| code == PROPAIR || code == GRAVVHCL
			|| code == HOVERCRAFT || code == LARGEBOAT
			|| code == SMALLBOAT || code == SHIPBOAT)
		{
			if (find_skl(ENCLOSURE) < 1)
				addskill(ENCLOSURE, 1);
			if (find_skl(ENCLOSURE) < (find_skl(code) + amount))
			{
				printf("You can not get this skill due to claustrophobia.\n");
				printf("You will be given the enclosure skill instead.\n");
				code = ENCLOSURE;
			}
		}
	}
	if (race == NEWT)
	{
		if (code == GAMBLING)
			code = BRAWLING;
		if (code == FORGERY)
			code = ARTISAN;
		if (code == STREETWISE)
			code = LIAISON;
	}
	if (race == HHKAR)
	{
		if (code == CAROUSING)
			code = TOLERANCE;
	}
	if (race == DROYNE)
		maxskillpoints = intl * 3;
	else
		maxskillpoints = intl + edu;
	num = 0; // see if it is an existing skill
	while ((num < skillcount) && (skillcode [num] != code))
		num++;
	if (skillcode [num] == code) // increase an existing skill
	{
		if ((skillrating [num] + amount) > maxskillpoints)
		{
			printskill(code);
			printf(" value would be %d. ");
			printf("You can not exceed your Intl + Edu in a skill.\n");
			return;
		}
		skillrating [num] = skillrating [num] + amount;
	}
	if (num == skillcount) // add a new skill
	{
		if (skillcount >= maxskill) // are we are the end of the skill table?
		{
			printf("You can not add this skill.\n");
			printf("You are already at the maximum number of skills (%d).\n", maxskill);
			return;
		}
		else
		{
			if ((skillrating [num] + amount) > maxskillpoints)
			{
				printskill(code);
				printf(" value would be %d. ");
				printf("You can not exceed your Intl + Edu in a skill.\n");
				return;
			}
			skillrating [num] = skillrating [num] + amount;
			{
				skillcode [skillcount] = code;
				if (code == ADMIN && race == NEWT) /* the first time Newts get ADMIN they get level 2 */
					amount++;
				skillrating [skillcount] = amount;
				skillcount++;
				if (code == MEDICAL) // anyone with medical is a medic
					medic++;
				if (code == PROSPECTING || code == GAMBLING) // set gambler flag
					gambler++;
			}
		}
	}
	printskill(code);
	printf(" value now %d\n", skillrating [num]);
}


int chk_skl(int skill, int value)
{
	int cur_val;

	cur_val = find_skl(skill);
	if (cur_val >= value)
		return 1;
	return 0;
}


int find_skl(int skill)
{
	int i;

	i = 0;
	while (i < skillcount && skill != skillcode[i])
		i++;
	if (skill == skillcode[i])
		return skillrating[i];
	return -1;
}


void dispskil(int sequ, int skl_nbr)
{
	printf("   %d. ", sequ);
	printskill(skl_nbr);
	printf("\n");
}


int picktable()
{
  int  choice, max;

  if (pick <= 2)
  {
    printf("\nSelect the skill table you want to use.\n\n");
    if (race == HLANSSAI)
	{
		printf("   1. Hlanssai life\n   2. Hlanssai activity\n");
		if (careernbr == TECHY)
			printf("   3. N'tarronth\n");
		else
			printf("   3. N'tarronchii'a\n");
	}
	else
		printf("   1. personal development\n   2. service\n   3. education\n");
	max = 3;
    if (race != ZHODANI)
	{
		if (edu >= 8 && race != HLANSSAI)
		{
			printf("   4. advanced education\n");
			max = 4;
		}
	}
	else
	{
		if (soc >= 10 && careernbr != ZHOPROLES)
		{
			printf("   4. Noble/Intendent education\n");
			max = 4;
		}
	}
    if (race == SOLOMANI)
	{
		if (careernbr != IRIS && alt_career == LANDGUARD)
		{
			printf("   5. home guard army table\n");
			max = 5;
		}
		if (careernbr != IRIS && alt_career == SPACEGUARD)
		{
			printf("   5. home guard navy table\n");
			max = 5;
		}
		if (careernbr == IRIS && alt_career > 0) // Solsec agents area
		{
			printf("   5. service table for %s\n", alt_careername);
			max = 5;
		}
	}
    choice = getsel_int(1, max);
    if (choice == 4 && edu < 8 && race != ZHODANI)
	{
      printf("Come on, try again.\n");
      return picktable();
    }
  }
  else
  {
    choice = d6();
    if ((race != ZHODANI && edu >= 8) || (race == ZHODANI && soc >= 10))
	{
      if (choice == 6) choice = 2;
      if (choice == 5 && alt_career == 0) choice = 4;
    }
	else
	{
      if (choice == 4 || choice == 6) choice = 2;
      if (choice == 5 && alt_career == 0) choice = 3;
    }
  }
//  printf("\nChoice %d\n", choice);
  if (race == ZHODANI && choice == 4)
  {
	  zhopsiedu();
	  choice = 6;
  }
  if (choice == 5) altcareertbl();
  return choice;
}


void zhopsiedu()
{
	switch (careernbr)
	{
		case ARMY: zhopsimerc(); break;
		case NAVY: zhopsinavy(); break;
		case MARINE: zhopsimerc(); break;
		case SCOUT: zhopsinavy(); break;
		case FLYER: zhopsinavy(); break;
		case SAILOR: zhopsiother(); break;
		case COP: zhopsiother(); break;
		case DOCTOR: zhopsiother(); break;
		case DIPLOMAT: zhopsiother(); break;
		case SCIENTIST: zhopsiother(); break;
		case ZHOGOVT: zhopsiother(); break;
		case BUREAUCRAT: zhopsiother(); break;
		case MERCHANT: zhopsiother(); break;
		case BELTER: zhopsiother(); break;
		case PIRATE: break;
		case ROGUE: break;
		case HUNTER: zhopsiother(); break;
		case BARBARIAN: zhopsiother(); break;
		case ZHOGUARD: zhopsiguard(); break;
		case ZHOPROLES: break;
	}
}


void zhopsimerc()
{
  int roll;

  roll = d6();
  if (line == 1) roll += 4;
  switch (roll)
  {
    case 1: gottelepath(); break;
    case 2: gottelepath(); break;
    case 3: gotclair(); break;
    case 4: gottelekin(); break;
    case 5: bumppsi(); break;
    case 6: gotteleport(); break;
    case 7: gotclair(); break;
    case 8: gottelepath(); break;
    case 9: bumppsi(); break;
    default: gotteleport(); break;
  }
}


void zhopsinavy()
{
  int roll;

  roll = d6();
  switch (roll)
  {
    case 1: gottelekin(); break;
    case 2: bumppsi(); break;
    case 3: psitalents(-8); break;
    case 4: bumppsi(); break;
    case 5: gotaware(); break;
    default: gottelekin(); break;
  }
}


void zhopsiguard()
{
  int roll;

  roll = d6();
  switch (roll)
  {
    case 1: gotteleport(); break;
    case 2: bumppsi(); bumppsi(); break;
    case 3: psitalents(-8); break;
    case 4: bumppsi(); break;
    case 5: gottelekin(); break;
    default: gotteleport(); break;
  }
}


void zhopsiother()
{
  int roll;

  roll = d6();
  switch (roll)
  {
    case 1: gotclair(); break;
    case 2: bumppsi(); break;
    case 3: addskill(NVCOMM, 1); break;
    case 4: addskill(PSYCHOLOGY, 1); break;
    case 5: addskill(LIAISON, 1); break;
    default:
		{
			if (careernbr == MERCHANT)
				addskill(TRADER, 1);
			else 
				if (careernbr == HUNTER || careernbr == BARBARIAN)
					addskill(HUNTER, 1);
				else
					addskill(ADMIN, 1);
			break;
		}
  }
}


void gottelepath()
{
	if (telepath == 1)
		bumppsi();
	else
	{
		telepath = 1;
		printf("Got telepathy\n");
	}
}


void gotclair()
{
	if (clair == 1)
		bumppsi();
	else
	{
		clair = 1;
		printf("Got clairvoyance\n");
	}
}


void gotteleport()
{
	if (teleport == 1)
		bumppsi();
	else
	{
		teleport = 1;
		printf("Got teleportation\n");
	}
}


void gottelekin()
{
	if (telekin == 1)
		bumppsi();
	else
	{
		telekin = 1;
		printf("Got telekinesis\n");
	}
}


void gotaware()
{
	if (aware == 1)
		bumppsi();
	else
	{
		aware = 1;
		printf("Got awareness\n");
	}
}


void resolve_skill(int skillnbr, int amount)
{
	int i;
	
	i = 0;
	/* handle adjustments to UPP values in the skill tables */
	{
		switch (skillnbr)
		{
        case ACADEMIC: acad(amount); break;
        case AIRCRAFT: airc(amount); break;
        case ANIMALS: animal(amount); break;
        case ARCHAICWEAP: archaic(amount); break;
        case BLADCMBT: bc(amount); break;
        case ECONOMIC: econ(amount); break;
        case ENVIRON: env(amount); break;
        case EXPLORATORY: explore(amount); break;
        case FAGUNNERY: fag(amount); break;
        case GUNCMBT: gc(amount); break;
        case GUNNERY: gunner(amount); break;
        case HANDCMBT: hc(amount); break;
        case INBORN: inbrn(amount); break;
        case INTERPERS: interp(amount); break;
        case MENTAL: mentl(amount); break;
        case PHYSICAL: physicl(amount); break;
        case SCIENCE: sci(amount); break;
        case SPACE: spac(amount); break;
        case SPACCMBT: spacecmbt(amount); break;
        case SPACTECH: spacetech(amount); break;
        case SPCLCMBT: special(amount); break;
        case TECHNICAL: techl(amount); break;
        case VEHICLE: vhcl(amount); break;
        case VICE: vc(amount); break;
        case MIXED_CMBT: mc(amount); break;
        case MIL_MED: milmed(amount); break;
        case SCRNTECH: scrnt(amount); break;
        case WEAPTECH: weapon(amount); break;
        case BOATS: boats(amount); break;
        case CMBTSUPT: cmbtsupt(amount); break;
        case INFLUENCE: influ(amount); break;
        case INFILTRATION: infiltrate(amount); break;
        case INVESTIGATION: invest(amount); break;
        case PERSONALCMBT: pc(amount); break;
        case SPACVHCL: spacvhcl(amount); break;
        case ARTSY: arts(amount); break;
        case ARTILLERY: artillery(amount); break;
		case ADDSTR: 
			{
				for (i = 0; i < amount; i++)
					bumpstr();
				break;
			}
		case ADDDEX:
			{
				for (i = 0; i < amount; i++)
					bumpdex();
				break;
			}
		case ADDEND:
			{
				for (i = 0; i < amount; i++)
					bumpend();
				break;
			}
		case ADDINT:
			{
				for (i = 0; i < amount; i++)
					bumpintl();
				break;
			}
		case ADDEDU:
			{
				for (i = 0; i < amount; i++)
					bumpedu();
				break;
			}
		case ADDSOC:
			{
				for (i = 0; i < amount; i++)
					bumpsoc();
				break;
			}
		case ADDPSI:
			{
				for (i = 0; i < amount; i++)
					bumppsi();
				break;
			}
		}
		return;
	}
	addskill(skillnbr, amount);
}