/* UPP.C is part of the CHARGEN program that selects the characters */
/* universal personality profile */

#include <stdio.h>
#include <string.h>

#include "chargen.h"

void upp();
void prntupp();
int uppchoice();
void pickrace();
void pickminorrace();
void prntrace();
void showrace(int racenbr);
void picksex();
void prntsex();
void finalsex();
void bumpstr();
void bumpdex();
void bumpcon();
void bumpintl();
void bumpedu();
void bumpsoc();
void dropsoc();
void bumppsi();
void patriarch();
void kkree_class();
void ptrch_class();
void psitraining();
void psitalents();
int convupp(char uppentry);

extern int d6();
extern int d12();
extern int d12plus();
extern char getche_y_n();
extern int getsel_int(int min, int max);
extern int getsel_bigint(int min, int max);
extern void addskill(int skill, int skl_val);
extern void dispskil(int sequ, int skill);
extern void bp_add(int amt);
extern int bp_adj(int roll, int nbr);

#include "chargen.h"

void upp()
{
	char choice;
	char uppentry[26];

	if (race == 0)
		pickrace(); /* only happens for humans */
	printf("Your race is ");
	showrace(race);
	printf("\n");
	if (sex == 0)
		picksex();
	if (race == KKREE)
		patriarch();
	printf("Would you like a random UPP?");
	choice = getche_y_n();  
	if (choice == 'N' || choice == 'n')
	{
		printf("Enter UPP:\n->");
		fgets(uppentry, 26, stdin);
		if (uppentry[strlen(uppentry) - 1] == '\n') uppentry[strlen(uppentry) - 1] = '\0';
		if (race == ZHODANI)
		{
			if ((strlen(uppentry)) != 7)
			{
				printf("Invalid UPP (must be 7 digits) - try again!\n");
				upp();
				return;
			}
		}
		else
		{
			if ((strlen(uppentry)) != 6)
			{
				printf("Invalid UPP (must be 6 digits) - try again!\n");
				upp();
				return;
			}
		}
		str = convupp(uppentry[0]);
		if (str < 1)
		{
			printf("Invalid str value - try again\n");
			upp();
			return;
		}
		dex = convupp(uppentry[1]);
		if (dex < 1)
		{
			printf("Invalid dex value - try again\n");
			upp();
			return;
		}
		end = convupp(uppentry[2]);
		if (end < 1)
		{
			printf("Invalid end value - try again\n");
			upp();
			return;
		}
		intl = convupp(uppentry[3]);
		if (intl < 1)
		{
			printf("Invalid intl value - try again\n");
			upp();
			return;
		}
		edu = convupp(uppentry[4]);
		if (edu < 1)
		{
			printf("Invalid edu value - try again\n");
			upp();
			return;
		}
		soc = convupp(uppentry[5]);
		if (soc < 1)
		{
			printf("Invalid soc value - try again\n");
			upp();
			return;
		}
		if (race == ZHODANI)
		{
			psi = convupp(uppentry[6]);
			if (psi < 0)
			{
				printf("Invalid psi value - try again\n");
				upp();
				return;
			}
			if (soc >= 10 && psi > 0) psitraining();
			return;
		}
		return;
	}
	if (race == DROYNE)
	{
		str = d6();
		dex = d6();
		end = d6();
		intl = d6();
		edu = d6();
		soc = 0;
	}
	else
	{
		if (race == TIRRILS)
		{
			str = d12() - 4;
			dex = d6() + 3;
			end = d6() + 3;
			intl = d12() - 1;
			edu = d6();
			soc = d6();
			age = 2;
			appearent_age = age;
		}
		else
		{
			pick = uppchoice();
			if (pick == 1)
			{
				str = d12plus();
				dex = d12plus();
				end = d12plus();
				intl = d12plus();
				edu = d12plus();
				soc = d12plus();
			}
			else
			{
				str = d12();
				dex = d12();
				end = d12();
				intl = d12();
				edu = d12();
				soc = d12();
			}
		}
	}
	if (race == GEONEE)
	{
		str++;
		end--;
	}
	if (race == ZHODANI)
	{
		if (pick == 1)
			psi = d12plus();
		else
			psi = d12();
		if (psi >= 9 && soc < 10)
			soc = 10;
		if (soc >= 10 && edu < 8)
			edu = 8;
		if (edu > soc)
			edu = soc;
	}
	if (race == ASLAN)
	{
		str += 2;
		end += 2;
		dex--;
	}
	if (race == KKREE)
	{
		if (sex == 1)
		{
			str += 6;
			end += 6;
			if (branch == 1)
			{
				intl += 2;
				edu += 2;
			}
			else
			{
				intl -= 4;
				edu -= 4;
			}
		}
		else
		{
			str += 3;
			end += 3;
			edu -= 5;
		}
	}
	if (race == VARGR)
	{
		str--;
		end--;
		dex += 2;
		soc = d6();
	}
	if (race == DOLPHINS)
	{
		str += 2;
		end += 2;
		soc -= 4;
		if (soc < 1)
			soc = 1;
	}
	if (race == JONKEREEN)
	{
		end++;
		dex--;
	}
	if (race == DARRIAN)
	{
		str = d6() + 3;
		end = d6() + 3;
		edu++;
	}
	if (race == HHKAR)
	{
		str = d12() + 3;
		end = d12() + 3;
	}
	if (race == SUERRAT)
	{
		str = d6() + 3;
		soc--;
		if (d12() == 12)
		{
			end--;
			printf("You are an albino\n");
			blue_blood++;
		}
	}
	if (race == LLAMIYA)
	{
		str -= 2;
		dex += 2;
		end += 3;
		intl += 6;
		soc = d6();
	}
	if (race == VEGAN)
	{
		str--;
		dex++;
	}
	if (race == FLORIANI)
	{
		if (blue_blood == 2)
		{
			str += 2;
			end += 2;
			intl -= 2;
			edu -= 2;
			soc--;
		}
		else
		{
			str -= 2;
			end -= 2;
			intl += 2;
			edu += 2;
			soc++;
		}
	}
	if (race == NEWT)
	{
		str = str - 4;
		end = end - 4;
	}
	if (race == LLELLEWYLOLY)
	{
		str = ((d6() + 1) / 2) + 2;
		dex--;
		end--;
	}
	if (race == CAFADI)
	{
		str++;
		end++;
		dex--;
	}
	if (race == HLANSSAI)
	{
		str -= 2;
		edu -= 2;
		dex += 2;
		soc = d6() + 4;
	}
	if (race == GIRUGKAGH)
	{
		str = d6() + 2;
		end = d6() + 2;
		dex = d6() + 7;
	}
	if (race == ITHKLUR)
	{
		str += 2;
		end++;
		intl++;
		edu = d6();
		soc--;
	}
	if (str < 1)
		str = 1;
	if (dex < 1)
		dex = 1;
	if (end < 1)
		end = 1;
	if (intl < 1)
		intl = 1;
	if (edu < 1)
		edu = 1;
	if (soc < 1)
		soc = 1;
	if (str > 15)
		str = 15;
	if (dex > 15)
		dex = 15;
	if (end > 15)
		end = 15;
	if (intl > 15)
		intl = 15;
	if (edu > 15)
		edu = 15;
	if (soc > 15)
		soc = 15;
	prntupp();  
	printf("Would you like to use this UPP?");
	choice = getche_y_n();  
	if (choice == 'N' || choice == 'n')
	{
		upp();
		return;
	}
	if (pick == 1) bp_add(3); /* if they want to cheat help start their career */
	if (race == ZHODANI && soc >= 10 && psi > 0) psitraining();
	return;
}


void prntupp()
{
	printf("\nstr = %d  ", str);
	printf("dex = %d  ", dex);
	printf("end = %d  ", end);
	printf("int = %d  ", intl);
	if (race == DROYNE)
		printf("sense");
	else
		printf("edu");
	printf(" = %d  ", edu);
	if (race == SOLOMANI)
		printf("party");
	else
		if (race == VARGR || race == TIRRILS)
			printf("cha");
		else
			if (race == KKREE || race == DROYNE)
				printf("caste");
			else
				if (race == HIVER)
					printf("curio");
				else
					printf("soc");
	printf(" = %d", soc);
	if (psi > 0)
		printf(" psi = %d  ", psi);
	printf("\n");
}


int uppchoice()
{
	int answer;
  
	printf("\nYou have the option of generating the universal personality\n");
	printf("profile using 2 d6 or the best 2 of 3 d6. Do you want to use the\n");
	printf("best 2 of 3 d6 method?");
	answer = getche_y_n();
	if (answer == 'Y' || answer == 'y')
		return 1;
	else
		return 0;
}


void pickrace() /* only used for humans */
{
	int choice;

	printf("You have the option to pick your characters race. These are your options:\n\n");
	printf("   1. don't care\n   2. ");
	showrace(IMPERIAL);
	printf("\n   3. ");
	showrace(VILANI);
	printf("\n   4. ");
	showrace(SOLOMANI);
	printf("\n   5. ");
	showrace(ZHODANI);
	printf("\n   6. ");
	showrace(DARRIAN);
	printf("\n   7. minor human race");
	choice = getsel_int(1, 7);
	switch(choice)
	{
		case 2: race = IMPERIAL; break;
		case 3: race = VILANI; break;
		case 4: race = SOLOMANI; break;
	    case 5: race = ZHODANI; break;
		case 6: race = DARRIAN; break;
	    case 7: pickminorrace(); break;
		default: race = HUMAN; break;
	}
	if (race <= 0)
		pickrace();
	printf("\nYour characters race is ");
	prntrace();
	printf(".\n");
}


void pickminorrace()
{
	int choice;

	printf("These are your options for minor human races:\n\n");
	printf("   1. none (go to previous menu)\n   2. ");
	showrace(JONKEREEN);
	printf("\n   3. ");
	showrace(GEONEE);
	printf("\n   4. ");
	showrace(ANSWERIN);
	printf("\n   5. ");
	showrace(CAFADI);
	printf("\n   6. ");
	showrace(LURIANI);
	printf("\n   7. ");
	showrace(HLANSSAI);
	printf("\n   8. ");
	showrace(SWORDWORLD);
	printf("\n   9. ");
	showrace(SUERRAT);
	printf("\n   10. ");
	showrace(FLORIANI);
	printf("\n   11. ");
	showrace(IRHADRE);
	choice = getsel_bigint(1, 11);
	switch(choice)
	{	
		case 2: race = JONKEREEN; break;
	    case 3: race = GEONEE; break;
		case 4: race = ANSWERIN; break;
	    case 5: race = CAFADI; break; 
		case 6: race = LURIANI; break; 
	    case 7: race = HLANSSAI; break; 
		case 8: race = SWORDWORLD; break;
		case 9: race = SUERRAT; break;
		case 10:
		{
			race = FLORIANI;
			printf("Choose your caste\n   1. Barnai\n   2. Feskals\n");
			blue_blood = getsel_int(1, 2);
			break;
		}
		case 11: race = IRHADRE; break;
		default: break;
	}
}


void prntrace()
{
	showrace(race);
}


void showrace(int racenbr)
{
	switch (racenbr)
	{
		case IMPERIAL: printf("Imperial human"); break;
		case VILANI: printf("Vilani"); break;
		case SOLOMANI: printf("Solomani"); break;
	    case ZHODANI: printf("Zhodani"); break;
		case ASLAN: printf("Aslan"); break;
	    case VARGR: printf("Vargr"); break;
		case DARRIAN: printf("Darrian"); break;
	    case DROYNE: printf("Droyne"); break;
		case HIVER: printf("Hiver"); break;
	    case JONKEREEN: printf("Jonkareen"); break;
		case KKREE: printf("K'kree"); break;
	    case LLELLEWYLOLY: printf("Llellewyloly"); break;
		case LOESKALTH: printf("Loeskalth"); break;
	    case SUERRAT: printf("Suerrat"); break;
		case VEGAN: printf("Vegan"); break;
	    case GEONEE: printf("Geonee"); break;
		case DOLPHINS: printf("Dolphins"); break;
	    case TIRRILS: printf("Tirrils"); break;
		case NEWT: printf("Newt"); break;
		case GIRUGKAGH: printf("Girug'kagh"); break;
		case GITHIASKIO: printf("Githiaskio"); break;
		case HLANSSAI: printf("Hlanssai"); break;
		case SWORDWORLD: printf("Sword Worlder"); break;
		case IRHADRE: printf("Irhandre"); break;
		case JGDILJADG: printf("Jdg-Il-Jadg"); break;
		case LURIANI: printf("Luriani"); break;
		case CAFADI: printf("Cadafi"); break;
		case ANSWERIN: printf("Answerin"); break;
		case HHKAR: printf("Hhkar"); break;
		case LLAMIYA: printf("Llamiya"); break;
		case ITHKLUR: printf("Ithklur"); break;
	    case FLORIANI: printf("Floriani"); break;
		case HUMAN: printf("other human"); break;
	    default: printf("unknown ?"); break;
	}
	return;
}


void picksex()
{
  int choice, max;

  if (race == HHKAR)
  {
	  sex = 1;
	  finalsex();
	  return;
  }
  printf("You have the option to pick the sex of your character. These are your options.\n\n");
  printf("   1. don't care, pick one at random\n");
  if (race == DROYNE)
  {
	  printf("   2. alpha male\n   3. female\n   4. beta male\n");
	  max = 4;
  }
  else
  {
	  printf("   2. male\n   3. female\n");
	  max = 3;
  }
  choice = getsel_int(1, max);
  if (choice == 1)
  {
    choice = d12();
	if (race == DROYNE)
	{
	  if (choice <= 5) sex = 1;
      else
	    if (choice >= 9) sex = 3;
		else sex = 2;
    }
	else
	{
	  if (choice <= 7)
	  {
	    sex = 1;
      }
	  else
	  {
	    sex = 2;
      }
	}
  }
  else
  {
    sex = choice - 1;
  }
  finalsex();
}


void finalsex()
{
  printf("\nYour characters sex is ");
  prntsex();
  printf(".\n");
}  


void prntsex()
{
  if (sex == 1)
  {
    if (race == DROYNE) 
      printf("alpha male");
    else
      printf("male");
  }
  else
  {
    if (race == DROYNE && sex == 3)
      printf("beta male");
    else
      printf("female");
  }
}


void bumpstr()
{
  printf("Adding 1 to str\n");
  str++;
  if (race == ASLAN)
  {
    if (str > 17) str = 17;
  }
  else
  {
    if (race == KKREE)
	{
      if (str > 25) str = 25;
    }
	else
	{
      if (str > 15) str = 15;
    }
  }
}


void bumpdex()
{
  printf("Adding 1 to dex\n");
  dex++;
  if (dex > 16 && race == VARGR) end = 16;
  if (dex > 15 && race != VARGR) dex = 15;
}


void bumpend()
{
  printf("Adding 1 to end\n");
  end++;
  if (race == ASLAN)
  {
    if (end > 17) end = 17;
  }
  else
  {
    if (race == KKREE)
	{
      if (end > 25) end = 25;
    }
	else
	{
      if (end > 15) end = 15;
    }
  }
}


void bumpintl()
{
  printf("Adding 1 to intl\n");
  intl++;
  if (intl > 15) intl = 15;
}


void bumpedu()
{
  printf("Adding 1 to edu\n");
  edu++;
  if (edu > 15) edu = 15;
}


void bumpsoc()
{
  if (race == ZHODANI && (soc == 9 || soc == 10))
  {
	printf("Max soc reached\n");
	return;
  }
  printf("Adding 1 to soc\n");
  soc++;
  if (soc > 15) soc = 15;
}


void dropsoc()
{
  soc--;
  if (soc < 1) soc = 1;
  printf("Dropping soc by 1 to %d\n", soc);
}


void bumppsi()
{
	if (psi >= 15)
	{
		psi = 15;
		return;
	}
	printf("Adding 1 to Psi\n");
	psi++;
	if (telepath == 1) addskill(TELEPATHY, 1);
	if (clair == 1) addskill(CLAIRVOYANCE, 1);
	if (telekin == 1) addskill(TELEKINESIS, 1);
	if (aware == 1) addskill(AWARENESS, 1);
	if (teleport == 1) addskill(TELEPORTATION, 1);
	if (psispecial == 1) addskill(PSISPCL, 1);
	if (psi >= 9 && soc < 10 && race == ZHODANI)
	{
		soc = 10;
		printf("You have become an Intendent! Congratulations.\n");
	}
}


void patriarch()
{
  int choice;

  if (sex == 2)
  {
    branch = 0;
  }
  else
  {
    printf("What is the role of this character within the family?\n");
    printf("\n   1. patriarch\n   2. body guard\n   3. servant\n");
    choice = getsel_int(1, 3);
    branch = choice;
  }
  if (branch == 1)
  {
    ptrch_class();
  }
  else
  {
    kkree_class();
  }
}


void kkree_class()
{
  int choice;

  if (branch == 3)
  {
    line = 3;
    return;
  }
  printf("What is the class of this K'kree family member.\n");
  printf("   1. Noble\n   2. Well-Born\n   3. Servant\n");
  choice = getsel_int(1, 3);
  line = choice;
  if (line == 1) rankeo = 'O';
}


void ptrch_class()
{
  int roll;

  roll = d12();
  if (roll >= 9)
  {
    line = 1;
    rankeo = 'O';
    printf("You are a noble.\n");
  }
  else
  {
    line = 2;
    printf("You are well born.\n");
  }
}


void psitraining()
{
	int tryit;

	tryit = 0;
	telepath = 0;
	clair = 0;
	telekin = 0;
	aware = 0;
	teleport = 0;
	psispecial = 0;
	printf("You received psionic training.\n");
	if (psi == 0)
	{
		psi = d12plus() - ((appearent_age - 18) / 4);
		if (race == NEWT)
			psi -= 3;
		if (race == ITHKLUR)
			psi -= 2;
		if (race == LLELLEWYLOLY || race == LLAMIYA)
			psi = 0;
		if (psi < 1)
		{
			psi = 0;
			printf("It turns out that you had no actual psionic talent.\n");
			return;
		}
		printf("Psi = %d\n", psi);
	}
	while (tryit < 6)
	{
		psitalents(tryit);
		tryit++;
	}
	if (telepath < 0)
		telepath = 0;
	if (clair < 0)
		clair = 0;
	if (telekin < 0)
		telekin = 0;
	if (aware < 0)
		aware = 0;
	if (teleport < 0)
		teleport = 0;
	if (psispecial < 0)
		psispecial = 0;
}


void psitalents(int tryit)
{
	int choice = 0;
	int roll, gotit, neednbr, min, max;

	if ((telepath + clair + telekin + aware + teleport + psispecial) >= 6)
	{
		bumppsi();
		return;
	}
	min = 0;
	max = 0;
	printf("\nSelect the psionic talent you want.\n\n");
	if (telepath == 0)
	{
		dispskil(1, TELEPATHY);
		min = 1;
		max = 1;
	}
	if (clair == 0)
	{
		dispskil(2, CLAIRVOYANCE);
		if (min == 0) min = 2;
		max = 2;
	}
	if (telekin == 0)
	{
		dispskil(3, TELEKINESIS);
		if (min == 0) min = 3;
		max = 3;
	}
	if (aware == 0)
	{
		dispskil(4, AWARENESS);
		if (min == 0) min = 4;
		max = 4;
	}
	if (teleport == 0)
	{
		dispskil(5, TELEPORTATION);
		if (min == 0) min = 5;
		max = 5;
	}
	if (psispecial == 0)
	{
		dispskil(6, PSISPCL);
		if (min == 0) min = 6;
		max = 6;
	}
	choice = getsel_int(min, max);
	switch (choice)
	{
		case 1: neednbr = 4; break;
		case 2: neednbr = 5; break;
		case 3: neednbr = 5; break;
		case 4: neednbr = 6; break;
		case 5: neednbr = 7; break;
		case 6: neednbr = 9; break;
	}
	roll = d12();
	roll = bp_adj(roll, neednbr);
	if ((roll - tryit) >= neednbr)
	{
		gotit = 1;
		printf("You got it!\n");
	} 
	else
	{
		gotit = -1;
		printf("You didn't get it...\n");
	}
	switch (choice)
	{
		case 1:
		{
			telepath = gotit;
			if (gotit > 0)
				addskill(TELEPATHY, psi);
			break;
		}
		case 2:
		{
			clair = gotit;
			if (gotit > 0)
				addskill(CLAIRVOYANCE, psi);
			break;
		}
		case 3:
		{
			telekin = gotit;
			if (gotit > 0)
				addskill(TELEKINESIS, psi);
			break;
		}
		case 4:
		{
			aware = gotit;
			if (gotit > 0)
				addskill(AWARENESS, psi);
			break;
		}
		case 5:
		{
			teleport = gotit;
			if (gotit > 0)
				addskill(TELEPORTATION, psi);
			break;
		}
		case 6:
		{
			psispecial = gotit;
			if (gotit > 0)
				addskill(PSISPCL, psi);
			break;
		}
	}
}

int convupp(char uppentry)
{
	int uppvalue;

	switch (uppentry)
	{
      case '0': uppvalue = 0; break;
      case '1': uppvalue = 1; break;
      case '2': uppvalue = 2; break;
      case '3': uppvalue = 3; break;
      case '4': uppvalue = 4; break;
      case '5': uppvalue = 5; break;
      case '6': uppvalue = 6; break;
      case '7': uppvalue = 7; break;
      case '8': uppvalue = 8; break;
      case '9': uppvalue = 9; break;
      case 'a': uppvalue = 10; break;
      case 'b': uppvalue = 11; break;
      case 'c': uppvalue = 12; break;
      case 'd': uppvalue = 13; break;
      case 'e': uppvalue = 14; break;
      case 'f': uppvalue = 15; break;
      case 'A': uppvalue = 10; break;
      case 'B': uppvalue = 11; break;
      case 'C': uppvalue = 12; break;
      case 'D': uppvalue = 13; break;
      case 'E': uppvalue = 14; break;
      case 'F': uppvalue = 15; break;
      default: uppvalue = -1; break;
	}
	return uppvalue;
}