/* DROCARER.C is part of the MegaTraveller (C) character generation */
/* program. It is used each term to select the droyne characters career. */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

/*
#ifndef UNIX
#include <conio.h>
#endif
*/

#include "chargen.h"

extern void cascades();
extern void background();
extern void dfltech();
extern void dfltcareer();
extern void addskill(int skill, int skl_val);
extern char getche_y_n();
extern int d4();
extern int d6();
extern int d12();
extern void drorank();
extern void dromerc();
extern void dronavy();
extern void drotechy();
extern void drowarrior();
extern void drosport();
extern void droworker();
extern void drodrone();
extern void droleader();
extern int getsel_int(int min, int max);
extern void gotarmy();
extern void gotnavy();
extern void gotleader();
extern void bumpedu();
extern void bc(int skl_val);
extern void gc(int skl_val);
extern void drotech_sst(int roll);
extern void drowar_sst(int roll);
extern void drosprt_sst(int roll);
extern void drowrkr_sst(int roll);
extern void drodrn_sst(int roll);
extern void droldr_sst(int roll);
extern void altcareertbl();

void careers();
void getcareer();
void coyns();
int pickcaste(int roll);
void drocareer();
int setcaste();
void dropickcareer();
void drodraft();
void drogotleader();
void gotworker();
void gotdrone();
void gottechy();
void gotsport();
void gotwarrior();
void droweapon(int amount);
int getweap(int amount);
int swweap(int choice, int amount);
int pickweap(int amount);
void crosstrain();
void getct();
void swct(int choice);
void pickct();
void psionics(int amount);
int getpsi();
int swpsi(int choice);
int pickpsi();
int specialpsi();
int getspclpsi();
int swspclpsi(int roll);
int pickspclpsi();
void bumpsense();
int dropicktable();
int dro_dist(int neednbr, int modvalue, int modneeds);
void psionictrain();


void careers()
{
  cascades();
  dfltech();
  background();
  getcareer();
  printf("Career = %s (%d)\n", career, careernbr);
  dfltcareer();
  addskill(HOME, 0);
  addskill(INVISIBILITY, 0);
  if (edu >= 6) psionictrain();
  drocareer();
}


void getcareer()
{
  int choice;

  age = 12;
  appearent_age = age;
  coyns();
  printf("Career selection can be random or you can try to pick your\n");
  printf("characters career. Do you want to try to pick your characters\n");
  printf("career?");
  choice = getche_y_n();
  if (choice == 'Y' || choice == 'y') {
    dropickcareer();
  } else {
      drodraft();
  }
}


void coyns()
{
  int roll1, roll2;

  roll1 = 0;
  roll2 = 0;
  alt_career = 0;
  while (roll1 != 1) {
    roll1 = d6();
    roll2 = d6();
    if (roll2 == 1 && (roll1 == 2 || roll1 == 3 || roll1 == 6)) alt_career--;
    if (roll2 == 2) {
      if (roll1 == 3) alt_career--;
      if (roll1 == 5) alt_career++;
    }
    if (roll2 == 3 && (roll1 == 3 || roll1 == 5)) alt_career--;
    if (roll2 == 4) {
      if (roll1 == 5) alt_career--;
      if (roll1 == 4 || roll1 == 6) alt_career++;
    }
    if (roll2 == 5) {
      if (roll1 == 5) alt_career--;
      if (roll1 == 3) alt_career++;
    }
    if (roll2 == 6 && (roll1 == 2 || roll1 == 3 || roll1 >= 5)) alt_career++;
  }
  soc = pickcaste(roll2);
  drorank();
  printf("\n");
}


int pickcaste(int roll)
{
  int choice;

  printf("Do you wish to accept the result of the Coyns (A) or pick your characters\n");
  printf("caste (P)? Enter 'A' or 'P'->");
/*
#ifndef UNIX
  choice = getche();
#else
*/
  choice = getchar();
//#endif

  printf("\n");

  if (iscntrl(choice) != 0) {
    if (choice == 13) {
      choice = 'A';
      printf("I assume that meant accept the coyns\n");
    }
    else
      if (choice == 27) exit(-1);
  }
  if (choice == 'A' || choice == 'a') return roll;
  if (choice == 'P' || choice == 'p') return setcaste();
  printf("Wrong - try again\n");
  return pickcaste(roll);
}


void drocareer()
{
  switch (careernbr) {
    case ARMY: dromerc(); break;
    case NAVY: dronavy(); break;
    case SCIENTIST: drotechy(); break;
    case WARRIOR: drowarrior(); break;
    case SPORT: drosport(); break;
    case WORKER: droworker(); break;
    case DRONE: drodrone(); break;
    case PARTY: droleader(); break;
    default: printf("unknown Droyne career %d", careernbr); break;
  }
}


int setcaste()
{
  int   choice;

  printf("\nWhat caste do you want?\n\n");
  printf("   1. worker\n   2. warrior\n   3. drone\n");
  printf("   4. technician\n   5. sport\n   6. leader\n");
  choice = getsel_int(1, 6);
  return choice;
}


void dropickcareer()
{
  int   choice;

  if (careernbr != 0) return;
  printf("\nWhat career do you want?\n\n");
  printf("   1. pick one at random\n");
  printf("   2. army\n   3. navy\n");
  printf("   4. follow caste career\n");
  choice = getsel_int(1, 4);
  switch (choice) {
    case 2: gotarmy(); break;
    case 3: gotnavy(); break;
    default: drodraft(); break;
  }
}


void drodraft()
{
  switch (soc) {
    case 1: gotworker(); break;
    case 2: gotwarrior(); break;
    case 3: gotdrone(); break;
    case 4: gottechy(); break;
    case 5: gotsport(); break;
    case 6: drogotleader(); break;
  }
}


void drogotleader()
{
  soc = 6;
  gotleader();
}


void gotworker()
{
  strncpy(career,"Worker",7);
  careernbr = WORKER;
  soc = 1;
}


void gotdrone()
{
  strncpy(career,"Drone",6);
  careernbr = DRONE;
  soc = 3;
}


void gotsport()
{
  strncpy(career,"Sport",6);
  careernbr = SPORT;
  soc = 5;
}


void gotwarrior()
{
  strncpy(career,"Warrior",8);
  careernbr = WARRIOR;
  soc = 2;
}


void droweapon(int amount)
{
  int  skill;

  if (pick == 2 || pick == 4) {
    skill = getweap(amount);
  } else {
    skill = pickweap(amount);
  }
  addskill(skill, amount);
}


int getweap(int amount)
{
  int  choice;

  choice = d4();
  return swweap(choice, amount);
}


int swweap(int choice, int amount)
{
  switch (choice) {
    case 1: bc(amount); break;
    case 2: gc(amount); break;
    case 3: return UNARMEDCMBT;
    default: return NOGRAV;
  }
  return 0;
}


int pickweap(int amount)
{
  int choice;

  printf("You have the following options for the Weapon cascade skill.\n\n");
  printf("   1. blade combat *\n   2. gun combat *\n   3. unarmed combat\n");
  printf("   4. zero-G combat\n");
  choice = getsel_int(1, 4);
  return swweap(choice, amount);
}


void crosstrain()
{
  if (pick == 2 || pick == 4) {
    getct();
  } else {
    pickct();
  }
}


void getct()
{
  int  choice;

  choice = d6();
  if (choice == soc) getct();
  swct(choice);
}


void swct(int choice)
{
  int roll;

  roll = d6();
  switch (choice) {
    case 1: drowrkr_sst(roll); break;
    case 2: drowar_sst(roll); break;
    case 3: drodrn_sst(roll); break;
    case 4: drotech_sst(roll); break;
    case 5: drosprt_sst(roll); break;
    case 6: droldr_sst(roll); break;
  }
}


void pickct()
{
  int choice;

  printf("You have the following options for cross training.\n\n");
  printf("   1. worker skills\n   2. warrior skills\n   3. drone skills\n");
  printf("   4. technician skills\n   5. sport skills\n   6. leader skills\n");
  choice = getsel_int(1, 6);
  swct(choice);
}


void psionics(int amount)
{
  int  skill;

  if (edu < 6) {
    edu = 6;
    psionictrain();
  }
  if (pick == 2 || pick == 4) {
    skill = getpsi();
  } else {
    skill = pickpsi();
  }
  addskill(skill, amount);
}


int getpsi()
{
  int  roll;

  roll = d6();
  return swpsi(roll);
}


int swpsi(int choice)
{
  switch (choice) {
    case 1: return TELEPATHY;
    case 2: return CLAIRVOYANCE;
    case 3: return TELEKINESIS;
    case 4: return AWARENESS;
    case 5: return TELEPORTATION;
    case 6: return specialpsi();
  }
  printf("You failed to get any psionic skills.\n");
  return 0;
}


int pickpsi()
{
  int choice;

  printf("You have the following options for psionics.\n\n");
  printf("   1. telepathy\n   2. clairvoyance\n   3. telekinesis\n");
  printf("   4. awareness\n   5. teleportation\n");   
  printf("   6. Droyne specific psionic skill\n");
  choice = getsel_int(1, 6);
  return swpsi(choice);
}


int specialpsi()
{
  int skill;

  if (pick == 2 || pick == 4) {
    skill = getspclpsi();
  } else {
    skill = pickspclpsi();
  }
  return skill;
}


int getspclpsi()
{
  int roll;

  roll = d6();
  return swspclpsi(roll);
}


int swspclpsi(int roll)
{
  switch (roll) {
    case 1: return INVISIBILITY;
    case 2: return TRAIN;
    case 3: return HOME;
    case 4: return LINK;
    case 5: return INWARDEYE;
    default: return REJUVENATION;
  }
}


int pickspclpsi()
{
  int choice;

  printf("You have the following options for Droyne specific psionics.\n\n");
  printf("   1. invisibility\n   2. train\n   3. home\n");
  printf("   4. link\n   5. inward eye\n   6. rejuvenation\n");
  choice = getsel_int(1, 6);
  return swspclpsi(choice);
}


void bumpsense()
{
  bumpedu();
  if (edu == 6) {
    psionictrain();
  }
}


int dropicktable()
{
  int  choice;

  if (pick <= 2) {
    printf("\nSelect the %s skill table you want to use.\n\n", career);
    printf("   1. personal development\n   2. service\n");
    printf("   3. education\n");
    printf("   4. %s caste\n", career);
    choice = getsel_int(1, 4);
  } else {
    choice = d6();
    if (choice == 6) choice = 2;
    if (choice == 5) choice = 4;
  }
  return choice;
}


int dro_dist(int neednbr, int modvalue, int modneeds)
{
  int  roll;

  roll = d12();
  if (modvalue >= modneeds) roll++; 
  if (roll >= neednbr) {
    printf("You achieved distinction!\n");
    mcuf++;
    if (roll >= (neednbr + 4)) return 2;
    return 1;
  }
  return 0;
}


void psionictrain()
{
  int  skill, choice, try, roll, count;

  printf("You received psionic training!\n");
  count = 0;
  choice = 0;
  while (count < 6 && choice == 0) {
    try = d6();
    roll = d12();
    if ((try + count + 3) <= 12) {
      if (roll >= (try + count + 3)) {
        choice = try;
        skill = swpsi(choice);
        if (skill != 0) addskill(skill, 1);
      }
    }
    count++;
  }
}


void altcareertbl()
{
}
