/* DROLEADR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>


void droleader();
void droldrmot(int term);
void droldrskills(int skills);
void droldr_pdt(int roll);
void droldr_sst(int roll);

extern int d6();
extern int basic_surv(int need_nbr, int upp, int upp_val);
extern int dro_dist(int need_nbr, int upp, int upp_val);
extern int reenlist(int need_nbr);
extern int basic_bene();
extern int basic_spec_duty(int roll);
extern void bumpsense();
extern void bumpintl();
extern int dropicktable();
extern void crosstrain();
extern void psionics();
extern void spac(int skl_val);
extern void vc(int skl_val);
extern void addskill(int skill, int skl_val);

#include "chargen.h"

void droleader()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    if (terms == 1) droldr_pdt(d6());
    newterm = basic_surv(5, intl, 5);
    skills = 0;
    if (newterm == 0) {
      skills = basic_spec_duty(5) + 1;
      skills += dro_dist(8, intl, 5);
    }
    if (skills != 0) droldrskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(0);
  }
  terms = terms - anagathics;
  droldrmot(terms);
}


void droldrmot(int term)
{
  int  roll;
  
  while (term > 0) {
    term--;
    roll = basic_bene();
    switch (roll) {
      case 1: bumpintl(); bumpintl(); break;
      case 2: weapons++; break;
      case 3: weapons++; break;
      case 4: weapons++; break;
      case 5: hipsg++; break;
      default: ship++; break;
    }
  }
}


void droldrskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = dropicktable();
    roll = d6();
    if (table == 1) {
      droldr_pdt(roll);
    }
    if (table == 2) {
      droldr_sst(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(LEADER, 1); break;
        case 2: addskill(LEADER, 1); break;
        case 3: addskill(LEADER, 1); break;
        case 4: addskill(INTERROGATE, 1); break;
        case 5: addskill(LIAISON, 1); break;
        case 6: crosstrain(1); break;
      }
    }
    if (table == 4) {
      if (alt_career < 0) {
        switch (roll) {
          case 1: addskill(LEADER, 1); break;
          case 2: addskill(APPEAL, 1); break;
          case 3: addskill(LIAISON, 1); break;
          case 4: spac(1); break;
          case 5: spac(1); break;
          case 6: addskill(LEADER, 1); break;
        }
      } else {
        if (alt_career == 0) {
          switch (roll) {
            case 1: addskill(LEADER, 1); break;
            case 2: addskill(LEADER, 1); break;
            case 3: addskill(INSTRUCTION, 1); break;
            case 4: addskill(INTERROGATE, 1); break;
            case 5: addskill(PREDICTION, 1); break;
            case 6: bumpsense(); bumpsense(); break;
          }
        } else {
          switch (roll) {
            case 1: addskill(LEADER, 1); break;
            case 2: addskill(LEADER, 1); break;
            case 3: addskill(LEADER, 1); break;
            case 4: bumpintl(); break;
            case 5: vc(1); break;
            case 6: spac(1); break;
          }
        }
      }
    }
    skills--;
  }
}


void droldr_pdt(int roll)
{
  switch (roll) {
    case 1: addskill(LEADER, 1); break;
    case 2: addskill(APPEAL, 1); break;
    case 3: addskill(LIAISON, 1); break;
    case 4: crosstrain(1); break;
    case 5: bumpsense(); bumpsense(); break;
    case 6: bumpintl(); bumpintl(); break;
  }
}


void droldr_sst(int roll)
{
  switch (roll) {
    case 1: addskill(LIAISON, 1); break;
    case 2: addskill(APPEAL, 1); break;
    case 3: addskill(LEADER, 1); break;
    case 4: addskill(LIAISON, 1); break;
    case 5: addskill(FLYING, 1); break;
    case 6: addskill(FLYING, 1); break;
  }
}

