/* DROMERC.C is a MegaTraveller (c) aid for Droyne Mercenary */
/* character generation written by Greg Svenson*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void dromerc();
void army_get_branch();
int army_set_branch();
int army_pickbranch();
void merc_do_initial();
int merc_doterms();
int merc_xfer();
void merc_branch(int branch_nbr);
int merc_do_year();
void armymot(int term);
void merc_branch_tbl(int brnch);
void merc_war();
void merc_drone();
void merc_tech();
void merc_inf();
void merc_arty();
void merc_recon();
void merc_militia();
void merc_sport();
void merc_leader();
void merc_sup();
void drop_troops();
void merc_spcl_asgn();
void sch_msg();
int ldr_pick_sch();
int ldr_pick_sprt();
int ldr_pick_tech();
int ldr_pick_war();
int ldr_pick_wrkr();
int want_school();
int try_school();
int aide_pick_sch();
void merc_attache();
void merc_spcl_sch();
void skirmish_sch();
void orbtl_aslt_sch();
void merc_gen_skl();
void merc_caste();
int merc_pick_tbl();
int merc_asgn();
int recon_mos();
int drop_mos();
void merc_cross_train();

extern int d2();
extern int d3();
extern int d4();
extern int d6();
extern int d12();
extern int getsel_int(int min, int max);
extern int anag();
extern char getche_y_n();
extern void adv_dstnctn();
extern int survive(int roll, int adjust);
extern int bp_skill(int roll);
extern int bp_skill1(int roll, int need_nbr);
extern void bp_cmbt();
extern int reenlist(int need_nbr);
extern void bumpsense();
extern void bumpintl();
extern void bumpstr();
extern void bumpdex();
extern void drowarmot(int term);
extern void drodrnmot(int term);
extern void drotechmot(int term);
extern void drosprtmot(int term);
extern void droldrmot(int term);
extern void psionics(int skl_val);
extern void bc(int skl_val);
extern void gc(int skl_val);
extern void vhcl(int skl_val);
extern void fag(int skl_val);
extern void weapon(int skl_val);
extern int wrkr_pick_sch();
extern int war_pick_sch();
extern int tech_pick_sch();
extern int sprt_pick_sch();
extern void merc_cmd_col();
extern void merc_staff_col();
extern void merc_prot_frcs();
extern void merc_intl_sch();
extern int get_bigint();
extern void droyne_life();
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern void bp_add(int amt);
extern int ask_adj_asgn(int roll);
extern void gotspcldty(int spcldutynbr);
extern void instructor(int spcldutynbr);

#include "chargen.h"

int  merc_cross[7];

extern int  aide, nv_anag, distinction, distn;

void dromerc()
{
  int i;

  for (i = 1; i <= 6; i++) {
    merc_cross[i] = 0;
  }
  aide = 0;
  army_get_branch();
  merc_do_initial();
  while (merc_doterms() == 0);
  terms = terms - anagathics;
  armymot(terms);
}


void army_get_branch()
{
  if (branch == 0) {
    if (pick != 4) {
      branch = army_pickbranch();
    } else {
      branch = army_set_branch();
    }
  }
  merc_cross[branch]++;
  merc_branch(branch);
  printf("You were assigned to the %s branch.\n", office);
}


int army_set_branch()
{
  int roll;

  roll = d4();
  if (soc == 1) {
    if (roll <= 2) return 4;
    else return 1;
  }
  if (soc == 2) {
    if (roll <= 2) return 2;
    else return 1;
  }
  if (soc == 3) {
    return 4;
  }
  if (soc == 4) {
    if (roll <= 2) return 3;
    else return 4;
  }
  if (soc == 5) {
    if (roll <= 2) return 2;
    else return 4;
  }
  return roll;
}


int army_pickbranch()
{
  int choice;
  
  printf("You have the option to choose the branch you wish to serve in\n"); 
  printf("within the Droyne Army.\n");
  printf("\n   1. pick one at random\n");   
  if (soc <= 2 || soc == 6) printf("   2. infantry\n");
  if (soc == 2 || soc >= 5) printf("   3. recon\n");   
  if (soc == 4 || soc == 6) printf("   4. artillery\n");
  if (soc != 2) printf("   5. support\n");
  choice = getsel_int(1, 5);
  if (choice == 1) {
    return army_set_branch();
  }
  return (choice - 1);
}


void merc_do_initial()
{
  merc_branch_tbl(branch);
  merc_branch_tbl(branch);
  age++;
  nv_anag = anag();
  if (nv_anag == 0) appearent_age++;
}


extern int assignment, combat;

int merc_doterms()
{
  int survival;
  
  combat = 0; 
  assignment = 0;
  distn = 0;
  do {
    survival = merc_do_year();
  } while (((age % 4) != 0) && (survival == 0));
  if (survival != 0) return 1;
  survival = reenlist(0);
  if (distinction < 0 || survival != 0) return 1; 
  drafted = 0;
  branch = merc_xfer();
  nv_anag = anag();
  return 0;
}


int merc_xfer()
{
  char choice;
  int  i, roll;

  if (distinction <= 0) return branch;
  if (pick == 4) {
    roll = d6();
    if (merc_cross[roll] == 0) {
      merc_branch(branch);
      printf("You are in the %s branch.\n", office);
      return branch;
    } else {
      merc_branch(roll);
      printf("You are in the %s branch.\n", office);
      return roll;
    }
  }
  for (i = 1; i <= 6; i++) {
    if (merc_cross[i] != 0 && branch != i) {
      merc_branch(i);
      printf("You have the option to transfer to the %s branch.\n", office); 
      printf("Do you want to?");
      choice = getche_y_n();
      if (choice == 'Y' || choice == 'y') return i;
    }
  }
  return branch;
}


void merc_branch(int branch_nbr)
{
  switch (branch_nbr) {
    case 1: strncpy(office,"Infantry",9); break;
    case 2: strncpy(office,"Recon",6); break; 
    case 3: strncpy(office,"Artillery",10); break; 
    case 4: strncpy(office,"Support",8); break; 
    case 5: strncpy(office,"Militia",8); break; 
    case 6: strncpy(office,"Drop-Troops",12); break; 
    default: strncpy(office,"unknown?",9); break;
  }
}


int merc_do_year()
{
  int   adjust, roll;
  
  age++;
  if (nv_anag == 0) appearent_age++;
  assignment = merc_asgn();
  printf("branch = %d, assignment = %d\n", branch, assignment);
  if (decor > 0) {
    if (branch == 6) decor--;
    if ((branch == 1 || branch == 5) && intl >= 8) decor--;
    if (branch == 2 && end >= 8) decor--;
  }
  adjust = 0;
  adv_dstnctn(adjust);
  if (assignment == 10) merc_spcl_asgn();
  if (skil != 0) {
    roll = d12();
    if (roll < skil) roll = bp_skill(roll);
    if (roll >= (skil + 4)) merc_gen_skl();
    if (roll >= skil) merc_gen_skl();
  }
  roll = d12();
  if (roll == (surv - adjust)) {
    printf("You were wounded!\n");
    distinction += 5;
  }
  if (distinction < 1 && branch != 5) {
    branch = 5;
    merc_branch(branch);
    printf("You were transfered to the %s.\n", office);
  }
  return survive(roll, adjust);
}


void armymot(int term)
{
  term += mcuf;
  switch (soc) {
    case 1: break;
    case 2: drowarmot(term); break;
    case 3: drodrnmot(term); break;
    case 4: drotechmot(term); break;
    case 5: drosprtmot(term); break;
    case 6: droldrmot(term); break;
  }
}


void merc_branch_tbl(int brnch)
{
  switch (brnch) {
    case 1: merc_inf(); break;
    case 2: merc_recon(); break;
    case 3: merc_arty(); break;
    case 4: merc_sup(); break;
    case 5: merc_militia(); break;
    case 6: drop_troops(); break;
  }
}


void merc_war()
{
  int  roll;

  roll = d6();
  roll += terms;  
  switch (roll) {
    case 1: gc(1); break;
    case 2: weapon(2); break;
    case 3: bumpstr(); bumpstr(); break;
    case 4: addskill(UNARMEDCMBT, 1); break;
    case 5: bumpdex(); bumpdex(); break;
    case 6: bc(1); break;
    case 7: addskill(NOGRAV, 1); break;
    case 8: weapon(2); break;
    default: addskill(TACTICS, 1); break;
  }
}


void merc_drone()
{
  int  roll;

  roll = d6();
  roll += terms;  
  switch (roll) {
    default: addskill(STEWARD, 1); break;
    case 2: addskill(MEDICAL, 1); break;
    case 4: bumpsense(); bumpsense(); break;
    case 6: vhcl(1); break;
    case 8: addskill(INSTRUCTION, 1); break;
    case 9: psionics(1); break;
  }
}


void merc_tech()
{
  int  roll;

  roll = d6();
  roll += terms;  
  switch (roll) {
    case 1: addskill(MECHANICAL, 1); break;
    default: addskill(ELECTRONICS, 1); break;
    case 3: addskill(GRAVITICS, 1); break;
    case 4: addskill(COMPUTER, 1); break;
    case 5: vhcl(1); break;
    case 6: vhcl(1); break;
    case 8: addskill(HANDYMAN, 1); break;
    case 9: addskill(MEDICAL, 1); break;
  }
}


void merc_inf()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 1: weapon(2); break;
    case 2: addskill(HEAVYWEAP, 1); break;
    case 3: addskill(BATTLEDRESS, 1); break;
    case 4: addskill(SURVIVAL, 1); break;
    case 5: weapon(2); break;
    case 6: addskill(HEAVYWEAP, 1); break;
    case 7: addskill(HANDYMAN, 1); break;
    default: addskill(TACTICS, 1); break;
  }
}


void merc_arty()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 1: fag(1); break;
    case 2: fag(1); break;
    case 3: fag(1); break;
    case 4: addskill(HEAVYWEAP, 1); break;
    case 5: vhcl(1); break;
    case 7: addskill(ELECTRONICS, 1); break;
    case 8: vhcl(1); break;
    default: addskill(COMPUTER, 1); break;
 }
}


void merc_recon()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 1: vhcl(1); break;
    case 2: addskill(HEAVYWEAP, 1); break;
    case 3: addskill(BATTLEDRESS, 1); break;
    case 4: vhcl(1); break;
    case 5: addskill(RECON, 1); break;
    case 6: vhcl(1); break;
    case 7: addskill(HANDYMAN, 1); break;
    default: addskill(TACTICS, 1); break;
 }
}


void merc_militia()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 1: weapon(2); break;
    case 2: addskill(HEAVYWEAP, 1); break;
    case 4: addskill(SURVIVAL, 1); break;
    case 3: addskill(RECON, 1); break;
    case 5: vhcl(1); break;
    case 6: addskill(FLYING, 1); break;
    default: weapon(1); break;
 }
}


void merc_sport()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    default: addskill(LIAISON, 1); break;
    case 2: addskill(COMPUTER, 1); break;
    case 3: addskill(CAROUSING, 1); break;
    case 4: addskill(APPEAL, 1); break;
    case 5: vhcl(1); break;
    case 6: addskill(VACCSUIT, 1); break;
    case 7: addskill(PILOT, 1); break;
    case 9: merc_cross_train(1); break;
  }
}


void merc_leader()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    default: addskill(LEADER, 1); break;
    case 2: addskill(ADMIN, 1); break;
    case 3: bumpintl(); bumpintl(); break;
    case 4: addskill(INSTRUCTION, 1); break;
    case 5: addskill(APPEAL, 1); break;
    case 7: bumpintl(); bumpintl(); break;
    case 9: addskill(ADMIN, 1); break;
  }
}


void merc_sup()
{
  int  roll;

  roll = d6();
  if (soc == 3) roll += 3;
  switch (roll) {
    case 5: addskill(COMPUTER, 1); break;
    case 3: addskill(GRAVITICS, 1); break;
    case 2: addskill(ELECTRONICS, 1); break;
    case 1: addskill(MECHANICAL, 1); break;
    case 4: addskill(HANDYMAN, 1); break;
    case 6: psionics(1); break;
    case 7: psionics(1); break;
    default: addskill(STEWARD, 1); break;
  }
}


void drop_troops()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 1: weapon(2); break;
    case 2: addskill(VACCSUIT, 1); break;
    case 3: addskill(BATTLEDRESS, 1); break;
    case 4: addskill(NOGRAV, 1); break;
    case 5: weapon(2); break;
    case 6: addskill(PILOT, 1); break;
    case 7: addskill(FLYING, 1); break;
    case 8: addskill(NOGRAV, 1); break;
    default: vhcl(1); break;
  }
}


void merc_spcl_asgn()
{
  int roll;
  
  if (soc == 3) {
    addskill(STEWARD, 1);
    bumpsense();
    bumpsense();
    printf("You were an Aide.\n");
    return;
  }
  if (aide != 0) {
    aide = 0;
    roll = aide_pick_sch();
  } else {
    if (pick >= 3) {
      switch (soc) {
        case 1: roll = d2(); break;
        case 2: roll = d4(); break;
        case 4: roll = d3(); break;
        case 5: roll = d4(); break;
        case 6: roll = d4(); break;
      }
    } else {
      switch (soc) {
        case 1: roll = wrkr_pick_sch(); break;
        case 2: roll = war_pick_sch(); break;
        case 4: roll = tech_pick_sch(); break;
        case 5: roll = sprt_pick_sch(); break;
        case 6: roll = ldr_pick_sch(); break;
      }
    }
  }
  if (roll <= 1) {
    merc_cross_train();
    return;
  }
  if (roll == 2) {
    switch (soc) {
      case 1: merc_prot_frcs(); break;
      case 2: merc_prot_frcs(); break;
      case 4: merc_spcl_sch(); break;
      case 5: merc_attache(); break;
      case 6: merc_cmd_col(); break;
    }
  }
  if (roll == 3) {
    switch (soc) {
      case 2: orbtl_aslt_sch(); break;
      case 4: merc_staff_col(); break;
      case 5: merc_intl_sch(); break;
      case 6: merc_staff_col(); break;
    }
  }
  if (roll == 4) {
    switch (soc) {
      case 2: skirmish_sch(); break;
      case 5: merc_staff_col(); break;
      case 6: merc_intl_sch(); break;
    }
  }
}


void sch_msg()
{
  printf("Which service school do you wish to attend?\n\n");
  printf("   1. cross training\n");
}


int ldr_pick_sch()
{
  int choice;

  sch_msg();
  printf("   2. command college\n");
  printf("   3. staff college\n");
  printf("   4. intelligence school\n");
  choice = getsel_int(1, 4);
  return choice;
}


int sprt_pick_sch()
{
  int choice;

  sch_msg();
  printf("   2. generals attache\n");
  printf("   3. intelligence school\n");
  printf("   4. staff college\n");
  choice = getsel_int(1, 4);
  return choice;
}


int tech_pick_sch()
{
  int choice;

  sch_msg();
  printf("   2. specialist school\n");
  printf("   3. staff college\n");
  choice = getsel_int(1, 3);
  return choice;
}


int war_pick_sch()
{
  int choice;

  sch_msg();
  printf("   2. protected forces school\n");
  printf("   3. orbital assult school\n");
  printf("   4. skirmisher school\n");
  choice = getsel_int(1, 4);
  return choice;
}


int wrkr_pick_sch()
{
  int choice;

  sch_msg();
  printf("   2. protected forces school\n");
  choice = getsel_int(1, 2);
  return choice;
}


int want_school()
{
  char choice;
  
  if (pick >= 3) {
    if (distinction >= 12) return try_school();
    else return 0;
  }
  printf("You have %d distinction points, do you want to apply\n", distinction); 
  printf("for a service school?");
  choice = getche_y_n();
  printf("\n");
  if (choice == 'Y' || choice == 'y') return try_school();
  return 0;
}


int try_school()
{
  int points, roll;

  if (pick >= 3) points = 8;
  else {
    printf("Enter the number of distinction points you want to expend to get in.\n->");
    points = get_bigint();
    if (points == 0) return 0;
    if (points < 2 || points > distinction) {
      printf("You need at least 2 points to have a chance and you can not exceed\n");
      printf("your total distinction points (%d). Try again.\n", distinction);
      return try_school();
    }
  }
  distinction -= points;
  printf("You distinction is now %d. ", distinction);
  roll = d12();
  if (roll <= points) {
    printf("You got a special assignment!\n");
    return 10;
  }
  printf("You failed to get a special assignment, sorry.\n");
  return 0;
}


int aide_pick_sch()
{
  int choice;

  printf("As an Generals Attache you can pick your next assignment.\n\n");
  printf("   1. cross training\n   2. intelligence school\n");
  printf("   3. staff college\n");
  choice = getsel_int(1, 3);
  if (choice == 1) return 1;
  if (choice == 2) return 3;
  return 4;
}


void merc_attache()
{
  distinction += 5;
  aide = 1;
  printf("You got 5 distinction during your year as an Generals Attache.\n");
}


void merc_spcl_sch()
{
	int roll;

	gotspcldty(SPECIALISTSCH);
	if (special_duty[SPECIALISTSCH] > 1)
	{
		if ((chk_skl(COMPUTER, 4) == 1) || (chk_skl(ELECTRONICS, 4) == 1) 
			|| (chk_skl(GRAVITICS, 4) == 1) || (chk_skl(MECHANICAL, 4) == 1))
		{
			instructor(SPECIALISTSCH);
			return;
		}
	}
	roll = bp_skill1(d6(), 4);
	if (roll >= 4) addskill(COMPUTER, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4) addskill(ELECTRONICS, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4) addskill(GRAVITICS, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4) addskill(MECHANICAL, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4) vhcl(1);
}


void skirmish_sch()
{
  int roll;

	gotspcldty(DROSKIRMISHSCH);
	if (special_duty[DROSKIRMISHSCH] > 1)
	{
		if ((chk_skl(DEMOLITIONS, 4) == 1) || (chk_skl(SURVIVAL, 4) == 1) 
			|| (chk_skl(RECON, 4) == 1) || (chk_skl(SMALLBLAD, 4) == 1)
			|| (chk_skl(FOIL, 4) == 1) || (chk_skl(CUDGEL, 4) == 1)
			|| (chk_skl(AXE, 4) == 1) || (chk_skl(POLEARM, 4) == 1)
			|| (chk_skl(HANDGUN, 4) == 1) || (chk_skl(RIFLMAN, 4) == 1)
			|| (chk_skl(CMBTRIFLMAN, 4) == 1) || (chk_skl(SUBMG, 4) == 1)
			|| (chk_skl(ENERGYWEAP, 4) == 1) || (chk_skl(LASERWEAP, 4) == 1)
			|| (chk_skl(NEURALWEAP, 4) == 1) || (chk_skl(LARGEBLAD, 4) == 1))
		{
			instructor(DROSKIRMISHSCH);
			return;
		}
	}
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(DEMOLITIONS, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) gc(1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(SURVIVAL, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) bc(1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(RECON, 1);
}


void orbtl_aslt_sch()
{
  int roll;

	gotspcldty(DROORBITALASLTSCH);
	if (special_duty[DROORBITALASLTSCH] > 1)
	{
		if ((chk_skl(HEAVYWEAP, 4) == 1) || (chk_skl(SURVIVAL, 4) == 1) 
			|| (chk_skl(RECON, 4) == 1) || (chk_skl(TACTICS, 4) == 1)
			|| (chk_skl(HANDGUN, 4) == 1) || (chk_skl(RIFLMAN, 4) == 1)
			|| (chk_skl(CMBTRIFLMAN, 4) == 1) || (chk_skl(SUBMG, 4) == 1)
			|| (chk_skl(ENERGYWEAP, 4) == 1) || (chk_skl(LASERWEAP, 4) == 1)
			|| (chk_skl(NEURALWEAP, 4) == 1) || (chk_skl(BATTLEDRESS, 4) == 1))
		{
			instructor(DROORBITALASLTSCH);
			return;
		}
	}
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(HEAVYWEAP, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) gc(1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(SURVIVAL, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(BATTLEDRESS, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(RECON, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(TACTICS, 1);
}


void merc_gen_skl()
{
  int roll;

  if (pick <= 2) roll = merc_pick_tbl();
  else roll = d3();
  if (roll == 1) droyne_life();
  if (roll == 2) merc_branch_tbl(branch);
  if (roll == 3) merc_caste();
}


void merc_caste()
{
  switch (soc) {
    case 1: droyne_life(); break;
    case 2: merc_war(); break;
    case 3: merc_drone(); break;
    case 4: merc_tech(); break;
    case 5: merc_sport(); break;
    case 6: merc_leader(); break;
  }
}


int merc_pick_tbl()
{
  int choice;
  printf("\nPlease select the table you wish to use for your new skill.\n");
  printf("\n   1. Droyne life\n");   
  merc_branch(branch); 
  printf("   2. The table for %s\n", office); 
  printf("   3. The table for your caste\n");
  choice = getsel_int(1, 3);
  return choice;
}


int merc_asgn()
{
  int roll, asgnmt;

  combat = 0;
  if (aide == 1)
  {
    printf("You were assigned to special duty.\n");
    return 10;
  }
  skil = 0; surv = 0; decor = 0;
  if (distinction > 2)
  {
    asgnmt = want_school();
    if (asgnmt != 0) return asgnmt;
  }
  roll = d12();
  if (pick == 1)
	  roll = ask_adj_asgn(roll);
  if (branch == 4)
  {
    if (pick == 4 && (roll == 3 || roll == 7) && brownie_points > 3)
	{
		roll--;
		bp_cmbt();
	}
    if (pick == 4 && roll == 10 && brownie_points > 3)
	{
		roll++;
		bp_cmbt();
	}
	switch (roll)
	{
      case 2: asgnmt = 4; break;
      case 3: asgnmt = 5; break;
      case 4: asgnmt = 2; break;
      case 5: asgnmt = 8; break;
      case 6: asgnmt = 8; break;
      case 7: asgnmt = 6; break;
      case 8: asgnmt = 1; break;
      case 9: asgnmt = 1; break;
      case 10: asgnmt = 6; break;
      case 11: asgnmt = 2; break;
      case 12: asgnmt = 8; break;
      default: asgnmt = 7; break;
    }
    surv = 4;
    decor = 5;
    skil = 8;
    switch (asgnmt) 
	{
      case 1: surv = 0; decor = 7; skil = 8; break;
      case 2: decor = 6; skil = 7; break;
      case 4: surv = 6; decor = 6; break;
      case 5: surv = 4; skil = 7; break;
      case 6: break;
      case 7: surv = 7; break;
      case 8: decor = 7; skil = 7; break;
    }
  }
  if (branch == 3)
  {
    if (pick == 4 && (roll == 4 || roll == 6) && brownie_points > 3)
	{
		roll--;
		bp_cmbt();
	}
    switch (roll)
	{
      case 2: asgnmt = 4; break;
      case 3: asgnmt = 2; break;
      case 4: asgnmt = 5; break;
      case 5: asgnmt = 8; break;
      case 6: asgnmt = 5; break;
      case 7: asgnmt = 6; break;
      case 8: asgnmt = 1; break;
      case 9: asgnmt = 1; break;
      case 10: asgnmt = 5; break;
      case 11: asgnmt = 5; break;
      case 12: asgnmt = 5; break;
      default: asgnmt = 7; break;
    }
    surv = 4;
    decor = 5;
    skil = 7;
    switch (asgnmt)
	{
      case 1: surv = 0; decor = 6; skil = 9; break;
      case 2: skil = 6; break;
      case 4: surv = 5; decor = 4; skil = 6; break;
      case 5: surv = 6; break;
      case 6: surv = 3; break;
      case 7: surv = 7; decor = 4; skil = 6; break;
      case 8: break;
    }
  }
  if (branch == 1 || branch == 2)
  {
    if (pick == 4 && ((branch == 1 && roll == 7)
		|| (branch == 2 && roll == 6))
		&& brownie_points > 3)
	{
		roll--;
		bp_cmbt();
	}
    if (pick == 4 && roll == 10 && brownie_points > 3)
	{
		roll++;
		bp_cmbt();
	}
    switch (roll)
	{
      case 2: asgnmt = 4; break;
      case 3: asgnmt = 4; break;
      case 4: asgnmt = 2; break;
      case 5: asgnmt = 2; break;
      case 6:
			{
				if (branch == 1) asgnmt = 2;
				else asgnmt = 5;
			}
			break;
      case 7: asgnmt = 6; break;
      case 8: asgnmt = 1; break;
      case 9: asgnmt = 1; break;
      case 10: asgnmt = 5; break;
      case 11:
		  {
			    if (branch == 1) asgnmt = 3;
				else asgnmt = 5;
			}
			break;
      case 12: asgnmt = 3; break;
      default: asgnmt = 7; break;
    }
    if (branch == 1)
	{
      surv = 6;
      decor = 4;
      skil = 7;
      switch (asgnmt)
	  {
        case 1: surv = 0; decor = 7; skil = 8; break;
        case 2: surv = 5; skil = 6; break;
        case 3: decor = 3; break;
        case 4: surv = 7; decor = 3; skil = 8; break;
        case 5: break;
        case 7: skil = 6; break;
        case 6: surv = 5; decor = 5; break;
      }
      if (intl >= 8 && decor != 0) decor--;
    }
    if (branch == 2)
	{
      surv = 7;
      decor = 5;
      skil = 7;
      switch (asgnmt)
	  {
        case 1: surv = 0; decor = 6; skil = 9; break;
        case 2: surv = 5; skil = 5; break;
        case 3: surv = 6; break;
        case 4: decor = 4; skil = 5; break;
        case 5: break;
        case 6: surv = 6; skil = 8; break;
        case 7: decor = 4; break;
      }
      if (recon_mos() != 0 && surv != 0) surv--; /* check mos */
      if (end >= 8 && decor != 0) decor--;
    }
  }
  if (branch == 6)
  {
    if (pick == 4 && (roll == 4 || roll == 7) && brownie_points > 3)
	{
		roll--;
		bp_cmbt();
	}
    if (pick == 4 && roll == 9 && brownie_points > 3)
	{
		roll++;
		bp_cmbt();
	}
    switch (roll)
	{
      case 2: asgnmt = 4; break;
      case 3: asgnmt = 4; break;
      case 4: asgnmt = 5; break;
      case 5: asgnmt = 2; break;
      case 6: asgnmt = 2; break;
      case 7: asgnmt = 3; break;
      case 8: asgnmt = 1; break;
      case 9: asgnmt = 3; break;
      case 10: asgnmt = 8; break;
      case 11: asgnmt = 8; break;
      case 12: asgnmt = 4; break;
      default: asgnmt = 7; break;
    }
    surv = 7;
    decor = 4;
    skil = 5;
    switch (asgnmt)
	{
      case 1: surv = 0; decor = 6; skil = 8; break;
      case 2: surv = 6; break;
      case 3: decor = 5; skil = 6; break;
      case 4: surv = 8; skil = 7; break;
      case 5: decor = 5; skil = 6; break;
      case 7: break;
      case 8: surv = 6; decor = 3; break;
    }
    if (drop_mos() != 0 && surv != 0) surv--;
  }
  if (branch == 5)
  {
    if (pick == 4 && (roll == 3 || roll == 11) && brownie_points > 3)
	{
		roll++;
		bp_cmbt();
	}
    if (pick == 4 && roll == 6 && brownie_points > 3)
	{
		roll--;
		bp_cmbt();
	}
    switch (roll)
	{
      case 2: asgnmt = 9; break;
      case 3: asgnmt = 9; break;
      case 4: asgnmt = 2; break;
      case 5: asgnmt = 8; break;
      case 6: asgnmt = 5; break;
      case 7: asgnmt = 6; break;
      case 8: asgnmt = 1; break;
      case 9: asgnmt = 6; break;
      case 10: asgnmt = 6; break;
      case 11: asgnmt = 9; break;
      case 12: asgnmt = 4; break;
      default: asgnmt = 7; break;
    }
    surv = 8;
    decor = 4;
    skil = 7;
    switch (asgnmt)
	{
      case 1: surv = 0; decor = 7; skil = 8; break;
      case 2: surv = 4; break;
      case 4: surv = 6; decor = 5; break;
      case 5: surv = 6; break;
      case 6: surv = 5; decor = 5; break;
      case 7: surv = 8; decor = 3; skil = 6; break;
      case 8: surv = 4; break;
      case 9: decor = 5; break;
    }
    if (intl >= 8 && decor != 0) decor--;
  }
  printf("This is ");
  switch (asgnmt)
  {
    case 1: printf("training.\n"); break;
    case 2: printf("police action.\n"); cmbt++; combat++; break;
    case 3: printf("ships troops.\n"); break;
    case 4: printf("a raid.\n"); cmbt++; combat++; break;
    case 5: printf("internal security.\n"); break;
    case 6: printf("garrison.\n"); break;
    case 7: printf("an expedition.\n"); break;
    case 8: printf("counterinsurgency.\n"); cmbt++; combat++; break;
    case 9: printf("guerrilla warfare.\n"); break;
    case 10: printf("special duty.\n"); break;
    default: printf("unknown asgnmt %d\n", asgnmt);
  }
  return asgnmt;
}


int recon_mos()
{
  int qual;

  qual = chk_skl(HEAVYWEAP, 2);
  if (qual == 0) qual = chk_skl(BATTLEDRESS, 2);
  if (qual == 0) qual = chk_skl(RECON, 2);
  if (qual == 0) qual = chk_skl(VEHICLE, 2);
  if (qual == 0) qual = chk_skl(TACTICS, 2);
  if (qual == 0) qual = chk_skl(HANDYMAN, 2);
  if (qual != 0) return 1;
  return 0;
}


int drop_mos()
{
  int qual;

  qual = chk_skl(GUNCMBT, 2);
  if (qual == 0) qual = chk_skl(NOGRAV, 2);
  if (qual == 0) qual = chk_skl(BATTLEDRESS, 2);
  if (qual == 0) qual = chk_skl(PILOT, 2);
  if (qual == 0) qual = chk_skl(FLYING, 2);
  if (qual == 0) qual = chk_skl(VEHICLE, 2);
  if (qual != 0) return 1;
  return 0;
}


void merc_cross_train()
{
  int  roll;

  printf("You got cross-training.\n");
  if (soc == 3)
  {
    printf("Opps! Sorry, Drones can't get cross training!\n");
    return;
  }
  bp_add(1);
  if (pick >= 3) {
    if (soc == 1 || soc == 4) {
      roll = d2() + 2;
      if (soc == 1 && roll == 3) roll = 1;
    } else {
      if (soc == 2 || soc == 5) {
        roll = d3();
        if (roll == 3) roll = 6;
      } else {
        roll = d6();
      }
    }
    merc_cross[roll]++;
    merc_branch_tbl(roll);
    return;
  }
  printf("You have the option to get cross-training in any field. Pick one.\n");
  if (soc <= 2 || soc >= 5) {
    printf("\n   1. infantry ");
    if (merc_cross[1] > 0) printf("*");
  }
  if (soc == 2 || soc >= 5) {
    printf("\n   2. recon ");
    if (merc_cross[2] > 0) printf("*");
  }
  if (soc == 4 || soc == 6) {
    printf("\n   3. artillery ");
    if (merc_cross[3] > 0) printf("*");
  }
  if (soc == 1 || soc == 4 || soc == 6) {
    printf("\n   4. support ");
    if (merc_cross[4] > 0) printf("*");
  }
  printf("\n   5. militia ");
  if (merc_cross[5] > 0) printf("*");
  if (soc == 2 || soc >= 5) {
    printf("\n   6. drop troops ");
    if (merc_cross[6] > 0) printf("*");
  }
  printf("\n\n* = already cross-trained in this branch\n");
  roll = getsel_int(1, 6);
  merc_branch_tbl(roll);
  merc_cross[roll]++;
}
