/* DRONAVY.C is a Megatraveler (c) players aide written by Greg Svenson
     which is used to create Droyne Naval characters. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void dronavy();
void nv_get_branch();
void nv_set_branch();
int picksecurity();
int pickcrew();
int pickskilled();
int pickflight();
void nv_do_initial();
int nv_doterms();
int nv_xfer();
int nv_do_year();
int nv_mos();
int cmd_mos();
int crew_mos();
int comfort_mos();
void navymot(int term);
void droyne_life();
void nv_warrior();
void nv_drone();
void nv_tech();
void nv_sport();
void nv_leader();
void nv_cmd_tbl();
void nv_engr();
void nv_boat();
void nv_bridge();
void nv_crew();
void nv_gun();
void nv_comfort();
void nv_spcl_asgn();
int dronv_pick_sch();
int nvldr_pick();
int nvsprt_pick();
int nvtech_pick();
int nv_pick_sch();
void nv_attache();
void nv_gen_skl();
int nv_pick_tbl();
int nv_asgn();
void nv_cross_train();
void nv_branch(int branch_nbr);
void nv_branch_tbl(int brnch);
void nv_caste(int caste);
void adv_dstnctn(int adjust);

extern int d6();
extern int d2();
extern int d3();
extern int d9();
extern int d12();
extern int getsel_int(int min, int max);
extern int anag();
extern char getche_y_n();
extern int survive(int roll, int adjust);
extern int bp_skill(int roll);
extern int bp_skill1(int roll, int need_nbr);
extern void bp_cmbt();
extern int find_skl(int skill);
extern int reenlist(int need_nbr);
extern void bumpsense();
extern void bumpintl();
extern void bumpstr();
extern void bumpdex();
extern void bumpend();
extern void drowarmot(int term);
extern void drodrnmot(int term);
extern void drotechmot(int term);
extern void drosprtmot(int term);
extern void droldrmot(int term);
extern void psionics(int skl_val);
extern void bc(int skl_val);
extern void gc(int skl_val);
extern void vhcl(int skl_val);
extern void gunner(int skl_val);
extern void weapon(int skl_val);
extern void nv_gun_sch();
extern void nv_spcl_sch();
extern void nv_engr_sch();
extern void nv_intl_sch();
extern void nv_cmd_col();
extern void nv_staff_col();
extern void drop_troops();
extern int get_bigint();
extern int nv_adj();
extern void droyne_life();
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern void bp_add(int amt);
extern void instructor(int spcldutynbr);
extern int ask_adj_asgn(int roll);

#include "chargen.h"

extern int  aide, nv_anag, nv_cross[10];
int    distn, distinction;

void dronavy()
{
  int i;

  for (i = 1; i <= 9; i++) {
    nv_cross[i] = 0;
  }
  aide = 0;
  nv_get_branch();
  nv_do_initial();
  while (nv_doterms() == 0);
  terms = terms - anagathics;
  navymot(terms + mcuf);
}


void nv_get_branch()
{
  if (branch == 0) nv_set_branch();
  nv_branch(branch);
  printf("You were assigned to the %s branch.\n", office);
}


void nv_set_branch()
{
  if (soc == 6) branch = 1;
  if (soc == 5) branch = pickflight();
  if (soc == 4) branch = pickskilled();
  if (soc == 3) branch = 6;
  if (soc == 2) branch = picksecurity();
  if (soc == 1) branch = pickcrew();
  nv_cross[branch]++;
}


int picksecurity()
{
  int choice;
  
  nv_cross[7]++;
  nv_cross[8]++;
  if (pick == 4) {
    return (d2() + 6);
  }
  printf("You can choose between these branches for security.\n");
  printf("\n   1. troops\n   2. gunnery\n");
  choice = getsel_int(1, 2);
  choice += 6;
  return choice;
}


int pickcrew()
{
  int choice;
  
  nv_cross[9]++;
  nv_cross[8]++;
  if (pick == 4) {
    return (d2() + 7);
  }
  printf("You can choose between these branches for crew.\n");
  printf("\n   1. gunnery\n   2. crew\n");
  choice = getsel_int(1, 2);
  choice += 7;
  return choice;
}


int pickskilled()
{
  int choice;
  
  nv_cross[4]++;
  nv_cross[5]++;
  if (pick == 4) {
    return (d2() + 3);
  }
  printf("You can choose between these branches for skilled crew.\n");
  printf("\n   1. bridge\n   2. engineer\n");
  choice = getsel_int(1, 2);
  choice += 3;
  return choice;
}


int pickflight()
{
  int choice;
  
  nv_cross[2]++;
  nv_cross[3]++;
  if (pick == 4) {
    return (d2() + 1);
  }
  printf("You can choose between these branches for flight.\n");
  printf("\n   1. bridge\n   2. boat\n");
  choice = getsel_int(1, 2);
  choice++;
  return choice;
}


void nv_do_initial()
{
  nv_branch_tbl(branch);
  nv_branch_tbl(branch);
  age++;
  nv_anag = anag();
  if (nv_anag == 0) appearent_age++;
}


extern int assignment, combat;

int nv_doterms()
{
  int survival;
  
  combat = 0;
  assignment = 0;
  distn = 0;
  do {
    survival = nv_do_year();
  } while (((age % 4) != 0) && (survival == 0));
  if (survival != 0) return 1;
  survival = reenlist(0);
  if (distinction < 0 || survival != 0) return 1; 
  drafted = 0;
  branch = nv_xfer();
  nv_anag = anag();
  return 0;
}


int nv_xfer()
{
  char choice;
  int  i, roll;

  if (pick == 4) {
    roll = d9();
    if (nv_cross[roll] == 0) {
      nv_branch(branch);
      printf("You are in the %s branch.\n", office);
      return branch;
    } else {
      nv_branch(roll);
      printf("You are in the %s branch.\n", office);
      return roll;
    }
  }
  for (i = 1; i <= 9; i++) {
    if (nv_cross[i] != 0 && branch != i) {
      nv_branch(i);
      printf("You have the option to transfer to the %s branch.\n", office); 
      printf("Do you want to?");
      choice = getche_y_n();
      if (choice == 'Y' || choice == 'y') return i;
    }
  }
  return branch;
}


int nv_do_year()
{
  int   adjust, roll;
  
  age++;
  if (nv_anag == 0) appearent_age++;
  assignment = nv_asgn();
  if (branch == 2 && chk_skl(NAVIGATION, 1) != 0 && decor > 0) decor--;
  if (branch == 4 && chk_skl(NAVIGATION, 4) != 0 && decor > 0) decor--;
  if (branch == 5 && chk_skl(ENGINEERING, 1) != 0 && decor > 0) decor--;
  if (branch == 8 && dex >= 9 && decor > 0) decor--;
  if (branch == 9 && crew_mos() != 0 && decor > 0) decor--;
  adjust = nv_adj();
  adv_dstnctn(adjust);
  if (assignment == 7) nv_spcl_asgn();
  if (skil != 0) {
    roll = d12();
    if (branch == 8 && soc == 2) roll++;
    if (roll < skil) roll = bp_skill(roll);
    if (roll >= (skil + 4)) nv_gen_skl();
    if (roll >= skil) nv_gen_skl();
  }
  roll = d12();
  if ((branch == 6 || branch == 1) && (nv_mos() != 0)) roll++;
  if (branch == 3) roll += find_skl(PILOT);
  if (branch == 2 || branch == 7) roll += terms;
  return survive(roll, adjust);
}


int nv_mos()
{
  if (branch == 1) return cmd_mos();
  else
    return comfort_mos();
}


int cmd_mos()
{
  int qual;

  qual = chk_skl(LEADER, 2);
  if (qual == 0) qual = chk_skl(LIAISON, 2);
  if (qual == 0) qual = chk_skl(APPEAL, 2);
  if (qual == 0) qual = chk_skl(SHIPTAC, 2);
  if (qual == 0) qual = chk_skl(NAVIGATION, 2);
  if (qual == 0) qual = chk_skl(FLEETTAC, 2);
  if (qual != 0) return 1;
  return 0;
}


int crew_mos()
{
  int qual;

  qual = chk_skl(STEWARD, 2);
  if (qual != 0) return 1;
  return 0;
}


int comfort_mos()
{
  int qual;

  qual = chk_skl(STEWARD, 2);
  if (qual == 0) qual = chk_skl(HANDYMAN, 2);
  if (qual != 0) return 1;
  return 0;
}


void navymot(int term)
{
  term += mcuf;
  switch (soc) {
    case 1: break;
    case 2: drowarmot(term); break;
    case 3: drodrnmot(term); break;
    case 4: drotechmot(term); break;
    case 5: drosprtmot(term); break;
    case 6: droldrmot(term); break;
  }
}


void droyne_life()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 1: bumpstr(); bumpstr(); break;
    case 2: bumpdex(); bumpdex(); break;
    case 3: bumpend(); bumpend(); break;
    case 4: bumpintl(); bumpintl(); break;
    case 6: addskill(FLYING, 1); break;
    case 7: addskill(FLYING, 1); break;
    case 8: bumpend(); break;
    case 9: bumpintl(); break;
    default: bumpsense(); break;
  }
}


void nv_warrior()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 1: gc(1); break;
    case 2: weapon(2); break;
    case 3: bumpstr(); bumpstr(); break;
    case 4: addskill(UNARMEDCMBT, 1); break;
    case 5: bumpdex(); bumpdex(); break;
    case 6: bc(1); break;
    case 7: addskill(NOGRAV, 1); break;
    case 8: weapon(2); break;
    case 9: addskill(TACTICS, 1); break;
    default: addskill(TACTICS, 1); break;
  }
}


void nv_drone()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 1: addskill(STEWARD, 1); break;
    case 2: addskill(MEDICAL, 1); break;
    case 3: addskill(STEWARD, 1); break;
    case 4: bumpsense(); bumpsense(); break;
    case 5: addskill(STEWARD, 1); break;
    case 6: vhcl(1); break;
    case 7: addskill(STEWARD, 1); break;
    case 8: addskill(INSTRUCTION, 1); break;
    case 9: psionics(1); break;
    default: addskill(STEWARD, 1); break;
  }
}


void nv_tech()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 1: addskill(MECHANICAL, 1); break;
    case 2: addskill(ELECTRONICS, 1); break;
    case 3: addskill(GRAVITICS, 1); break;
    case 4: addskill(COMPUTER, 1); break;
    case 5: vhcl(1); break;
    case 6: addskill(NAVALARCH, 1); break;
    case 7: addskill(HANDYMAN, 1); break;
    case 8: addskill(ENGINEERING, 1); break;
    case 9: addskill(MEDICAL, 1); break;
    default: addskill(ELECTRONICS, 1); break;
  }
}


void nv_sport()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 1: addskill(LIAISON, 1); break;
    case 2: addskill(COMPUTER, 1); break;
    case 3: addskill(CAROUSING, 1); break;
    case 4: addskill(APPEAL, 1); break;
    case 5: vhcl(1); break;
    case 6: addskill(VACCSUIT, 1); break;
    case 7: addskill(PILOT, 1); break;
    case 8: addskill(LIAISON, 1); break;
    case 9: nv_cross_train(1); break;
    default: addskill(LIAISON, 1); break;
  }
}


void nv_leader()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 2: addskill(ADMIN, 1); break;
    case 3: addskill(VACCSUIT, 1); break;
    case 4: addskill(INSTRUCTION, 1); break;
    case 5: addskill(APPEAL, 1); break;
    case 9: addskill(ADMIN, 1); break;
    default: addskill(LEADER, 1); break;
  }
}


void nv_cmd_tbl()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 1: addskill(LEADER, 1); break;
    case 2: addskill(LIAISON, 1); break;
    case 3: addskill(APPEAL, 1); break;
    case 4: addskill(NAVIGATION, 1); break;
    case 5: addskill(LEADER, 1); break;
    case 6: addskill(LIAISON, 1); break;
    case 7: addskill(SHIPTAC, 1); break;
    case 8: addskill(SHIPTAC, 1); break;
    default: addskill(FLEETTAC, 1); break;
  }
}


void nv_engr()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
	case 1: addskill(ENGINEERING, 1); break;
	case 2: addskill(MECHANICAL, 1); break;
	case 3: addskill(MECHANICAL, 1); break;
	case 4: addskill(ELECTRONICS, 1); break;
	case 5: addskill(GRAVITICS, 1); break;
	case 6: addskill(COMPUTER, 1); break;
	default: addskill(ENGINEERING, 1); break;
  }
}


void nv_boat()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 1: addskill(PILOT, 1); break;
    case 2: addskill(VACCSUIT, 1); break;
    case 3: addskill(NOGRAV, 1); break;
    case 4: addskill(PILOT, 1); break;
    case 5: addskill(PILOT, 1); break;
    case 6: addskill(PILOT, 1); break;
    default: addskill(SHIPTAC, 1); break;
  }
}


void nv_bridge()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 1: addskill(NAVIGATION, 1); break;
    case 2: addskill(ELECTRONICS, 1); break;
    case 3: addskill(GRAVITICS, 1); break;
    case 4: addskill(NAVIGATION, 1); break;
    case 5: addskill(NAVIGATION, 1); break;
    case 6: addskill(PILOT, 1); break;
    case 7: addskill(PILOT, 1); break;
    default: addskill(SHIPTAC, 1); break;
  }
}


void nv_comfort()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
	case 1: addskill(STEWARD, 1); break;
	case 2: addskill(HANDYMAN, 1); break;
	case 3: addskill(STEWARD, 1); break;
	case 4: addskill(STEWARD, 1); break;
	case 5: addskill(HANDYMAN, 1); break;
	case 6: bumpstr(); break;
	case 7: bumpdex(1); break;
	case 8: bumpend(); break;
	default: bumpintl(); break;
  }
}


void nv_crew()
{
  int  roll;

  roll = d6();
  roll += terms;
  switch (roll) {
	case 2: bumpstr(); break;
	case 3: bumpstr(); bumpstr(); break;
	case 4: bumpdex(); bumpdex(); break;
	case 5: bumpend(); bumpend(); break;
	case 6: bumpstr(); break;
	case 7: bumpdex(); break;
	default: addskill(STEWARD, 1); break;
  }
}


void nv_gun()
{
  int roll;

  roll = d6();
  roll += terms;
  switch (roll) {
    case 6: addskill(COMPUTER, 1); break;
    case 7: gc(1); break;
    case 8: bumpdex(); break;
    default: gunner(1); break;
  }
}


void nv_spcl_asgn()
{
  int roll;
  
  if (aide != 0)
  {
    aide = 0;
    roll = nv_pick_sch();
  }
  else
  {
    if (pick >= 3) roll = d6();
    else roll = dronv_pick_sch();
  }
  if (soc <= 2) nv_gun_sch();
  if (soc == 3) psionics(1);
  if (soc == 4)
  {
    if (roll >= 5) nv_spcl_sch();
    else
      if (roll >= 3) nv_engr_sch();
      else nv_staff_col();
  }
  if (soc == 5)
  {
    if (roll == 7) nv_cross_train();
    if (roll == 6)
	{
      if (terms >= 2) nv_intl_sch();
      else nv_cross_train();
    }
    if (roll == 5) nv_attache();
    if (roll == 4) nv_attache();
    if (roll == 3) psionics(1);
    if (roll == 2)
	{
      if (terms >= 4) nv_cmd_col();
      else nv_cross_train();
    }
    if (roll == 1) nv_staff_col();
  }
  if (soc == 6)
  {
    if (roll >= 4)
	{
      if (terms >= 2) nv_intl_sch();
      else nv_cross_train();
    }
	else 
	{
      if (terms >= 4) nv_cmd_col();
      else nv_cross_train();
    }
  }
}


int dronv_pick_sch()
{
  if (soc <= 3) return 1;
  if (soc == 4) return nvtech_pick();
  if (soc == 5) return nvsprt_pick();
  return nvldr_pick();
}


int nvldr_pick()
{
  int choice;

  if (terms < 4) return 4;
  printf("Please select the special assignment you want.\n\n");
  printf("   1. intelligence school\n");
  printf("   2. command college\n");
  choice = getsel_int(1, 2);
  if (choice == 1) return 4;
  return 1;
}


int nvsprt_pick()
{
  int choice;

  printf("Please select the special assignment you want.\n\n");
  printf("   1. staff college\n");
  printf("   2. cross training\n");
  printf("   3. admirals attache\n");
  printf("   4. psionics school\n");
  if (terms >= 2) printf("   5. intelligence school\n");
  if (terms >= 4) printf("   6. command college\n");
  choice = getsel_int(1, 6);
  if (choice == 1) return 1;
  if (choice == 2) return 7;
  if (choice == 3) return 5;
  if (choice == 4) return 3;
  if (choice == 5) return 6;
  if (choice == 6) return 2;
  printf("Wrong - try again!\n");
  return nvsprt_pick();
}


int nvtech_pick()
{
  int choice;

  printf("Please select the special assignment you want.\n\n");
  printf("   1. staff college\n");
  printf("   2. engineering school\n");
  printf("   3. specialist school\n");
  choice = getsel_int(1, 3);
  return (choice * 2);
}


int nv_pick_sch()
{
  int choice;

  printf("As an Admirals Attache you can pick your next assignment.\n\n");
  printf("   1. cross-training\n");
  if (terms >= 2) printf("   2. intelligence school\n");
  printf("   3. psionics school\n   4. staff college\n");
  if (terms >= 4) printf("   5. command college\n");
  choice = getsel_int(1, 5);
  if (choice == 1) return 7;
  if (choice == 2) return 6;
  if (choice == 3) return 3;
  if (choice == 4) return 1;
  if (choice == 5) return 2;
  printf("Wrong - try again!\n");
  return nv_pick_sch();
}


void nv_attache()
{
  bumpsense();
  aide = 1;
  distinction += 5;
  printf("You gained 5 distinction during your year as an Aide.\n");
  bp_add(1);
}


void nv_gen_skl()
{
  int roll;

  if (pick <= 2) roll = nv_pick_tbl();
  else roll = d3();
  if (roll == 1) droyne_life();
  if (roll == 2) nv_caste(soc);
  if (roll == 3) nv_branch_tbl(branch);
}


int nv_pick_tbl()
{
  int choice;
  printf("\nPlease select the table you wish to use for your new skill.\n");
  printf("\n   1. Droyne life\n");   
  printf("   2. The table for your caste\n");
  nv_branch(branch);
  printf("   3. The table for %s\n", office); 
  choice = getsel_int(1, 3);
  return choice;
}


int nv_asgn()
{
  int roll;

  combat = 0;
  if (aide == 1)
  {
    printf("You were assigned to special duty.\n");
    return 7;
  }
  roll = d6();
  if (roll == 6 && assignment != 0)
  {
    printf("You were allowed to repeat your last assignment.\n");
    if (assignment > 3 && assignment < 7)
	{
      combat = 1;
      cmbt++;
    }
    return assignment;
  }
  skil = 0; surv = 0; decor = 0;
  roll = d12();
  if (soc == 5) roll++;
  if (terms >= 3) roll++;
  if (pick == 1)
	  roll = ask_adj_asgn(roll);
  if (pick == 4 && (roll == 2 || roll == 8 || roll == 10) && brownie_points > 3)
  {
	  roll++;
	  brownie_points--;
	  printf("You used 1 brownie point to get a better assignment.\n");
  }
  if (pick == 4 && roll == 6 && brownie_points > 0)
  {
	  roll--;
	  brownie_points--;
	  printf("You used 1 brownie point to get a better assignment.\n");
  }
  if (roll >= 12)
  {
    printf("This is a battle assignment.\n");
    cmbt++;
    combat = 1;
    switch (branch)
	{
      case 1: skil = 4; surv = 6; decor = 5; break;
      case 2: skil = 5; surv = 4; decor = 5; break;
      case 3: skil = 5; surv = 6; decor = 4; break;
      case 4: skil = 4; surv = 5; decor = 4; break;
      case 5: skil = 6; surv = 5; decor = 5; break;
      case 6: skil = 5; surv = 5; decor = 5; break;
      case 7: skil = 5; surv = 5; decor = 5; break;
      case 8: skil = 5; surv = 6; decor = 4; break;
      default: skil = 4; surv = 5; decor = 5; break;
    }
    return 6;
  }
  if (roll == 7)
  {
    printf("This is a training assignment.\n");
    surv = 0; skil = 6; decor = 6;
    switch (branch) 
	{
      case 1: break;
      case 2: surv = 3; break;
      case 3: surv = 4; decor = 5; break;
      case 4: break;
      case 5: decor = 7; break;
      case 6: decor = 7; break;
      case 7: surv = 3; decor = 7; break;
      case 8: skil = 7; break;
      default: break;
    }
    return 1;
  }
  if (roll <= 2 || roll == 10)
  {
    printf("This is a shore duty assignment.\n");
    switch (branch)
	{
      case 1: skil = 6; surv = 4; decor = 5; break;
      case 2: skil = 6; surv = 3; decor = 6; break;
      case 3: skil = 7; surv = 3; decor = 8; break;
      case 4: skil = 7; decor = 6; break;
      case 5: skil = 6; surv = 3; decor = 6; break;
      case 6: skil = 6; surv = 4; decor = 7; break;
      case 7: skil = 5; surv = 5; decor = 6; break;
      case 8: surv = 3; decor = 8; break;
      default: skil = 7; decor = 5; break;
    }
    return 2;
  }
  if (roll == 4)
  {
    printf("This is a seige assignment.\n");
    cmbt++;
    combat = 1;
    switch (branch)
	{
      case 1: skil = 5; surv = 5; decor = 4; break;
      case 2: skil = 6; surv = 3; decor = 5; break;
      case 3: skil = 4; surv = 5; decor = 5; break;
      case 4: skil = 5; surv = 4; decor = 5; break;
      case 5: skil = 6; surv = 4; decor = 5; break;
      case 6: skil = 5; surv = 5; decor = 6; break;
      case 7: skil = 6; surv = 5; decor = 6; break;
      case 8: skil = 5; surv = 5; decor = 6; break;
      default: skil = 6; surv = 4; decor = 6; break;
    }
    return 4;
  }
  if (roll == 9 || roll == 5)
  {
    printf("This is a strike assignment.\n");
    cmbt++;
    combat = 1;
    switch (branch)
	{
      case 1: skil = 4; surv = 6; decor = 5; break;
      case 2: skil = 6; surv = 3; decor = 4; break;
      case 3: skil = 5; surv = 5; decor = 4; break;
      case 4: skil = 5; surv = 5; decor = 5; break;
      case 5: skil = 6; surv = 5; decor = 6; break;
      case 6: skil = 5; surv = 5; decor = 6; break;
      case 7: skil = 5; surv = 5; decor = 5; break;
      case 8: skil = 5; surv = 5; decor = 5; break;
      default: skil = 5; surv = 5; decor = 5; break;
    }
    return 5;
  }
  if (roll == 6 || roll == 8)
  {
    printf("This is a patrol assignment.\n");
    switch (branch)
	{
      case 1: skil = 5; surv = 4; decor = 5; break;
      case 2: skil = 5; surv = 3; decor = 5; break;
      case 3: skil = 6; surv = 4; decor = 5; break;
      case 4: skil = 5; surv = 3; decor = 5; break;
      case 5: skil = 6; surv = 4; decor = 5; break;
      case 6: skil = 5; surv = 4; decor = 6; break;
      case 7: skil = 6; surv = 4; decor = 6; break;
      case 8: skil = 6; surv = 4; decor = 6; break;
      default: skil = 5; surv = 3; decor = 5; break;
    }
    return 3;
  }
  printf("This is special duty.\n");
  return 7;
}


void nv_cross_train()
{
  int  roll;

  printf("You got cross-training.\n");
  bp_add(1);
  if (pick >= 3)
  {
    roll = d6();
  }
  else
  {
    printf("You have the option to get cross-training in any caste\n"); 
    printf("service field.\n");
    printf("\n   1. Worker");
    printf("\n   2. Warrior");
    printf("\n   3. Drone");
    printf("\n   4. Technician");
    printf("\n   5. Sport");
    printf("\n   6. Leader");
    roll = getsel_int(1, 6);
  }
  nv_caste(roll);
}


void nv_branch(int branch_nbr)
{
  switch (branch_nbr) {
    case 1: strncpy(office,"Command",8); break;
    case 2: strncpy(office,"Flt Bridge",11); break;
    case 3: strncpy(office,"Flt Boat",9); break; 
    case 4: strncpy(office,"Bridge Crew",12); break; 
    case 5: strncpy(office,"Engineering",12); break; 
    case 6: strncpy(office,"Comfort Crew",13); break; 
    case 7: strncpy(office,"Troops",7); break; 
    case 8: strncpy(office,"Gunnery",8); break; 
    case 9: strncpy(office,"Crew",5); break;
    default: strncpy(office,"unknown?",9); break;
  }
}


void nv_branch_tbl(int brnch)
{
  switch (brnch) {
    case 1: nv_cmd_tbl(); break;
    case 2: nv_bridge(); break;
    case 3: nv_boat(); break;
    case 4: nv_bridge(); break;
    case 5: nv_engr(); break;
    case 6: nv_comfort(); break;
    case 7: drop_troops(); break;
    case 8: nv_gun(); break;
    case 9: nv_crew(); break;
  }
}


void nv_caste(int caste)
{
  switch (caste) {
    case 1: droyne_life(); break;
    case 2: nv_warrior(); break;
    case 3: nv_drone(); break;
    case 4: nv_tech(); break;
    case 5: nv_sport(); break;
    case 6: nv_leader(); break;
  }
}


void adv_dstnctn(int adjust)
{
  int  roll, delta_dist;

  if (decor == 0 || distn > 0) return;
  roll = d12() + adjust;
  delta_dist = (roll - decor);
  if (delta_dist >= 0) {
    mcuf++;
    distn++;
  }
  distinction += delta_dist;
}
