/* DROTECHN.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>


void drotechy();
void drotechmot(int term);
void drotechskills(int skills);
void drotech_pdt(int roll);
void drotech_sst(int roll);

extern int d6();
extern int basic_surv(int need_nbr, int upp, int upp_val);
extern int dro_dist(int need_nbr, int upp, int upp_val);
extern int reenlist(int need_nbr);
extern int basic_bene();
extern int basic_spec_duty(int roll);
extern void bumpsense();
extern void bumpintl();
extern int dropicktable();
extern void crosstrain();
extern void bumpdex();
extern void psionics(int skl_val);
extern void vhcl(int skl_val);
extern void addskill(int skill, int skl_val);
extern void mot_weapon();
extern void mot_lopsg();
extern void mot_kit();

#include "chargen.h"


void drotechy()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    if (terms == 1) drotech_pdt(d6());
    newterm = basic_surv(5, intl, 4);
    skills = 0;
    if (newterm == 0) {
	  skills = basic_spec_duty(5) + 1;
      skills += dro_dist(8, edu, 6);
    }
    if (skills != 0) drotechskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(0);
  }
  terms = terms - anagathics;
  drotechmot(terms);
}


void drotechmot(int term)
{
  int  roll;
  
  while (term > 0)
  {
    term--;
    roll = basic_bene();
    switch (roll)
	{
      case 1: bumpintl(); bumpintl(); break;
      case 2: bumpintl(); break;
      case 3: mot_weapon(); break;
      case 4: mot_lopsg(); break;
      default: mot_kit(); break;
    }
  }
}


void drotechskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = dropicktable();
    roll = d6();
    if (table == 1) {
      drotech_pdt(roll);
    }
    if (table == 2) {
      drotech_sst(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: crosstrain(1); break;
        case 2: addskill(MECHANICAL, 1); break;
        case 3: addskill(COMPUTER, 1); break;
        case 4: addskill(ELECTRONICS, 1); break;
        case 5: addskill(GRAVITICS, 1); break;
        case 6: crosstrain(1); break;
      }
    }
    if (table == 4) {
      if (alt_career < 0) {
        switch (roll) {
          case 1: addskill(MECHANICAL, 1); break;
          case 2: addskill(MECHANICAL, 1); break;
          case 3: addskill(ELECTRONICS, 1); break;
          case 4: addskill(ELECTRONICS, 1); break;
          case 5: addskill(HANDYMAN, 1); break;
          case 6: addskill(HANDYMAN, 1); break;
        }
      } else {
        if (alt_career == 0) {
          switch (roll) {
            case 1: addskill(MECHANICAL, 1); break;
            case 2: addskill(ELECTRONICS, 1); break;
            case 3: addskill(GRAVITICS, 1); break;
            case 4: addskill(COMPUTER, 1); break;
            case 5: addskill(NAVALARCH, 1); break;
            case 6: addskill(ENGINEERING, 1); break;
          }
        } else {
          switch (roll) {
            case 1: addskill(COMPUTER, 1); break;
            case 2: addskill(COMPUTER, 1); break;
            case 3: addskill(LIAISON, 1); break;
            case 4: addskill(ENGINEERING, 1); break;
            case 5: addskill(INSTRUCTION, 1); break;
            case 6: addskill(GRAVITICS, 1); break;
          }
        }
      }
    }
    skills--;
  }
}


void drotech_pdt(int roll)
{
  switch (roll) {
    case 1: addskill(MECHANICAL, 1); break;
    case 2: addskill(MECHANICAL, 1); break;
    case 3: addskill(ELECTRONICS, 1); break;
    case 4: addskill(ELECTRONICS, 1); break;
    case 5: bumpsense(); bumpsense(); break;
    case 6: psionics(1); break;
  }
}


void drotech_sst(int roll)
{
  switch (roll) {
    case 1: addskill(MECHANICAL, 1); break;
    case 2: addskill(ELECTRONICS, 1); break;
    case 3: addskill(GRAVITICS, 1); break;
    case 4: vhcl(1); break;
    case 5: bumpdex(); break;
    case 6: addskill(FLYING, 1); break;
  }
}

