/* DROWAROR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>


void drowarrior();
void drowarmot(int term);
void drowarskills(int skills);
void drowar_pdt(int roll);
void drowar_sst(int roll);

extern int d6();
extern int basic_surv(int need_nbr, int upp, int upp_val);
extern int dro_dist(int need_nbr, int upp, int upp_val);
extern int reenlist(int need_nbr);
extern int basic_bene();
extern int basic_spec_duty(int roll);
extern void bumpsense();
extern void bumpdex();
extern int dropicktable();
extern void crosstrain();
extern void bumpstr();
extern void psionics(int skl_val);
extern void gc(int skl_val);
extern void vhcl(int skl_val);
extern void droweapon(int skl_val);
extern void addskill(int skill, int skl_val);
extern void mot_weapon();
extern void mot_ship();
extern void mot_kit();

#include "chargen.h"


void drowarrior()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    if (terms == 1) drowar_pdt(d6());
    newterm = basic_surv(7, str, 6);
    skills = 0;
    if (newterm == 0) {
	  skills = basic_spec_duty(4) + 1;
      skills += dro_dist(8, intl, 5);
    }
    if (skills != 0) drowarskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(0);
  }
  terms = terms - anagathics;
  drowarmot(terms);
}


void drowarmot(int term)
{
  int  roll;
  
  while (term > 0)
  {
    term--;
    roll = basic_bene();
    switch (roll)
	{
      case 1: bumpstr(); bumpstr(); break;
      case 2: bumpdex(); bumpdex(); break;
      case 3: mot_weapon(); break;
      case 4: mot_weapon(); break;
      case 5: mot_kit(); break;
      default: mot_ship(); break;
    }
  }
}


void drowarskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = dropicktable();
    roll = d6();
    if (table == 1) {
      drowar_pdt(roll);
    }
    if (table == 2) {
      drowar_sst(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: crosstrain(1); break;
        case 2: addskill(SURVIVAL, 1); break;
        case 3: droweapon(2); break;
        case 4: addskill(DEMOLITIONS, 1); break;
        case 5: addskill(TACTICS, 1); break;
        case 6: crosstrain(1); break;
      }
    }
    if (table == 4) {
      if (alt_career < 0) {
        switch (roll) {
          case 1: droweapon(2); break;
          case 2: droweapon(2); break;
          case 3: droweapon(2); break;
          case 4: addskill(RECON, 1); break;
          case 5: addskill(TACTICS, 1); break;
          case 6: crosstrain(1); break;
        }
      } else {
        if (alt_career > 0) {
          switch (roll) {
            case 1: gc(1); break;
            case 2: addskill(NOGRAV, 1); break;
            case 3: droweapon(2); break;
            case 4: addskill(SHIPTAC, 1); break;
            case 5: addskill(VACCSUIT, 1); break;
            case 6: gc(1); break;
          }
        } else {
          switch (roll) {
            case 1: addskill(HUNTING, 1); break;
            case 2: addskill(HUNTING, 1); break;
            case 3: addskill(RECON, 1); break;
            case 4: droweapon(2); break;
            case 5: addskill(MEDICAL, 1); break;
            case 6: addskill(SURVIVAL, 1); break;
          }
        }
      }
    }
    skills--;
  }
}


void drowar_pdt(int roll)
{
  switch (roll) {
    case 1: droweapon(2); break;
    case 2: droweapon(2); break;
    case 3: droweapon(2); break;
    case 4: addskill(RECON, 1); break;
    case 5: bumpdex(); break;
    case 6: addskill(UNARMEDCMBT, 1); break;
  }
}


void drowar_sst(int roll)
{
  switch (roll) {
    case 1: addskill(UNARMEDCMBT, 1); break;
    case 2: psionics(1); break;
    case 3: addskill(RECON, 1); break;
    case 4: vhcl(1); break;
    case 5: droweapon(2); break;
    case 6: psionics(1); break;
  }
}

