/* HivArmy.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int hivarmy();
void army_get_branch();
int army_set_branch();
int army_pickbranch();
void merc_do_initial();
int merc_doterms();
int merc_xfer();
int merc_off_xfer();
void merc_branch(int branch_nbr);
int merc_do_year();
void armymot(int term);
void armybene();
void merc_branch_tbl(int brnch);
void merc_nco();
void merc_cmd_off();
void army_life();
void merc_adv();
void merc_arty();
void merc_sup();
void merc_spcl_asgn();
int merc_pick_sch();
void merc_attache();
void merc_ocs();
void merc_spcl_sch();
void merc_gen_skl();
void merc_pick_tbl();
int merc_asgn();
int merc_mos();
int adv_mos();
int art_mos();
int army_cmd();
void merc_cross_train();

extern int hiv_stsfctn(int needs, int mod, int mod_needs);
extern int hiv_do_year();
extern int nv_adj();
extern int anag();
extern int getrank();
extern int survive(int adjust, int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d2();
extern int d3();
extern int d4();
extern int d5();
extern int d6();
extern int d12();
extern int getsel_int(int min, int max);
extern char getche_y_n();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern int bp_skill(int roll);
extern int bp_skill1(int roll, int need_nbr);
extern int bp_spcl_duty(int roll);
extern int reenlist(int need_nbr);
extern void decorate(int adjust);
extern void hiv_life();
extern void merc_cmd_col();
extern void merc_staff_col();
extern void merc_prot_frcs();
extern void merc_intl_sch();
extern void hiv_med();
extern void hiv_flt();
extern int mar_cmd();
extern int inf_mos();
extern void decorate(int adjust);
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void physicl(int skl_val);
extern void artillery(int skl_val);
extern void airc(int skl_val);
extern void econ(int skl_val);
extern void spac(int skl_val);
extern void acad(int skl_val);
extern void techl(int skl_val);
extern void influ(int skl_val);
extern void gc(int skl_val);
extern void env(int skl_val);
extern void vc(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void inbrn(int skl_val);
extern void bp_cmbt();
extern void bp_add(int amt);
extern int ask_adj_asgn(int roll);
extern void gotspcldty(int spcldutynbr);
extern void merc_rcrtng();
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_weapon();

#include "chargen.h"

int  merc_cross[8];

extern int  aide, nv_anag;

int hivarmy()
{
	int survival, i;
  
	if (terms == 0)
	{
		for (i = 1; i <= 7; i++)
			merc_cross[i] = 0;
		army_get_branch();
		merc_do_initial();
	}
	survival = merc_doterms();
	if (hiv_stsfctn(8, intl, 5) > 0)
		merc_gen_skl();
	if (survival != 0)
		return 1;
	if (nv_anag == 0)
		armymot(1);
	return 0;
}


void army_get_branch()
{
	if (branch == 0)
		branch = army_set_branch();
	merc_cross[branch]++;
	merc_branch(branch);
	printf("You were assigned to the %s branch.\n", office);
}


int army_set_branch()
{
	if (branch != 0)
		return branch;
	if (mil_acd > 0)
		return 1; // advisor
	if (med_sch > 0)
		return 5; // medical
	if (flt_sch > 0)
		return 2; // flight
	if (tech_sch > 0)
		return 6; // support
	if (d2() > 1)
		return 4; // artillery
	return 6; //support
}


void merc_do_initial()
{
	if (rank == 0 && rankeo == 'E')
		rank++;
	merc_branch_tbl(branch);
	merc_branch_tbl(branch);
	age++;
	nv_anag = anag();
	if (nv_anag == 0)
		appearent_age++;
}


int merc_doterms()
{
	int survival, need_nbr;
  
	command = combat = assignment = 0;
	nv_promo = 0;
	if (branch == 2 || branch == 5)
		do
			survival = hiv_do_year();
		while (((age % 4) != 2) && (survival == 0));
	else
		do
			survival = merc_do_year();
		while (((age % 4) != 2) && (survival == 0));
	if (survival != 0)
		return 1;
	need_nbr = 7;
	if (rankeo == 'E')
		need_nbr -= 2;
	survival = reenlist(need_nbr);
	if (survival != 0)
		return 1; 
	drafted = 0;
	branch = merc_xfer();
	nv_anag = anag();
	return 0;
}


int merc_xfer()
{
	char choice;
	int  i, roll;

	if (pick == 4)
	{
		roll = d6();
		if ((merc_cross[roll] == 0 && rankeo == 'E') || roll == 3)
		{
			merc_branch(branch);
			printf("You are in the %s branch.\n", office);
			return branch;
		}
		else
		{
			if ((roll == 2 && merc_cross[2] == 0)
				|| (roll == 5 && merc_cross[5] == 0))
				roll = army_set_branch();
			merc_branch(roll);
			printf("You are in the %s branch.\n", office);
			return roll;
		}
	}
	if (rankeo == 'E')
	{
		for (i = 1; i <= 7; i++)
		{
			if (merc_cross[i] != 0 && branch != i)
			{
				merc_branch(i);
				printf("You have the option to transfer to the %s branch.\nDo you want to?", office); 
    			choice = getche_y_n();
				if (choice == 'Y' || choice == 'y')
					return i;
			}
		}
	}
	else
		branch = merc_off_xfer();
	return branch;
}


int merc_off_xfer()
{
	int choice, max;

	printf("You have the option to transfer to another branch. Pick one.\n\n");
	printf("   1. advisor\n   2. artillery\n   3. support\n");
	max = 3;
	if (merc_cross[2] != 0)
	{
		printf("   4. flight\n");
		max = 4;
	}
	if (merc_cross[5] != 0)
	{
		printf("   5. medical\n");
		max = 5;
	}
	choice = getsel_int(1, max);
	if (choice == 1)
		return 1;
	if (choice == 2)
		return 4;
	if (choice == 3)
		return 6;
	if (choice == 4 && merc_cross[2] != 0)
		return 2;
	if (choice == 5 && merc_cross[5] != 0)
		return 5;
	printf("Wrong - try again!\n");
	return merc_off_xfer();
}


void merc_branch(int branch_nbr)
{
	switch (branch_nbr)
	{
	case 1:
		{
			if (race == HIVER)
				strncpy(office,"Advisor",8);
			else
				strncpy(office,"Infantry",9);
			break;
		}
    case 2: strncpy(office,"Flight",7); break; 
    case 4: strncpy(office,"Artillery",10); break; 
	case 5: strncpy(office,"Medical",8); break; 
    case 6: strncpy(office,"Support",8); break; 
	default: strncpy(office,"unknown?",9); break;
	}
}


int merc_do_year()
{
	int   roll;
  
	age++;
	if (nv_anag == 0)
		appearent_age++;
	if (careernbr == ARMY)
		command = army_cmd();
	else
		command = mar_cmd();
	assignment = merc_asgn();
	if (combat != 0 && command != 0)
		cmd++;
	if ((rank < 9 && rankeo == 'E') || (rankeo == 'O' && rank < 10))
	{
		if (nv_promo == 0 && promo != 0)
		{
			roll = d12();
			if ((branch <= 4 && edu >= 7) || (branch == 6 && intl >= 8))
				roll++;
			if (roll >= promo)
			{
				nv_promo++;
				rank++;
				printf("You were promoted. ");
				getrank();
				if (rankeo == 'O' && rank == 4)
					addskill(LEADER, 1);
			}
		}
	}
	if (assignment == 8)
		merc_spcl_asgn();
	if (skil != 0)
	{
		roll = d12();
		if (roll < skil)
			roll = bp_skill(roll);
		if (roll >= (skil + 4))
			merc_gen_skl();
		if (roll >= skil)
			merc_gen_skl();
	}
	roll = d12();
	if (rankeo == 'E')
		roll += 2;
	return survive(roll, 0);
}


void armymot(int term)
{
	int  roll, amt;
	char choice;
  
	while (term > 0)
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c')
		{
			roll = basic_cash();
			amt = 0;
			switch (roll)
			{
				case 1: amt = 1000; break;
		        case 2: amt = 5000; break;
			    case 3: amt = 10000; break;
				case 4: amt = 10000; break;
		        case 5: amt = 10000; break;
				case 6: amt = 20000; break;
		        case 7: amt = 30000; break;
			}
			mot_cash(amt);
		}
		else
		{
			armybene();
		}
		term--;
	}
	while (term > 0)
	{
		armybene();
		term--;
	}
}


void armybene()
{
	int roll;

	roll = basic_bene();
	switch (roll)
	{
		case 1: mot_lopsg(); break;
	    case 2: bumpedu(); break;
		case 3: bumpintl(); break;
	    case 4: mot_weapon(); break;
	    case 5: mot_midpsg(); break;
		case 6: mot_hipsg(); break;
		case 7: bumpsoc(); break;
	}
}


void merc_branch_tbl(int branch_nbr)
{
	switch (branch_nbr)
	{
	    case 1: merc_adv(); break;
		case 2: hiv_flt(); break;
		case 4: merc_arty(); break;
	    case 5: hiv_med(); break;
		case 6: merc_sup(); break;
	}
}


void merc_nco()
{
	int  roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: artillery(1); break;
		case 2: addskill(TACTICS, 1); break;
		case 3: addskill(INSTRUCTION, 1); break;
		case 4: addskill(LINGUISTICS, 1); break;
		case 5: artillery(1); break;
		case 6: addskill(LEADER, 1); break;
		case 7: addskill(TACTICS, 1); break;
		case 8: inbrn(1); break;
		default: interp(1); break;
	}
}


void merc_cmd_off()
{
	int  roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: addskill(INSTRUCTION, 1); break;
		case 2: airc(1); break;
		case 3: addskill(PERSUASION, 1); break;
		case 4: addskill(LEADER, 1); break;
		case 5: addskill(TACTICS, 1); break;
		case 6: addskill(LEADER, 1); break;
		case 7: addskill(TACTICS, 1); break;
		case 8: influ(1); break;
		default: inbrn(1); break;
	}
}


void army_life()
{
	int  roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: physicl(1); break;
		case 2: vc(1); break;
		case 3: gc(1); break;
		case 4: vhcl(1); break;
		case 5: addskill(LINGUISTICS, 1); break;
		case 6: addskill(INSTRUCTION, 1); break;
		case 7: addskill(ACTING, 1); break;
		case 8: econ(1); break;
		default: interp(1); break;
	}
}


void merc_adv()
{
	int  roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: env(1); break;
		case 2: artillery(1); break;
		case 3: addskill(PERSUASION, 1); break;
		case 4: addskill(LIAISON, 1); break;
		case 5: addskill(TACTICS, 1); break;
		case 6: addskill(LINGUISTICS, 1); break;
		case 7: addskill(LEADER, 1); break;
		case 8: influ(1); break;
		default: inbrn(1); break;
	}
}


void merc_arty()
{
	int  roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: vhcl(1); break;
		case 2: artillery(1); break;
		case 3: vhcl(1); break;
		case 4: addskill(MECHANICAL, 1); break;
		case 5: artillery(1); break;
		case 6: addskill(ROBOTOPS, 1); break;
		case 7: addskill(COMPUTER, 1); break;
		case 8: influ(1); break;
		default: techl(1); break;
	}
}


void merc_staff_off()
{
	int  roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: addskill(MECHANICAL, 1); break;
		case 2: airc(1); break;
		case 3: addskill(ROBOTOPS, 1); break;
		case 4: addskill(ELECTRONICS, 1); break;
		case 5: addskill(RESEARCH, 1); break;
		case 6: addskill(COMPUTER, 1); break;
		case 7: econ(1); break;
		case 8: interp(1); break;
		default: acad(1); break;
	}
}


void merc_sup()
{
	int  roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: vhcl(1); break;
		case 2: addskill(MECHANICAL, 1); break;
		case 3: addskill(CMBTENGR, 1); break;
		case 4: addskill(ELECTRONICS, 1); break;
		case 5: addskill(MEDICAL, 1); break;
		case 6: addskill(COMPUTER, 1); break;
		case 7: econ(1); break;
		case 8: interp(1); break;
		default: techl(1); break;
	}
}


void merc_spcl_asgn()
{
	int roll;
  
	if (aide != 0)
	{
		aide = 0;
		roll = merc_pick_sch();
	}
	else
	{
		roll = d6();
	    if (age >= 38 && rankeo == 'E') 
			roll--;
		else
			if (end >= 7)
				roll++;
	}
	if (roll <= 1)
		if (rankeo == 'E')
			merc_cross_train();
		else
			merc_intl_sch();
	if (roll == 2)
		if (rankeo == 'E') 
			merc_spcl_sch();
		else
			merc_cmd_col();
	if (roll == 5 || roll == 3)
		merc_rcrtng();
	if (rankeo == 'E')
	{
		if (roll == 4 || (race == ITHKLUR && roll >= 6))
			merc_prot_frcs();
		if (roll >= 6 && race != ITHKLUR)
			merc_ocs();
	}
	else
	{
		if (roll == 4)
			merc_attache();
		if (roll >= 6)
			merc_staff_col();
	}
}


int merc_pick_sch()
{
	int choice;

	printf("As an Admirals Aide you can pick your next assignment.\n\n");
	printf("   1. intelligence school\n   2. recruiting\n");
	printf("   3. command college\n   4. staff college\n");
	choice = getsel_int(1, 4);
	if (choice == 1)
		return 1;
	if (choice == 2)
		return 5;
	if (choice == 3)
		return 2;
	return 6;
}


void merc_attache()
{
	int roll;

	roll = d6();
	if (roll <= 4)
		gotspcldty(ATTACHE);
	else
	{
		aide = 1;
	    gotspcldty(AIDE);
	}
	bumpsoc();
	if (rank >= 10)
		printf("You were not eligible for a promotion.");
	else
	{
		rank++;
	    nv_promo++;
		printf("You were promoted.");
	}
}


void merc_ocs()
{
	gotspcldty(OCS);
	rankeo = 'O';
	if (rank >= 8)
		rank = 3;
	else
		if (rank == 7)
			rank = 2;
		else
			rank = 1;
	branch = merc_xfer();
	merc_branch(branch);
	printf("Your new assignment is with the %s branch.\n", office);
	merc_branch_tbl(branch);
	merc_staff_off();
	merc_staff_off();
}


void merc_spcl_sch()
{
	int roll;

	gotspcldty(SPECIALISTSCH);
	roll = d6();
	if ((intl + edu) >= 16)
		switch (roll)
		{
			case 1: addskill(MEDICAL, 1); break;
			case 2: addskill(COMPUTER, 1); break;
			case 3: addskill(LIAISON, 1); break;
			case 4: env(1); break;
			case 5: spac(1); break;
			case 6: acad(1); break;
		}
	else
		switch (roll)
		{
			case 1: addskill(COMMO, 1); break;
			case 2: addskill(MECHANICAL, 1); break;
			case 3: addskill(SHIPBOAT, 1); break;
			case 4: addskill(ELECTRONICS, 1); break;
			case 5: vhcl(1); break;
			case 6: addskill(GRAVITICS, 1); break;
		}
}


void merc_gen_skl()
{
	int roll;

	if (pick <= 2)
	{
		merc_pick_tbl();
		return;
	}
	if (rankeo == 'O' || rank >= 3)
	{
		roll = d5();
		if (roll == 3)
			roll = 2;
	}
	else
	{
		roll = d4();
		if (roll == 4)
			roll = 2;
	}
	if (roll == 1)
		hiv_life();
	if (roll == 2)
		merc_branch_tbl(branch);
	if (roll == 3)
		army_life(branch);
	if (roll == 4)
	{
		if (rankeo == 'E')
			merc_nco();
		else
			if (command == 1)
				merc_cmd_off();
			else
				merc_staff_off();
	}
}


void merc_pick_tbl()
{
	int choice, max;

	max = 3;
	printf("\nPlease select the table you wish to use for your new skill.\n");
	printf("\n   1. Hiver Life\n");   
	merc_branch(branch); 
	printf("   2. The table for %s\n   3. Ground Support Duty\n", office); 
	if (rankeo == 'E' && rank >= 3) 
	{
		printf("   4. NCO\n");
		max = 4;
	}
	if (rankeo == 'O' && command == 1)
	{
		printf("   4. Command Officer\n");
		max = 4;
	}
	if (rankeo == 'O' && command != 1) 
	{
		printf("   4. Staff Officer\n");
		max = 4;
	}
	choice = getsel_int(1, max);
	switch (choice)
	{
		case 1: hiv_life(); break;
		case 2: merc_branch_tbl(branch); break;
		case 3: army_life(); break;
	    case 4: 
		{
			if (rankeo == 'E')
				merc_nco();
			else
				if (command == 1)
					merc_cmd_off();
				else
					merc_staff_off();
			break;
		}
	}
}


int merc_asgn()
{
	int roll, asgnmt;

	combat = 0;
	if (aide == 1)
	{
		printf("You were assigned to special duty.\n");
	    skil = surv = decor = promo = 0;
		return 8;
	}
	roll = d12();
	/* use a brownie point to get special duty */
	if (pick == 1)
		roll = ask_adj_asgn(roll);
	else
	{
		if (pick == 4)
		{
			roll = bp_spcl_duty(roll);
			if (roll == 8 && brownie_points > 3)
			{
				roll++;
				bp_cmbt();
			}
		}
	}
	if (branch == 1) // advisor or infantry
	{
		if (pick == 4 && roll == 6 && brownie_points > 3)
		{
			roll--;
			bp_cmbt();
		}
		switch (roll)
		{
			case 2: asgnmt = 5; break;
			case 3: asgnmt = 5; break;
			case 4: asgnmt = 4; break;
			case 5: asgnmt = 4; break;
			case 6: asgnmt = 6; break;
			case 7: asgnmt = 6; break;
			case 8: asgnmt = 1; break;
			case 9: asgnmt = 3; break;
			case 10: asgnmt = 2; break;
			default: asgnmt = 8; break;
		}
	}
	if (branch == 4) // artillery
	{
		if (pick == 4 && (roll == 6 || roll == 3) && brownie_points > 3)
		{
			roll--;
			bp_cmbt();
		}
		switch (roll)
		{
			case 2: asgnmt = 5; break;
			case 3: asgnmt = 1; break;
			case 4: asgnmt = 4; break;
			case 5: asgnmt = 3; break;
			case 6: asgnmt = 6; break;
			case 7: asgnmt = 6; break;
			case 8: asgnmt = 1; break;
			case 9: asgnmt = 3; break;
			case 10: asgnmt = 4; break;
			default: asgnmt = 8; break;
		}
	}
	if (branch == 6) // support
	{
		if (pick == 4 && (roll == 5 || roll == 3) && brownie_points > 3)
		{
			roll--;
			bp_cmbt();
		}
		switch (roll)
		{
			case 2: asgnmt = 5; break;
			case 3: asgnmt = 2; break;
			case 4: asgnmt = 4; break;
			case 5: asgnmt = 6; break;
			case 6: asgnmt = 6; break;
			case 7: asgnmt = 6; break;
			case 8: asgnmt = 1; break;
			case 9: asgnmt = 3; break;
			case 10: asgnmt = 2; break;
			default: asgnmt = 8; break;
		}
	}
	if (branch == 1) // advisor or infantry
	{
		switch (asgnmt)
		{
			case 1: surv = 0; decor = 0; promo = 6; skil = 7; break;
			case 2: surv = 4; decor = 12; promo = 6; skil = 0; break;
			case 3: surv = 5; decor = 9; promo = 8; skil = 7; break;
			case 4: surv = 5; decor = 10; promo = 9; skil = 8; break;
			case 5: surv = 6; decor = 6; promo = 6; skil = 5; break;
			case 6: surv = 0; decor = 0; promo = 7; skil = 0; break;
			case 7: surv = 4; decor = 12; promo = 6; skil = 6; break;
			case 8: surv = 0; decor = 0; promo = 0; skil = 0; break;
		}
		if (merc_mos() != 0 && surv != 0)
			surv++; /* check mos */
		if (edu > 7 && promo != 0)
			promo++;
	}
	if (branch == 6 || branch == 4) // support or artillery
	{
		switch (asgnmt)
		{
			case 1: surv = 0; decor = 0; promo = 6; skil = 8; break;
			case 2: surv = 4; decor = 0; promo = 6; skil = 0; break;
			case 3: surv = 4; decor = 10; promo = 9; skil = 7; break;
			case 4: surv = 5; decor = 11; promo = 10; skil = 7; break;
			case 5: surv = 6; decor = 7; promo = 7; skil = 6; break;
			case 6: surv = 0; decor = 0; promo = 7; skil = 0; break;
			case 7: surv = 3; decor = 12; promo = 6; skil = 6; break;
			case 8: surv = 0; decor = 0; promo = 0; skil = 0; break;
		}
		if (intl > 8 && promo != 0)
			promo++;
	}
	switch (asgnmt) // all branches
	{
		case 1: printf("This is training.\n"); break;
	    case 2: printf("This is internal security.\n"); break;
		case 3: printf("This is police action.\n"); cmbt++; combat++; break;
	    case 4: printf("This is counter insurgency.\n"); cmbt++; combat++; break;
		case 5: printf("This is a raid.\n"); cmbt++; combat++; break;
	    case 6: printf("This is garrison.\n"); break;
		case 7: printf("This is ships troops.\n"); break;
	    case 8: printf("This is special duty.\n"); break;
	}
	return asgnmt;
}


int merc_mos()
{
	switch (branch)
	{
	case 1:
		{
			if (race == HIVER)
				return adv_mos();
			else
				return inf_mos();
		}
	case 4: return art_mos();
	}
	return -1;
}


int adv_mos()
{
  int qual;

  qual = chk_skl(HEAVYWEAP, 2);
  if (qual == 0) qual = chk_skl(VACCSUIT, 2);
  if (qual == 0) qual = chk_skl(GUNCMBT, 2);
  if (qual == 0) qual = chk_skl(VEHICLE, 2);
  if (qual == 0) qual = chk_skl(ENVIRON, 2);
  if (qual != 0) return 1;
  return 0;
}


int art_mos()
{
	int qual;

	qual = chk_skl(FAGUNNERY, 2);
	if (qual == 0)
		qual = chk_skl(COMPUTER, 2);
	if (qual == 0)
		qual = chk_skl(MECHANICAL, 2);
	if (qual == 0)
		qual = chk_skl(VEHICLE, 2);
	if (qual == 0)
		qual = chk_skl(FORWARDOBS, 2);
	if (qual == 0)
		qual = chk_skl(TECHNICAL, 2);
	if (qual != 0)
		return 1;
	return 0;
}


int army_cmd()
{
	int  roll;
	char choice;

	if (rankeo == 'E')
		return 0;
	if (aide == 1)
	{
		printf("As an Generals Aide you have the option to take a command\n");
	    printf("assignment this year automaticly. Do you want to?");
		choice = getche_y_n();
	    if (choice == 'Y' || choice == 'y')
		{
			aide = 0;
			return 1;
		}
	}
	roll = d12();
	if (branch == 1 && roll >= 7)
		return 1;
	if (branch == 4 && roll >= 8)
		return 1;
	if (branch == 6 && roll >= 10)
		return 1;
	return 0;
}


void merc_cross_train()
{
	int  i, roll, max;

	printf("You got cross-training.\n");
	bp_add(1);
	if (pick >= 3)
	{
		roll = d3();
		merc_cross[roll]++;
		merc_branch_tbl(roll);
		return;
	}
	printf("You have the option to get cross-training in any field. Pick one.\n");
	printf("\n   1. advisor");
	if (merc_cross[1] > 0)
		printf("*");
	printf("\n   2. artillery");
	if (merc_cross[4] > 0)
		printf("*");
	printf("\n   3. support");
	if (merc_cross[6] > 0)
		printf("*");
	max = 3;
	if (merc_cross [2] > 0)
	{
		printf("\n   4. flight*");
		max = 4;
	}
	if (merc_cross [5] > 0)
	{
		printf("\n   5. medical*");
		max = 5;
	}
	printf("\n\n* = already cross-trained in this branch\n");
	roll = getsel_int(1, max);
	i = 0;
	if (roll == 3)
		i = 6;
	if (roll == 2)
		i = 4;
	if (roll == 1)
		i = 1;
	if (roll == 4 && merc_cross[2] > 0)
		i = 2;
	if (roll == 5 && merc_cross[5] > 0)
		i = 5;
	if (i == 0)
	{
		printf("Wrong - try again!\n");
		merc_cross_train();
		return;
	}
	merc_branch_tbl(i);
	merc_cross[i]++;
}