/* HivDplmt.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int hivdplmt();
void hivdplmtmot();
void hivdplmtskills(int skills);
void hivdplmt_tbl(int roll);

extern int hiv_stsfctn(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void physicl(int skl_val);
extern void bumpsoc();
extern void bumpedu();
extern void bumpintl();
extern void mentl(int skl_val);
extern void spac(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void gc(int skl_val);
extern void econ(int skl_val);
extern void acad(int skl_val);
extern void inbrn(int skl_val);
extern void techl(int skl_val);
extern void vc(int skl_val);
extern void mot_cash(int amt);
extern void mot_ship();
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_weapon();

#include "chargen.h"

int hivdplmt()
{
	int     skills, newterm;
  
	newterm = basic_surv(4, edu, 9);
	if (newterm == 0)
	{
		skills = basic_spec_duty(9);
	    if (terms == 1)
			skills++;
		if (blue_blood == 1)
			skills++;
		skills += hiv_stsfctn(5, intl, 8);
		skills += basic_promo(6, soc, 10);
	}
	if (skills != 0)
		hivdplmtskills(skills);
	printf("This ends the term.\n");
	hivdplmtmot();
	return newterm;
}


void hivdplmtmot()
{
	int  roll, amt;
	char choice;
  
	choice = getche_mot();
	if (choice == 'C' || choice == 'c')
	{
		roll = basic_cash();
		amt = 0;
		switch (roll)
		{
			case 1: amt = 2000; break;
	        case 2: amt = 5000; break;
		    case 3: amt = 10000; break;
			case 4: amt = 10000; break;
	        case 5: amt = 10000; break;
		    case 6: amt = 20000; break;
			case 7: amt = 30000; break;
		}
		mot_cash(amt);
	}
	else
	{
		roll = basic_bene();
		if (rank >= 6) roll++;
		switch (roll)
		{
			case 1: mot_midpsg(); break;
		    case 2: bumpintl(); break;
		    case 3: bumpedu(); break;
		    case 4: mot_weapon(); break;
			case 5: mot_hipsg(); break;
			case 6: bumpsoc(); break;
			case 7: mot_ship(); break;
		}
	}
}


void hivdplmtskills(int skills)
{
	int  table, roll;

	while (skills > 0)
	{
		table = picktable();
	    roll = d6();
		if (table == 1)
		{
			if (roll == 6)
				roll = d6();
			switch (roll)
			{
		        case 1: physicl(1); break;
			    case 2: bumpedu(); break;
				case 3: mentl(1); break;
				case 4: vc(1); break;
			    case 5: inbrn(1); break;
				case 6: gc(1); break;
			}
		}
		if (table == 2)
			hivdplmt_tbl(roll);
	    if (table == 3)
		{
			switch (roll)
			{
		        case 1: spac(1); break;
			    case 2: interp(1); break;
				case 3: inbrn(1); break;
				case 4: addskill(LINGUISTICS, 1); break;
			    case 5: econ(1); break;
				case 6: addskill(LIAISON, 1); break;
			}
		}
		if (table == 4)
		{
			switch (roll)
			{
			case 1: bumpsoc(); break;
	        case 2: addskill(LIAISON, 1); break;
		    case 3: techl(1); break;
			case 4: acad(1); break;
	        case 5: acad(1); break;
		    case 6: inbrn(1); break;
			}
		}
		skills--;
	}
}


void hivdplmt_tbl(int roll)
{
	if (roll < 1 || roll >= 6)
		roll = d6();
	switch (roll)
	{
        case 1: interp(1); break;
        case 2: interp(1); break;
        case 3: vhcl(1); break;
        case 4: vhcl(1); break;
        case 5: vc(1); break;
        case 6: gc(1); break;
	}
}
