/* HIVEXPLR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int hivexplorer();
void explormot(int term);
void explorskills(int skills);

extern int basic_surv(int neednbr, int upp, int upp_val);
extern int hiv_stsfctn(int neednbr, int upp, int upp_val);
extern int basic_promo(int neednbr, int upp, int upp_val);
extern int basic_spec_duty(int roll);
extern int picktable();
extern int d6();
extern int d12();
extern char getche_mot();
extern void bumpintl();
extern void bumpend();
extern void bumpdex();
extern void bumpstr();
extern void bumpedu();
extern void bumpsoc();
extern void addskill(int skill, int skl_val);
extern void vhcl(int val);
extern void bc(int val);
extern void weapon(int val);
extern void mot_cash(int amt);
extern void mot_midpsg();
extern void mot_ship();
extern void mot_weapon();

#include "chargen.h"

int hivexplorer()
{
	int  skills, newterm;
  
	newterm = basic_surv(6, soc, 7);
	if (newterm == 0)
	{
		skills = basic_spec_duty(4);
	    if (terms == 1)
			skills++;
		if (blue_blood == 1)
			skills++;
	    skills += hiv_stsfctn(8, intl, 5);
		skills += basic_promo(8, end, 5);
	}
	if (skills >= 0)
		explorskills(skills);
	printf("That competes this term!\n");
	explormot(1);
	return newterm;
}


void explormot(int term)
{
	int  roll, choice, amt;
  
	choice = getche_mot();
	roll = d6();
	if (choice == 'C' || choice == 'c')
	{
		amt = 0;
		switch (roll)
		{
			case 1: amt = 1000; break;
			case 2: amt = 1000; break;
			case 3: amt = 5000; break;
			case 4: amt = 30000; break;
			case 5: amt = 40000; break;
			case 6: amt = 50000; break;
		}
		mot_cash(amt);
	}
	else
	{
		switch (roll)
		{
			case 1: bumpedu(); break;
			case 2: bumpedu(); bumpedu(); break;
			case 3: mot_weapon(); break;
			case 4: mot_midpsg(); break;
	        case 5: mot_midpsg(); break;
		    case 6: mot_ship(); break;
		}
	}
}


void explorskills(int skills)
{
	int  table, roll;

	while (skills > 0)
	{
		table = picktable();
		roll = d6();
		if (table == 1)
		{
			switch (roll)
			{
				case 1: bumpstr(); break;
		        case 2: bumpdex(); break;
				case 3: bumpend(); break;
		        case 4: addskill(CAROUSING, 1); break;
				case 5: addskill(GAMBLING, 1); break;
				case 6: addskill(MANIPULATION, 1); break;
			}
		}
		if (table == 2)
		{
			switch (roll)
			{
				case 1: vhcl(1); break;
		        case 2: addskill(VACCSUIT, 1); break;
				case 3: addskill(MECHANICAL, 1); break;
		        case 4: addskill(ELECTRONICS, 1); break;
				case 5: addskill(GRAVITICS, 1); break;
		        case 6: addskill(COMPUTER, 1); break;
			}
		}
		if (table == 3)
		{
			if (roll > 4)
				roll = d6();
			switch (roll)
			{
				case 1: addskill(SHIPBOAT, 1); break;
		        case 2: addskill(TRANSLATOR, 1); break;
				case 3: addskill(ENGINEERING, 1); break;
		        case 4: vhcl(1); break;
				case 5: weapon(1); break;
		        case 6: bc(1); break;
			}
		}
		if (table == 4)
		{
			switch (roll)
			{
				case 1: addskill(MEDICAL, 1); break;
		        case 2: bumpedu(); break;
				case 3: bumpintl(); break;
		        case 4: bumpsoc(); break;
				case 5: addskill(HANDYMAN, 1); break;
		        case 6: addskill(HANDYMAN, 1); break;
			}
		}
		skills--;
	}
}

