/* HivMedic.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int hivmedic();
void hivmedicmot(int term);
void hivmedicskills(int skills);
void hivmedic_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int hiv_stsfctn(int needs, int mod, int mod_needs);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpend();
extern void bumpstr();
extern void bumpedu();
extern void bumpdex();
extern void spac(int skl_val);
extern void sci(int skl_val);
extern void mentl(int skl_val);
extern void interp(int skl_val);
extern void econ(int skl_val);
extern void acad(int skl_val);
extern void techl(int skl_val);
extern void vhcl(int skl_val);
extern void mot_cash(int amt);
extern void mot_tas();
extern void mot_midpsg();
extern void mot_lopsg();
extern void mot_medkit();

#include "chargen.h"

int hivmedic()
{
	int skills, newterm;

	newterm = basic_surv(4, intl, 8);
	if (newterm == 0)
	{
		skills = basic_spec_duty(9);
		if (terms == 1)
			skills++;
		if (blue_blood == 1) skills++;
		skills += hiv_stsfctn(8, intl, 5);
		skills += basic_promo(6, soc, 5);
	}
	if (skills != 0)
		hivmedicskills(skills);
	printf("This ends the term.\n");
	hivmedicmot(1);
	return newterm;
}


void hivmedicmot(int term)
{
	int  roll, amt;
	char choice;
  
	choice = getche_mot();
	if (choice == 'C' || choice == 'c')
	{
		roll = basic_cash();
		amt = 0;
		switch (roll)
		{
			case 1: amt = 10000; break;
			case 2: amt = 10000; break;
			case 3: amt = 20000; break;
			case 4: amt = 30000; break;
			case 5: amt = 40000; break;
			case 6: amt = 60000; break;
			case 7: amt = 100000; break;
		}
		mot_cash(amt);
	}
	else
	{
		roll = basic_bene();
		switch (roll)
		{
			case 1: mot_lopsg(); break;
			case 2: bumpedu(); break;
			case 3: bumpedu(); break;
			case 4: mot_medkit(); break;
		    case 5: mot_medkit(); break;
			case 6: mot_midpsg(); break;
			case 7: mot_tas(); break;
		}
	}
}


void hivmedicskills(int skills)
{
	int  table, roll;

	while (skills > 0)
	{
		table = picktable();
		roll = d6();
		if (table == 1)
		{
			switch (roll)
			{
				case 1: bumpstr(); break;
				case 2: bumpedu(); break;
				case 3: mentl(1); break;
		        case 4: bumpdex(); break;
				case 5: bumpend(); break;
		        case 6: soc++; break;
			}
		}
		if (table == 2)
			hivmedic_tbl(roll);
		if (table == 3)
		{
			switch (roll)
			{
				case 1: sci(1); break;
				case 2: vhcl(1); break;
		        case 3: techl(1); break;
				case 4: econ(1); break;
		        case 5: spac(1); break;
				case 6: addskill(MEDICAL, 1); break;
			}
		}
		if (table == 4)
		{
			switch (roll)
			{
				case 1: sci(1); break;
		        case 2: addskill(MEDICAL, 1); break;
				case 3: addskill(BIOLOGY, 1); break;
		        case 4: addskill(LINGUISTICS, 1); break;
				case 5: interp(1); break;
		        case 6: acad(1); break;
			}
		}
		skills--;
	}
}


void hivmedic_tbl(int roll)
{
	if (roll < 1 || roll > 6)
		roll = d6();
	switch (roll)
	{
		case 1: addskill(MEDICAL, 1); break;
		case 2: techl(1); break;
        case 3: addskill(LIAISON, 1); break;
        case 4: interp(1); break;
        case 5: bumpdex(); break;
        case 6: addskill(MEDICAL, 1); break;
	}
}
