/* HIVNAVY.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int hivnavy();
void hiv_get_branch();
int hiv_subsec();
int hiv_subflt();
int hiv_set_branch();
int hiv_pickbranch();
void hiv_do_initial();
int hiv_doterms(); 
int hiv_xfer();
void hiv_branch(int branch_nbr);
int hiv_do_year();
int hiv_mos();
int crew_mos();
int cmd_mos();
void hivnavymot(int term);
void hiv_branch_tbl(int brnch);
void hiv_petty_off();
void hiv_cmd_off();
void hiv_staff_off();
void hiv_life();
void hiv_crew();
void hiv_flt();
void hiv_cmd();
void hiv_sec();
void hiv_engr();
void hiv_med();
void hiv_tech();
void hiv_shore_duty();
void hiv_ship_duty();
void hiv_spcl_asgn();
void hiv_recruit();
void hiv_ocs();
void hiv_spcl_sch();
void hiv_gen_skl();
void hiv_table(int roll);
void hiv_duty();
void hiv_pick_tbl();
int hiv_asgn();
void hiv_cross_train();

extern int nv_cmd();
extern int anag();
extern int hiv_stsfctn(int needs, int mod, int mod_needs);
extern int getrank();
extern int survive(int adjust, int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d4();
extern int d5();
extern int d6();
extern int d9();
extern int d12(); 
extern int getsel_int(int min, int max);
extern char getche_y_n();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int find_skl(int skill);
extern int chk_skl(int skill, int skl_val);
extern int bp_skill(int roll);
extern int bp_skill1(int roll, int need_nbr);
extern int bp_spcl_duty(int roll);
extern int reenlist(int need_nbr);
extern void nv_intl_sch();
extern void nv_gun_sch();
extern void nv_engr_sch();
extern void nv_cmd_col();
extern void nv_staff_col();
extern void bumpdex();
extern void bumpstr();
extern void bumpend();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void gunner(int skl_val);
extern void gc(int skl_val);
extern void vhcl(int skl_val);
extern void bp_add(int amt);
extern void bp_cmbt();
extern void merc_rcrtng();
extern int ask_adj_asgn(int roll);
extern void gotspcldty(int spcldutynbr);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_hipsg();
extern void mot_weapon();
extern void mot_tas();

#include "chargen.h"

extern int nv_anag, nv_cross[10];

int hivnavy()
{
	int survival, i;
  
	if (terms == 0)
	{
		for (i = 1; i <= 10; i++)
			nv_cross[i] = 0;
		hiv_get_branch();
		hiv_do_initial();
	}
	survival = hiv_doterms();
	if (hiv_stsfctn(8, intl, 5) > 0)
		hiv_gen_skl();
	if (survival != 0)
		return 1;
	if (nv_anag == 0)
		hivnavymot(1);
	return 0;
}


void hiv_get_branch()
{
	char choice;

	printf("Do you want to be in the security branch?");
	choice = getche_y_n();
	if (choice == 'Y' || choice == 'y')
		branch = 7;
	if (branch == 0)
	{
		if (intl >= 9)
			branch = hiv_pickbranch();
		else
			branch = hiv_set_branch();
	}
	nv_cross[branch]++;
	if (branch == 2)
	{
		nv_cross[8]++;
		branch = hiv_subflt();
	}
	if (branch == 7)
	{
		nv_cross[9]++; 
		branch = hiv_subsec();
	}
	hiv_branch(branch);
	printf("You were assigned to the %s branch.\n", office);
}


int hiv_subsec()
{
	int choice;

	printf("You have these options within the security branch:\n\n");   
	printf("   1. gunnery\n   2. ships troops\n");
	choice = getsel_int(1, 2);
	if (choice == 1)
		return 7;
	return 9;
}


int hiv_subflt()
{
	int choice;

	printf("You have these options within the flight branch:\n\n");   
	printf("   1. bridge\n   2. boat\n");
	choice = getsel_int(1, 2);
	if (choice == 1)
		return 2;
	return 8;
}


int hiv_set_branch()
{
	int roll;

	roll = d6();
	return roll;
}


int hiv_pickbranch()
{
	int choice;

	if (pick == 4)
		return hiv_set_branch();
	printf("Due to your high social status you have the option to choose\n");
	printf("the branch you with to serve in within the Navy.\n");
	printf("\n   1. pick one at random\n   2. crew\n");
	printf("   3. flight\n   4. medical\n   5. technical\n");
	printf("   6. engineering\n   7. command\n");
	choice = getsel_int(1, 7);
	if (choice == 1)
		return hiv_set_branch();
	choice--;
	return choice;
}


void hiv_do_initial()
{
	if (rank == 0)
		rank++;
	hiv_branch_tbl(branch);
	hiv_branch_tbl(branch);
	age++;
	nv_anag = anag();
	if (nv_anag == 0)
		appearent_age++;
}


extern int nv_promo, assignment, command, combat;

int hiv_doterms()
{
	int survival, need_nbr;
  
	command = 0;
	combat = 0;
	assignment = 0;
	nv_promo = 0;
	do
	{
		survival = hiv_do_year();
	} while (((age % 4) != 2) && (survival == 0));
	if (survival != 0)
		return 2;
	need_nbr = 1;
	survival = reenlist(need_nbr);
	if (survival != 0)
		return 1; 
	drafted = 0;
	branch = hiv_xfer();
	nv_anag = anag();
	return 0;
}


int hiv_xfer()
{
	int  i, roll, choice;

	if (pick == 4)
	{
		roll = d9();
		if (nv_cross[roll] == 0)
		{
			hiv_branch(branch);
			printf("You are in the %s branch.\n", office);
			return branch;
		}
		else
		{
			hiv_branch(roll);
			printf("You are in the %s branch.\n", office);
			return roll;
		}
	}
	for (i = 1; i <= 9; i++)
	{
		if (nv_cross[i] != 0 && branch != i)
		{
			hiv_branch(i);
			printf("You have the option to transfer to the %s branch.\n", office); 
			printf("Do you want to?");
			choice = getche_y_n();
			if (choice == 'Y' || choice == 'y')
				return i;
		}
	}
	return branch;
}


void hiv_branch(int branch_nbr)
{
	switch (branch_nbr)
	{
		case 1: strncpy(office,"Crew",5); break;
		case 2: strncpy(office,"Flight-Bridge",14); break; 
	    case 3: strncpy(office,"Medical",8); break; 
		case 4: strncpy(office,"Technical",10); break; 
	    case 5: strncpy(office,"Engineering",12); break; 
		case 6: strncpy(office,"Command",8); break; 
	    case 7: strncpy(office,"Gunnery",8); break; 
		case 8: strncpy(office,"Flight-Boat",12); break;
	    case 9: strncpy(office,"Troops",7); break; 
		default: strncpy(office,"unknown?",9); break;
	}
}


int hiv_do_year()
{
	int roll;

	age++;
	if (nv_anag == 0)
		appearent_age++;
	command = nv_cmd();
	assignment = hiv_asgn();
	if (combat != 0 && command != 0)
		cmd++;
	if ((rank < 9 && rankeo == 'E') || (rankeo == 'O' && rank < 10))
	{
		if (nv_promo == 0)
		{
			roll = d12();
			if (intl >= 5)
				roll++;
			if (roll >= 10)
			{
				nv_promo++;
				rank++;
				printf("You were promoted. ");
				getrank();
				if (rankeo == 'O' && rank == 4)
					addskill(LEADER, 1);
			}
		}
	}
	if (assignment == 8)
		hiv_spcl_asgn();
	if (skil != 0)
	{
		roll = d12();
		if (roll < skil)
			roll = bp_skill(roll);
	    if (roll >= (skil + 4))
			hiv_gen_skl();
		if (roll >= skil)
			hiv_gen_skl();
	}
	roll = d12();
	if ((branch == 6 || branch == 1) && (hiv_mos() != 0))
		roll++;
	if (branch == 2 || branch == 9)
		roll += (terms - 1);
	if (branch == 8)
		roll += (find_skl(PILOT));
	return survive(roll, 0);
}


int hiv_mos()
{
	if (branch != 6)
		return crew_mos();
	else
		return cmd_mos();
}


int crew_mos()
{
	int qual;

	qual = chk_skl(STEWARD, 2);
	if (qual == 0)
		qual = chk_skl(COMPUTER, 2);
	if (qual == 0)
		qual = chk_skl(MECHANICAL, 2);
	if (qual == 0)
		qual = chk_skl(GRAVITICS, 2);
	if (qual == 0)
		qual = chk_skl(COMMO, 2);
	if (branch == 1 && qual == 0)
		qual = chk_skl(LIAISON, 2);
	if (qual == 0)
		qual = chk_skl(VEHICLE, 2);
	if (qual != 0)
		return 1;
	return 0;
}


int cmd_mos()
{
	int qual;

	qual = chk_skl(VEHICLE, 2);
	if (qual == 0)
		qual = chk_skl(COMPUTER, 2);
	if (qual == 0)
		qual = chk_skl(SHIPTAC, 2);
	if (qual == 0)
		qual = chk_skl(LEADER, 2);
	if (qual == 0)
		qual = chk_skl(ADMIN, 2);
	if (qual != 0)
		return 1;
	return 0;
}


void hivnavymot(int term)
{
	int choice, roll, amt;

	while (term > 0)
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c')
		{
			roll = basic_cash();
			amt = 0;
			switch (roll)
			{
				case 1: amt = 1000; break;
		        case 2: amt = 5000; break;
				case 3: amt = 10000; break;
		        case 4: amt = 10000; break;
				case 5: amt = 10000; break;
				default: amt = 20000; break;
			}
			mot_cash(amt);
		}
		else
		{
			roll = basic_bene();
			term--;
			switch (roll)
			{
				case 1: mot_lopsg(); break;
				case 2: bumpedu(); break;
				case 3: bumpintl(); bumpintl(); break;
				case 4: mot_weapon(); break;
				case 5: mot_hipsg(); break;
				default: mot_tas(); break;
			}
		}
		term--;
	}
}


void hiv_branch_tbl(int brnch)
{
	switch (brnch)
	{
		case 1: hiv_crew(); break;
	    case 2: hiv_flt(); break;
		case 7: hiv_sec(); break;
	    case 5: hiv_engr(); break;
		case 3: hiv_med(); break;
	    case 4: hiv_tech(); break;
		case 6: hiv_cmd(); break;
	    case 8: hiv_flt(); break;
		case 9: hiv_sec(); break;
	}
}


void hiv_petty_off()
{
	int roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: addskill(VACCSUIT, 1); break;
	    case 2: addskill(PSYCHOLOGY, 1); break;
		case 3: gc(1); break;
	    case 4: addskill(MECHANICAL, 1); break;
		case 5: addskill(MEDICAL, 1); break;
	    case 6: addskill(LEADER, 1); break;
		case 7: bumpsoc(); break;
	    case 8: bumpedu(); break;
		case 9: addskill(INSTRUCTION, 1); break;
		default: addskill(HANDYMAN, 1); break;
	}
}


void hiv_cmd_off()
{
	int roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: vhcl(1); break;
	    case 2: addskill(LEADER, 1); break;
		case 3: addskill(SHIPBOAT, 1); break;
	    case 5: addskill(LEADER, 1); break;
		case 4: addskill(PILOT, 1); break;
	    case 6: addskill(SIGNLANG, 1); break;
		case 7: addskill(LIAISON, 1); break;
	    case 8: addskill(MANIPULATION, 1); break;
		default: addskill(FLEETTAC, 1); break;
	}
}


void hiv_life()
{
	int roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: addskill(CAROUSING, 1); break;
		case 2: bumpstr(); break;
	    case 3: bumpend(); break;
		case 4: addskill(VACCSUIT, 1); break;
	    case 5: bumpdex(); break;
		case 6: addskill(NOGRAV, 1); break;
	    case 7: bumpedu(); break;
		case 8: addskill(ACTING, 1); break;
	    case 9: bumpsoc(); break;
		default: addskill(PSYCHOLOGY, 1); break;
	}
}


void hiv_crew()
{
	int roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
        case 1: addskill(MECHANICAL, 1); break;
        case 2: addskill(STEWARD, 1); break;
        case 3: addskill(COMPUTER, 1); break;
        case 4: addskill(COMMO, 1); break;
        case 5: addskill(LIAISON, 1); break;
        case 6: vhcl(1); break;
        case 7: addskill(GRAVITICS, 1); break;
        default: addskill(COMMO, 1); break;
	}
}


void hiv_flt()
{
	int roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: addskill(VACCSUIT, 1); break;
		case 2: addskill(ADMIN, 1); break;
		case 3: addskill(SHIPBOAT, 1); break;
		case 5: addskill(PILOT, 1); break;
		case 4: addskill(COMMO, 1); break;
		case 6: addskill(NAVIGATION, 1); break;
		default: addskill(PILOT, 1); break;
	}
}


void hiv_cmd()
{
	int roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: vhcl(1); break;
		case 2: addskill(LEADER, 1); break;
		case 3: addskill(LEADER, 1); break;
		case 5: addskill(LEADER, 1); break;
		case 4: addskill(SHIPTAC, 1); break;
		case 6: addskill(SHIPTAC, 1); break;
		case 7: addskill(ADMIN, 1); break;
		default: addskill(COMPUTER, 1); break;
	}
}


void hiv_sec()
{
	int roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: addskill(NOGRAV, 1); break;
        case 2: gc(1); break;
        case 3: addskill(TACTICS, 1); break;
        case 4: gc(1); break;
        case 5: addskill(CAROUSING, 1); break;
        default: gunner(1); break;
	}
}


void hiv_staff_off()
{
	int roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
        case 1: addskill(COMPUTER, 1); break;
        case 2: addskill(ELECTRONICS, 1); break;
        case 5: addskill(SHIPTAC, 1); break;
        case 4: addskill(ADMIN, 1); break;
        case 3: addskill(ADMIN, 1); break;
        case 6: addskill(SIGNLANG, 1); break;
        case 7: addskill(COMMO, 1); break;
        case 8: addskill(INSTRUCTION, 1); break;
        default: addskill(FLEETTAC, 1); break;
	}
}


void hiv_engr()
{
	int roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
        case 3: addskill(MECHANICAL, 1); break;
        case 1: addskill(ELECTRONICS, 1); break;
        case 5: addskill(ENGINEERING, 1); break;
        case 2: addskill(GRAVITICS, 1); break;
        case 4: addskill(VACCSUIT, 1); break;
        case 6: addskill(ENGINEERING, 1); break;
        case 7: addskill(ENGINEERING, 1); break;
        default: addskill(HANDYMAN, 1); break;
	}
}


void hiv_med()
{
	int roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
        case 1: addskill(ADMIN, 1); break;
        case 4: addskill(COMPUTER, 1); break;
        default: addskill(MEDICAL, 1); break;
	}
}


void hiv_tech()
{
	int roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 3: addskill(MECHANICAL, 1); break;
		case 7: addskill(COMMO, 1); break;
		case 4: addskill(COMPUTER, 1); break;
		case 5: addskill(COMPUTER, 1); break;
		case 2: addskill(GRAVITICS, 1); break;
		case 6: vhcl(1); break;
		default: addskill(ELECTRONICS, 1); break;
	}
}


void hiv_shore_duty()
{
	int roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: addskill(CAROUSING, 1); break;
		case 2: vhcl(1); break;
		case 3: addskill(LIAISON, 1); break;
		case 5: addskill(CAROUSING, 1); break;
		case 7: addskill(SURVIVAL, 1); break;
		case 8: vhcl(1); break;
		default: addskill(VACCSUIT, 1); break;
	}
}


void hiv_ship_duty()
{
	int roll;

	roll = d6();
	roll += (terms - 1);
	switch (roll)
	{
		case 1: bumpdex(); break;
		case 5: addskill(MECHANICAL, 1); break;
		case 3: addskill(MECHANICAL, 1); break;
		case 6: addskill(ELECTRONICS, 1); break;
		case 4: addskill(SHIPBOAT, 1); break;
		case 2: addskill(VACCSUIT, 1); break;
		case 7: addskill(GRAVITICS, 1); break;
		case 8: addskill(COMMO, 1); break;
		case 9: addskill(ADMIN, 1); break;
		default: addskill(HANDYMAN, 1); break;
	}
}


void hiv_spcl_asgn()
{
	int roll;

	roll = d6();
	if (roll == 2)
		nv_gun_sch();
	if (roll == 1)
		hiv_recruit();
	if (rankeo == 'E')
	{
		if (roll == 3)
			hiv_cross_train();
		if (roll == 4)
			hiv_spcl_sch();
		if (roll == 5)
			nv_engr_sch();
		if (roll >= 6)
			hiv_ocs();
	}
	else
	{
		if (roll == 3)
			nv_intl_sch();
		if (roll == 4)
			nv_cmd_col();
		if (roll >= 5)
			nv_staff_col();
	}
}


void hiv_recruit()
{
	int roll;

	merc_rcrtng();
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(ADMIN, 1);
}


void hiv_ocs()
{
	gotspcldty(OCS);
	rankeo = 'O';
	if (rank >= 7)
		rank = 2;
	else
		rank = 1;
	branch = hiv_xfer();
	hiv_branch(branch);
	printf("Your new assignment is with the %s branch.\n", office);
}


void hiv_spcl_sch()
{
	int roll;

	gotspcldty(SPECIALISTSCH);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(ELECTRONICS, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(ADMIN, 1);
	roll = bp_skill1(d6(), 4);
	if (roll >= 4)
		addskill(COMPUTER, 1);
}


void hiv_gen_skl()
{
	int roll;

	if (pick <= 2)
	{
		hiv_pick_tbl();
		return;
	}
	if (rankeo == 'O' || rank >= 4)
	{
		roll = d6();
		if (roll >= 5)
			roll = 3;
	}
	else
	{
		roll = d4();
		if (roll == 4)
			roll = 3;
	}
	hiv_table(roll);
}


void hiv_table(int roll)
{
	if (roll == 1)
		hiv_life();
	if (roll == 2)
		hiv_duty();
	if (roll == 3)
		hiv_branch_tbl(branch);
	if (roll == 4)
	{
		if (rankeo == 'E')
			hiv_petty_off();
		else
			if (branch == 1)
				hiv_cmd_off();
			else
				hiv_staff_off();
	}
}


void hiv_duty()
{
	if (assignment == 1)
		hiv_shore_duty();
	else
		hiv_ship_duty();
}


void hiv_pick_tbl()
{
	int choice;

	printf("\nPlease select the table you wish to use for your new skill.\n");
	printf("\n   1. Hiver life\n");   
	hiv_branch(branch);
	printf("   2. The table for %s\n", office); 
	if (assignment == 1)
	{
		printf("   3. Shore duty\n");
	}
	else
	{
		printf("   3. Shipboard duty\n");
	}
	if (rankeo == 'E' && rank >= 4)
		printf("   4. Petty officer\n");
	if (rankeo == 'O' && branch == 1)
		printf("   4. Command Officer\n");
	if (rankeo == 'O' && branch != 1)
		printf("   4. Staff Officer\n");
	choice = getsel_int(1, 4);
	if (rankeo == 'E' && rank < 4 && choice == 4)
	{
		printf("Wrong - try again!\n");
		hiv_pick_tbl();
		return;
	}
	hiv_table(choice);
}


int hiv_asgn()
{
  
	int roll;

	combat = 0;
	roll = d6();
	if (roll == 6 && assignment != 0)
	{
		printf("You were allowed to repeat your last assignment.\n");
		if (assignment > 3 && assignment < 7)
		{
			combat = 1;
			cmbt++;
		}
		return assignment;
	}
	roll = d12();
	if (branch == 7 || branch == 9) roll++;
	if (pick == 1)
		roll = ask_adj_asgn(roll);
	else
		if (pick == 4 && (roll == 2 || roll == 7 || roll == 10)
			&& brownie_points > 3)
		{
			roll++;
			bp_cmbt();
		}
	if (roll >= 12)
	{
		printf("This is a skirmish assignment.\n");
		cmbt++;
	    combat = 1;
		switch (branch)
		{
			case 1: skil = 5; surv = 5; promo = 5; break;
			case 2: skil = 5; surv = 4; promo = 5; break;
			case 3: skil = 4; surv = 5; promo = 4; break;
			case 4: skil = 4; surv = 5; promo = 5; break;
			case 5: skil = 6; surv = 5; promo = 5; break;
			case 6: skil = 4; surv = 6; promo = 5; break;
			case 7: skil = 5; surv = 6; promo = 4; break;
			case 8: skil = 5; surv = 6; promo = 4; break;
			default: skil = 5; surv = 5; promo = 5; break;
		}
		return 6;
	}
	if (roll == 7)
	{
		printf("This is a training assignment.\n");
		surv = 0;
	    skil = 6;
		promo = 6;
		switch (branch)
		{
			case 2: surv = 3; break;
			case 5: promo = 7; break;
			case 1: promo = 7; break;
			case 7: skil = 7; break;
			case 8: surv = 4; promo = 5; break;
			case 9: surv = 3; promo = 7; break;
		}
		return 1;
	}
	if (roll == 2 || roll == 10)
	{
		printf("This is a shore duty assignment.\n");
		switch (branch)
		{
			case 1: skil = 6; surv = 4; promo = 7; break;
			case 2: skil = 6; surv = 3; promo = 6; break;
			case 3: skil = 7; surv = 0; promo = 6; break;
			case 4: skil = 7; surv = 0; promo = 5; break;
			case 5: skil = 6; surv = 3; promo = 6; break;
			case 6: skil = 6; surv = 4; promo = 5; break;
			case 7: skil = 0; surv = 3; promo = 8; break;
			case 8: skil = 7; surv = 3; promo = 8; break;
			default: skil = 5; surv = 5; promo = 6; break;
		}
		return 2;
	}
	if (roll == 4)
	{
		printf("This is a seige assignment.\n");
		cmbt++;
		combat = 1;
		switch (branch)
		{
			case 1: skil = 5; surv = 5; promo = 6; break;
			case 2: skil = 6; surv = 3; promo = 5; break;
			case 3: skil = 5; surv = 4; promo = 5; break;
			case 4: skil = 6; surv = 4; promo = 6; break;
			case 5: skil = 6; surv = 4; promo = 5; break;
			case 6: skil = 5; surv = 5; promo = 4; break;
			case 7: skil = 5; surv = 5; promo = 6; break;
			case 8: skil = 4; surv = 5; promo = 5; break;
			default: skil = 6; surv = 5; promo = 6; break;
		}
		return 4;
	}
	if (roll == 9 || roll == 5)
	{
		printf("This is a strike assignment.\n");
		cmbt++;
		combat = 1;
		switch (branch)
		{
			case 1: skil = 5; surv = 6; promo = 5; break;
			case 2: skil = 6; surv = 3; promo = 4; break;
			case 3: skil = 5; surv = 5; promo = 5; break;
			case 4: skil = 5; surv = 5; promo = 5; break;
			case 5: skil = 5; surv = 6; promo = 6; break;
			case 6: skil = 4; surv = 6; promo = 5; break;
			case 7: skil = 5; surv = 5; promo = 5; break;
			case 8: skil = 5; surv = 4; promo = 5; break;
			default: skil = 6; surv = 5; promo = 6; break;
		}
		return 5;
	}
	if (roll == 8)
	{
		printf("This is a patrol assignment.\n");
		switch (branch)
		{
			case 1: skil = 5; surv = 4; promo = 6; break;
			case 2: skil = 5; surv = 3; promo = 5; break;
			case 3: skil = 5; surv = 3; promo = 5; break;
			case 4: skil = 5; surv = 3; promo = 5; break;
			case 5: skil = 6; surv = 4; promo = 5; break;
			case 6: skil = 5; surv = 4; promo = 5; break;
			case 7: skil = 6; surv = 4; promo = 6; break;
			case 8: skil = 6; surv = 4; promo = 5; break;
			default: skil = 6; surv = 4; promo = 6; break;
		}
		return 3;
	}
	if (roll == 6)
	{
		printf("This is a exploration assignment.\n");
		switch (branch)
		{
			case 1: skil = 5; surv = 5; promo = 5; break;
			case 2: skil = 5; surv = 4; promo = 4; break;
			case 3: skil = 5; surv = 5; promo = 5; break;
			case 4: skil = 5; surv = 5; promo = 5; break;
			case 5: skil = 6; surv = 5; promo = 5; break;
			case 6: skil = 6; surv = 5; promo = 5; break;
			case 7: skil = 6; surv = 5; promo = 5; break;
			case 8: skil = 5; surv = 5; promo = 5; break;
			default: skil = 5; surv = 5; promo = 4; break;
		}
		return 7;
	}
	printf("This is special duty.\n");
	skil = surv = promo = decor = 0;
	return 8;
}


void hiv_cross_train()
{
	int roll;

	printf("You got cross-training.\n");
	bp_add(1);
	if (pick >= 3)
	{
		roll = d9();
		nv_cross[roll]++;
		hiv_branch_tbl(roll);
		return;
	}
	printf("You have the option to get cross-training in any field. Pick one.\n");
	printf("\n   1. crew");
	if (nv_cross[1] > 0)
		printf("*");
	printf("\n   2. flight - bridge");
	if (nv_cross[2] > 0)
		printf("*");
	printf("\n   3. medical");
	if (nv_cross[3] > 0)
		printf("*");
	printf("\n   4. technical");
	if (nv_cross[4] > 0)
		printf("*");
	printf("\n   5. engineering");
	if (nv_cross[5] > 0)
		printf("*");
	printf("\n   6. command");
	if (nv_cross[6] > 0)
		printf("*");
	printf("\n   7. gunnery");
	if (nv_cross[7] > 0)
		printf("*");
	printf("\n   8. flight - boat");
	if (nv_cross[8] > 0)
		printf("*");
	printf("\n   9. ships troops");
	if (nv_cross[9] > 0)
		printf("*");
	printf("\n\n* = already cross-trained in this branch\n");
	roll = getsel_int(1, 9);
	hiv_branch_tbl(roll);
	nv_cross[roll]++;
}
