/* HIVSTORY.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int hivstory();
void storymot(int term);
void storyskills(int skills);

extern int basic_surv(int neednbr, int upp, int upp_val);
extern int hiv_stsfctn(int neednbr, int upp, int upp_val);
extern int basic_promo(int neednbr, int upp, int upp_val);
extern int basic_spec_duty(int roll);
extern int picktable();
extern int d6();
extern char getche_mot();
extern void bumpintl();
extern void bumpend();
extern void bumpdex();
extern void bumpstr();
extern void bumpedu();
extern void bumpsoc();
extern void addskill(int skill, int skl_val);
extern void vhcl(int val);
extern void weapon(int val);
extern void mot_cash(int amt);
extern void mot_hipsg();
extern void mot_weapon();

#include "chargen.h"

int hivstory()
{
  int  skills, newterm;
  
  newterm = basic_surv(3, intl, 11);
  if (newterm == 0) {
    skills = basic_spec_duty(6);
    if (terms == 1) skills++;
    if (blue_blood == 1) skills++;
    skills += hiv_stsfctn(8, soc, 7);
    skills += basic_promo(8, soc, 9);
  }
  if (skills != 0) storyskills(skills);
  printf("That competes this term!\n");
  storymot(1);
  return newterm;
}


void storymot(int term)
{
  int  roll, choice, amt;
  
  choice = getche_mot();
  roll = d6();
  if (choice == 'C' || choice == 'c')
  {
    amt = 0;
	switch (roll)
	{
      case 1: amt = 5000; break;
      case 2: amt = 10000; break;
      case 3: amt = 10000; break;
      case 4: amt = 10000; break;
      case 5: amt = 20000; break;
      case 6: amt = 20000; break;
    }
	mot_cash(amt);
  }
  else
  {
      switch (roll)
	  {
        case 1: bumpintl(); break;
        case 2: bumpintl(); bumpintl(); break;
        case 3: mot_weapon(); break;
        case 4: mot_hipsg(); break;
        case 5: mot_hipsg(); break;
        case 6: bumpsoc(); break;
      }
  }
}


void storyskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: bumpstr(); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: addskill(CAROUSING, 1); break;
        case 5: bumpedu(); break;
        case 6: bumpsoc(); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: vhcl(1); break;
        case 2: addskill(CAROUSING, 1); break;
        case 3: addskill(ELECTRONICS, 1); break;
        case 4: addskill(ELECTRONICS, 1); break;
        case 5: addskill(TRANSLATOR, 1); break;
        case 6: addskill(MANIPULATION, 1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(VACCSUIT, 1); break;
        case 2: addskill(TRANSLATOR, 1); break;
        case 3: addskill(LIAISON, 1); break;
        case 4: addskill(ADMIN, 1); break;
        case 5: weapon(1); break;
        case 6: bumpsoc(); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: addskill(MEDICAL, 1); break;
        case 2: addskill(CAROUSING, 1); break;
        case 3: bumpintl(); break;
        case 4: addskill(TRANSLATOR, 1); break;
        case 5: addskill(LIAISON, 1); break;
        case 6: addskill(ADMIN, 1); break;
      }
    }
    skills--;
  }
}

