/* HivTechy.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int hivtechy();
void hivtechymot(int term);
void hivtechyskills(int skills);
void techy_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int hiv_stsfctn(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void physicl(int skl_val);
extern void bumpdex();
extern void econ(int skl_val);
extern void mc(int skl_val);
extern void influ(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void sci(int skl_val);
extern void bumpintl();
extern void acad(int skl_val);
extern void techl(int skl_val);
extern void mot_cash(int amt);
extern void mot_tas();
extern void mot_lopsg();
extern void mot_hipsg();
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_techtool();

#include "chargen.h"

int hivtechy()
{
	int skills, newterm;

	newterm = basic_surv(4, intl, 8);
	if (newterm == 0)
	{
		skills = basic_spec_duty(6);
		if (terms == 1)
			skills++;
		if (blue_blood == 1)
			skills++;
		skills += hiv_stsfctn(8, intl, 5);
		skills += basic_promo(6, edu, 5);
	}
	if (skills >= 0)
		hivtechyskills(skills);
	printf("This ends the term.\n");
	hivtechymot(1);
	return newterm;
}


void hivtechymot(int term)
{
	int  roll, amt;
	char choice;
  
	while (term > 0)
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c') 
		{
			roll = basic_cash();
			amt = 0;
			switch (roll)
			{
				case 1: amt = 1000; break;
		        case 2: amt = 2000; break;
				case 3: amt = 5000; break;
		        case 4: amt = 10000; break;
				case 5: amt = 10000; break;
		        case 6: amt = 20000; break;
				case 7: amt = 30000; break;
			}
			mot_cash(amt);
		}
		else
		{
			roll = basic_bene();
			switch (roll)
			{
				case 1: mot_lopsg(); break;
			    case 2: mot_midpsg(); break;
				case 3: mot_hipsg(); break;
			    case 4: mot_techtool(); break;
				case 5: mot_techtool(); break; /* for techy used for hand computer */
			    case 6: mot_tas(); break;
				case 7: mot_weapon(); break;
			}
		}
		term--;
	}
}


void hivtechyskills(int skills)
{
	int  table, roll;

	while (skills > 0)
	{
		table = picktable();
		roll = d6();
		if (table == 1)
		{
			if (roll == 4)
				roll = d6();
			switch (roll)
			{
				case 1: physicl(1); break;
				case 2: bumpdex(); break;
				case 3: econ(1); break;
				case 4: mc(1); break;
				case 5: influ(1); break;
				case 6: vhcl(1); break;
			}
		}
		if (table == 2)
			techy_tbl(roll);
	    if (table == 3)
		{
			switch (roll)
			{
				case 1: bumpintl(); break;
				case 2: techl(1); break;
				case 3: techl(1); break;
				case 4: addskill(COMPUTER, 1); break;
				case 5: interp(1); break;
				case 6: addskill(HANDYMAN, 1); break;
			}
		}
		if (table == 4)
		{
			switch (roll)
			{
				case 1: techl(1); break;
				case 2: addskill(RESEARCH, 1); break;
				case 3: techl(1); break;
				case 4: addskill(PERCEPTION, 1); break;
				case 5: sci(1); break;
				case 6: acad(1); break;
			}
		}
		skills--;
	}
}


void techy_tbl(int roll)
{
	if (roll < 1 || roll > 6)
		roll = d6();
	switch (roll)
	{
		case 1: addskill(MECHANICAL, 1); break;
	    case 2: techl(1); break;
		case 3: techl(1); break;
	    case 4: addskill(ELECTRONICS, 1); break;
		case 5: addskill(COMPUTER, 1); break;
	    case 6: addskill(HANDYMAN, 1); break;
	}
}