/* ITHDPLMT.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int ithdplmt();
void ithdplmtmot(int term);
void ithdplmtbene();
void ithdplmtskills(int skills);
void ithdplmt_tbl(int roll);

extern int ith_comm(int need_nbr, int skill1, int skill2, int skl_val);
extern int ith_promo(int need_nbr, int skill1, int skill2, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot(int term);
extern int basic_bene();
extern int d6();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpdex();
extern void bumpintl();
extern void bumpsoc();
extern void bumpedu();
extern void bumpend();
extern void physicl(int skl_val);
extern void mentl(int skl_val);
extern void spac(int skl_val);
extern void mc(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void econ(int skl_val);
extern void acad(int skl_val);
extern void inbrn(int skl_val);
extern void milmed(int skl_val);
extern void vc(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_weapon();
extern void mot_hipsg();
extern void mot_ship();

#include "chargen.h"

int ithdplmt()
{
	int     skills, newterm;
  
	newterm = 0;
	skills = basic_spec_duty(6);
	newterm = basic_surv(5, dex, 8);
	if (newterm == 0)
	{
		skills++;
		if (rankeo == 'E')
			skills += ith_comm(9, edu, intl, 13);
		else
			skills += ith_promo(11, edu, intl, 13);
	}
	if (skills != 0)
		ithdplmtskills(skills);
	ithdplmtmot(1);
	return newterm;
}


void ithdplmtmot(int term)
{

	int  cash, roll, amt;
	char choice;
  
	term = basic_mot(term);
	if (term < 3)
		cash = term;
	else
		cash = 3;
	while ((term > 0) && (cash > 0))
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c')
		{
			cash--;
			roll = basic_cash();
			term--;
			amt = 0;
			switch (roll)
			{
				case 1: amt = 10000; break;
				case 2: amt = 20000; break;
				case 3: amt = 30000; break;
				case 4: amt = 40000; break;
				case 5: amt = 40000; break;
				case 6: amt = 50000; break;
				case 7: amt = 50000; break;
			}
			mot_cash(amt);
		}
		else
		{
			ithdplmtbene();
			term--;
		}
	}
	while (term > 0)
	{
		ithdplmtbene();
		term--;
	}
}


void ithdplmtbene()
{
	int roll;

	roll = basic_bene();
	switch (roll)
	{
		case 1: mot_lopsg(); break;
		case 3: bumpedu(); break;
		case 2: bumpintl(); bumpintl(); break;
		case 4: mot_weapon(); break;
		case 5: mot_hipsg(); break;
		case 6: bumpsoc(); break;
		default: mot_ship(); break;
	}
}


void ithdplmtskills(int skills)
{
	int  table, roll;

	while (skills > 0)
	{
		table = picktable();
		roll = d6();
		if (table == 1)
		{
			switch (roll)
			{
				case 1: physicl(1); break;
				case 2: bumpdex(); break;
				case 3: bumpend(); break;
				case 4: vc(1); break;
				case 5: bumpsoc(); break;
				case 6: mentl(1); break;
			}
		}
		if (table == 2)
			ithdplmt_tbl(roll);
		if (table == 3)
		{
			switch (roll)
			{
				case 1: addskill(STREETWISE, 1); break;
				case 2: econ(1); break;
				case 3: addskill(LIAISON, 1); break;
				case 4: addskill(COMPUTER, 1); break;
				case 5: inbrn(1); break;
				case 6: mc(1); break;
			}
		}
		if (table == 4)
		{
			switch (roll)
			{
				case 1: acad(1); break;
				case 2: addskill(LIAISON, 1); break;
				case 3: spac(1); break;
				case 4: milmed(1); break;
				case 5: interp(1); break;
				case 6: bumpsoc(); break;
			}
		}
		skills--;
	}
}


void ithdplmt_tbl(int roll)
{
	if (roll < 1 || roll > 6)
		roll = d6();
	switch (roll)
	{
		case 1: vhcl(1); break;
		case 2: addskill(VACCSUIT, 1); break;
		case 3: mentl(1); break;
		case 4: vc(1); break;
		case 5: mc(1); break;
		case 6: vhcl(1); break;
	}
}

