/* ITHEXPLR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int ithexplorer();
void ithexplorermot(int term);
void ithexplorerbene();
void ithexplorerskills(int skills);
void ithexplorer_tbl(int roll);

extern int ith_comm(int need_nbr, int skill1, int skill2, int skl_val);
extern int ith_promo(int need_nbr, int skill1, int skill2, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int ith_success();
extern int basic_cash();
extern int basic_mot(int term);
extern int basic_bene();
extern int d6();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpdex();
extern void bumpintl();
extern void bumpsoc();
extern void bumpedu();
extern void bumpend();
extern void physicl(int skl_val);
extern void mentl(int skl_val);
extern void techl(int skl_val);
extern void explore(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void econ(int skl_val);
extern void spacetech(int skl_val);
extern void inbrn(int skl_val);
extern void special(int skl_val);
extern void milmed(int skl_val);
extern void vc(int skl_val);
extern void spac(int skl_val);
extern void gc(int skl_val);
extern void mc(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_weapon();
extern void mot_ship();

#include "chargen.h"

int ithexplorer()
{
	int     skills, newterm;
  
	newterm = 0;
	skills = basic_spec_duty(6);
	newterm = basic_surv(5, end, 8);
	if (newterm == 0)
	{
		skills++;
		if (rankeo == 'E')
			skills += ith_comm(10, end, intl, 13);
		else
			skills += ith_promo(12, end, intl, 13);
	}
	if (skills != 0)
		ithexplorerskills(skills);
	ithexplorermot(1);
	return newterm;
}


void ithexplorermot(int term)
{

	int  cash, roll, amt;
	char choice;
  
	term = basic_mot(term);
	if (term < 3)
		cash = term;
	else
		cash = 3;
	while ((term > 0) && (cash > 0))
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c')
		{
			cash--;
			roll = basic_cash();
			term--;
			amt = 0;
			switch (roll)
			{
				case 1: amt = 5000; break;
				case 2: amt = 10000; break;
				case 3: amt = 20000; break;
				case 4: amt = 30000; break;
				case 5: amt = 50000; break;
				case 6: amt = 70000; break;
				case 7: amt = 90000; break;
			}
			mot_cash(amt);
		}
		else
		{
			ithexplorerbene();
			term--;
		}
	}
	while (term > 0)
	{
		ithexplorerbene();
		term--;
	}
}


void ithexplorerbene()
{
	int roll;

	roll = basic_bene();
	switch (roll)
	{
		case 1: mot_lopsg(); break;
		case 3: bumpedu(); bumpedu(); break;
		case 2: bumpintl(); bumpintl(); break;
		case 4: mot_weapon(); break;
		case 5: mot_weapon(); break;
		default: mot_ship(); break;
	}
}


void ithexplorerskills(int skills)
{
	int  table, roll;

	while (skills > 0)
	{
		table = picktable();
		roll = d6();
		if (table == 1)
		{
			switch (roll)
			{
				case 1: physicl(1); break;
				case 2: bumpdex(); break;
				case 3: bumpend(); break;
				case 4: vc(1); break;
				case 5: gc(1); break;
				case 6: mentl(1); break;
			}
		}
		if (table == 2)
			ithexplorer_tbl(roll);
		if (table == 3)
		{
			switch (roll)
			{
				case 1: addskill(MECHANICAL, 1); break;
				case 2: vhcl(1); break;
				case 3: addskill(ELECTRONICS, 1); break;
				case 4: special(1); break;
				case 5: inbrn(1); break;
				case 6: mc(1); break;
			}
		}
		if (table == 4)
		{
			switch (roll)
			{
				case 1: explore(1); break;
				case 2: spacetech(1); break;
				case 3: spac(1); break;
				case 4: techl(1); break;
				case 5: interp(1); break;
				case 6: milmed(1); break;
			}
		}
		skills--;
	}
}


void ithexplorer_tbl(int roll)
{
	if (roll < 1 || roll > 6)
		roll = d6();
	switch (roll)
	{
		case 1:
			{
				if (race == TIRRILS)
					addskill(FLYING, 1);
				else
					addskill(GRAVVHCL, 1);
				break;
			}
		case 2: addskill(VACCSUIT, 1); break;
		case 3: spac(1); break;
		case 4: addskill(MECHANICAL, 1); break;
		case 5: addskill(ELECTRONICS, 1); break;
		case 6: inbrn(1); break;
	}
}
