/* ITHFLYER.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

int ithflyer();
void ithflyermot(int term);
void ithflyerbene();
void ithflyerskills(int skills);
void ithflyer_tbl(int roll);

extern int ith_comm(int need_nbr, int skill1, int skill2, int skl_val);
extern int ith_promo(int need_nbr, int skill1, int skill2, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void physicl(int skl_val);
extern void bumpsoc();
extern void bumpedu();
extern void bumpdex();
extern void bumpend();
extern void mentl(int skl_val);
extern void bc(int skl_val);
extern void hc(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void gc(int skl_val);
extern void spac(int skl_val);
extern void airc(int skl_val);
extern void inbrn(int skl_val);
extern void techl(int skl_val);
extern void vc(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_hipsg();

#include "chargen.h"

int ithflyer()
{
	int  skills, newterm;
  
	newterm = 0;
	skills = basic_spec_duty(6);
	newterm = basic_surv(5, dex, 8);
	if (newterm == 0)
	{
		skills++;
		if (rankeo == 'E')
			skills += ith_comm(10, intl, soc, 13);
		else
			skills += ith_promo(12, intl, soc, 13);
	}
	if (skills != 0)
		ithflyerskills(skills);
	ithflyermot(1);
	return newterm;
}


void ithflyermot(int term)
{
	int  cash, roll, amt;
	char choice;
  
	cash = basic_mot();
	while ((term > 0) && (cash > 0))
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c')
		{
			roll = basic_cash();
			cash--;
			term--;
			amt = 0;
			switch (roll)
			{
				case 1: amt = 2000; break;
				case 2: amt = 5000; break;
				case 3: amt = 10000; break;
				case 4: amt = 10000; break;
				case 5: amt = 10000; break;
				case 6: amt = 20000; break;
				case 7: amt = 30000; break;
			}
			mot_cash(amt);
		}
		else
		{
			term--;
			ithflyerbene();
		}
	}
	while (term > 0)
	{
		ithflyerbene();
		term--;
	}
}


void ithflyerbene()
{
	int roll;

	roll = basic_bene();
	switch (roll)
	{
		case 1: mot_lopsg(); break;
		case 2: bumpedu(); break;
		case 3: mot_weapon(); break;
		case 4: mot_weapon(); break;
		case 5: mot_midpsg(); break;
		case 6: mot_hipsg(); break;
		case 7: bumpsoc(); break;
	}
}


void ithflyerskills(int skills)
{
	int  table, roll;

	while (skills > 0)
	{
		table = picktable();
		roll = d6();
		if (table == 1)
		{
			switch (roll)
			{
				case 1: physicl(1); break;
				case 2: bumpdex(); break;
				case 3: bumpend(); break;
				case 4: vc(1); break;
				case 5: addskill(BRAWLING, 1); break;
				case 6: inbrn(1); break;
			}
		}
		if (table == 2)
			ithflyer_tbl(roll);
		if (table == 3)
		{
			switch (roll)
			{
				case 1: airc(1); break;
				case 2: addskill(MECHANICAL, 1); break;
				case 3: addskill(ELECTRONICS, 1); break;
				case 4: addskill(GRAVITICS, 1); break;
				case 5: addskill(SURVIVAL, 1); break;
				case 6: gc(1); break;
			}
		}
		if (table == 4)
		{
			switch (roll)
			{
				case 1: addskill(MEDICAL, 1); break;
				case 2: inbrn(1); break;
				case 3: spac(1); break;
				case 4: techl(1); break;
				case 5: interp(1); break;
				case 6: inbrn(1); break;
			}
		}
		skills--;
	}
}


void ithflyer_tbl(int roll)
{
	if (roll < 1 || roll > 6)
		roll = d6();
	switch (roll)
	{
		case 1: hc(1); break;
		case 2: addskill(VACCSUIT, 1); break;
		case 3: gc(1); break;
		case 4: airc(1); break;
		case 5: vhcl(1); break;
		case 6: vhcl(1); break;
	}
}
