/* ITHMERC.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void itharmy_init();
void itharmy_get_branch();
int itharmy_set_branch();
int itharmy_pickbranch();
void ithmerc_do_initial();
int ithmerc_doterms();
int ithmerc_do_year();
int ithmerc_xfer();
int ithmerc_off_xfer();
void ithmerc_branch_tbl(int brnch);
void ithmerc_cmd_off();
void merc_life();
void itharmy_life();
void merc_inf();
void ithmerc_arty();
void ithmerc_sup();
void ithmerc_gen_skl();
void ithmerc_life();
void ithmerc_pick_tbl();
int inf_mos();
void ithmerc_cross_train();

extern void merc_branch(int branch_nbr);
extern void armymot(int term);
extern void marinemot(int term);
extern void armybene();
extern void merc_spcl_asgn();
extern int merc_pick_sch();
extern void merc_attache();
extern void merc_staff_off();
extern void merc_spcl_sch();
extern void merc_prot_frcs();
extern void merc_intl_sch();
extern int merc_asgn();
extern int merc_mos();
extern int art_mos();
extern int army_cmd();
extern int nv_adj();
extern int mar_cmd();
extern int anag();
extern int getrank();
extern int survive(int adjust, int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d3();
extern int d4();
extern int d2();
extern int d6();
extern int d8();
extern int d12();
extern int getsel_int(int min, int max);
extern char getche_y_n();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern int bp_skill(int roll);
extern int reenlist(int need_nbr);
extern void decorate(int adjust);
extern void mar_life();
extern void mar_shiptroop();
extern void merc_cmd_col();
extern void merc_staff_col();
extern void mar_shipboard();
extern void bumpdex();
extern void bumpstr();
extern void bumpend();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void bc(int skl_val);
extern void spac(int skl_val);
extern void acad(int skl_val);
extern void techl(int skl_val);
extern void fag(int skl_val);
extern void gc(int skl_val);
extern void env(int skl_val);
extern void vc(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void inbrn(int skl_val);
extern int ith_comm(int need_nbr, int skill1, int skill2, int skl_val);
extern int ith_promo(int need_nbr, int skill1, int skill2, int skl_val);

#include "chargen.h"

extern int  merc_cross[8];

extern int  aide, nv_anag;

void itharmy_init()
{
	int i;

	for (i = 1; i <= 7; i++)
	{
		merc_cross[i] = 0;
	}
	aide = 0;
	itharmy_get_branch();
	ithmerc_do_initial();
}


void itharmy_get_branch()
{
	if (branch == 0)
		if (pick != 4)
			branch = itharmy_pickbranch();
		else
			branch = itharmy_set_branch();
	merc_cross[branch]++;
	merc_branch(branch);
	printf("You were assigned to the %s branch.\n", office);
}


int itharmy_set_branch()
{
	int roll;

	if ((blue_blood % 10) == 1)
		return 6; // facilitators get support branch
	roll = d3();  // must be a guardian
	if (roll <= 2)
		return 1; // prefer infantry
	else
		return 4; // otherwise artillery
}


int itharmy_pickbranch()
{
	int choice, max;
  
	if ((blue_blood % 10) == 1)
		return 6; // facilitators get support branch
	printf("You have the option to choose the branch you wish to serve in\n"); 
	printf("within Ground Support.\n");
	printf("\n   1. pick one at random\n   2. infantry\n   3. artillery\n");
	max = 3;
	choice = getsel_int(1, max);
	if (choice == 1)
		return itharmy_set_branch();
	if (choice == 2)
		return 1;
	return 4;
}


void ithmerc_do_initial()
{
	ithmerc_branch_tbl(branch);
	gc(1);
	age++;
	nv_anag = anag();
	if (nv_anag == 0)
		appearent_age++;
}


extern int nv_promo, assignment, command, combat;

int ithmerc_doterms()
{
	int survival, skills;

	command = combat = assignment = 0;
	if (terms > 1)
	{
		nv_anag = anag();
		branch = ithmerc_xfer();
	}
	do
	{
		survival = ithmerc_do_year();
	} while (((age % 4) != 2) && (survival == 0));
	if (survival != 0)
		return 1;
	skills = 0;
	if (branch == 6)
	{
		if (rankeo == 'E')
			skills += ith_comm(10, intl, soc, 13);
		else
			skills += ith_promo(12, intl, soc, 13);
	}
	else
	{
		if (rankeo == 'E')
			skills += ith_comm(11, str, soc, 14);
		else
			skills += ith_promo(13, str, soc, 14);
	}
	if (skills > 0)
		do
		{
			ithmerc_gen_skl();
			skills--;
		} while (skills > 0);
	drafted = 0;
	if (nv_anag == 0)
		if (careernbr == ARMY)
			armymot(1);
		else
			marinemot(1);
	return 0;
}


int ithmerc_do_year()
{
	int   roll, adjust;
  
	age++;
	if (nv_anag == 0)
		appearent_age++;
	if (careernbr == ARMY)
		command = army_cmd();
	else
		command = mar_cmd();
	assignment = merc_asgn();
	if (combat != 0 && command != 0)
		cmd++;
	adjust = nv_adj();
	decorate(adjust);
	if (assignment == 8)
		merc_spcl_asgn();
	if (skil != 0)
	{
		roll = d12();
		if (roll < skil)
			roll = bp_skill(roll);
		if (roll >= (skil + 4))
			ithmerc_gen_skl();
		if (roll >= skil)
			ithmerc_gen_skl();
	}
	roll = d12();
	if (rankeo == 'E')
		roll += 2;
	return survive(roll, 0);
}


int ithmerc_xfer()
{
	char choice;
	int  i, roll;

	if ((blue_blood % 10) == 1)
		return branch;
	if (pick == 4)
	{
		roll = d4();
		if (roll >= 3)
			roll = 4;
		else
			roll = 1;
		if (merc_cross[roll] == 0 && rankeo == 'E')
		{
			merc_branch(branch);
			printf("You are in the %s branch.\n", office);
			return branch;
		}
		else
		{
			roll = itharmy_set_branch();
			merc_branch(roll);
			printf("You are in the %s branch.\n", office);
			return roll;
		}
	}
	if (rankeo == 'E')
	{
		for (i = 1; i <= 4; i++)
		{
			if (merc_cross[i] != 0 && branch != i)
			{
				merc_branch(i);
				printf("You have the option to transfer to the %s branch.\nDo you want to?", office); 
    			choice = getche_y_n();
				if (choice == 'Y' || choice == 'y')
					return i;
			}
		}
	}
	else
		branch = ithmerc_off_xfer();
	return branch;
}


int ithmerc_off_xfer()
{
	int choice, max;

	if ((blue_blood % 10) == 1)
		return branch;
	printf("You have the option to transfer to another branch. Pick one.\n\n");
	printf("   1. infantry\n   2. artillery\n");
	max = 2;
	choice = getsel_int(1, max);
	if (choice == 1)
		return 1;
	if (choice == 3)
		return 4;
	printf("Wrong - try again!\n");
	return ithmerc_off_xfer();
}


void ithmerc_branch_tbl(int branch_nbr)
{
	switch (branch_nbr)
	{
	case 1: merc_inf(); break;
	case 4: ithmerc_arty(); break;
	case 6: ithmerc_sup(); break;
	}
}


void ithmerc_cmd_off()
{
	int  roll;

	roll = d6();
	if (rank >= 4)
		roll++;
	if (rank >= 7)
		roll++;
	switch (roll)
	{
	case 1: bumpend(); break;
	case 2: gc(1); break;
	case 3: addskill(HEAVYWEAP, 1); break;
	case 4: vhcl(1); break;
	case 5: addskill(TACTICS, 1); break;
	case 6: addskill(LEADER, 1); break;
	case 7: addskill(TACTICS, 1); break;
	case 8: inbrn(1); break;
	}
}


void itharmy_life()
{
	int  roll;

	roll = d6();
	if (rankeo == 'O')
		roll++;
	if (rankeo == 'O' && rank >= 4)
		roll++;
	if (rankeo == 'O' && rank >= 7)
		roll++;
	switch (roll)
	{
		case 1: addskill(BRAWLING, 1); break;
		case 2: bumpstr(); break;
		case 3: vc(1); break;
		case 4: bumpdex(); break;
		case 5: bumpend(); break;
		case 6: bumpend(); break;
		case 7: addskill(HANDGUN, 1); break;
		default: bumpsoc(); break;
	}
}


void merc_inf()
{
	int  roll;

	roll = d6();
	if (tech >= TLAVGSTEL)
		roll++;
	switch (roll)
	{
		case 1: gc(1); break;
		case 2: gc(1); break;
		case 3: addskill(HEAVYWEAP, 1); break;
		case 4: addskill(HEAVYWEAP, 1); break;
		case 5: vhcl(1); break;
		case 6: env(1); break;
		case 7: addskill(VACCSUIT, 1); break;
	}
}


void ithmerc_arty()
{
	int  roll;

	roll = d6();
	if (tech >= TLAVGSTEL)
		roll++;
	switch (roll)
	{
		case 1: fag(1); break;
		case 2: fag(1); break;
		case 3: vhcl(1); break;
		case 4: addskill(MECHANICAL, 1); break;
		case 5: addskill(FORWARDOBS, 1); break;
		case 6: addskill(COMPUTER, 1); break;
		case 7: techl(1); break;
	}
}


void ithmerc_staff_off()
{
	int  roll;

	roll = d6();
	if (rankeo == 'O' && rank >= 4)
		roll++;
	if (rankeo == 'O' && rank >= 7)
		roll++;
	switch (roll)
	{
		case 1: addskill(MECHANICAL, 1); break;
		case 2: addskill(FORWARDOBS, 1); break;
		case 3: addskill(COMPUTER, 1); break;
		case 4: addskill(ELECTRONICS, 1); break;
		case 5: addskill(MEDICAL, 1); break;
		case 6: addskill(INSTRUCTION, 1); break;
		case 7: addskill(ADMIN, 1); break;
		case 8: acad(1); break;
	}
}


void ithmerc_sup()
{
	int  roll;

	roll = d6();
	if (tech >= TLAVGSTEL)
		roll++;
	switch (roll)
	{
		case 1: vhcl(1); break;
		case 2: addskill(CMBTENGR, 1); break;
		case 3: addskill(ELECTRONICS, 1); break;
		case 4: addskill(MECHANICAL, 1); break;
		case 5: addskill(MEDICAL, 1); break;
		case 6: vhcl(1); break;
		case 7: techl(1); break;
	}
}


void ithmerc_gen_skl()
{
	int roll;

	if (pick <= 2)
	{
		ithmerc_pick_tbl();
		return;
	}
	if (assignment != 7)
	{
		if (rankeo == 'O' || rank >= 3)
		{
			roll = d4();
			if (roll == 4)
				roll = 2;
		}
		else
		{
			roll = d3();
			if (roll == 3)
				roll = 2;
		}
	}
	else
	{
		if (rankeo == 'O' || rank >= 3)
		{
			roll = d8();
			if (roll == 6)
				roll = 5;
			if (roll > 6)
				roll = 2;
		}
		else
		{
			roll = d6();
			if (roll == 3)
				roll = 2;
			if (roll == 6)
				roll = 5;
		}
	}
	if (roll == 1)
		merc_life();
	if (roll == 2)
		ithmerc_branch_tbl(branch);
	if (roll == 3)
	{
		if (command == 1)
			ithmerc_cmd_off();
		else
			merc_staff_off();
	}
	if (roll == 4)
		mar_shipboard();
	if (roll == 5)
		mar_shiptroop();
}


void merc_life()
{
	if (careernbr == ARMY)
		itharmy_life();
	else
		mar_life();
}


void ithmerc_pick_tbl()
{
	int choice, max;

	max = 2;
	printf("\nPlease select the table you wish to use for your new skill.\n");
	if (careernbr == ARMY)
		printf("\n   1. Ground Support life\n");   
	if (careernbr == MARINE)
		printf("\n   1. Strike Force life\n");  
	merc_branch(branch);
	printf("   2. The table for %s\n", office); 
	if (rankeo == 'O')
	{
		if (command == 1)
			printf("   3. Command Officer\n");
		else
			printf("   3. Staff Officer\n");
		max = 3;
	}
	if (assignment == 7)
	{
		printf("   4. shipboard\n   5. ships troops\n");
		max = 5;
	}
	choice = getsel_int(1, max);
	if ((rankeo == 'E' && choice == 3)
		|| (assignment != 7 && (choice == 5 || choice == 4)))
	{
		printf("Wrong - try again!\n");
		ithmerc_pick_tbl();
		return;
	}
	switch (choice)
	{
	case 1: merc_life(); break;
	case 2: ithmerc_branch_tbl(branch); break;
	case 3: 
	{
		if (command == 1)
			ithmerc_cmd_off();
		else
			merc_staff_off();
		break;
	}
	case 4: mar_shipboard(); break;
	case 5: mar_shiptroop(); break;
	}
}


int inf_mos()
{
	int qual;

	qual = chk_skl(HEAVYWEAP, 2);
	if (qual == 0)
		qual = chk_skl(VACCSUIT, 2);
	if (qual == 0)
		qual = chk_skl(GUNCMBT, 2);
	if (qual == 0)
		qual = chk_skl(VEHICLE, 2);
	if (qual == 0)
		qual = chk_skl(ENVIRON, 2);
	if (qual != 0)
		return 1;
	return 0;
}


void ithmerc_cross_train()
{
	int  i, roll;

	printf("You got cross-training.\n");
	if (pick >= 3 || (blue_blood % 10) == 1)
	{
		roll = d2();
		if ((blue_blood % 10) == 1)
			roll = 6;
		merc_cross[roll]++;
		ithmerc_branch_tbl(roll);
		return;
	}
	printf("You have the option to get cross-training in any field. Pick one.\n");
	printf("\n   1. infantry");
	if (merc_cross[1] > 0)
		printf("*");
	printf("\n   2. artillery");
	if (merc_cross[4] > 0)
		printf("*");
	printf("\n\n* = already cross-trained in this branch\n");
	roll = getsel_int(1, 2);
	i = 0;
	if (roll == 2)
		i = 4;
	if (roll == 1)
		i = 1;
	if (i == 0)
	{
		printf("Wrong - try again!\n");
		ithmerc_cross_train();
		return;
	}
	ithmerc_branch_tbl(i);
	merc_cross[i]++;
}