/* ITHNAVY.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include "conio.h"
#include <string.h>

void ithnavy_init();
void nv_get_branch();
int nv_set_branch();
int nv_pickbranch();
void nv_do_initial();
int nv_doterms();
int nv_xfer();
int nv_do_year();
int nv_mos();
int ln_mos();
int gun_mos();
void navymot(int term);
void navybene();
void nv_petty_off();
void nv_cmd_off();
void nv_life();
void nv_line();
void nv_flt();
void nv_gun();
void nv_staff_off();
void nv_engr();
void nv_med();
void nv_tech();
void nv_duty();
void nv_ship_duty();
void nv_shore_duty();
void nv_spcl_asgn();
int nv_pick_sch();
void nv_attache();
void nv_ocs();
void nv_gen_skl();
void nv_pick_tbl();
int nv_asgn();
void nv_off_init();
void nv_cross_train();
void nv_branch(int branch_nbr);
void nv_branch_tbl(int brnch);

extern int nv_adj();
extern int nv_cmd();
extern int anag();
extern int getrank();
extern int survive(int adjust, int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d4();
extern int d6();
extern int d12();
extern int getsel_int(int min, int max);
extern char getche_y_n();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern int bp_skill(int roll);
extern int reenlist(int need_nbr);
extern void decorate(int adjust);
extern void nv_spcl_sch();
extern void nv_intl_sch();
extern void nv_gun_sch();
extern void nv_engr_sch();
extern void nv_cmd_col();
extern void nv_staff_col();
extern void merc_life();
extern void ithmerc_cmd_off();
extern void ithmerc_staff_off();
extern void merc_nco();
extern void merc_spcl_asgn();
extern void mar_shipboard();
extern void bumpdex();
extern void bumpstr();
extern void bumpend();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void gunner(int skl_val);
extern void special(int skl_val);
extern void bc(int skl_val);
extern void spac(int skl_val);
extern void acad(int skl_val);
extern void techl(int skl_val);
extern void spacetech(int skl_val);
extern void gc(int skl_val);
extern void acad(int skl_val);
extern void vc(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void inbrn(int skl_val);
extern void env(int skl_val);
extern void hc(int skl_val);
extern void bp_add(int amt);
extern int ith_comm(int need_nbr, int skill1, int skill2, int skl_val);
extern int ith_promo(int need_nbr, int skill1, int skill2, int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_weapon();
extern void mot_hipsg();
extern void mot_tas();

#include "chargen.h"

extern int  aide, nv_anag, nv_cross[10];

void ithnavy_init()
{
	int i;

	for (i = 1; i <= 7; i++)
	{
		nv_cross[i] = 0;
	}
	aide = 0;
	nv_get_branch();
	nv_do_initial();
	nv_cross[branch]++;
	while (nv_doterms() == 0);
	terms = terms - anagathics;
	navymot(terms);
}


void nv_get_branch()
{
	if (branch == 0)
		if (soc >= 9)
			branch = nv_pickbranch();
		else
			branch = nv_set_branch();
	nv_branch(branch);
	printf("You were assigned to the %s branch.\n", office);
}


int nv_set_branch()
{
	int roll;

	if (med_sch > 0)
		return 5;
	if (tech_sch > 0)
		return 4;
	if (flt_sch > 0)
		return 2;
	roll = d6();
	if (edu >= 9)
		roll += 2;
	if (intl >= 10)
		roll += 2;
	if (line == 1)
		roll -= 2;
	if (roll <= 0)
		return 6;
	if (roll <= 2)
		return 1;
	if (rankeo == 'E')
	{
		if (roll <= 4)
			return 4;
		if (roll <= 6)
			return 3;
	}
	else
	{
		if (roll <= 3)
			return 4;
		if (roll <= 4)
			return 3;
		if (roll <= 5)
			return 1;
		if (roll <= 6)
			return 2;
	}
	return 5;
}


int nv_pickbranch()
{
	int choice, max;

	if (pick == 4)
		return nv_set_branch();
	printf("Due to your high social status you have the option to choose\n");
	printf("the branch you with to serve in within the Navy.\n");
	printf("\n   1. pick one at random\n   2. line/crew\n");
	printf("   3. flight\n   4. gunnery\n   5. engineering\n");
	printf("   6. medical\n");  
	printf("   7. technical\n");
	max = 7;
	choice = getsel_int(1, max);
	if (choice == 1)
		return nv_set_branch();
	choice--;
	return choice;
}


void nv_do_initial()
{
	if (rankeo == 'E')
	{
	    nv_branch_tbl(branch);
	    nv_branch_tbl(branch);
	}
	else
	{
	    nv_off_init();    
		nv_off_init();
	}
	nv_cross[branch]++;
	age++;
	nv_anag = anag();
	if (nv_anag == 0)
		appearent_age++;
}


extern int nv_promo, assignment, command, combat;

int nv_doterms()
{
	int survival, skills;
  
	command = combat = assignment = skills = 0;
	if (terms > 1)
	{
		nv_anag = anag();
		branch = nv_xfer();
	}
	do {
		survival = nv_do_year();
	} while (((age % 4) != 2) && (survival == 0));
	if (survival != 0)
		return 1;
	if (rankeo == 'E')
		skills += ith_comm(10, intl, soc, 13);
	else
		skills += ith_promo(12, intl, soc, 13);
	if (skills > 0)
		do
		{
			nv_gen_skl();
			skills--;
		} while (skills > 0);
	drafted = 0;
	if (nv_anag == 0)
		navymot(1);
	return 0;
}


int nv_xfer()
{
	char choice;
	int  i, roll;

	if (pick == 4) 
	{
		roll = d6();
		if (nv_cross[roll] == 0)
		{
			nv_branch(branch);
			printf("You are in the %s branch.\n", office);
			return branch;
		}
		else
		{
			nv_branch(roll);
			printf("You are in the %s branch.\n", office);
			return roll;
		}
	}
	for (i = 1; i <= 7; i++)
	{
		if (nv_cross[i] != 0 && branch != i)
		{
			nv_branch(i);
			printf("You have the option to transfer to the %s branch.\n", office); 
			printf("Do you want to?");
			choice = getche_y_n();
			if (choice == 'Y' || choice == 'y')
				return i;
		}
	}
	return branch;
}


int nv_do_year()
{
	int   adjust, roll;
  
	age++;
	if (nv_anag == 0)
		appearent_age++;
	command = nv_cmd();
	assignment = nv_asgn();
	if (combat != 0 && command != 0)
		cmd++;
	if ((rank < 9 && rankeo == 'E') 
		|| ((rankeo == 'O') && ((line == 1 && rank < 10)
		|| (line == 2 && rank < 8) || (line == 3 && rank < 7))))
	{
		if ((rankeo != 'O' || nv_promo == 0) && promo != 0)
		{
			roll = d12();
			if ((branch == 1 && edu >= 7) || (branch >= 4 && intl >= 8)
				|| (branch == 2 && intl >= 8) || (branch == 3 && end >= 8))
				roll++;
			if (roll >= promo)
			{
				nv_promo++;
				rank++;
				printf("You were promoted. ");
				getrank();
				nv_gen_skl();
			}
		}
	}
	adjust = nv_adj();
	decorate(adjust);
	if (assignment == 7)
		nv_spcl_asgn();
	if (skil != 0)
	{
		roll = d12();
		if (roll < skil)
			roll = bp_skill(roll);
		if (roll >= (skil + 4))
		{
			if (spec_skill != 0)
			{
				printf("Increasing your specialty skill. ");
				addskill(spec_skill, 1);
			}
			else
			{
				nv_gen_skl();
				nv_gen_skl();
			}
		}
		else
		{
			if (roll >= skil)
				nv_gen_skl();
		}
	}
	roll = d12();
	if ((branch == 3 || branch == 1) && (nv_mos() != 0))
		roll++;
	return survive(roll, adjust);
}


int nv_mos()
{
	if (branch == 1)
		return ln_mos();
	else
		return gun_mos();
}


int ln_mos()
{
	int qual;

	qual = chk_skl(ELECTRONICS, 2);
	if (qual == 0)
		qual = chk_skl(COMPUTER, 2);
	if (qual == 0)
		qual = chk_skl(MECHANICAL, 2);
	if (qual == 0)
		qual = chk_skl(GUNCMBT, 2);
	if (qual == 0)
		qual = chk_skl(NAVIGATION, 2);
	if (qual == 0)
		qual = chk_skl(INTERPERS, 2);
	if (qual == 0)
		qual = chk_skl(NOGRAV, 2);
	if (qual == 0)
		qual = chk_skl(VACCSUIT, 2);
	if (qual != 0)
		return 1;
	return 0;
}


int gun_mos()
{
	int qual;

	qual = chk_skl(GUNNERY, 2);
	if (qual == 0)
		qual = chk_skl(COMPUTER, 2);
	if (qual == 0)
		qual = chk_skl(SENSOROPS, 2);
	if (qual == 0)
		qual = chk_skl(GUNCMBT, 2);
	if (qual == 0)
		qual = chk_skl(FORWARDOBS, 2);
	if (qual == 0)
		qual = chk_skl(SPCLCMBT, 2);
	if (qual == 0)
		qual = chk_skl(COMMO, 2);
	if (qual != 0)
		return 1;
	return 0;
}


void navymot(int term)
{
	int  cash, roll, amt;
	char choice;
  
	cash = basic_mot();
	while ((term > 0) && (cash > 0))
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c')
		{
			cash--;
			roll = basic_cash();
			term--;
			amt = 0;
			switch (roll)
			{
			case 1: amt = 1000; break;
			case 2: amt = 5000; break;
			case 3: amt = 5000; break;
			case 4: amt = 10000; break;
			case 5: amt = 20000; break;
			case 6: amt = 50000; break;
			case 7: amt = 50000; break;
			}
			mot_cash(amt);
		}
		else
		{
			term--;
			navybene();
		}
	}
	while (term > 0)
	{
		navybene();
		term--;
	}
}


void navybene()
{
	int roll;

	roll = basic_bene();
	switch (roll)
	{
	case 1: mot_lopsg(); break;
	case 2: bumpedu(); break;
	case 3: bumpintl(); bumpintl(); break;
	case 4: mot_weapon(); break;
	case 5: mot_hipsg(); break;
	case 6: mot_tas(); break;
	case 7: bumpsoc(); bumpsoc(); break;
	}
}


void nv_petty_off()
{
	int  roll;

	roll = d6();
	if (rank >= 5)
		roll += 2;
	if (rank >= 7)
		roll += 2;
	switch (roll)
	{
	case 1: addskill(VACCSUIT, 1); break;
	case 2: bc(1); break;
	case 3: gc(1); break;
	case 4: addskill(MECHANICAL, 1); break;
	case 5: addskill(MEDICAL, 1); break;
	case 6: vhcl(1); break;
	case 7: addskill(NOGRAV, 1); break;
	case 8: bumpedu(); break;
	case 9: addskill(INSTRUCTION, 1); break;
	case 10: interp(1); break;
	}
}


void nv_cmd_off()
{
	int  roll;

	roll = d6();
	if (rank >= 4)
		roll += 2;
	if (rank >= 7)
		roll += 2;
	switch (roll)
	{
	case 1: vhcl(1); break;
	case 2: bumpend(); break;
	case 3: addskill(SHIPBOAT, 1); break;
	case 4: gc(1); break;
	case 5: addskill(PILOT, 1); break;
	case 6: addskill(LEADER, 1); break;
	case 7: addskill(LEADER, 1); break;
	case 8: bumpsoc(); break;
	case 9: inbrn(1); break;
	case 10: addskill(SHIPTAC, 1); break;
	}
}


void nv_life()
{
	int  roll;

	roll = d6();
	if (rankeo == 'O')
		roll += 4;
	switch (roll)
	{
		case 1: bumpstr(); break;
		case 2: bumpedu(); break;
		case 3: addskill(CAROUSING, 1); break;
		case 4: addskill(BRAWLING, 1); break;
		case 5: bumpend(); break;
		case 6: bumpdex(); break;
		case 7: bumpend(); break;
		case 8: bumpedu(); break;
		case 9: inbrn(1); break;
		case 10: addskill(VACCSUIT, 1); break;
	}
}


void nv_line()
{
	int  roll;

	roll = d6();
	if (line == 1)
		roll += 2;
	if (line == 2)
		roll++;
	switch (roll)
	{
		case 1: addskill(MECHANICAL, 1); break;
		case 2: addskill(ELECTRONICS, 1); break;
		case 3: gc(1); break;
		case 4: addskill(NAVIGATION, 1); break;
		case 5: addskill(COMPUTER, 1); break;
		case 6: interp(1); break;
		case 7: addskill(NOGRAV, 1); break;
		case 8: addskill(VACCSUIT, 1); break;
	}
}


void nv_flt()
{
	int  roll;

	roll = d6();
	if (line == 1)
		roll += 2;
	if (line == 2)
		roll++;
	switch (roll)
	{
		case 1: addskill(VACCSUIT, 1); break;
		case 2: addskill(ADMIN, 1); break;
		case 3: gc(1); break;
		case 4: addskill(SHIPBOAT, 1); break;
		case 5: addskill(COMMO, 1); break;
		case 6: spac(1); break;
		case 7: addskill(PILOT, 1); break;
		case 8: addskill(PILOT, 1); break;
	}
}


void nv_gun()
{
	int  roll;

	roll = d6();
	if (line == 1)
		roll += 2;
	if (line == 2)
		roll++;
	switch (roll)
	{
		case 1: addskill(FORWARDOBS, 1); break;
		case 2: gc(1); break;
		case 3: addskill(COMMO, 1); break;
		case 4: addskill(COMPUTER, 1); break;
		case 5: addskill(SENSOROPS, 1); break;
		case 6: special(1); break;
		case 7: gunner(1); break;
		case 8: gunner(1); break;
	}
}


void nv_staff_off()
{
	int  roll;

	roll = d6();
	if (rank >= 4) roll += 4;
	switch (roll)
	{
		case 1: addskill(COMPUTER, 1); break;
		case 2: addskill(ELECTRONICS, 1); break;
		case 3: gc(1); break;
		case 4: addskill(SHIPTAC, 1); break;
		case 5: addskill(BRIBERY, 1); break;
		case 6: acad(1); break;
		case 7: addskill(SHIPTAC, 1); break;
		case 8: addskill(FLEETTAC, 1); break;
		case 9: addskill(FLEETTAC, 1); break;
		case 10: bumpintl(); break;
	}
}


void nv_engr()
{
	int  roll;

	roll = d6();
	if (line == 1)
		roll += 2;
	if (line == 2)
		roll++;
	switch (roll)
	{
		case 1: addskill(MECHANICAL, 1); break;
		case 2: addskill(ELECTRONICS, 1); break;
		case 3: addskill(ENGINEERING, 1); break;
		case 4: addskill(MECHANICAL, 1); break;
		case 5: addskill(VACCSUIT, 1); break;
		case 6: spacetech(1); break;
		case 7: addskill(ENGINEERING, 1); break;
		case 8: addskill(ENGINEERING, 1); break;
	}
}


void nv_med()
{
	int  roll;

	roll = d6();
	if (line == 1)
		roll += 2;
	if (line == 2)
		roll++;
	switch (roll)
	{
		case 1: addskill(ADMIN, 1); break;
		case 2: techl(1); break;
		case 3: addskill(ELECTRONICS, 1); break;
		case 4: addskill(ADMIN, 1); break;
		case 5: addskill(MEDICAL, 1); break;
		case 6: addskill(COMPUTER, 1); break;
		case 7: addskill(MEDICAL, 1); break;
		case 8: addskill(MEDICAL, 1); break;
	}
}


void nv_tech()
{
	int  roll;

	roll = d6();
	if (line == 1)
		roll += 2;
	if (line == 2)
		roll++;
	switch (roll)
	{
		case 1: addskill(MECHANICAL, 1); break;
		case 2: addskill(MECHANICAL, 1); break;
		case 3: addskill(ELECTRONICS, 1); break;
		case 4: addskill(ELECTRONICS, 1); break;
		case 5: addskill(COMPUTER, 1); break;
		case 6: addskill(COMPUTER, 1); break;
		case 7: addskill(GRAVITICS, 1); break;
		case 8: techl(1); break;
	}
}


void nv_duty()
{
	if (assignment <= 2 || careernbr == ARMY)
		nv_shore_duty();
	else
		if (careernbr == NAVY)
			nv_ship_duty();
		else
			mar_shipboard();

}


void nv_shore_duty()
{
	int  roll;

	roll = d6();
	if (rankeo == 'O' && rank >= 4)
		roll++;
	if (rankeo == 'O' && rank >= 7)
		roll += 3;
	switch (roll)
	{
		case 1: vc(1); break;
		case 2: vhcl(1); break;
		case 3: addskill(FORWARDOBS, 1); break;
		case 4: addskill(VACCSUIT, 1); break;
		case 5: addskill(LIAISON, 1); break;
		case 6: addskill(VACCSUIT, 1); break;
		case 7: addskill(FORWARDOBS, 1); break;
		case 8: env(1); break;
		case 9: addskill(VACCSUIT, 1); break;
		case 10: addskill(BATTLEDRESS, 1); break;
	}
}


void nv_ship_duty()
{
	int  roll;

	roll = d6();
	if (rankeo == 'O')
		roll += 4;
	switch (roll)
	{
		case 1: bumpdex(); break;
		case 2: addskill(GAMBLING, 1); break;
		case 3: addskill(MECHANICAL, 1); break;
		case 4: hc(1); break;
		case 5: addskill(SHIPBOAT, 1); break;
		case 6: addskill(VACCSUIT, 1); break;
		case 7: addskill(NOGRAV, 1); break;
		case 8: addskill(COMMO, 1); break;
		case 9: inbrn(1); break;
		case 10: addskill(ADMIN, 1); break;
	}
}


void nv_spcl_asgn()
{
	int roll;
  
	if (careernbr != NAVY)
	{
		merc_spcl_asgn();
		return;
	}
	if (aide != 0)
	{
		aide = 0;
		roll = nv_pick_sch();
	}
	else
		roll = d6();
	if (age >= 38) 
		roll--;
	else
		if (edu >= 8)
			roll++;
	if (roll <= 1)
		nv_cross_train();
	if (roll == 2)
	{
		if (rankeo == 'E') 
			nv_spcl_sch();
		else
			nv_intl_sch();
	}
	if (roll == 3)
		addskill(RECRUITING, 1);
	if (rankeo == 'E')
	{
		if (roll == 4)
			nv_gun_sch();
		if (roll == 5)
			nv_engr_sch();
		if (roll >= 6)
			nv_ocs();
	}
	else
	{
		if (roll == 4)
			nv_attache();
		if (roll == 5)
			nv_cmd_col();
		if (roll >= 6)
			nv_staff_col();
	}
}


int nv_pick_sch()
{
	int choice;

	printf("As an Admirals Aide you can pick your next assignment.\n\n");
	printf("   1. cross-training\n   2. intelligence school\n");
	printf("   3. recruiting\n   4. command college\n   5. staff college\n");
	choice = getsel_int(1, 5);
	if (choice == 1)
		return 1;
	if (choice == 2)
		return 2;
	if (choice == 3)
		return 3;
	if (choice == 4)
		return 5;
	return 6;
}


void nv_attache()
{
	int roll;

	bumpsoc();
	if ((rank >= 10) || (line == 2 && rank >= 8) || (line == 3 && rank >= 7)) 
		printf("You were not eligible for a promotion ");
	else
	{
		rank++;
		nv_promo++;
		printf("You were promoted ");
	}
	roll = d6();
	if (roll <= 4)
		printf("during your year as a Naval Attache.\n");
	else
	{
		aide = 1;
		printf("during your year as an Admirals Aide.\n");
	}
}


void nv_ocs()
{
	char fleet[20];

	printf("You got Officer Candidate School. Congratulations!\n");
	rankeo = 'O';
	if (rank >= 7) 
		rank = 2;
	else
		rank = 1;
	branch = nv_xfer();
	nv_branch(branch);
	if (blue_blood < 20)
		strncpy(fleet, "Federation Navy", 16);
	else
		strncpy(fleet, "Client State Fleet", 19);
	printf("Your new assignment is with the %s branch of the %s.\n", 
		office, fleet);
}


void nv_gen_skl()
{
	int roll;

	if (pick <= 2)
	{
		nv_pick_tbl();
		return;
	}
	if (rankeo == 'O' || rank >= 4)
	{
		roll = d6();
		if (roll >= 5)
			roll = 3;
	}
	else
	{
		roll = d4();
		if (roll == 4)
			roll = 3;
	}
	if (roll == 1)
	{ 
		if (careernbr == NAVY)
			nv_life();
		else
			merc_life();
	}
	if (roll == 2)
		nv_duty();
	if (roll == 3)
		nv_branch_tbl(branch);
	if (roll == 4)
	{
		if (command == 1)
		{
			if (careernbr == NAVY)
				nv_cmd_off();
			else
				ithmerc_cmd_off();
		}
		else
		{
			if (careernbr == NAVY)
				nv_staff_off();
			else
				ithmerc_staff_off();
		}
	}
}


void nv_pick_tbl()
{
	int choice, max;

	max = 3;
	printf("\nPlease select the table you wish to use for your new skill.\n");
	if (careernbr == NAVY)
		printf("\n   1. Navy life\n");   
	if (careernbr == ARMY)
		printf("\n   1. Ground Support life\n");
	if (careernbr == MARINE)
		printf("\n   1. Strike Force life\n");   
	nv_branch(branch);
	printf("   2. The table for %s\n", office); 
	if (assignment <= 2 || careernbr == ARMY)
		printf("   3. Shore duty\n");
	else
		printf("   3. Shipboard duty\n");
	if (rankeo == 'E' && rank >= 4)
	{
		printf("   4. Petty officer\n");
		max = 4;
	}
	else
	{
		if (rankeo == 'O') 
			if (command == 1)
			{
				printf("   4. Command Officer\n");
				max = 4;
			}
			else
			{
				printf("   4. Staff Officer\n");
				max = 4;
		}
	}
	choice = getsel_int(1, max);
	switch (choice)
	{
	case 1:
		{
			if (careernbr == NAVY)
				nv_life(); 
			if (careernbr == ARMY || careernbr == MARINE)
				merc_life(); 
			break;
		}
	case 2: nv_branch_tbl(branch); break;
	case 3: nv_duty(); break;
	case 4:
		{
			if (rankeo == 'E')
				nv_petty_off();
			else
				if (command == 1)
					nv_cmd_off();
				else
					nv_staff_off();
			break;
		}
	}
}


int nv_asgn()
{
	int roll;

	combat = 0;
	if (aide == 1)
	{
		printf("You were assigned to special duty.\n");
		skil = surv = decor = promo = 0;
		return 7;
	}
	roll = d6();
	if (roll == 6 && assignment != 0)
	{
		printf("You were allowed to repeat your last assignment.\n");
		if (assignment > 3 && assignment < 7)
		{
			combat = 1;
			cmbt++;
		}
		return assignment;
	}
	roll = d12();
	if (roll == 2)
	{
		printf("This is a battle assignment.\n");
		cmbt++;
		combat = 1;
		switch (branch)
		{
		case 1: skil = 5; surv = 6; decor = 6; promo = 6; break;
		case 2: skil = 6; surv = 4; decor = 8; promo = 9; break;
		case 3: skil = 6; surv = 6; decor = 7; promo = 6; break;
		case 5: skil = 6; surv = 4; decor = 10; promo = 6; break;
		default: skil = 5; surv = 5; decor = 7; promo = 6; break;
		}
		return 6;
	}
	if (col > 0 && rankeo == 'E' && rank >= 4)
		roll++;
	if (roll == 7)
	{
		printf("This is a training assignment.\n");
		surv = 0;
		if (branch == 2)
		{
			surv = 3;
			promo = 0;
		}
		skil = 7;
		if (branch == 3 || branch == 5)
			skil = 8;
		decor = 0;
		promo = 7;
		if (branch == 1 || branch == 3)
			promo = 8;
		return 1;
	}
	if (roll == 3 || roll == 10)
	{
		printf("This is a shore duty assignment.\n");
		switch (branch)
		{
		case 1: surv = 4; skil = 7; promo = 7; decor = 12; break;
		case 2: surv = 3; skil = 0; promo = 11; decor = 0; break;
		case 3: surv = 3; skil = 0; promo = 6; decor = 12; break;
		case 5: skil = 6; surv = 0; decor = 0; promo = 6; break;
		default: skil = 7; surv = 0; decor = 0; promo = 8; break;
		}
		return 2;
	}
	if (roll == 4)
	{
		printf("This is a seige assignment.\n");
		cmbt++;
		combat = 1;
		switch (branch)
		{
		case 1: skil = 6; surv = 5; promo = 8; decor = 10; break; 
		case 2: skil = 7; surv = 3; promo = 10; decor = 9; break; 
		case 3: skil = 5; surv = 5; promo = 8; decor = 10; break; 
		case 5: skil = 7; surv = 3; decor = 0; promo = 8; break;
		default: skil = 7; surv = 4; decor = 11; promo = 8; break;
		}
		return 4;
	}
	if (roll == 9 || roll == 5)
	{
		printf("This is a strike assignment.\n");
		cmbt++;
		combat = 1;
		switch (branch)
		{
		case 1: skil = 5; surv = 6; promo = 7; decor = 7; break; 
		case 2: skil = 6; surv = 3; promo = 9; decor = 9; break; 
		case 3: skil = 6; surv = 5; promo = 7; decor = 9; break; 
		case 5: skil = 7; surv = 3; promo = 6; decor = 11; break;
		default: skil = 6; surv = 5; promo = 6; decor = 7; break;
		}
		return 5;
	}
	if (roll == 6 || roll == 8)
	{
		printf("This is a patrol assignment.\n");
		switch (branch)
		{
		case 1: skil = 6; surv = 4; promo = 7; decor = 11; break; 
		case 2: skil = 7; surv = 3; promo = 11; decor = 10; break; 
		case 3: skil = 7; surv = 4; promo = 8; decor = 11; break; 
		case 5: skil = 7; surv = 3; promo = 7; decor = 0; break;
		default: skil = 6; surv = 3; promo = 5; decor = 12; break;
		}
		return 3;
	}
	printf("This is special duty.\n");
	bp_add(1);
	skil = surv = promo = decor = 0;
	return 7;
}


void nv_off_init()
{
	int roll;

	if (pick >= 3)
	{
		roll = d6();
		if (roll <= 3)
			nv_staff_off();
		else
			nv_branch_tbl(branch);
	}
	else
	{
		printf("Your initial skills can come from the following tables.\n\n");
		printf("   1. the skills table for your branch\n   2. staff officer\n");
		roll = getsel_int(1, 2);
		if (roll == 1)
			nv_branch_tbl(branch);
		else
			nv_staff_off();
	}
}


void nv_cross_train()
{
	int  roll;

	printf("You got cross-training.\n");
	if (pick >= 3)
	{
		roll = d6();
		nv_cross[roll]++;
		nv_branch_tbl(roll);
		return;
	}
	printf("You have the option to get cross-training in any field. Pick one.\n");
	printf("\n   1. line/crew");
	if (nv_cross[1] > 0)
		printf("*");
	printf("\n   2. flight");
	if (nv_cross[2] > 0)
		printf("*");
	printf("\n   3. gunnery");
	if (nv_cross[3] > 0)
		printf("*");
	printf("\n   4. engineering");
	if (nv_cross[4] > 0)
		printf("*");
	printf("\n   5. medical");
	if (nv_cross[5] > 0)
		printf("*");
	printf("\n   6. technical");
	if (nv_cross[6] > 0)
		printf("*");
	printf("\n\n* = already cross-trained in this branch\n");
	roll = getsel_int(1, 6);
	nv_branch_tbl(roll);
	nv_cross[roll]++;
}


void nv_branch(int branch_nbr)
{
	switch (branch_nbr)
	{
	case 1: strncpy(office,"Line/Crew",10); break;
	case 2: strncpy(office,"Flight",7); break; 
	case 3: strncpy(office,"Gunnery",8); break; 
	case 4: strncpy(office,"Engineering",12); break; 
	case 5: strncpy(office,"Medical",8); break; 
	case 6: strncpy(office,"Technical",10); break; 
	default: strncpy(office,"unknown?",9); break;
	}
}


void nv_branch_tbl(int brnch)
{
	switch (brnch)
	{
	case 1: nv_line(); break;
	case 2: nv_flt(); break;
	case 3: nv_gun(); break;
	case 4: nv_engr(); break;
	case 5: nv_med(); break;
	case 6: nv_tech(); break;
	}
}
