/* ITHSTRIK.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>

void strikeforce_init();
void mar_get_branch();
int mar_set_branch();
int mar_pickbranch();
void marinemot(int term);
void marinebene();
void mar_life();
void mar_shipboard();
void mar_shiptroop();
int mar_cmd();

extern int ithmerc_do_initial();
//extern int merc_doterms();
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d2();
extern int d3();
extern int d6();
extern int d12();
extern int getsel_int(int min, int max);
extern char getche_y_n();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern void merc_branch();
extern void bumpdex();
extern void bumpstr();
extern void bumpend();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void gc(int skl_val);
extern void env(int skl_val);
extern void vc(int skl_val);
extern void hc(int skl_val);
extern void env(int skl_val);
extern void gunner();
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_weapon();
extern void mot_hipsg();
extern void mot_tas();

#include "chargen.h"

extern int  merc_cross[8];

extern int  aide, nv_anag;

void strikeforce_init()
{
	int i;

	for (i = 1; i <= 7; i++)
		merc_cross[i] = 0;
	aide = 0;
	mar_get_branch();
	ithmerc_do_initial();
}


void mar_get_branch()
{
	if (branch == 0)
		if (pick != 4)
			branch = mar_pickbranch();
		else
			branch = mar_set_branch();
	merc_cross[branch]++;
	merc_branch(branch);
	printf("You were assigned to the %s branch.\n", office);
}


int mar_set_branch()
{
	int roll;

	if (tech_sch > 0)
		return 6;
	roll = d3();
	if (roll <= 2)
		return 1;
	return 6;
}


int mar_pickbranch()
{
	int choice, max;
  
	max = 3;
	printf("You have the option to choose the branch you wish to serve in\n"); 
	printf("within the Marine Corps.\n");
	printf("\n   1. pick one at random\n   2. infantry\n");
	printf("   3. support\n");
	choice = getsel_int(1, max);
	if (choice == 1)
		return mar_set_branch();
	if (choice == 2)
		return 1;
	return 6;
}


void marinemot(int term)
{
	int  cash, roll, amt;
	char choice;

	cash = basic_mot();
	while ((term > 0) && (cash > 0))
	{
		choice = getche_mot();
		if (choice == 'C' || choice == 'c')
		{
			cash--;
			roll = basic_cash();
			term--;
			amt = 0;
			switch (roll)
			{
			case 1: amt = 2000; break;
			case 2: amt = 5000; break;
			case 3: amt = 5000; break;
			case 4: amt = 10000; break;
			case 5: amt = 20000; break;
			case 6: amt = 30000; break;
			case 7: amt = 40000; break;
			}
			mot_cash(amt);
		}
		else
		{
			term--;
			marinebene();
		}
	}
	while (term > 0)
	{
		marinebene();    
		term--;
	}
}


void marinebene()
{
	int roll;

	roll = basic_bene();
	switch (roll)
	{
	case 1: mot_lopsg(); break;
	case 2: bumpedu(); break;
	case 3: bumpintl(); bumpintl(); break;
	case 4: mot_weapon(); break;
	case 5: mot_hipsg(); break;
	case 6: mot_tas(); break;
	case 7: bumpsoc(); bumpsoc(); break;
	}
}


void mar_life()
{
	int  roll;

	roll = d6();
	if (rankeo == 'O')
		roll++;
	if (rankeo == 'O' && rank >= 4)
		roll++;
	if (rankeo == 'O' && rank >= 7)
		roll++;
	switch (roll)
	{
	case 1: addskill(BRAWLING, 1); break;
	case 2: vc(1); break;
	case 3: bumpstr(); break;
	case 4: bumpdex(); break;
	case 5: bumpend(); break;
	case 6: hc(1); break;
	case 7: bumpedu(); break;
	default: bumpsoc(); break;
	}
}


void mar_shipboard()
{
	int  roll;

	roll = d6();
	if (rankeo == 'O' && rank >= 2)
		roll++;
	if (rankeo == 'O' && rank >= 4)
		roll++;
	switch (roll)
	{
	case 1: addskill(FORWARDOBS, 1); break;
	case 2: addskill(SHIPBOAT, 1); break;
	case 3: gunner(1); break;
	case 4: addskill(VACCSUIT, 1); break;
	case 5: gunner(1); break;
	case 6: addskill(VACCSUIT, 1); break;
	case 7: addskill(SHIPTAC, 1); break;
	default: addskill(FLEETTAC, 1); break;
	}
}


void mar_shiptroop()
{
	int  roll;

	roll = d6();
	if (tech >= TLAVGSTEL)
		roll++;
	switch (roll)
	{
	case 1: gc(1); break;
	case 2: gc(1); break;
	case 3: addskill(NOGRAV, 1); break;
	case 4: addskill(FORWARDOBS, 1); break;
	case 5: addskill(HIGHG, 1); break;
	case 6: env(1); break;
	case 7: addskill(BATTLEDRESS, 1); break;
	}
}


int mar_cmd()
{
	int  roll;
	char choice;

	if (rankeo == 'E')
		return 0;
	if (aide == 1)
	{
		printf("As a Generals Aide you have the option to take a command\n");
		printf("assignment this year automaticly. Do you want to?");
		choice = getche_y_n();
		if (choice == 'Y' || choice == 'y')
		{
			aide = 0;
			return 1;
		}
	}
	roll = d12();
	if (branch == 1 && roll >= 7)
		return 1;
	if (branch == 6 && roll >= 10)
		return 1;
	return 0;
}