/* ARMY.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void army();
void army_get_branch();
int army_set_branch();
int army_pickbranch();
void merc_do_initial();
int merc_doterms();
int merc_xfer();
int merc_off_xfer();
void merc_branch(int branch_nbr);
int merc_do_year();
void armymot(int term);
void armybene();
void merc_branch_tbl(int brnch);
void merc_nco();
void merc_cmd_off();
void army_life();
void merc_inf();
void merc_arty();
void merc_cav();
void merc_sup();
void merc_cmdo();
void merc_spcl_asgn();
int merc_pick_sch();
void merc_attache();
void merc_ocs();
void merc_spcl_sch();
void merc_cmdo_sch();
void merc_gen_skl();
void merc_life();
void merc_pick_tbl();
int merc_asgn();
int merc_mos();
int inf_mos();
int cav_mos();
int art_mos();
int cmdo_mos();
int army_cmd();
void merc_cross_train();

extern int nv_do_year();
extern int nv_adj();
extern int mar_cmd();
extern int anag();
extern void adv_aging(int anags);
extern int getrank();
extern int survive(int adjust, int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d3();
extern int d4();
extern int d5();
extern int d6();
extern int d7();
extern int d8();
extern int d12();
extern int getsel_int(int min, int max);
extern char getche_y_n();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern int bp_skill(int roll);
extern int bp_skill1(int roll, int need_nbr);
extern int bp_spcl_duty(int roll);
extern void bp_add(int amt);
extern void bp_cmbt();
extern int reenlist(int need_nbr);
extern void decorate(int adjust);
extern void mar_life();
extern void mar_shiptroop();
extern void merc_cmd_col();
extern void merc_staff_col();
extern void merc_rcrtng();
extern void merc_prot_frcs();
extern void merc_intl_sch();
extern void mar_shipboard();
extern void nv_med();
extern void nv_flt();
extern void bumpdex();
extern void bumpstr();
extern void bumpend();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void bc(int skl_val);
extern void spac(int skl_val);
extern void acad(int skl_val);
extern void techl(int skl_val);
extern void fag(int skl_val);
extern void gc(int skl_val);
extern void env(int skl_val);
extern void vc(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void inbrn(int skl_val);
extern void zhopsiedu();
extern void gottelepath();
extern void gotspcldty(int spcldutynbr);
extern int ask_adj_asgn(int roll);
extern void instructor(int spcldutynbr);
extern void disp_skill_table(char table_name[20], int skill_entries[7], int amount);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_weapon();

#include "chargen.h"

int  merc_cross[8];

void army()
{
  int i;

  for (i = 1; i <= 7; i++)
  {
    merc_cross[i] = 0;
  }
  assignment = aide = 0;
  army_get_branch();
  merc_do_initial();
  while (merc_doterms() == 0);
  terms = terms - anagathics;
  armymot(terms);
}


void army_get_branch()
{
  if (branch == 0)
  {
    if (pick != 4)
	{
      branch = army_pickbranch();
    }
	else
	{
      branch = army_set_branch();
    }
  }
  merc_cross[branch]++;
  merc_branch(branch);
  printf("You were assigned to the %s branch.\n", office);
}


int army_set_branch()
{
  int roll;

  if (tech_sch > 0) return 6;
  if (col == 14) roll = d8();
  else roll = d4();
  if (roll == 1) return 1;
  if (roll == 2) return 3;
  if (roll == 3) return 4;
  if (roll == 4) return 6;
  return 7;
}


int army_pickbranch()
{
  int choice, max;
  
  printf("You have the option to choose the branch you wish to serve in\n"); 
  printf("within the Army.\n");
  printf("\n   1. pick one at random\n   2. infantry\n   3. ");
  if (race == ZHODANI) printf("armor");
  else printf("cavalry");
  printf("\n   4. artillery\n   5. support\n");
  max = 5;
  if (col == 14 && race != ZHODANI)
  {
	  printf("   6. commandos\n");
	  max = 6;
  }
  if (race == ZHODANI && line == 1)
  {
	  printf("   6. thought police\n");
	  max = 6;
  }
  choice = getsel_int(1, max);
  if (choice == 1) return army_set_branch();
  if (choice == 2) return 1;
  if (choice == 5) return 6;
  if (choice == 6) return 7;
  return choice;
}


void merc_do_initial()
{
	if (race == ZHODANI && soc >= 10 && rankeo == 'E')
	{
		rankeo = 'O';
		rank = 0;
	}
	if (rank == 0 && rankeo == 'E') rank++;
	addskill(CMBTRIFLMAN, 1);
	if (branch == 7 && race != ZHODANI) 
		merc_cmdo_sch();
	else
		merc_branch_tbl(branch);
	age++;
	nv_anag = anag();
	if (nv_anag == 0) appearent_age++;
}


int merc_doterms()
{
	int survival, need_nbr;
  
	nv_promo = 0;
	if (branch == 2 || branch == 5)
	{
		do
		{
			survival = nv_do_year();
		} while (((age % 4) != 2) && (survival == 0));
	}
	else
	{  
		do
		{
			survival = merc_do_year();
		} while (((age % 4) != 2) && (survival == 0));
	}
	if (survival != 0) return 1;
	adv_aging(nv_anag);
	need_nbr = 7;
	if (rankeo == 'E') need_nbr -= 2;
	survival = reenlist(need_nbr);
	if (survival != 0) return 1; 
	drafted = 0;
	branch = merc_xfer();
	nv_anag = anag();
	return 0;
}


int merc_xfer()
{
  char choice;
  int  i, roll, prev_branch;

  prev_branch = branch;
  if (pick == 4)
  {
    roll = d7();
    if (merc_cross[roll] == 0 && rankeo == 'E')
	{
      merc_branch(branch);
      printf("You are in the %s branch.\n", office);
      return branch;
    }
	else
	{
      if ((roll == 2 && merc_cross[2] == 0)
        || (roll == 5 && merc_cross[5] == 0)
        || (roll == 7 && merc_cross[7] == 0 && mil_acd != HONORS))
        roll = army_set_branch();
      merc_branch(roll);
      printf("You are in the %s branch.\n", office);
      return roll;
    }
  }
  if (rankeo == 'E')
  {

    for (i = 7; i > 0; i--)
	{
      if (merc_cross[i] != 0 && branch != i)
	  {
        merc_branch(i);
        printf("You have the option to transfer to the %s branch.\nDo you want to?", office); 
    	choice = getche_y_n();
	    if (choice == 'Y' || choice == 'y') return i;
      }
    }
  }
  else
  {
    branch = merc_off_xfer();
  }
  return branch;
}


int merc_off_xfer()
{
  int choice, max;

  printf("You have the option to transfer to another branch. Pick one.\n\n");
  printf("   1. infantry\n   2. ");
  if (race == ZHODANI) printf("armor");
  else printf("cavalry");
  printf("\n   3. artillery\n   4. support\n");
  max = 4;
  if (merc_cross[2] != 0)
  {
	  printf("   5. flight\n");
	  max = 5;
  }
  if (merc_cross[5] != 0)
  {
	  printf("   6. medical\n");
	  max = 6;
  }
  if (merc_cross[7] != 0)
  {
	  if (race == ZHODANI && line == 1) printf("   7. thought police\n");
	  else printf("   7. commando\n");
	  max = 7;
  }
  choice = getsel_int(1, max);
  if (choice == 1) return 1;
  if (choice == 2) return 3;
  if (choice == 3) return 4;
  if (choice == 4) return 6;
  if (choice == 5 && merc_cross[2] != 0) return 2;
  if (choice == 6 && merc_cross[5] != 0) return 5;
  if (choice == 7 && merc_cross[7] != 0) return 7;
  printf("Wrong - try again!\n");
  return merc_off_xfer();
}


void merc_branch(int branch_nbr)
{
  switch (branch_nbr) {
    case 1: strncpy(office,"Infantry",9); break;
    case 2: strncpy(office,"Flight",7); break; 
    case 3: 
		{
			if (race == ZHODANI) strncpy(office,"Armor",6);
			else strncpy(office,"Cavalry",8);
		}
		break; 
    case 4: strncpy(office,"Artillery",10); break; 
    case 5: strncpy(office,"Medical",8); break; 
    case 6: strncpy(office,"Support",8); break; 
    case 7:
		{
			if (race == ZHODANI && line == 1) strncpy(office,"Thought Police",15);
			else strncpy(office,"Commando",9);
		}
		break; 
    default: strncpy(office,"unknown?",9); break;
  }
}


int merc_do_year()
{
  int   adjust, roll;
  
  age++;
  if (nv_anag == 0)
	  appearent_age++;
  if (careernbr == ARMY)
	  command = army_cmd();
  else
	  command = mar_cmd();
  assignment = merc_asgn();
  if (command != 0)
  {
	  printf(". You were in command");
	  if (combat != 0) cmd++;
  }
  printf(".\n");
  if ((rank < 9 && rankeo == 'E') 
    || (rankeo == 'O' && rank < 10))
  {
    if ((rankeo != 'O' || nv_promo == 0) && promo != 0)
	{
      roll = d12();
      if ((branch <= 4 && edu >= 7) || (branch == 6 && intl >= 8) 
        || (branch == 7 && end >= 8))
	  { 
        roll++;
      }
      if (roll >= promo)
	  {
        nv_promo++;
        rank++;
        printf("You were promoted. ");
        getrank();
        merc_gen_skl();
        if (roll >= (promo + 4)) merc_gen_skl();
      }
    }
  }
  adjust = nv_adj();
  decorate(adjust);
  if (assignment == 8)
	  merc_spcl_asgn();
  if (skil != 0)
  {
    roll = d12();
    if (roll < skil)
		roll = bp_skill(roll);
    if (roll >= (skil + 4))
	{
      if (spec_skill != 0)
	  {
        printf("Increasing your specialty skill. ");
        addskill(spec_skill, 1);
      }
	  else
	  {
        merc_gen_skl();
        merc_gen_skl();
      }
    }
	else
	{
      if (roll >= skil)
		  merc_gen_skl();
    }
  }
  roll = d12();
  if (rankeo == 'E')
	  roll += 2;
  return survive(roll, adjust);
}


void armymot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
		cash--;
		term--;
		amt = 0;
		roll = basic_cash();
		switch (roll)
		{
			case 1: amt = 2000; break;
	        case 2: amt = 5000; break;
		    case 3: amt = 10000; break;
			case 4: amt = 10000; break;
	        case 5: amt = 10000; break;
		    case 6: amt = 20000; break;
			case 7: amt = 30000; break;
		}
		mot_cash(amt);
    }
	else
	{
        term--;
        armybene();
    }
  }
  while (term > 0)
  {
    armybene();
    term--;
  }
}


void armybene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpedu(); break;
    case 3: bumpintl(); break;
    case 4: mot_weapon(); break;
    case 5: mot_midpsg(); break;
    case 6: mot_hipsg(); break;
    case 7: bumpsoc(); break;
  }
}


void merc_branch_tbl(int branch_nbr)
{
  switch (branch_nbr)
  {
    case 1: merc_inf(); break;
    case 2: nv_flt(); break;
    case 3: merc_cav(); break;
    case 4: merc_arty(); break;
    case 5: nv_med(); break;
    case 6: merc_sup(); break;
    case 7: merc_cmdo(); break;
  }
}


void merc_nco()
{
/*	char table_name[20];
	int  skill_entries[10];

	strcpy(table_name, "NCO");
	skill_entries[0] = 0;
	skill_entries[1] = HEAVYWEAP;
	skill_entries[2] = MECHANICAL;
	skill_entries[3] = TACTICS;
	skill_entries[4] = HEAVYWEAP;
	skill_entries[5] = MECHANICAL;
	skill_entries[6] = TACTICS;
	skill_entries[7] = LEADER;
	skill_entries[8] = INBORN;
	skill_entries[9] = INTERPERS;
*/
	int  roll;

	roll = d6();
	if (rank >= 4) roll++;
	if (rank >= 7) roll++;
/*	if (rank >= 5 && rank < 7)
	{
		disp_skill_table(table_name, skill_entries[1], 1);

	}
	else
	{
		if (rank >= 7 && rank < 9)
		{
			disp_skill_table(table_name, skill_entries[2], 1);
		}
		else
		{
			if (rank >= 9)
			{
				disp_skill_table(table_name, skill_entries[3], 1);
			}
			else
			{
				disp_skill_table(table_name, skill_entries[0], 1);
			}
		}
	}
*/
	switch (roll)
	{
		case 1: addskill(HEAVYWEAP, 1); break;
	    case 2: addskill(MECHANICAL, 1); break;
		case 3: addskill(TACTICS, 1); break;
	    case 4: addskill(HEAVYWEAP, 1); break;
		case 5: addskill(MECHANICAL, 1); break;
	    case 6: addskill(TACTICS, 1); break;
		case 7: addskill(LEADER, 1); break;
	    case 8: inbrn(1); break;
		case 9: interp(1); break;
	}
}


void merc_cmd_off()
{
  int  roll;

  roll = d6();
  if (rank >= 4) roll++;
  if (rank >= 7) roll++;
  switch (roll)
  {
    case 1: bumpend(); break;
    case 2: gc(1); break;
    case 3: addskill(HEAVYWEAP, 1); break;
    case 4: vhcl(1); break;
    case 5: addskill(TACTICS, 1); break;
    case 6: addskill(LEADER, 1); break;
    case 7: addskill(TACTICS, 1); break;
    case 8: inbrn(1); break;
  }
}


void army_life()
{
  int  roll;

  roll = d6();
  if (rankeo == 'O') roll++;
  if (rankeo == 'O' && rank >= 4) roll++;
  if (rankeo == 'O' && rank >= 7) roll++;
  switch (roll)
  {
        case 1: addskill(BRAWLING, 1); break;
        case 2: bumpstr(); break;
        case 3: vc(1); break;
        case 4: bumpdex(); break;
        case 5: bumpend(); break;
        case 6: bumpend(); break;
        case 7: addskill(HANDGUN, 1); break;
        default: bumpsoc(); break;
  }
}


void merc_inf()
{
  int  roll;

  roll = d6();
  if (tech >= 5 && race != ZHODANI) roll++;
  if (race == ZHODANI && line == 1) roll++;
  switch (roll)
  {
        case 1: gc(1); break;
        case 2: addskill(CMBTRIFLMAN, 1); break;
        case 3: addskill(HEAVYWEAP, 1); break;
        case 4: addskill(HEAVYWEAP, 1); break;
        case 5: vhcl(1); break;
        case 6: env(1); break;
        case 7: addskill(VACCSUIT, 1); break;
  }
}


void merc_arty()
{
  int  roll;

  roll = d6();
  if (tech >= 5 && race != ZHODANI) roll++;
  if (race == ZHODANI && line == 1) roll++;
  switch (roll) {
        case 1: fag(1); break;
        case 2: fag(1); break;
        case 3: vhcl(1); break;
        case 4: addskill(MECHANICAL, 1); break;
        case 5: addskill(FORWARDOBS, 1); break;
        case 6: addskill(COMPUTER, 1); break;
        case 7: techl(1); break;
  }
}


void merc_cav()
{
  int  roll;

  roll = d6();
  if (tech >= 5 && race != ZHODANI) roll++;
  if (race == ZHODANI && line == 1) roll++;
  switch (roll)
  {
        case 1: vhcl(1); break;
        case 2: vhcl(1); break;
        case 3: addskill(HEAVYWEAP, 1); break;
        case 4: addskill(HEAVYWEAP, 1); break;
        case 5: 
			{
				if (race == ZHODANI) addskill(RECON, 1);
				else addskill(MECHANICAL, 1);
			}
			break;
        case 6: vhcl(1); break;
        case 7: 
			{
				if (race == ZHODANI) addskill(COMPUTER, 1);
				else techl(1);
			}
			break;
  }
}


void merc_staff_off()
{
  int  roll;

  roll = d6();
  if (rankeo == 'O' && rank >= 4) roll++;
  if (rankeo == 'O' && rank >= 7) roll++;
  switch (roll) {
        case 1: addskill(MECHANICAL, 1); break;
        case 2: addskill(FORWARDOBS, 1); break;
        case 3: addskill(COMPUTER, 1); break;
        case 4: addskill(ELECTRONICS, 1); break;
        case 5: addskill(MEDICAL, 1); break;
        case 6: addskill(INSTRUCTION, 1); break;
        case 7: addskill(ADMIN, 1); break;
        case 8: acad(1); break;
  }
}


void merc_sup()
{
  int  roll;

  roll = d6();
  if (tech >= 5 && race != ZHODANI) roll++;
  if (race == ZHODANI && line == 1) roll++;
  switch (roll) {
        case 1: vhcl(1); break;
        case 2: addskill(CMBTENGR, 1); break;
        case 3: addskill(ELECTRONICS, 1); break;
        case 4: addskill(MECHANICAL, 1); break;
        case 5: addskill(MEDICAL, 1); break;
        case 6: vhcl(1); break;
        case 7: techl(1); break;
  }
}


void merc_cmdo()
{
  int  roll;

  roll = d6();
  if (tech >= 5 && race != ZHODANI) roll++;
  if (race == ZHODANI && line == 1) roll++;
  if (race != ZHODANI)
	  switch (roll)
		{
        case 1: gc(1); break;
        case 2: addskill(CMBTRIFLMAN, 1); break;
        case 3: addskill(HEAVYWEAP, 1); break;
        case 4: addskill(DEMOLITIONS, 1); break;
        case 5: env(1); break;
        case 6: addskill(RECON, 1); break;
        case 7: addskill(BATTLEDRESS, 1); break;
		}
  else
	  switch (roll)
		{
        case 1: break;
        case 2: addskill(LIAISON, 1); break;
        case 3: addskill(PSYCHOLOGY, 1); break;
        case 4: addskill(NVCOMM, 1); break;
        case 5: addskill(ADMIN, 1); break;
        case 6: gottelepath(); break;
        case 7: addskill(LIAISON, 1); break;
		}
}


void merc_spcl_asgn()
{
	int roll;
  
	if (aide != 0)
	{
		aide = 0;
		roll = merc_pick_sch();
	}
	else
	{
		roll = d6();
		if (age >= 38 && rankeo == 'E') 
			roll--;
		else
			if (end >= 7) roll++;
	}
	if (roll == 5 && brownie_points > 3)
	{
		brownie_points--;
		if (rankeo == 'E')
		{
			roll++;
			printf("You used 1 BP to get OCS.\n");
		} 
		else
		{
			roll--;
			printf("You used 1 BP to get attache.\n");
		}
	}
	if ((roll == 2 || roll == 4) && merc_cross[7] == 0 && brownie_points > 3)
	{
		roll = 3;
		brownie_points--;
		printf("You used 1 BP to get commando school.\n");
	}
	if (roll == 3) merc_cmdo_sch(1);
	if (roll == 5) merc_rcrtng();
	if (rankeo == 'E')
	{
		if (roll <= 1) merc_cross_train();
		if (roll == 2) merc_spcl_sch();
	    if (roll == 4) merc_prot_frcs();
		if (roll >= 6) merc_ocs();
	}
	else
	{
		if (roll <= 1) merc_intl_sch();
		if (roll == 2) merc_cmd_col();
	    if (roll == 4) merc_attache();
		if (roll >= 6) merc_staff_col();
	}
}


int merc_pick_sch()
{
  int choice;

  printf("As a Generals Aide you can pick your next assignment.\n\n");
  printf("   1. intelligence school\n   2. commando school\n");
  printf("   3. recruiting\n   4. command college\n   5. staff college\n");
  choice = getsel_int(1, 5);
  if (choice == 1) return 1;
  if (choice == 2) return 3;
  if (choice == 3) return 5;
  if (choice == 4) return 2;
  return 6;
}


void merc_attache()
{
  int roll;

  bumpsoc();
  if (rank >= 10)
  {
    printf("You were not eligible for a promotion. ");
  }
  else
  {
    rank++;
    nv_promo++;
    printf("You were promoted. ");
  }
  roll = d6();
  if (roll <= 4)
  {
	  gotspcldty(ATTACHE);
  }
  else
  {
      aide = 1;
      gotspcldty(AIDE);
  }
}


void merc_ocs()
{
  gotspcldty(OCS);
  rankeo = 'O';
  if (rank >= 8) rank = 3;
  else
    if (rank == 7) rank = 2;
    else rank = 1;
  if (race == ZHODANI) rank = 0;
  branch = merc_xfer();
  merc_branch(branch);
  printf("Your new assignment is with the %s branch.\n", office);
  merc_branch_tbl(branch);
  merc_staff_off();
  merc_staff_off();
}


void merc_spcl_sch()
{
  int roll;

  gotspcldty(SPECIALISTSCH);
  roll = d6();
  if ((intl + edu) >= 16)
  {
    switch (roll)
	{
      case 1: addskill(MEDICAL, 1); break;
      case 2: addskill(COMPUTER, 1); break;
      case 3: addskill(LIAISON, 1); break;
      case 4: env(1); break;
      case 5: spac(1); break;
      case 6: acad(1); break;
    }
  }
  else
  {
    switch (roll)
	{
      case 1: addskill(COMMO, 1); break;
      case 2: addskill(MECHANICAL, 1); break;
      case 3: addskill(SHIPBOAT, 1); break;
      case 4: addskill(ELECTRONICS, 1); break;
      case 5: vhcl(1); break;
      case 6: addskill(GRAVITICS, 1); break;
    }
  }
}



void merc_cmdo_sch()
{
	int roll;

	merc_cross[7]++;
	branch = 7;
	if (race == ZHODANI && line == 1)
	{
		gotspcldty(THOUGHTPOLICESCH);
		if (special_duty[THOUGHTPOLICESCH] > 1)
		{
			if ((chk_skl(NVCOMM, 4) == 1) || (chk_skl(PSYCHOLOGY, 4) == 1) 
				|| (chk_skl(LIAISON, 4) == 1))
			{
				instructor(THOUGHTPOLICESCH);
				return;
			}
		}
		roll = bp_skill1(d6(), 3);
		if (roll >= 3) addskill(NVCOMM, 1);
		roll = bp_skill1(d6(), 3);
		if (roll >= 3) addskill(PSYCHOLOGY, 1);
		roll = bp_skill1(d6(), 3);
		if (roll >= 3) addskill(LIAISON, 1);
		roll = bp_skill1(d6(), 3);
		if (roll >= 3) gottelepath();
		return;
	}
	gotspcldty(COMMANDOSCH);
	if (special_duty[COMMANDOSCH] > 1)
	{
		if ((chk_skl(BRAWLING, 4) == 1) || (chk_skl(HANDGUN, 4) == 1) 
			|| (chk_skl(RIFLMAN, 4) == 1) || (chk_skl(LASERWEAP, 4) == 1)
		    || (chk_skl(NEURALWEAP, 4) == 1) || (chk_skl(ENERGYWEAP, 4) == 1) 
			|| (chk_skl(CMBTRIFLMAN, 4) == 1) || (chk_skl(SUBMG, 4) == 1)
			|| (chk_skl(DEMOLITIONS, 4) == 1) || (chk_skl(INTRUSION, 4) == 1)
			|| (chk_skl(STEALTH, 4) == 1) || (chk_skl(SURVIVAL, 4) == 1)
			|| (chk_skl(INSTRUCTION, 4) == 1) || (chk_skl(VACCSUIT, 4) == 1)
			|| (chk_skl(RECON, 4) == 1) || (chk_skl(AXE, 4) == 1)
			|| (chk_skl(CUDGEL, 4) == 1) || (chk_skl(POLEARM, 4) == 1)
			|| (chk_skl(FOIL, 4) == 1)
			|| (chk_skl(LARGEBLAD, 4) == 1) || (chk_skl(SMALLBLAD, 4) == 1))
		{
			instructor(COMMANDOSCH);
			return;
		}
	}
	roll = bp_skill1(d6(), 5);
	if (roll >= 5) addskill(BRAWLING, 1);
	roll = bp_skill1(d6(), 5);
	if (roll >= 5) addskill(DEMOLITIONS, 1);
	roll = bp_skill1(d6(), 5);
	if (roll >= 5) addskill(INTRUSION, 1);
	roll = bp_skill1(d6(), 5);
	if (roll >= 5) addskill(STEALTH, 1);
	roll = bp_skill1(d6(), 5);
	if (roll >= 5) gc(1);
	roll = bp_skill1(d6(), 5);
	if (roll >= 5) addskill(SURVIVAL, 1);
	roll = bp_skill1(d6(), 5);
	if (roll >= 5) addskill(INSTRUCTION, 1);
	roll = bp_skill1(d6(), 5);
	if (roll >= 5) addskill(VACCSUIT, 1);
	roll = bp_skill1(d6(), 5);
	if (roll >= 5) bc(1);
	roll = bp_skill1(d6(), 5);
	if (roll >= 5) addskill(RECON, 1);
}


void merc_gen_skl()
{
  int roll;

  if (pick <= 2) {
    merc_pick_tbl();
    return;
  }
  if (assignment != 7) {
    if (rankeo == 'O' || rank >= 3) {
      roll = d4();
      if (roll == 4) roll = 2;
    } else {
      roll = d3();
      if (roll == 3) roll = 2;
    }
  } else {
    if (rankeo == 'O' || rank >= 3) {
      roll = d8();
      if (roll == 6) roll = 5;
      if (roll > 6) roll = 2;
    } else {
      roll = d6();
      if (roll == 3) roll = 2;
      if (roll == 6) roll = 5;
    }
  }
  if (roll == 1) merc_life();
  if (roll == 2) merc_branch_tbl(branch);
  if (roll == 3)
  {
    if (rankeo == 'E') merc_nco();
    else
      if (command == 1) merc_cmd_off();
      else merc_staff_off();
  }
  if (roll == 4) mar_shipboard();
  if (roll == 5) mar_shiptroop();
}


void merc_life()
{
  if (careernbr == ARMY) army_life();
  else
    mar_life();
}


void merc_pick_tbl()
{
  int choice, max;

  max = 2;
  printf("\nPlease select the table you wish to use for your new skill.\n");
  if (careernbr == ARMY) printf("\n   1. Army life\n");   
  if (careernbr == MARINE) printf("\n   1. Marine life\n");  
  merc_branch(branch); 
  printf("   2. The table for %s\n", office); 
  if (rankeo == 'E' && rank >= 3) 
  {
	  printf("   3. NCO\n");
	  max = 3;
  }
  if (rankeo == 'O' && command == 1)
  {
	  printf("   3. Command Officer\n");
	  max = 3;
  }
  if (rankeo == 'O' && command == 0) 
  {
	  printf("   3. Staff Officer\n");
	  max = 3;
  }
  if (assignment == 7) {
    printf("   4. shipboard\n   5. ships troops\n");
	max = 5;
  }
  if (race == ZHODANI && soc >= 10)
  {
	  printf("   6. Noble/Intendent education\n");
	  max = 6;
  }
  choice = getsel_int(1, max);
  if ((rankeo == 'E' && rank < 3 && choice == 3)
    || (assignment != 7 && (choice == 5 || choice == 4))
	|| (race == ZHODANI && soc < 10 && choice == 6))
  {
    printf("Wrong - try again!\n");
    merc_pick_tbl();
    return;
  }
  switch (choice) {
    case 1: merc_life(); break;
    case 2: merc_branch_tbl(branch); break;
    case 3: 
	{
      if (rankeo == 'E') merc_nco();
      else
        if (command == 1) merc_cmd_off();
        else
          merc_staff_off();
      break;
    }
    case 4: mar_shipboard(); break;
    case 5: mar_shiptroop(); break;
	case 6: zhopsiedu(); break;
  }
}


int merc_asgn()
{
  int roll, asgnmt;

  combat = 0;
  if (aide == 1)
  {
    printf("You were assigned to special duty.\n");
    skil = surv = decor = promo = 0;
    return 8;
  }
  roll = d12();
  /* use a brownie point to get special duty */
  if (brownie_points > 0)
	  if (pick == 1) roll = ask_adj_asgn(roll);
	  else
		  if (pick == 4) roll = bp_spcl_duty(roll);
  if (branch == 1)
  {
	if (pick == 4 && roll == 6 && brownie_points > 3)
	{
		roll--;
		bp_cmbt();
	}
	if (pick == 4 && roll == 8 && brownie_points > 3)
	{
		roll++;
		bp_cmbt();
	}
    switch (roll)
	{
      case 2: asgnmt = 5; break;
      case 3: asgnmt = 5; break;
      case 4: asgnmt = 4; break;
      case 5: asgnmt = 4; break;
      case 6: asgnmt = 6; break;
      case 7: asgnmt = 6; break;
      case 8: asgnmt = 1; break;
      case 9: asgnmt = 3; break;
      case 10: asgnmt = 2; break;
      default: asgnmt = 8; break;
    }
  }
  if (branch == 3)
  {
	if (pick == 4 && roll == 3 && brownie_points > 3)
	{
		roll--;
		bp_cmbt();
	}
	if (pick == 4 && roll == 6 && brownie_points > 3)
	{
		roll--;
		bp_cmbt();
	}
	if (pick == 4 && roll == 8 && brownie_points > 3)
	{
		roll++;
		bp_cmbt();
	}
    if (race == ZHODANI)
		switch (roll) // Zhodani armor
		{
		  case 2: asgnmt = 5; break;
	      case 3: asgnmt = 1; break;
		  case 4: asgnmt = 4; break;
	      case 5: asgnmt = 3; break;
		  case 6: asgnmt = 6; break;
	      case 7: asgnmt = 6; break;
		  case 8: asgnmt = 6; break;
	      case 9: asgnmt = 1; break;
		  case 10: asgnmt = 3; break;
		  case 11: asgnmt = 1; break;
	      default: asgnmt = 3; break;
		}
	else
		switch (roll) // cavalry
		{
		  case 2: asgnmt = 5; break;
	      case 3: asgnmt = 1; break;
		  case 4: asgnmt = 4; break;
	      case 5: asgnmt = 3; break;
		  case 6: asgnmt = 6; break;
	      case 7: asgnmt = 6; break;
		  case 8: asgnmt = 1; break;
	      case 9: asgnmt = 3; break;
		  case 10: asgnmt = 2; break;
	      default: asgnmt = 8; break;
		}
  }
  if (branch == 4)
  {
	if (pick == 4 && roll == 3 && brownie_points > 3)
	{
		roll--;
		bp_cmbt();
	}
	if (pick == 4 && roll == 6 && brownie_points > 3)
	{
		roll--;
		bp_cmbt();
	}
	if (pick == 4 && roll == 8 && brownie_points > 3)
	{
		roll++;
		bp_cmbt();
	}
    switch (roll)
	{
      case 2: asgnmt = 5; break;
      case 3: asgnmt = 1; break;
      case 4: asgnmt = 4; break;
      case 5: asgnmt = 3; break;
      case 6: asgnmt = 6; break;
      case 7: asgnmt = 6; break;
      case 8: asgnmt = 1; break;
      case 9: asgnmt = 3; break;
      case 10: asgnmt = 4; break;
      default: asgnmt = 8; break;
    }
  }
  if (branch == 6)
  {
	if (pick == 4 && roll == 3 && brownie_points > 3)
	{
		roll--;
		bp_cmbt();
	}
	if (pick == 4 && roll == 5 && brownie_points > 3)
	{
		roll--;
		bp_cmbt();
	}
	if (pick == 4 && roll == 8 && brownie_points > 3)
	{
		roll++;
		bp_cmbt();
	}
	if (pick == 4 && roll == 10 && brownie_points > 3)
	{
		roll++;
		bp_cmbt();
	}
    switch (roll)
	{
      case 2: asgnmt = 5; break;
      case 3: asgnmt = 2; break;
      case 4: asgnmt = 4; break;
      case 5: asgnmt = 6; break;
      case 6: asgnmt = 6; break;
      case 7: asgnmt = 6; break;
      case 8: asgnmt = 1; break;
      case 9: asgnmt = 3; break;
      case 10: asgnmt = 2; break;
      default: asgnmt = 8; break;
    }
  }
  if (branch == 7)
  {
	  if (race == ZHODANI && line == 1)
	  {
		if (pick == 4 && roll == 3 && brownie_points > 3)
		{
			roll--;
			bp_cmbt();
		}
	    switch (roll) // Zhodani guards get thought police
		{
	      case 2: asgnmt = 4; break;
		  case 3: asgnmt = 2; break;
	      case 4: asgnmt = 2; break;
		  case 5: asgnmt = 9; break;
	      case 6: asgnmt = 9; break;
		  case 7: asgnmt = 9; break;
	      case 8: asgnmt = 6; break;
		  case 9: asgnmt = 7; break;
	      case 10: asgnmt = 2; break;
		  default: asgnmt = 1; break;
		}
	  }
	  else
	  {
		if (pick == 4 && roll == 7 && brownie_points > 3)
		{
			roll--;
			bp_cmbt();
		}
		if (pick == 4 && roll == 8 && brownie_points > 3)
		{
			roll++;
			bp_cmbt();
		}
	    switch (roll) // the rest get commandos
		{
	      case 2: asgnmt = 5; break;
		  case 3: asgnmt = 5; break;
	      case 4: asgnmt = 4; break;
		  case 5: asgnmt = 3; break;
	      case 6: asgnmt = 3; break;
		  case 7: asgnmt = 2; break;
	      case 8: asgnmt = 1; break;
		  case 9: asgnmt = 4; break;
	      case 10: asgnmt = 5; break;
		  default: asgnmt = 8; break;
		}
	  }
  }
// marines replace counter insergency and internal security with ships troops
  if (careernbr == MARINE && (asgnmt == 2 || asgnmt == 4)) asgnmt = 7;
  if (branch == 1 || branch == 3 || branch == 4)
  {
    switch (asgnmt)
	{
      case 1: surv = 0; decor = 0; promo = 6; skil = 7; break;
      case 2: surv = 4; decor = 12; promo = 6; skil = 0; break;
      case 3: surv = 5; decor = 9; promo = 8; skil = 7; break;
      case 4: surv = 5; decor = 10; promo = 9; skil = 8; break;
      case 5: surv = 6; decor = 6; promo = 6; skil = 5; break;
      case 6: surv = 0; decor = 0; promo = 7; skil = 0; break;
      case 7: surv = 4; decor = 12; promo = 6; skil = 6; break;
      case 8: surv = 0; decor = 0; promo = 0; skil = 0; break;
    }
    if (merc_mos() != 0 && surv != 0) surv++; /* check mos */
    if (edu > 7 && promo != 0) promo++;
  }
  if (branch == 6)
  {
    switch (asgnmt)
	{
      case 1: surv = 0; decor = 0; promo = 6; skil = 8; break;
      case 2: surv = 4; decor = 0; promo = 6; skil = 0; break;
      case 3: surv = 4; decor = 10; promo = 9; skil = 7; break;
      case 4: surv = 5; decor = 11; promo = 10; skil = 7; break;
      case 5: surv = 6; decor = 7; promo = 7; skil = 6; break;
      case 6: surv = 0; decor = 0; promo = 7; skil = 0; break;
      case 7: surv = 3; decor = 12; promo = 6; skil = 6; break;
      case 8: surv = 0; decor = 0; promo = 0; skil = 0; break;
    }
    if (intl > 8 && promo != 0) promo++;
  }
  if (branch == 7)
  {
    if (race == ZHODANI && line == 1)
		switch (asgnmt) // Zhodani guards get thought police
		{
		    case 1: surv = 0; decor = 0; promo = 9; skil = 5; break;
		    case 2: surv = 3; decor = 9; promo = 9; skil = 5; break;
		    case 4: surv = 4; decor = 8; promo = 8; skil = 5; break;
		    case 6: surv = 0; decor = 0; promo = 9; skil = 8; break;
		    case 7: surv = 4; decor = 7; promo = 6; skil = 7; break;
		    case 9: surv = 4; decor = 10; promo = 9; skil = 8; break;
		}
	else
		switch (asgnmt) // others get commandos
		{
		    case 1: surv = 3; decor = 0; promo = 8; skil = 6; break;
		    case 2: surv = 4; decor = 0; promo = 7; skil = 0; break;
		    case 3: surv = 4; decor = 9; promo = 8; skil = 7; break;
		    case 4: surv = 5; decor = 9; promo = 7; skil = 6; break;
		    case 5: surv = 6; decor = 5; promo = 6; skil = 5; break;
		    case 6: surv = 0; decor = 0; promo = 7; skil = 0; break;
		    case 7: surv = 5; decor = 10; promo = 6; skil = 6; break;
		    case 8: surv = 0; decor = 0; promo = 0; skil = 0; break;
		}
	if (cmdo_mos() != 0 && surv != 0) surv++; /* check mos */
	if (end > 8 && promo != 0) promo++;
  }
  printf("This is ");
  switch (asgnmt)
  {
    case 1: printf("training"); break;
    case 2: printf("internal security"); break;
    case 3: printf("police action"); cmbt++; combat++; break;
    case 4: printf("counter insurgency"); cmbt++; combat++; break;
    case 5: printf("a raid"); cmbt++; combat++; break;
    case 6: printf("garrison"); break;
    case 7: printf("ships troops"); break;
    case 8: printf("special duty"); break;
	case 9: printf("patrol"); break;
	case 10: printf("the frozen watch"); break;
  }
  return asgnmt;
}


int merc_mos()
{
  switch (branch) {
    case 1: return inf_mos();
    case 3: return cav_mos();
    case 4: return art_mos();
  }
  return -1;
}


int inf_mos()
{
  int qual;

  qual = chk_skl(HEAVYWEAP, 2);
  if (qual == 0) qual = chk_skl(VACCSUIT, 2);
  if (qual == 0) qual = chk_skl(GUNCMBT, 2);
  if (qual == 0) qual = chk_skl(VEHICLE, 2);
  if (qual == 0) qual = chk_skl(ENVIRON, 2);
  if (qual != 0) return 1;
  return 0;
}


int cav_mos()
{
  int qual;

  qual = chk_skl(HEAVYWEAP, 2);
  if (qual == 0) qual = chk_skl(MECHANICAL, 2);
  if (qual == 0) qual = chk_skl(TECHNICAL, 2);
  if (qual == 0) qual = chk_skl(VEHICLE, 2);
  if (qual != 0) return 1;
  return 0;
}


int art_mos()
{
  int qual;

  qual = chk_skl(FAGUNNERY, 2);
  if (qual == 0) qual = chk_skl(COMPUTER, 2);
  if (qual == 0) qual = chk_skl(MECHANICAL, 2);
  if (qual == 0) qual = chk_skl(VEHICLE, 2);
  if (qual == 0) qual = chk_skl(FORWARDOBS, 2);
  if (qual == 0) qual = chk_skl(TECHNICAL, 2);
  if (qual != 0) return 1;
  return 0;
}


int cmdo_mos()
{
  int qual;

  qual = chk_skl(GUNCMBT, 2);
  if (qual == 0) qual = chk_skl(HEAVYWEAP, 2);
  if (qual == 0) qual = chk_skl(BATTLEDRESS, 2);
  if (qual == 0) qual = chk_skl(RECON, 2);
  if (qual == 0) qual = chk_skl(DEMOLITIONS, 2);
  if (qual == 0) qual = chk_skl(ENVIRON, 2);
  if (qual != 0) return 1;
  return 0;
}


int army_cmd()
{
  int  roll;
  char choice;

  if (rankeo == 'E') return 0;
  if (aide == 1)
  {
    printf("As an Generals Aide you have the option to take a command\n");
    printf("assignment this year automaticly. Do you want to?");
    choice = getche_y_n();
    if (choice == 'Y' || choice == 'y')
	{
      aide = 0;
      return 1;
    }
  }
  roll = d12();
  if (branch == 1 && roll >= 7) return 1;
  if (branch == 3 && roll >= 7) return 1;
  if (branch == 4 && roll >= 8) return 1;
  if (branch == 7 && roll >= 6) return 1;
  if (roll >= 10) return 1;
  return 0;
}


void merc_cross_train()
{
  int  i, roll;

  printf("You got cross-training.\n");
  if (pick >= 3) {
    if (merc_cross[7] != 0) {
      roll = d7();
    } else {
      roll = d6();
    }
    merc_cross[roll]++;
    merc_branch_tbl(roll);
    return;
  }
  printf("You have the option to get cross-training in any field. Pick one.\n");
  printf("\n   1. infantry");
  if (merc_cross[1] > 0) printf("*");
  printf("\n   2. ");
  if (race == ZHODANI) printf("armor");
  else printf("cavalry");
  if (merc_cross[3] > 0) printf("*");
  printf("\n   3. artillery");
  if (merc_cross[4] > 0) printf("*");
  printf("\n   4. support");
  if (merc_cross[6] > 0) printf("*");
  if (merc_cross [2] > 0) printf("\n   5. flight*");
  if (merc_cross [5] > 0) printf("\n   6. medical*");
  if (merc_cross [7] > 0)
  {
    printf("\n   7. ");
	if (race == ZHODANI && line == 1) printf("thought police*");
	else printf("commando*");
  }
  printf("\n\n* = already cross-trained in this branch\n");
  roll = getsel_int(1, 7);
  i = 0;
  if (roll == 4) i = 6;
  if (roll == 3) i = 4;
  if (roll == 2) i = 3;
  if (roll == 1) i = 1;
  if (roll == 5 && merc_cross[2] > 0) i = 2;
  if (roll == 6 && merc_cross[5] > 0) i = 5;
  if (roll == 7 && merc_cross[7] > 0) i = 7;
  if (i == 0) {
    printf("Wrong - try again!\n");
    merc_cross_train();
    return;
  }
  merc_branch_tbl(i);
  merc_cross[i]++;
}
