/* BARBARIN.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void barbarian();
void barbarianmot(int term);
void barbarianbene();
void barbarianskills(int skills);
void barbrn_tbl(int roll);

#include "chargen.h"

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpdex();
extern void bc(int skl_val);
extern void hc(int skl_val);
extern void physicl(int skl_val);
extern void archaic(int skl_val);
extern void gc(int skl_val);
extern void env(int skl_val);
extern void vc(int skl_val);
extern void inbrn(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_hipsg();
extern void mot_weapon();
extern void mot_nada();

void barbarian()
{
  int     skills, newterm;
  
  newterm = 0;
  age -= 4;
  appearent_age -= 4;
  while (newterm == 0) {
    skills = basic_spec_duty(7);
    newterm = basic_surv(4, str, 8);
    if (newterm == 0) {
      skills += basic_comm(6, str, 10);
      skills += basic_promo(9, intl, 6);
    }
    skills = specskl(skills);
    if (skills != 0) barbarianskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  terms = terms - anagathics;
  barbarianmot(terms);
}


void barbarianmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: break;
        case 2: break;
        case 3: amt = 1000; break;
        case 4: amt = 2000; break;
        case 5: amt = 3000; break;
        case 6: amt = 4000; break;
        case 7: amt = 5000; break;
      }
	  mot_cash(amt);
    } 
	else 
	{
      barbarianbene();
      term--;
    }
  }
  while (term > 0)
  {
    barbarianbene();
    term--;
  }
}


void barbarianbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: mot_nada(); break;
    case 3: mot_weapon(); break;
    case 4: mot_weapon(); break;
    case 5: mot_weapon(); break;
    case 6: mot_hipsg(); break;
    case 7: mot_hipsg(); break;
  }
}


void barbarianskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: physicl(1); break;
        case 4: vc(1); break;
        case 5: physicl(1); break;
        case 6: hc(1); break;
      }
    }
    if (table == 2) {
      barbrn_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: hc(1); break;
        case 2: addskill(MECHANICAL, 1); break;
        case 3: env(1); break;
        case 4: env(1); break;
        case 5: vc(1); break;
        case 6: archaic(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: addskill(MEDICAL, 1); break;
        case 2: addskill(INTERROGATE, 1); break;
        case 3: addskill(TACTICS, 1); break;
        case 4: env(1); break;
        case 5: inbrn(1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}


void barbrn_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: hc(1); break;
        case 2: hc(1); break;
        case 3: bc(1); break;
        case 4: env(1); break;
        case 5: archaic(1); break;
        case 6: gc(1); break;
      }
}
