/* COACC.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void coacc();
void air_get_branch();
int air_set_branch();
int air_pickbranch();
void air_do_initial();
int air_doterms();
int air_xfer();
int air_do_year();
int air_mos();
int orbit_mos();
void imperial_duty();
int atmos_mos();
void air_flt_sgt();
void air_cmd_off();
void air_life();
void air_flt_off();
void air_grnd_off();
void air_atmos();
void air_orbit();
void air_staff_off();
void air_sec();
void air_med();
void air_tech();
void air_spcl_asgn();
void air_spcl_sch();
void air_adv_sch();
void air_space_sch();
void frwd_obs_sch();
void air_intl_sch();
void base_def_sch();
int air_pick_sch();
void air_attache();
void air_ocs();
void air_crew_sch();
void air_gen_skl();
void air_pick_tbl();
int air_asgn();
int air_cmd();
void air_off_init();
void air_cross_train(int choice);
void air_branch(int branch_nbr);
void air_branch_tbl(int brnch);

extern int nv_set_branch();
extern int nv_adj();
extern int anag();
extern void adv_aging(int anags);
extern int getrank();
extern int survive(int adjust, int roll);
extern int basic_cash();
extern int flyermot();
extern int basic_bene();
extern int d3();
extern int d5();
extern int d6();
extern int d12();
extern int getsel_int(int min, int max);
extern char getche_y_n();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern int find_skl(int skill);
extern int bp_skill(int roll);
extern int bp_skill1(int roll, int need_nbr);
extern void bp_cmbt();
extern int bp_spcl_duty(int roll);
extern int reenlist(int need_nbr);
extern void decorate(int adjust);
extern void nv_cmd_col();
extern void nv_staff_col();
extern void coacc_flt_sch();
extern void bumpdex();
extern void bumpend();
extern void bumpsoc();
extern void bumpedu();
extern void spac(int skl_val);
extern void airc(int skl_val);
extern void gunner();
extern void gc(int skl_val);
extern void vc(int skl_val);
extern void inbrn(int skl_val);
extern void bp_add(int amt);
extern void gotspcldty(int spcldutynbr);
extern void merc_rcrtng();
extern int ask_adj_asgn(int roll);
extern void instructor(int spcldutynbr);

#include "chargen.h"

int flight;

void coacc()
{
  int i;

  for (i = 1; i <= 5; i++)
  {
    nv_cross[i] = 0;
  }
  flight = 1;
  aide = 0;
  command = 0;
  combat = 0;
  assignment = 0;
  air_get_branch();
  air_do_initial();
  while (air_doterms() == 0);
  terms = terms - anagathics;
  flyermot(terms);
}


void air_get_branch()
{
  line = 2;
  if (branch == 0)
  {
    if (soc >= 9) branch = air_pickbranch();
    else branch = air_set_branch();
  }
  nv_cross[branch]++;
  air_branch(branch);
  printf("You were assigned to the %s branch.\n", office);
}


int air_set_branch()
{
  int roll;

  if (med_sch > 0) return 5;
  if (tech_sch > 0 || tech_acd > 0) return 3;
  roll = d6();
  if (tech >= 4) roll++;
  if (roll <= 2) return 3;
  if (roll <= 3) return 4;
  if (rankeo == 'E')
  {
    if (roll <= 4) return 4;
    if (roll <= 5) return 5;
    if (roll <= 6) return 2;
  }
  else
  {
    if (roll <= 6) return 2;
  }
  return 1;
}


int air_pickbranch()
{
  int choice;
  if (pick == 4) 
  {
    return nv_set_branch();
  }
  printf("Due to your high social status you have the option to choose\n");
  printf("the branch you with to serve in within the COACC.\n");
  printf("\n   1. pick one at random\n");
  if (tech >= 4) printf("   2. orbit\n");
  printf("   3. atmosphere\n   4. technical\n   5. security\n   6. medical\n");  
  choice = getsel_int(1, 6);
  if (tech < 4 && choice == 2)
  {
    printf("Wrong! Try again.\n");
    return air_pickbranch();
  }
  if (choice == 1)
  {
    return air_set_branch();
  }
  choice--;
  return choice;
}


void air_do_initial()
{
  if (rank == 0) rank++;
  if (rankeo == 'E') 
  {
    air_branch_tbl(branch);
    air_branch_tbl(branch);
  }
  else
  {
    air_off_init();    
    air_off_init();
  }
  age++;
  nv_anag = anag();
  if (nv_anag == 0) appearent_age++;
}


int air_doterms()
{
  int survival, roll;
  
  nv_promo = 0;
  adv_aging(nv_anag);
  do
  {
    survival = air_do_year();
  } while (((age % 4) != 2) && (survival == 0));
  if (survival != 0) return 1;
  survival = reenlist(6);
  if (survival != 0) return 1;
  if (flight == 1)
  {
    roll = d6();
    if (purple > 0) roll++;
    if (dex >= 8) roll--;
    if (terms > 2) roll += (terms - 2);
    if (roll >= 6)
	{
      printf("You were grounded!\n");
      flight = 0;
    }
  }
  drafted = 0;
  branch = air_xfer();
  nv_anag = anag();
  return 0;
}


int air_xfer()
{
  int  choice, i, roll;

  imperial_duty();
  if (line == 1) return branch;
  if (pick == 4)
  {
    roll = d6();
    if (nv_cross[roll] == 0)
	{
      air_branch(branch);
      printf("You are in the %s branch.\n", office);
      return branch;
    }
	else
	{
      air_branch(roll);
      printf("You are in the %s branch.\n", office);
      return roll;
    }
  }
  for (i = 1; i <= 5; i++)
  {
    if (nv_cross[i] != 0 && branch != i)
	{
      air_branch(i);
      printf("You have the option to transfer to the %s branch.\n", office); 
      printf("Do you want to?");
      choice = getche_y_n();
      if (choice == 'Y' || choice == 'y') return i;
    }
  }
  return branch;
}


int air_do_year()
{
  int   adjust, roll;
  
  age++;
  if (nv_anag == 0) appearent_age++;
  combat = 0;
  command = air_cmd();
  assignment = air_asgn();
  if (combat != 0 && command != 0) cmd++;
  if ((rank < 9 && rankeo == 'E')
    || (rankeo == 'O' && rank < 10))
  {
    if ((rankeo != 'O' || nv_promo == 0) && promo != 0)
	{
      roll = d12();
      if (branch >= 2 && edu >= 7) roll++;
      if (branch >= 5 && find_skl(MEDICAL) >= 4) roll += 2;
      if (roll >= promo)
	  {
        nv_promo++;
        rank++;
        printf("You were promoted. ");
        getrank();
        air_gen_skl();
      }
    }
  }
  adjust = nv_adj();
  decorate(adjust);
  if (assignment == 7) air_spcl_asgn();
  if (skil != 0)
  {
    roll = d12();
    if (branch == 3 && intl >= 8) roll++;
    if (roll < skil) roll = bp_skill(roll);
    if (roll >= (skil + 4)) air_gen_skl();
    if (roll >= skil) air_gen_skl();
  }
  roll = d12();
  if ((branch <= 4) && (air_mos() != 0)) roll++;
  return survive(roll, adjust);
}


int air_mos()
{
  if (branch == 1) return orbit_mos();
  if (branch == 2) return atmos_mos();
  if (branch == 3 || branch == 4) return chk_skl(CMBTRIFLMAN, 1);
  return -1;
}


int orbit_mos()
{
  int qual;

  qual = chk_skl(ELECTRONICS, 2);
  if (qual == 0) qual = chk_skl(COMPUTER, 2);
  if (qual == 0) qual = chk_skl(MECHANICAL, 2);
  if (qual == 0) qual = chk_skl(GUNCMBT, 2);
  if (qual == 0) qual = chk_skl(NAVIGATION, 2);
  if (qual == 0) qual = chk_skl(INTERPERS, 2);
  if (qual == 0) qual = chk_skl(NOGRAV, 2);
  if (qual == 0) qual = chk_skl(VACCSUIT, 2);
  if (qual != 0) return 1;
  return 0;
}


void imperial_duty()
{
  int qual;

  if (line == 1) return;
  qual = chk_skl(SHIPBOAT, 4);
  if (qual == 0) qual = chk_skl(GRAVVHCL, 4);
  if (qual == 0) qual = chk_skl(PROPAIR, 4);
  if (qual == 0) qual = chk_skl(BALLOONS, 4);
  if (qual == 0) qual = chk_skl(JETAIR, 4);
  if (qual == 0) qual = chk_skl(HELICOPTER, 4);
  if (qual != 0)
  {
    printf("You have been transfered to the Imperial COACC Advisory Group.\n");
    if (tech >= 4) branch = 1;
    else branch = 2;
    line = 1;
    nv_staff_col(1);
    air_cross_train(branch);
  }
}


int atmos_mos()
{
  int qual;

  qual = chk_skl(GUNNERY, 2);
  if (qual == 0) qual = chk_skl(COMPUTER, 2);
  if (qual == 0) qual = chk_skl(SENSOROPS, 2);
  if (qual == 0) qual = chk_skl(GUNCMBT, 2);
  if (qual == 0) qual = chk_skl(FORWARDOBS, 2);
  if (qual == 0) qual = chk_skl(SPCLCMBT, 2);
  if (qual == 0) qual = chk_skl(COMMO, 2);
  if (qual != 0) return 1;
  return 0;
}


void air_flt_sgt()
{
  int  roll;

  roll = d6();
  if (rank >= 6) roll += 3;
  switch (roll)
  {
    case 1: vc(1); break;
    case 2: gc(1); break;
    case 3: addskill(MECHANICAL, 1); break;
    case 4: addskill(ELECTRONICS, 1); break;
    case 5: addskill(MECHANICAL, 1); break;
    case 6: addskill(DEMOLITIONS, 1); break;
    case 7: addskill(INSTRUCTION, 1); break;
    case 8: addskill(LEADER, 1); break;
    case 9: addskill(ADMIN, 1); break;
  }
}


void air_cmd_off()
{
  int  roll;

  roll = d6();
  if (flight == 1) roll += 2;
  switch (roll)
  {
    case 1: addskill(HANDGUN, 1); break;
    case 2: addskill(LEADER, 1); break;
    case 3: addskill(LEADER, 1); break;
    case 4: addskill(LIAISON, 1); break;
    case 5: bumpend(); break;
    case 6: inbrn(1); break;
    case 7: addskill(TACTICS, 1); break;
    case 8: gunner(1); break;
  }
}


void air_life()
{
  int  roll;

  roll = d6();
  if (rankeo == 'O' && rank >= 4) roll += 3;
  switch (roll)
  {
    case 1: addskill(BRAWLING, 1); break;
    case 2: bumpdex(); break;
    case 3: bumpend(); break;
    case 4: addskill(CAROUSING, 1); break;
    case 5: bumpedu(); break;
    case 6: addskill(LEADER, 1); break;
    case 7: addskill(VACCSUIT, 1); break;
    case 8: addskill(HANDGUN, 1); break;
    default: bumpsoc(); break;
  }
}


void air_flt_off()
{
  int  roll;

  roll = d6();
  if (tech >= 5) roll += 2;
  switch (roll)
  {
    case 1: airc(1); break;
    case 2: gunner(); break;
    case 3: addskill(TACTICS, 1); break;
    case 4: gunner(1); break;
    case 5: addskill(NAVIGATION, 1); break;
    case 6: addskill(HANDGUN, 1); break;
    case 7: addskill(GRAVVHCL, 1); break;
    case 8: addskill(VACCSUIT, 1); break;
  }
}


void air_grnd_off()
{
  int  roll;

  roll = d6();
  switch (roll)
  {
        case 3: addskill(COMPUTER, 1); break;
        case 2: addskill(ADMIN, 1); break;
        case 1: gc(1); break;
		case 6: addskill(COMMO, 1); break;
        case 4: addskill(MECHANICAL, 1); break;
        case 5: addskill(ELECTRONICS, 1); break;
  }
}


void air_atmos()
{
  int  roll;

  roll = d6();
  if (tech >= 4) roll += 2;
  switch (roll)
  {
        case 1: airc(1); break;
        case 2: airc(1); break;
        case 3: addskill(TACTICS, 1); break;
        case 4: gunner(1); break;
        case 5: addskill(NAVIGATION, 1); break;
        case 6: gunner(1); break;
        case 7: addskill(VACCSUIT, 1); break;
        case 8: addskill(GRAVVHCL, 1); break;
  }
}


void air_staff_off()
{
  int  roll;

  roll = d6();
  switch (roll)
  {
        case 1: addskill(COMPUTER, 1); break;
        case 2: addskill(ADMIN, 1); break;
        case 3: addskill(INSTRUCTION, 1); break;
        case 4: addskill(LIAISON, 1); break;
        case 5: addskill(HANDGUN, 1); break;
        case 6: addskill(SUBMG, 1); break;
  }
}


void air_orbit()
{
  int  roll;

  roll = d6();
  switch (roll)
  {
        case 1: addskill(SHIPBOAT, 1); break;
        case 2: addskill(VACCSUIT, 1); break;
        case 3: addskill(NAVIGATION, 1); break;
        case 4: addskill(ENGINEERING, 1); break;
        case 5: addskill(SHIPTAC, 1); break;
        case 6: gunner(1); break;
  }
}


void air_sec()
{
  int  roll;

  roll = d6();
  switch (roll)
  {
        case 1: addskill(CMBTRIFLMAN, 1); break;
        case 2: addskill(HEAVYWEAP, 1); break;
        case 3: addskill(RECON, 1); break;
        case 4: addskill(CMBTRIFLMAN, 1); break;
        case 5: gunner(1); break;
        case 6: gunner(1); break;
  }
}


void air_med()
{
  int  roll;

  roll = d6();
  if (tech >= 5) roll++;
  switch (roll)
  {
        case 1: addskill(ADMIN, 1); break;
        case 2: addskill(ELECTRONICS, 1); break;
        case 3: addskill(MEDICAL, 1); break;
        case 4: addskill(COMPUTER, 1); break;
        case 5: addskill(MEDICAL, 1); break;
        case 6: addskill(ADMIN, 1); break;
        case 7: addskill(MESONGUN, 1); break;
  }
}


void air_tech()
{
  int  roll;

  roll = d6();
  if (tech >= 4) roll++;
  switch (roll)
  {
        case 1: gc(1); break;
        case 2: addskill(MECHANICAL, 1); break;
        case 3: addskill(MECHANICAL, 1); break;
        case 4: addskill(DEMOLITIONS, 1); break;
        case 5: addskill(MECHANICAL, 1); break;
        case 6: addskill(ELECTRONICS, 1); break;
        case 7: addskill(GRAVITICS, 1); break;
  }
}


void air_spcl_asgn()
{
  int roll;
  
  if (aide != 0)
  {
    aide = 0;
    roll = air_pick_sch();
  }
  else
  {
	  roll = d6();
	  if (tech >= 4) roll += 2;
	  if (age < 38 && rankeo == 'E' && (roll == 5 || roll == 7)
		  && brownie_points > 3)
	  {
		  roll = 6;
		  brownie_points--;
		  printf("You used 1 BP to get OCS.\n");
	  }
	  if (rankeo == 'E' && roll == 3 && brownie_points > 3)
	  {
		  roll++;
		  brownie_points--;
		  printf("You used 1 BP to avoid recruiting.\n");
	  }
	  if (rankeo = 'O' && flight == 1 && roll == 4 && brownie_points > 3)
	  {
		  roll--;
		  brownie_points--;
		  printf("You used 1 BP to get attache.\n");
	  }
  }
  if (rankeo == 'E')
  {
    if (age >= 38 && roll == 6)
	    air_spcl_asgn();
	else
		switch (roll)
		{
	      case 1: air_cross_train(0); break;
		  case 2: air_spcl_sch(); break;
	      case 3: merc_rcrtng(); break;
	      case 4: air_crew_sch(); break;
	      case 5: base_def_sch(); break;
		  case 6: air_ocs(); break;
		  default: air_space_sch(); break;
		}
  }
  else
  {
    if (flight == 1)
	{
      switch (roll)
	  {
        case 1: coacc_flt_sch(); break;
        case 2: air_intl_sch(); break;
        case 3: air_attache(); break;
        case 4: merc_rcrtng(); break;
        case 5: frwd_obs_sch(); break;
		case 6: air_adv_sch(); break;
        default: air_space_sch(); break;
      }
    }
	else
	{
      switch (roll)
	  {
		case 1: air_cross_train(0); break;
        case 2: coacc_flt_sch(); break;
        case 3: air_intl_sch(); break;
        case 4: base_def_sch(); break;
        case 5: nv_cmd_col(); break;
        default: nv_staff_col(); break;
      }
    }
  }
}


void air_spcl_sch()
{
  int  roll;

  gotspcldty(SPECIALISTSCH);
  if (special_duty[SPECIALISTSCH] > 1)
  {
	if ((chk_skl(MECHANICAL, 4) == 1) || (chk_skl(ELECTRONICS, 4) == 1) 
		|| (chk_skl(ORDNANCE, 4) == 1) || (chk_skl(MAINTENANCE, 4) == 1)
		|| (chk_skl(COMPUTER, 4) == 1) || (chk_skl(ENGINEERING, 4) == 1)
		|| (chk_skl(NAVIGATION, 4) == 1) || (chk_skl(PILOT, 4) == 1)
		|| (chk_skl(SENSOROPS, 4) == 1) || (chk_skl(SHIPBOAT, 4) == 1)
		|| (chk_skl(VACCSUIT, 4) == 1) || (chk_skl(HANDGUN, 4) == 1)
		|| (chk_skl(RIFLMAN, 4) == 1) || (chk_skl(SUBMG, 4) == 1)
		|| (chk_skl(ENERGYWEAP, 4) == 1) || (chk_skl(LASERWEAP, 4) == 1)
		|| (chk_skl(NEURALWEAP, 4) == 1) || (chk_skl(CMBTRIFLMAN, 4) == 1)
		|| (chk_skl(GRAVITICS, 4) == 1))
	{
		instructor(SPECIALISTSCH);
		return;
	}
  }
  roll = d6();
  if (tech >= TLEARSTEL) roll += 2;
  switch (roll)
  {
        case 1: addskill(MECHANICAL, 1); break;
        case 2: addskill(ELECTRONICS, 1); break;
        case 3: addskill(ORDNANCE, 1); break;
        case 4: addskill(MAINTENANCE, 1); break;
        case 5: addskill(COMPUTER, 1); break;
        case 6: gc(1); break;
        case 7: addskill(GRAVITICS, 1); break;
        case 8: spac(1); break;
  }
}


void air_adv_sch()
{
  int roll;

  gotspcldty(ADVAIRCMBTSCH);
  if (special_duty[ADVAIRCMBTSCH] > 1)
  {
	if ((chk_skl(TACTICS, 4) == 1) || (chk_skl(SCREENS, 4) == 1) 
		|| (chk_skl(SPINALWEAP, 4) == 1) || (chk_skl(TURRETWEAP, 4) == 1)
		|| (chk_skl(BALLOONS, 4) == 1) || (chk_skl(HELICOPTER, 4) == 1)
		|| (chk_skl(PROPAIR, 4) == 1) || (chk_skl(JETAIR, 4) == 1))
	{
		instructor(ADVAIRCMBTSCH);
		return;
	}
  }
  roll = d6();
  if (roll >= 4) airc(1);
  roll = d6();
  if (roll >= 4) addskill(TACTICS, 1);
  roll = d6();
  if (roll >= 4) gunner(1);
}


void air_space_sch()
{
  int roll;

  gotspcldty(SPACESCH);
  if (special_duty[SPACESCH] > 1)
  {
	if ((chk_skl(SHIPBOAT, 4) == 1) || (chk_skl(SCREENS, 4) == 1) 
		|| (chk_skl(SPINALWEAP, 4) == 1) || (chk_skl(TURRETWEAP, 4) == 1)
		|| (chk_skl(SHIPTAC, 4) == 1) || (chk_skl(NAVIGATION, 4) == 1)
		|| (chk_skl(VACCSUIT, 4) == 1) || (chk_skl(ENGINEERING, 4) == 1))
	{
		instructor(SPACESCH);
		return;
	}
  }
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(SHIPBOAT, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(SHIPTAC, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(NAVIGATION, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(ENGINEERING, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) gunner(1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(VACCSUIT, 1);
}


void frwd_obs_sch()
{
  int roll;

  gotspcldty(FORWARDOBSSCH);
  if (special_duty[FORWARDOBSSCH] > 1)
  {
	if ((chk_skl(FORWARDOBS, 4) == 1) || (chk_skl(SENSOROPS, 4) == 1) 
		|| (chk_skl(PROPAIR, 4) == 1) || (chk_skl(RECON, 4) == 1))
	{
		instructor(FORWARDOBSSCH);
		return;
	}
  }
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(FORWARDOBS, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(PROPAIR, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(SENSOROPS, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(RECON, 1);
}


void air_intl_sch()
{
  int roll;

  gotspcldty(INTELLIGENCESCH);
  if (special_duty[INTELLIGENCESCH] > 1)
  {
	if ((chk_skl(INTERROGATE, 4) == 1) || (chk_skl(SENSOROPS, 4) == 1) 
		|| (chk_skl(INTERVIEW, 4) == 1) || (chk_skl(RECON, 4) == 1))
	{
		instructor(INTELLIGENCESCH);
		return;
	}
  }
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(INTERROGATE, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(INTERVIEW, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(SENSOROPS, 1);
  if (rankeo == 'O' && flight == 1)
  {
    roll = bp_skill1(d6(), 4);
    if (roll >= 4) addskill(RECON, 1);
  }
}


void base_def_sch()
{
  int roll;

  gotspcldty(BASEDEFENSESCH);
  if (special_duty[BASEDEFENSESCH] > 1)
  {
	if ((chk_skl(HEAVYWEAP, 4) == 1) || (chk_skl(TACTICS, 4) == 1) 
		|| (chk_skl(SCREENS, 4) == 1) || (chk_skl(SPINALWEAP, 4) == 1)
		|| (chk_skl(TURRETWEAP, 4) == 1)
		|| (chk_skl(LEADER, 4) == 1) || (chk_skl(ATV, 4) == 1))
	{
		instructor(BASEDEFENSESCH);
		return;
	}
  }
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(HEAVYWEAP, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(TACTICS, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(LEADER, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(ATV, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) gunner(1);
}


int air_pick_sch()
{
  int choice;

  printf("As an Air Marshals Aide you can pick your next assignment.\n\n");
  printf("   1. flight school\n   2. intelligence school\n");
  printf("   3. recruiting\n   4. forward observer school\n");
  printf("   5. advanced air combat school\n");
  if (tech >= 4) printf("   6. space school\n");
  choice = getsel_int(1, 6);
  if (choice == 1) return 1;
  if (choice == 2) return 2;
  if (choice == 3) return 4;
  if (choice == 4) return 5;
  if (choice == 5) return 6;
  if (choice == 6 && tech >= 4) return 7;
  printf("Wrong - try again!\n");
  return air_pick_sch();
}


void air_attache()
{
  int roll;

  bumpsoc();
  roll = d6();
  if (roll > 4)
  {
    aide = 1;
    gotspcldty(AIDE);
    return;
  }
  gotspcldty(ATTACHE);
  if (rank >= 10) 
    printf("You were not eligible for a promotion.\n");
  else
  {
    rank++;
    nv_promo++;
    printf("You were promoted.\n");
  }
}


void air_ocs()
{
  gotspcldty(OCS);
  rankeo = 'O';
  if (rank < 7) rank = 1;
  if (rank == 7) rank = 2;
  if (rank >= 8) rank = 3;
  if (flight == 1) air_flt_off();
  else air_grnd_off();
  if (rank < 3) air_staff_off();
  if (rank < 2) air_branch_tbl(branch);
}


void air_crew_sch()
{
  int roll;

  gotspcldty(AIRCREWSCH);
  if (special_duty[AIRCREWSCH] > 1)
  {
	if ((chk_skl(NAVIGATION, 4) == 1) || (chk_skl(SENSOROPS, 4) == 1) 
		|| (chk_skl(SCREENS, 4) == 1) || (chk_skl(SPINALWEAP, 4) == 1)
		|| (chk_skl(TURRETWEAP, 4) == 1))
	{
		instructor(AIRCREWSCH);
		return;
	}
  }
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(NAVIGATION, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(SENSOROPS, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) gunner(1);
}


void air_gen_skl()
{
  int roll;

  if (pick <= 2)
  {
    air_pick_tbl();
    return;
  }
  roll = d6();
  if (rankeo == 'O' || (rankeo == 'E' && rank >= 5))
  {
    if (roll == 6) roll = 3;
    if (roll == 5) roll = 2;
    if (rankeo == 'E' && roll == 4) roll = 2; 
  }
  else
  {
    roll = d3();
    if (roll == 3) roll = 2;
  }
  if (roll == 1) air_life();
  if (roll == 2) air_branch_tbl(branch);
  if (roll == 3)
  {
    if (rankeo == 'E') air_flt_sgt();
    else
	{
      if (flight == 1) air_flt_off();
      else air_grnd_off();
    }
  }
  if (roll == 4)
  {
    if (command == 1) air_cmd_off();
    else air_staff_off();
  }
}


void air_pick_tbl()
{
  int choice;

  printf("\nPlease select the table you wish to use for your new skill.\n");
  printf("\n   1. Flyer life\n");   
  air_branch(branch);
  printf("   2. The table for %s\n", office); 
  if (rankeo == 'E' && rank >= 5) printf("   3. Flight Sargent\n");
  if (rankeo == 'O')
  {
    if (flight == 1) printf("   3. Flight Officer\n");
    else printf("   3. Ground Officer\n");
  }
  if (rankeo == 'O')
  {
    if (command == 1) printf("   4. Command Officer\n");
    else printf("   4. Staff Officer\n");
  }
  choice = getsel_int(1, 4);
  if (rankeo == 'E' && ((rank < 5 && choice >= 3) || choice == 4))
  {
    printf("Wrong - try again!\n");
    air_pick_tbl();
    return;
  }
  switch (choice) {
    case 1: air_life(); break;
    case 2: air_branch_tbl(branch); break;
    case 3:
		{
      if (rankeo == 'E') air_flt_sgt();
      else
        if (flight == 1) air_flt_off();
        else air_grnd_off();
      }
      break;
    case 4:
		{
      if (command == 1) air_cmd_off();
      else
        air_staff_off();
      }
      break;
  }
}


int air_asgn()
{
  int roll;

  combat = 0;
  if (aide == 1)
  {
    printf("You were assigned to special duty.\n");
    skil = surv = decor = promo = aide = 0;
    return 7;
  }
  roll = d6();
  if (roll == 6 && assignment != 0)
  {
    printf("You were allowed to repeat your last assignment.\n");
    if (assignment >=4 && assignment <= 6)
	{
      combat = 1;
      cmbt++;
    }
    return assignment;
  }
  roll = d12();
  /* use a brownie point to get special duty */
  if (pick == 1 && brownie_points > 0)
	  roll = ask_adj_asgn(roll);
  else
  {
	  if (pick == 4)
	  {
		  roll = bp_spcl_duty(roll);
		  if (((roll == 8 && branch <= 2) || (roll == 9 && branch > 2)) && brownie_points > 3)
		  {
			  roll++;
			  bp_cmbt();
		  }
	  }
  }
  printf("This is a ");
  if (roll <= 3 || (branch <= 2 && roll == 9)
	  || (branch > 2 && roll == 10))
  {
    if (flight == 1 && branch <= 2) printf("combat");
    else printf("base defence");
    printf(" assignment.\n");
    cmbt++;
    combat = 1;
    skil = 8;
    surv = 6;
    decor = 10;
    promo = 6;
    switch (branch)
	{
      case 1: skil = 6; surv = 7; decor = 6; break;
      case 2: skil = 6; decor = 6; break;
      case 3: promo = 8; break;
      case 4: surv = 7; decor = 8; break;
      case 5: surv = 4; promo = 8; break;
    }
    if (branch <= 2) return 6;
    else return 4;
  }
  if ((branch <= 2 && flight == 1 && (roll == 5 || roll == 7))
	  || ((branch > 2 || flight != 1)
	  && (roll == 5 || roll == 6 || roll == 8)))
  {
    if (branch <= 2)
	{
      if (flight == 1) printf("transport");
      else printf("support");
    }
	else printf("base operations");
    printf(" assignment.\n");
    decor = 12;
    skil = 10;
    surv = 4;
    promo = 10;
    if (branch == 1) surv = 3;
    if (branch == 2)
	{
      decor = 11;
      skil = 8;
    }
    if (branch == 3)
	{
      surv = 0;
      skil = 7;
    }
    if (branch == 4)
	{
      decor = 10;
      promo = 8;
      skil = 8;
    }
    if (branch == 5) surv = 0;
    if (branch <= 2) return 2;
    else return 3;
  }
  if ((branch <= 2 && flight == 1 && (roll == 6 || roll == 8)) ||
    ((branch > 2 || flight != 1) && (roll == 4 || roll == 7 || roll == 9)))
  {
    printf("training assignment.\n");
    decor = 0;
    skil = 6;
    surv = 0;
    promo = 6;
    if (branch <= 2) surv = 4;
    if (branch == 3) promo = 8;
    if (branch == 4)
	{
      surv = 3;
      skil = 7;
    }
    if (branch == 5)
	{
      promo = 8;
      skil = 7;
    }
    return 1;
  }
  if (roll == 4 || roll == 10)
  {
    printf("strike assignment.\n");
    cmbt++;
    combat = 1;
    promo = 8;
    skil = 8;
	surv = 6;
	decor = 10;
    switch (branch)
	{
      case 1: surv = 4; break; 
      case 2: decor = 9; break; 
    }
    return 5;
  }
  printf("special duty assignment.\n");
  skil = surv = promo = decor = 0;
  return 7;
}


int air_cmd()
{
  int  roll;
  char choice;

  if (rankeo == 'E') return 0;
  if (aide == 1)
  {
    printf("As an Admirals Aide you have the option to take a command\n");
    printf("assignment this year automaticly. Do you want to?");
    choice = getche_y_n();
    if (choice == 'Y' || choice == 'y')
	{
      aide = 0;
      return 1;
    }
  }
  roll = d12();
  if ((branch == 1 || branch == 4) && roll >= 8) return 1;
  if (roll >= 7 && branch == 2) return 1;
  if (roll >= 9 && branch == 3) return 1;
  if (roll >= 10 && branch == 5) return 1;
  return 0;
}


void air_off_init()
{
  int roll;

  if (pick >= 3)
  {
    roll = d6();
    if (roll <= 3) air_staff_off();
    else air_branch_tbl(branch);
  }
  else
  {
    printf("Your initial skills can come from the following tables.\n\n");
    printf("   1. the skills table for your branch\n   2. staff officer\n");
    roll = getsel_int(1, 2);
    if (roll == 1)
	{
      air_branch_tbl(branch);
    }
	else
	{
      if (roll == 2)
	  {
        air_staff_off();
      }
    }
  }
}


void air_cross_train(int choice)
{
  int  roll;

  printf("You got cross-training.\n");
  roll = 0;
  if (choice >= 1 && choice <= 5) roll = choice;
  if (pick >= 3) roll = d5();
  if (roll != 0)
  {
    nv_cross[roll]++;
    air_branch_tbl(roll);
    return;
  }
  printf("You have the option to get cross-training in any field. Pick one.\n");
  printf("\n   1. orbit");
  if (nv_cross[1] > 0) printf("*");
  printf("\n   2. atmosphere");
  if (nv_cross[2] > 0) printf("*");
  printf("\n   3. technical");
  if (nv_cross[3] > 0) printf("*");
  printf("\n   4. security");
  if (nv_cross[4] > 0) printf("*");
  printf("\n   5. medical");
  if (nv_cross[5] > 0) printf("*");
  printf("\n\n* = already cross-trained in this branch\n");
  roll = getsel_int(1, 5);
  air_branch_tbl(roll);
  nv_cross[roll]++;
}


void air_branch(int branch_nbr)
{
  switch (branch_nbr)
  {
    case 1: strncpy(office,"Orbit",6); break;
    case 2: strncpy(office,"Atmosphere",11); break; 
    case 3: strncpy(office,"Technical",10); break; 
    case 4: strncpy(office,"Security",9); break; 
    case 5: strncpy(office,"Medical",8); break; 
    default: strncpy(office,"unknown?",9); break;
  }
}


void air_branch_tbl(int brnch)
{
  switch (brnch)
  {
    case 1: air_orbit(); break;
    case 2: air_atmos(); break;
    case 3: air_tech(); break;
    case 4: air_sec(); break;
    case 5: air_med(); break;
  }
}
