/* COP.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void cop();
void copmot(int term);
void copbene();
void copskills(int skills);
void cop_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpdex();
extern void bumpsoc();
extern void bumpintl();
extern void mentl(int skl_val);
extern void hc(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void gc(int skl_val);
extern void econ(int skl_val);
extern void physicl(int skl_val);
extern void inbrn(int skl_val);
extern void env(int skl_val);
extern void techl(int skl_val);
extern void vc(int skl_val);
extern void bc(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_weapon();
extern void mot_tas();
extern void mot_forensickit();


#include "chargen.h"

void cop()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm == 0) {
    skills = basic_spec_duty(4);
    newterm = basic_surv(6, intl, 7);
    if (newterm == 0) {
      skills += basic_comm(6, edu, 7);
      skills += basic_promo(8, edu, 8);
    }
    skills = specskl(skills);
    if (skills != 0) copskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  terms = terms - anagathics;
  copmot(terms);
}


void copmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 2000; break;
        case 3: amt = 5000; break;
        case 4: amt = 7500; break;
        case 5: amt = 10000; break;
        case 6: amt = 25000; break;
        case 7: amt = 50000; break;
      }
	  mot_cash(amt);
    } 
	else
	{
        copbene();
        term--;
    }
  }
  while (term > 0)
  {
    copbene();
    term--;
  }
}


void copbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: mot_forensickit(); break;
    case 3: bumpintl(); break;
    case 4: mot_weapon(); break;
    case 5: mot_hipsg(); break;
    case 6: bumpsoc(); break;
    case 7: mot_tas(); break;
  }
}


void copskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      if (race == DOLPHINS && roll == 5) roll = 6;
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: mentl(1); break;
        case 4: hc(1); break;
        case 5: addskill(GAMBLING, 1); break;
        case 6: vc(1); break;
      }
    }
    if (table == 2) {
      cop_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: vc(1); break;
        case 2: addskill(FORENSIC, 1); break;
        case 3: env(1); break;
        case 4: addskill(TACTICS, 1); break;
        case 5: techl(1); break;
        case 6: addskill(INTERROGATE, 1); break;
      }
    }
    if (table == 4) {
      if (race == DOLPHINS && roll == 1) roll = 3;
      switch (roll) {
        case 1: addskill(LEGAL, 1); break;
        case 2: addskill(FORENSIC, 1); break;
        case 3: addskill(INTERVIEW, 1); break;
        case 4: econ(1); break;
        case 5: interp(1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}


void cop_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll)
	  {
        case 1: addskill(STREETWISE, 1); break;
        case 2: inbrn(1); break;
        case 3: gc(1); break;
        case 4: vhcl(1); break;
        case 5: hc(1); break;
        case 6: bc(1); break;
      }
}


