/* DARNAVY.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void darnavy();
void darfltsch();
int darnv_set_branch();
int darnv_doterms();
int darnv_do_year();
int dartechmos();
int darln_mos();
void darnavymot(int term);
void darnavybene();
void darnv_sa();
void darnv_tech();
void darnv_shore_duty();
void darnv_ship_duty();
void darnv_spcl_asgn();
void darnv_tech_sch();
void darnv_ocs();
void darnv_spcl_sch();
int darnv_asgn();
int darnv_asgnroll();
int darnv_cmd();
void darnv_cross_train();

extern int nv_get_branch();
extern int nv_do_initial();
extern int nv_adj();
extern int nv_xfer();
extern int anag();
extern void adv_aging(int anags);
extern int getrank();
extern int survive(int adjust, int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int d12();
extern int getsel_int(int min, int max);
extern char getche_y_n();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern int bp_adj(int roll, int nbr);
extern int bp_skill(int roll);
extern int bp_skill1(int roll, int need_nbr);
extern int reenlist(int need_nbr);
extern void decorate(int adjust);
extern int find_skl(int skill);
extern void nv_gen_skl();
extern int ln_mos();
extern void nv_attache();
extern void nv_gun_sch();
extern void nv_engr_sch();
extern void nv_intl_sch();
extern void bumpdex();
extern void nv_cmd_col();
extern void nv_staff_col();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void bc(int skl_val);
extern void nv_branch(int branch);
extern int darasgnroll();
extern void nv_branch_tbl(int roll);
extern void vhcl(int skl_val);
extern void bp_add(int amt);
extern void gotspcldty(int spcldutynbr);
extern void merc_rcrtng();
extern int ask_adj_asgn(int roll);
extern void instructor(int spcldutynbr);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_voucher();

#include "chargen.h"


void darnavy()
{
  int i;

  for (i = 1; i <= 9; i++)
    nv_cross[i] = 0;
  aide = 0;
  command = 0;
  combat = 0;
  assignment = 0;
  if (rankeo == 'O') darfltsch();
  nv_get_branch();
  nv_do_initial();
  while (darnv_doterms() == 0);
  terms = terms - anagathics;
  darnavymot(terms);
}


void darfltsch()
{
  int roll, choice;

  printf("You have the option to go to flight school. Do you wish to?");
  choice = getche_y_n();
  if (choice == 'n' || choice == 'N') return;
  roll = d12();
  if (dex >= 9) roll += 2;
  if (roll < 7 && brownie_points > 1) roll = bp_adj(roll, 9);
  if (roll < 9)
  {
    printf("You were not accepted into flight school, sorry.\n");
    return;
  }
  printf("Congratulations! You were accepted into flight school.\n");
  roll = d12();
  if (intl >= 8) roll += 2;
  if (roll < 7 && brownie_points > 1) roll = bp_adj(roll, 7);
  if (roll < 7)
  {
    printf("Sorry, you did not pass flight school.\n");
    age++;
    appearent_age++;
    return;
  }
  printf("Congrats! You passed flight school.\n");
  branch = 2;
  roll = d6();
  rank++;
  if (roll >= 4) rank++;
  printf("You were promoted to %c%d.\n", rankeo, rank);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(PILOT, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(PILOT, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(PILOT, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(NAVIGATION, 1);
}


int darnv_set_branch()
{
  int roll;

  if (branch != 0) return branch;
  roll = d6();
  if (tech >= 6) roll += 2;
  if (roll <= 2) {
    return 4;
  }
  if (roll == 3) {
    return 3;
  }
  if (roll == 4) {
    return 6;
  }
  return 1;
}


int darnv_doterms()
{
  int survival, need_nbr;
  
  adv_aging(nv_anag);
  do {
    survival = darnv_do_year();
  } while (((age % 4) != 2) && (survival == 0));
  if (survival != 0) return 1;
  need_nbr = 5;
  if (rankeo == 'E') need_nbr -= 2;
  survival = reenlist(need_nbr);
  if (survival != 0) return 1; 
  drafted = 0;
  branch = nv_xfer();
  nv_anag = anag();
  return 0;
}


int darnv_do_year()
{
  int   adjust, roll;
  
  age++;
  if (nv_anag == 0) appearent_age++;
  command = darnv_cmd();
  assignment = darnv_asgn();
  if (combat != 0 && command != 0) cmd++;
  if ((rank < 9 && rankeo == 'E') 
    || ((rankeo == 'O') && ((line == 1 && rank < 8)
    || (line == 2 && rank < 7)))) {
    if (promo != 0) {
      roll = d12();
      if ((branch == 1 && command == 1) || (branch >= 3 && dex >= 9)
        || (branch == 4 && find_skl(ENGINEERING) >= 4) 
        || (branch == 6 && dartechmos() >= 3)) roll++;
      if (roll >= promo) {
        rank++;
        printf("You were promoted. ");
        getrank();
        nv_gen_skl();
      }
    }
  }
  adjust = nv_adj();
  decorate(adjust);
  if (assignment == 7) darnv_spcl_asgn();
  if (skil != 0) {
    roll = d12();
    if (roll < skil) roll = bp_skill(roll);
    if (roll >= (skil + 4)) nv_gen_skl();
    if (roll >= skil) nv_gen_skl();
  }
  roll = d12();
  if (branch == 1 && ln_mos() != 0)
	  roll++;
  if (branch == 2 && find_skl >= 0)
	  roll += find_skl(PILOT);
  return survive(roll, adjust);
}


int dartechmos()
{
  int skl, highskl;

  highskl = 0;
  skl = find_skl(COMPUTER);
  if (skl > highskl) highskl = skl;
  skl = find_skl(HANDYMAN);
  if (skl > highskl) highskl = skl;
  skl = find_skl(GRAVITICS);
  if (skl > highskl) highskl = skl;
  skl = find_skl(ELECTRONICS);
  if (skl > highskl) highskl = skl;
  skl = find_skl(MECHANICAL);
  if (skl > highskl) highskl = skl;
  return highskl;
}


int darln_mos()
{
  int qual;

  qual = chk_skl(SHIPBOAT, 2);
  if (qual == 0) qual = chk_skl(PILOT, 2);
  if (qual == 0) qual = chk_skl(SHIPTAC, 2);
  if (qual == 0) qual = chk_skl(GUNCMBT, 2);
  if (qual == 0) qual = chk_skl(LEADER, 2);
  if (qual == 0) qual = chk_skl(VEHICLE, 2);
  if (qual == 0) qual = chk_skl(FLEETTAC, 2);
  if (qual != 0) return 1;
  return 0;
}


void darnavymot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 2000; break;
        case 3: amt = 2000; break;
        case 4: amt = 5000; break;
        case 5: amt = 10000; break;
        case 6: amt = 20000; break;
        case 7: amt = 30000; break;
      }
	  mot_cash(amt);
    } 
	else
	{
        term--;
        darnavybene();
    }
  }
  while (term > 0)
  {
    darnavybene();
    term--;
  }
}


void darnavybene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: bumpsoc(); break;
    case 2: bumpintl(); break;
    case 3: bumpedu(); bumpedu(); break;
    case 4: mot_weapon(); break;
    case 5: mot_voucher(); break;
    case 6: mot_voucher(); break;
    case 7: bumpsoc(); bumpsoc(); break;
  }
}


void darnv_sa()
{
  int  roll;

  roll = d6();
  if (line == 1) roll += 2;
  switch (roll) {
        case 1: addskill(ADMIN, 1); break;
        case 2: addskill(HANDYMAN, 1); break;
        case 3: addskill(SHIPTAC, 1); break;
        case 4: addskill(COMMO, 1); break;
        case 5: addskill(MEDICAL, 1); break;
        case 6: addskill(COMPUTER, 1); break;
        case 7: addskill(NAVIGATION, 1); break;
        case 8: addskill(FLEETTAC, 1); break;
  }
}


void darnv_tech()
{
  int  roll;

  roll = d6();
  if (line == 1) roll += 2;
  if (line == 2) roll++;
  switch (roll) {
        case 1: addskill(MECHANICAL, 1); break;
        case 2: addskill(ELECTRONICS, 1); break;
        case 3: addskill(GRAVITICS, 1); break;
        case 7: addskill(HANDYMAN, 1); break;
        default: addskill(COMPUTER, 1); break;
  }
}


void darnv_shore_duty()
{
  int  roll;

  roll = d6();
  if (rankeo == 'O') roll += 4;
  switch (roll) {
        case 1: addskill(BRAWLING, 1); break;
        case 2: vhcl(1); break;
        case 3: addskill(FORWARDOBS, 1); break;
        case 4: addskill(VACCSUIT, 1); break;
        case 5: addskill(LIAISON, 1); break;
        case 6: vhcl(1); break;
        case 7: addskill(FORWARDOBS, 1); break;
        case 8: addskill(SURVIVAL, 1); break;
        case 9: addskill(VACCSUIT, 1); break;
        case 10: addskill(BATTLEDRESS, 1); break;
  }
}


void darnv_ship_duty()
{
  int  roll;

  roll = d6();
  if (rankeo == 'O') roll += 4;
  switch (roll) {
        case 1: bumpdex(); break;
        case 2: addskill(NOGRAV, 1); break;
        case 3: addskill(MECHANICAL, 1); break;
        case 4: bc(1); break;
        case 5: addskill(SHIPBOAT, 1); break;
        case 6: addskill(VACCSUIT, 1); break;
        case 7: addskill(NOGRAV, 1); break;
        case 8: addskill(COMMO, 1); break;
        case 9: addskill(HANDYMAN, 1); break;
        case 10: addskill(ADMIN, 1); break;
  }
}


void darnv_spcl_asgn()
{
  int roll;
  
  roll = d6();
  if (edu >= 7) roll += 2;
  if (roll == 1)
  {
    if (rankeo == 'E') 
      darnv_spcl_sch();
    else
      nv_attache();
  }
  if (roll == 2) merc_rcrtng();
  if (rankeo == 'E')
  {
    if (roll == 3) nv_gun_sch();
    if (roll == 4) darnv_tech_sch();
    if (roll == 5) nv_engr_sch();
    if (roll == 6) darnv_cross_train();
    if (roll == 7) darnv_ocs();
    if (roll == 8) darnv_spcl_sch();
  }
  else
  {
    if (roll == 3) nv_intl_sch();
    if (roll == 4) nv_cmd_col();
    if (roll == 6 || roll == 5) nv_staff_col();
    if (roll >= 7) darnv_cross_train();
  }
}


void darnv_tech_sch()
{
  int roll;

  gotspcldty(TECHSCH);
  if (special_duty[TECHSCH] > 1)
  {
	if ((chk_skl(MECHANICAL, 4) == 1) || (chk_skl(ELECTRONICS, 4) == 1) 
		|| (chk_skl(GRAVITICS, 4) == 1))
	{
		instructor(TECHSCH);
		return;
	}
  }
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(MECHANICAL, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(ELECTRONICS, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(GRAVITICS, 1);
}


void darnv_ocs()
{
  char fleet[20];

  gotspcldty(OCS);
  rankeo = 'O';
  rank = 0;
  branch = nv_xfer();
  nv_branch(branch);
  if (line == 1) strncpy(fleet, "Confederation Navy", 19);
  if (line == 3) strncpy(fleet, "Planetary Navy", 15);
  printf("Your new assignment is with the %s branch of the %s.\n", 
    office, fleet);
}


void darnv_spcl_sch()
{
  int roll;

  gotspcldty(SPECIALISTSCH);
  roll = d6();
  if (rankeo == 'O') roll += 4;
  switch (roll) {
      case 1: addskill(MEDICAL, 1); break;
      case 2: addskill(COMPUTER, 1); break;
      case 3: addskill(LIAISON, 1); break;
      case 4: addskill(ADMIN, 1); break;
      case 5: addskill(MECHANICAL, 1); break;
      case 6: vhcl(1); break;
      case 7: addskill(SHIPBOAT, 1); break;
      case 8: addskill(ELECTRONICS, 1); break;
      case 9: addskill(NAVIGATION, 1); break;
      case 10: addskill(GRAVITICS, 1); break;
  }
}


int darnv_asgn()
{
  int roll;

  combat = 0;
  roll = d6();
  if (roll == 6 && assignment != 0)
  {
    printf("You were allowed to repeat your last assignment.\n");
    if (assignment > 3 && assignment < 7)
	{
      combat = 1;
      cmbt++;
    }
    return assignment;
  }
  skil = surv = decor = promo = 0;
  return darasgnroll();
}


int darasgnroll()
{
  int roll;

  roll = d12();
  if (rankeo == 'E' && edu >= 6) roll--; 
  if (pick == 1 && brownie_points > 0)
	  roll = ask_adj_asgn(roll);
  if (branch == 5 && (roll <= 2 || roll == 7 || roll == 10)) return darasgnroll();
  if (pick == 4)
  {
	  if (roll <= 2 && brownie_points > 3) roll = bp_adj(roll, 3);
	  if (roll == 10 && brownie_points > 3) roll = bp_adj(roll, 11);
  }
  printf("This is a ");
  if (roll >= 11)
  {
    printf("battle assignment.\n");
    cmbt++;
    combat = 1;
    switch (branch)
	{
      case 2: skil = 5; surv = 4; decor = 8; promo = 10; break;
      case 3: skil = 5; surv = 6; decor = 7; promo = 7; break;
      case 4: skil = 4; surv = 5; decor = 7; promo = 7; break;
      case 6: skil = 6; surv = 8; decor = 8; promo = 6; break;
      default: skil = 4; surv = 6; decor = 6; promo = 7; break;
    }
    return 6;
  }
  if (roll == 7)
  {
    printf("training assignment.\n");
    skil = 6;
    if (branch == 2) surv = 3;
    if (branch == 3) skil = 7;
    return 1;
  }
  if (roll <= 2 || roll == 10)
  {
    printf("shore duty assignment.\n");
    switch (branch)
	{
      case 2: surv = 3; promo = 12; break;
      case 3: surv = 3; decor = 12; break;
      case 4: skil = 7; break;
      case 6: surv = 3; skil = 7; promo = 9; break;
      default: surv = 4; skil = 6; decor = 12; break;
    }
    return 2;
  }
  if (roll == 4)
  {
    printf("seige assignment.\n");
    cmbt++;
    combat = 1;
    switch (branch)
	{
      case 2: skil = 6; surv = 3; promo = 11; decor = 9; break; 
      case 3: skil = 4; surv = 5; promo = 9; decor = 10; break; 
      case 4: skil = 6; surv = 4; decor = 11; promo = 9; break;
      case 6: skil = 6; surv = 3; promo = 9; break;
      default: skil = 5; surv = 5; promo = 9; decor = 10; break; 
    }
    return 4;
  }
  if (roll == 9 || roll == 5) {
    printf("strike assignment.\n");
    cmbt++;
    combat = 1;
    switch (branch) {
      case 2: skil = 6; surv = 3; promo = 10; decor = 9; break; 
      case 3: skil = 5; surv = 5; promo = 8; decor = 9; break; 
      case 4: skil = 5; surv = 5; promo = 7; decor = 7; break;
      case 6: skil = 6; surv = 3; promo = 8; decor = 9; break;
      default: skil = 4; surv = 6; promo = 8; decor = 7; break; 
    }
    return 5;
  }
  if (roll == 6 || roll == 8) {
    printf("patrol assignment.\n");
    switch (branch) {
      case 2: skil = 6; surv = 3; promo = 12; decor = 10; break; 
      case 3: skil = 6; surv = 4; promo = 9; decor = 11; break; 
      case 4: skil = 5; surv = 3; promo = 6; decor = 12; break;
      case 6: skil = 8; surv = 3; promo = 10; break;
      default: skil = 5; surv = 4; promo = 8; decor = 11; break; 
    }
    return 3;
  }
  printf("special duty assignment.\n");
  return 7;
}


int darnv_cmd()
{
  int  roll;

  if (rankeo == 'E' || rank == 0) return 0;
  roll = d12();
  if (rank <= 2) roll--;
  if (soc >= 10) roll += 2;
  if (edu >= 9) roll++;
  if (branch == 6) roll++;
  if (roll >= (6 + branch)) {
    return 1;
  }
  return 0;
}


void darnv_cross_train()
{
  int  roll;

  printf("You got cross-training.\n");
  if (pick >= 3) {
    roll = d6();
	if (roll == 5) roll = 1;
    nv_cross[roll]++;
    nv_branch_tbl(roll);
    return;
  }
  printf("You have the option to get cross-training in any field. Pick one.\n");
  printf("\n   1. line/crew");
  if (nv_cross[1] > 0) printf("*");
  printf("\n   2. flight");
  if (nv_cross[2] > 0) printf("*");
  printf("\n   3. gunnery");
  if (nv_cross[3] > 0) printf("*");
  printf("\n   4. engineering");
  if (nv_cross[4] > 0) printf("*");
  printf("\n   5. technical");
  if (nv_cross[6] > 0) printf("*");
  printf("\n\n* = already cross-trained in this branch\n");
  roll = getsel_int(1, 5);
  nv_branch_tbl(roll);
  if (roll == 5) roll++;
  nv_cross[roll]++;
}
