/* DARNOBLE.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void darnoble();
void darnoblemot(int term);
void darnoblebene();
void darnobleskills(int skills);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpdex();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void bumpstr();
extern void bumpend();
extern int darpicktable();
extern void bc(int skl_val);
extern void vhcl(int skl_val);
extern void gc(int skl_val);
extern void mot_cash(int amt);
extern void mot_voucher();
extern void mot_ship();

#include "chargen.h"

void darnoble()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(5);
    if (terms == 1) skills++;
    newterm = basic_surv(5, intl, 8);
    if (newterm == 0) {
      skills += basic_comm(9, intl, 9);
      skills += basic_promo(9, intl, 8);
    }
    if (skills != 0) darnobleskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  terms = terms - anagathics;
  darnoblemot(terms);
}


void darnoblemot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 5000; break;
        case 2: amt = 50000; break;
        case 3: amt = 10000; break;
        case 4: amt = 10000; break;
        case 5: amt = 20000; break;
        case 6: amt = 20000; break;
        case 7: amt = 40000; break;
      }
	  mot_cash(amt);
    } 
	else
	{
        term--;
        darnoblebene();
    }
  }
  while (term > 0)
  {
    darnoblebene();
    term--;
  }
}


void darnoblebene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: bumpsoc(); break;
    case 2: bumpintl(); bumpintl(); break;
    case 3: bumpedu(); bumpedu(); break;
    case 4: bumpsoc(); bumpsoc(); break;
    case 5: mot_voucher(); break;
    case 6: mot_voucher(); break;
    case 7: mot_ship(); break;
  }
}


void darnobleskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = darpicktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: bumpstr(); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: bumpintl(); break;
        case 5: bumpedu(); break;
        case 6: bumpedu(); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: vhcl(1); break;
        case 2: bc(1); break;
        case 3: gc(1); break;
        case 4: addskill(ADMIN, 1); break;
        case 5: addskill(ADMIN, 1); break;
        case 6: addskill(COMPUTER, 1); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: gc(1); break;
        case 2: addskill(ADMIN, 1); break;
        case 3: addskill(LIAISON, 1); break;
        case 4: addskill(STREETWISE, 1); break;
        case 5: addskill(LIAISON, 1); break;
        case 6: addskill(COMPUTER, 1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: addskill(ADMIN, 1); break;
        case 2: addskill(COMPUTER, 1); break;
        case 3: addskill(LEADER, 1); break;
        case 4: addskill(MEDICAL, 1); break;
        case 5: addskill(HANDYMAN, 1); break;
        case 6: addskill(LIAISON, 1); break;
      }
    }
    skills--;
  }
}
