/* DIPLOMAT.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void diplomat();
void diplomatmot(int term);
void diplomatbene();
void diplomatskills(int skills);
void diplomat_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void physicl(int skl_val);
extern void bumpsoc();
extern void bumpedu();
extern void bumpintl();
extern void mentl(int skl_val);
extern void bc(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void gc(int skl_val);
extern void econ(int skl_val);
extern void acad(int skl_val);
extern void inbrn(int skl_val);
extern void techl(int skl_val);
extern void vc(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_weapon();
extern void mot_hipsg();
extern void mot_tas();

#include "chargen.h"

void diplomat()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm == 0) {
    skills = basic_spec_duty(5);
    newterm = basic_surv(4, edu, 9);
    if (newterm == 0) {
      skills += basic_comm(5, intl, 8);
      skills += basic_promo(10, soc, 10);
    }
    skills = specskl(skills);
    if (skills != 0) diplomatskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(5);
  }
  terms = terms - anagathics;
  diplomatmot(terms);
}


void diplomatmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 2000; break;
        case 2: amt = 5000; break;
        case 3: amt = 10000; break;
        case 4: amt = 10000; break;
        case 5: amt = 10000; break;
        case 6: amt = 20000; break;
        case 7: amt = 30000; break;
      }
	  mot_cash(amt);
    } 
	else 
	{
        diplomatbene();
        term--;
    }
  }
  while (term > 0)
  {
    diplomatbene();
    term--;
  }
}


void diplomatbene()
{
  int roll;

  roll = basic_bene();
  switch (roll) {
    case 1: mot_lopsg(); break;
    case 2: bumpintl(); break;
    case 3: bumpedu(); break;
    case 4: mot_weapon(); break;
    case 5: mot_hipsg(); break;
    case 6: bumpsoc(); break;
    case 7: mot_tas(); break;
  }
}


void diplomatskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpedu(); break;
        case 3: mentl(1); break;
        case 4: bc(1); break;
        case 5: inbrn(1); break;
        case 6: gc(1); break;
      }
    }
    if (table == 2) {
      diplomat_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: vc(1); break;
        case 2: addskill(STREETWISE, 1); break;
        case 3: inbrn(1); break;
        case 4: addskill(INTERROGATE, 1); break;
        case 5: econ(1); break;
        case 6: addskill(RECRUITING, 1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: bumpsoc(); break;
        case 2: addskill(LIAISON, 1); break;
        case 3: techl(1); break;
        case 4: acad(1); break;
        case 5: interp(1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}


void diplomat_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: addskill(VACCSUIT, 1); break;
        case 2: mentl(1); break;
        case 3: vhcl(1); break;
        case 4: vhcl(1); break;
        case 5: vc(1); break;
        case 6: addskill(COMPUTER, 1); break;
      }
}
