/* DOC.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void doc();
void docmot(int term);
void docbene();
void docskills(int skills);
void doc_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpend();
extern void bumpstr();
extern void bumpedu();
extern void bumpdex();
extern void mentl(int skl_val);
extern void bc(int skl_val);
extern void sci(int skl_val);
extern void interp(int skl_val);
extern void econ(int skl_val);
extern void acad(int skl_val);
extern void techl(int skl_val);
extern void vc(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_weapon();
extern void mot_midpsg();
extern void mot_medkit();
extern void mot_tas();

#include "chargen.h"

void doc()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(6);
    newterm = basic_surv(4, intl, 8);
    if (newterm == 0) {
      skills += 2;
    }
    skills = specskl(skills);
    if (skills != 0) docskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(4);
  }
  terms = terms - anagathics;
  docmot(terms);
}


void docmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 20000; break;
        case 2: amt = 20000; break;
        case 3: amt = 20000; break;
        case 4: amt = 30000; break;
        case 5: amt = 40000; break;
        case 6: amt = 60000; break;
        case 7: amt = 100000; break;
      }
	  mot_cash(amt);
    } 
	else
	{
      if (choice == 'B' || choice == 'b')
	  {
        docbene();
        term--;
      } 
	  else
	  {
        printf("Wrong - try again!\n");
      }
    }
  }
  while (term > 0)
  {
    docbene();
    term--;
  }
}


void docbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpedu(); break;
    case 3: bumpedu(); break;
    case 4: mot_weapon(); break;
    case 5: mot_midpsg(); break;
    case 6: mot_medkit(); break;
    case 7: mot_tas(); break;
  }
}


void docskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: bumpstr(); break;
        case 2: bumpedu(); break;
        case 3: mentl(1); break;
        case 4: bumpdex(); break;
        case 5: bumpend(); break;
        case 6: soc++; break;
      }
    }
    if (table == 2) {
      doc_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: acad(1); break;
        case 2: addskill(MECHANICAL, 1); break;
        case 3: techl(1); break;
        case 4: addskill(ELECTRONICS, 1); break;
        case 5: addskill(MEDICAL, 1); break;
        case 6: addskill(MEDICAL, 1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: sci(1); break;
        case 2: addskill(MEDICAL, 1); break;
        case 3: mentl(1); break;
        case 4: econ(1); break;
        case 5: interp(1); break;
        case 6: acad(1); break;
      }
    }
    skills--;
  }
}


void doc_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: addskill(MEDICAL, 1); break;
        case 2: techl(1); break;
        case 3: bc(1); break;
        case 4: bumpdex(); break;
        case 5: vc(1); break;
        case 6: addskill(MEDICAL, 1); break;
      }
}
