/* ENTERTNR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <string.h>

void entertain();
void entertainmot(int term);
void entertainbene();
void entertainskills(int skills);
void entertain_tbl(int roll);
void gotentertain();

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void physicl(int skl_val);
extern void bumpstr();
extern void bumpend();
extern void bumpdex();
extern void bumpsoc();
extern void animal(int skl_val);
extern void hc(int skl_val);
extern void mc(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void influ(int skl_val);
extern void arts(int skl_val);
extern void explore(int skl_val);
extern void inbrn(int skl_val);
extern void spac(int skl_val);
extern void vc(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_ship();
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_tas();

#include "chargen.h"

void entertain()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm == 0)
  {
    skills = basic_spec_duty(6);
    newterm = basic_surv(4, soc, 8);
    if (newterm == 0) skills += 2;
    skills = specskl(skills);
    if (skills != 0) entertainskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(5);
  }
  terms -= anagathics;
  entertainmot(terms);
}


void entertainmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 2000; break;
        case 2: amt = 5000; break;
        case 3: amt = 10000; break;
        case 4: amt = 20000; break;
        case 5: amt = 40000; break;
        case 6: amt = 60000; break;
        case 7: amt = 100000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        entertainbene();
    }
  }
  while (term > 0)
  {
    entertainbene();
    term--;
  }
}


void entertainbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpsoc(); break;
    case 3: mot_midpsg(); break;
    case 4: bumpsoc(); break;
    case 5: mot_hipsg(); break;
    case 6: mot_tas(); break;
    case 7: mot_ship(); break;
  }
}


void entertainskills(int skills)
{
  int  table, roll;

  while (skills > 0)
  {
    table = picktable();
    roll = d6();
    if (table == 1)
	{
      switch (roll)
	  {
        case 1: bumpstr(); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: vc(1); break;
        case 5: hc(1); break;
        case 6: addskill(CAROUSING, 1); break;
      }
    }
    if (table == 2)
	{
      entertain_tbl(roll);
    }
    if (table == 3)
	{
      switch (roll)
	  {
        case 1: addskill(INSTRUCTION, 1); break;
        case 2: addskill(LEADER, 1); break;
        case 3: addskill(ROBOTOPS, 1); break;
        case 4: vhcl(1); break;
        case 5: animal(1); break;
        case 6: addskill(LINGUISTICS, 1); break;
      }
    }
    if (table == 4)
	{
      switch (roll)
	  {
        case 1: explore(1); break;
        case 2: addskill(LINGUISTICS, 1); break;
        case 3: spac(1); break;
        case 4: mc(1); break;
        case 5: inbrn(1); break;
        case 6: addskill(RESEARCH, 1); break;
      }
    }
    skills--;
  }
}


void entertain_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll)
	  {
        case 1: addskill(CAROUSING, 1); break;
        case 2: arts(1); break;
        case 3: arts(1); break;
        case 4: arts(1); break;
        case 5: interp(1); break;
        case 6: influ(1); break;
      }
}

void gotentertain()
{
  strncpy(career,"Entertainer",12);
  careernbr = ENTERTAINER;
}
