/* FARMER.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <string.h>

void farm();
void farmmot(int term);
void farmbene();
void farmskills(int skills);
void farm_tbl(int roll);
void gotfarm();

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void arts(int skl_val);
extern void bumpstr();
extern void bumpdex();
extern void bumpend();
extern void sci(int skl_val);
extern void animal(int skl_val);
extern void hc(int skl_val);
extern void vhcl(int skl_val);
extern void explore(int skl_val);
extern void gc(int skl_val);
extern void env(int skl_val);
extern void econ(int skl_val);
extern void inbrn(int skl_val);
extern void vc(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_midpsg();
extern void mot_weapon();

#include "chargen.h"

void farm()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm == 0)
  {
    skills = basic_spec_duty(6);
    newterm = basic_surv(5, end, 6);
    if (newterm == 0) skills += 2;
    skills = specskl(skills);
    if (skills != 0) farmskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(5);
  }
  terms -= anagathics;
  farmmot(terms);
}


void farmmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 2000; break;
        case 3: amt = 5000; break;
        case 4: amt = 10000; break;
        case 5: amt = 15000; break;
        case 6: amt = 20000; break;
        case 7: amt = 30000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        farmbene();
    }
  }
  while (term > 0)
  {
    farmbene();
    term--;
  }
}


void farmbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpstr(); break;
    case 3: bumpend(); break;
    case 4: bumpend(); break;
    case 5: mot_weapon(); break;
    case 6: mot_weapon(); break;
    case 7: mot_midpsg(); break;
  }
}


void farmskills(int skills)
{
  int  table, roll;

  while (skills > 0)
  {
    table = picktable();
    roll = d6();
    if (table == 1)
	{
      switch (roll)
	  {
        case 1: bumpstr(); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: vc(1); break;
        case 5: hc(1); break;
        case 6: arts(1); break;
      }
    }
    if (table == 2)
	{
      farm_tbl(roll);
    }
    if (table == 3)
	{
      switch (roll)
	  {
        case 1: addskill(MECHANICAL, 1); break;
        case 2: addskill(BIOLOGY, 1); break;
        case 3: addskill(ROBOTOPS, 1); break;
        case 4: econ(1); break;
        case 5: gc(1); break;
        case 6: addskill(THEOLOGY, 1); break;
      }
    }
    if (table == 4)
	{
      switch (roll)
	  {
        case 1: addskill(SENSOROPS, 1); break;
        case 2: addskill(METEOROLOGY, 1); break;
        case 3: addskill(ELECTRONICS, 1); break;
        case 4: addskill(COMPUTER, 1); break;
        case 5: sci(1); break;
        case 6: addskill(BIOLOGY, 1); break;
      }
    }
    skills--;
  }
}


void farm_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll)
	  {
        case 1: addskill(FARMING, 1); break;
        case 2: addskill(FARMING, 1); break;
        case 3: addskill(FARMING, 1); break;
        case 4: animal(1); break;
        case 5: vhcl(1); break;
        case 6: env(1); break;
      }
}

void gotfarm()
{
  strncpy(career,"farmer",7);
  careernbr = FARMER;
}
