/* HLANSSAI.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <string.h>

void hlanssai();
void hlanssaimot(int term);
void hlanssaicash();
void hlanssaiskills(int skills);
void hlweapon();

extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpintl();
extern void bumpdex();
extern void bumpend();
extern void bumpedu();
extern void bc(int skl_val);
extern void gc(int skl_val);
extern void vhcl(int skl_val);
extern void techl(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_midpsg();
extern void mot_weapon();

#include "chargen.h"

void hlanssai()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm == 0)
  {
    skills = basic_spec_duty(9) + 1;
    newterm = basic_surv(6, intl, 9);
    if (skills != 0) hlanssaiskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(4);
  }
  terms -= anagathics;
  hlanssaimot(terms);
}


void hlanssaimot(int term)
{
  int  roll;
  
  while (term > 0)
  {
	  roll = basic_bene();
	  switch (roll)
	  {
	    case 1: hlanssaicash(); break;
	    case 2: mot_weapon(); break;
	    case 3: mot_weapon(); break;
	    case 4: mot_lopsg(); break;
	    case 5: mot_midpsg(); break;
	    case 6: bumpedu(); break;
	  }
      term--;
  }
}


void hlanssaicash()
{
	int roll, amt;

    roll = basic_cash();
	amt = 0;
    switch (roll)
	{
        case 1: amt = 1000; break;
        case 2: amt = 1000; break;
        case 3: amt = 2000; break;
        case 4: amt = 2000; break;
        case 5: amt = 5000; break;
        case 6: amt = 10000; break;
    }
	mot_cash(amt);
}


void hlanssaiskills(int skills)
{
  int  table, roll;

  while (skills > 0)
  {
    table = picktable();
    roll = d6();
    if (table == 1)
	{
      switch (roll)
	  {
        case 1: bumpdex(); break;
        case 2: bumpintl(); break;
        case 3: bumpintl(); break;
        case 4: addskill(BRAWLING, 1); break;
        case 5: addskill(LIAISON, 1); break;
        case 6: addskill(SURVIVAL, 1); break;
      }
    }
    if (table == 2)
	{
      switch (roll)
	  {
        case 1: bumpend(); break;
        case 2: addskill(LIAISON, 1); break;
        case 3: addskill(SURVIVAL, 1); break;
        case 4: addskill(RECON, 1); break;
        case 5: hlweapon(1); break;
        case 6: bumpdex(); break;
      }
    }
    if (table == 3)
	{
		if (careernbr == SCIENTIST)
		{
		    switch (roll)
			{
				case 1: addskill(MECHANICAL, 1); break;
		        case 2: addskill(MEDICAL, 1); break;
			    case 3: addskill(ARTISAN, 1); break;
				case 4: vhcl(1); break;
		        case 5: addskill(ELECTRONICS, 1); break;
			    case 6: addskill(HANDYMAN, 1); break;
			}
		}
		else
		{
		    switch (roll)
			{
				case 1: addskill(HUNTING, 1); break;
		        case 2: addskill(SURVIVAL, 1); break;
			    case 3: bumpdex(); break;
				case 4: bumpintl(); break;
		        case 5: addskill(SWIMMING, 1); break;
			    case 6: addskill(RECON, 1); break;
			}
		}
	}
    skills--;
  }
}


void hlweapon()
{
	int roll;

	roll = d6();
	switch (roll)
	{
	case 1: addskill(BOW, 1); break;
	case 2: bc(1); break;
	case 3: bc(1); break;
	case 4: bc(1); break;
	case 5: gc(1); break;
	case 6: gc(1); break;
	}
}