/* LAWYER.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void lawyer();
void lawyermot(int term);
void lawyerbene();
void lawyerskills(int skills);
void lawyer_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void mentl(int skl_val);
extern void vc(int skl_val);
extern void influ(int skl_val);
extern void invest(int skl_val);
extern void interp(int skl_val);
extern void econ(int skl_val);
extern void acad(int skl_val);
extern void pc(int skl_val);
extern void bumpsoc();
extern void bumpend();
extern void bumpedu();
extern void bumpdex();
extern void mot_cash(int amt);
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_tas();

#include "chargen.h"

void lawyer()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(6);
    newterm = basic_surv(4, intl, 8);
    if (newterm == 0) {
      skills += 2;
    }
    skills = specskl(skills);
    if (skills != 0) lawyerskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(4);
  }
  terms = terms - anagathics;
  lawyermot(terms);
}


void lawyermot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 20000; break;
        case 2: amt = 30000; break;
        case 3: amt = 40000; break;
        case 4: amt = 50000; break;
        case 5: amt = 75000; break;
        case 6: amt = 10000; break;
        case 7: amt = 150000; break;
      }
	  mot_cash(amt);
    }
	else
	{
      if (choice == 'B' || choice == 'b')
	  {
        lawyerbene();
        term--;
      }
	  else
	  {
        printf("Wrong - try again!\n");
      }
    }
  }
  while (term > 0)
  {
    lawyerbene();
    term--;
  }
}


void lawyerbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_midpsg(); break;
    case 2: bumpedu(); break;
    case 3: bumpsoc(); break;
    case 4: bumpsoc(); break;
    case 5: mot_midpsg(); break;
    case 6: mot_hipsg(); break;
    case 7: mot_tas(); break;
  }
}


void lawyerskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: bumpsoc(); break;
        case 2: mentl(1); break;
        case 3: bumpdex(1); break;
        case 4: vc(1); break;
        case 5: bumpend(); break;
        case 6: bumpsoc(); break;
      }
    }
    if (table == 2)
      lawyer_tbl(roll);
    if (table == 3)
	{
      switch (roll)
	  {
        case 1: invest(1); break;
        case 2: addskill(INSTRUCTION, 1); break;
        case 3: interp(1); break;
        case 4: influ(1); break;
        case 5: addskill(LEGAL, 1); break;
        case 6: addskill(ADMIN, 1); break;
      }
    }
    if (table == 4)
	{
      switch (roll)
	  {
        case 1: acad(1); break;
        case 2: interp(1); break;
        case 3: econ(1); break;
        case 4: addskill(HISTORY, 1); break;
        case 5: addskill(RESEARCH, 1); break;
        case 6: invest(1); break;
      }
    }
    skills--;
  }
}


void lawyer_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll)
	  {
        case 1: addskill(ADMIN, 1); break;
        case 2: pc(1); break;
        case 3: vc(1); break;
        case 4: addskill(LEGAL, 1); break;
        case 5: addskill(PERSUASION, 1); break;
        case 6: addskill(ACTING, 1); break;
      }
}
