/* noble.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void noble();
void noblemot(int term);
void noblebene();
void nobleskills(int skills);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void physicl(int skl_val);
extern void bumpdex();
extern void bumpend();
extern void mentl(int skl_val);
extern void vc(int skl_val);
extern void hc(int skl_val);
extern void vhcl(int skl_val);
extern void env(int skl_val);
extern void gc(int skl_val);
extern void spac(int skl_val);
extern void spacetech(int skl_val);
extern void inbrn(int skl_val);
extern void acad(int skl_val);
extern void econ(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_hipsg();
extern void mot_tas();
extern void mot_ship();
extern void mot_weapon();

#include "chargen.h"

void noble()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(6);
    newterm = basic_surv(4, 0, 0);
    if (newterm == 0) {
      skills += basic_comm(5, edu, 9);
      skills += basic_promo(12, intl, 9);
    }
    skills = specskl(skills);
    if (skills != 0) nobleskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(4);
  }
  soc += rank;
  if (soc > 15) soc = 15;
  terms = terms - anagathics;
  noblemot(terms);
}


void noblemot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 10000; break;
        case 2: amt = 10000; break;
        case 3: amt = 50000; break;
        case 4: amt = 50000; break;
        case 5: amt = 100000; break;
        case 6: amt = 100000; break;
        case 7: amt = 200000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        noblebene();
    }
  }
  while (term > 0)
  {
    noblebene();
    term--;
  }
}


void noblebene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: mot_hipsg(); break;
    case 3: mot_weapon(); break;
    case 4: mot_weapon(); break;
    case 5: mot_tas(); break;
    case 6: mot_ship(); break;
    case 7: mot_ship(); break;
  }
}


void nobleskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: mentl(1); break;
        case 4: hc(1); break;
        case 5: bumpend(); break;
        case 6: vc(1); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: hc(1); break;
        case 2: env(1); break;
        case 3: gc(1); break;
        case 4: vhcl(1); break;
        case 5: vc(1); break;
        case 6: bumpdex(); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: vhcl(1); break;
        case 2: addskill(SHIPBOAT, 1); break;
        case 3: spacetech(1); break;
        case 4: addskill(NAVIGATION, 1); break;
        case 5: spac(1); break;
        case 6: addskill(LEADER, 1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: addskill(ADMIN, 1); break;
        case 2: addskill(COMPUTER, 1); break;
        case 3: addskill(LEADER, 1); break;
        case 4: acad(1); break;
        case 5: econ(1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}