/* Pirate.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void pirate();
void pir_get_line();
void pir_get_branch();
int pir_pickbranch();
void pir_do_initial();
int pir_doterms();
int pir_do_year();
void pir_a_mot(int term);
void pir_a_bene();
void pir_line();
void pir_line_tbl();
void pir_branch_tbl();
void solo_ship_life();
void squadron_life();
void org_crime_life();
void pir_crew();
void pir_boarder();
void pir_slaver();
void pir_guard();
void pir_mines();
void pir_factory();
void pir_life();
void pirate_tbl();
void pir_ship_life();
void pir_prison_life();
void pir_gen_skl();
int pir_pick_tbl();
int pir_asgn();
int pir_asgn_prison();
void pir_spcl_asgn();
void pir_asgn_tbl();
void pir_asgn_name();

extern void getrank();
extern int survive(int need_nbr, int adjust);
extern int bp_skill(int roll);
extern void bp_spcl_duty();
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d5();
extern int d6();
extern int d12();
extern int anag();
extern void adv_aging(int anags);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void physicl(int skl_val);
extern void dropsoc();
extern void bumpstr();
extern void bumpdex();
extern void bumpend();
extern void bumpintl();
extern void gunner(int skl_val);
extern void bc(int skl_val);
extern int getsel_int(int min, int max);
extern void gc(int skl_val);
extern void bp_add(int amt);
extern int ask_adj_asgn(int roll);
extern int bp_skill1(int roll, int need_nbr);
extern void gotspcldty(int spcldutynbr);
extern void mot_cash(int amt);
extern void mot_midpsg();
extern void mot_hipsg();
extern void mot_letter();
extern void mot_ship();
extern void mot_weapon();

#include "chargen.h"

extern int  nv_anag;

void pirate()
{
  pir_get_line(0);
  bc(1);
  while (pir_doterms() == 0);
  terms = terms - anagathics;
  if (rankeo == 'O')
  {
    terms += 3;
    if (rank >= 3) terms++;
    if (rank >= 5) terms++;
  }
  else
  {
    if (rank >= 4) terms++;
    if (rank >= 7) terms++;
    if (rank >= 10) terms++;
  }
  pir_a_mot(terms);
}


void pir_get_line(int newline)
{
  int roll;

  if (newline == 0)
  {
    roll = d12();
    if (soc <= 7) roll++;
    if (end >= 9) roll += 2;
    if (roll <= 5) line = 3;
    else
      if (roll <= 9) line = 2;
      else line = 1;
  }
  else line = newline;
  printf("You joined a ");
  pir_line();
  printf(".\n");
}


void pir_line()
{
  switch (line)
  {
    case 1: printf("organized crime ring"); break;
    case 2: printf("pirate squadron"); break;
    default: printf("single ship"); break;
  }
}


void pir_get_branch()
{
  int roll;

  roll = d6();
  if (roll == 6)
  {
    branch = 1;
    strcpy(office, "ship board");
  }
  else
  {
    branch = 2;
    strcpy(office, "prison");
    printf("You were caught and sent to %s.\n", office);
	special_duty[PRISON]++;
  }
}


extern int nv_promo, assignment;

int pir_doterms()
{
  int survival;
  
  assignment = 0;
  adv_aging(nv_anag);
  pir_get_branch();
  do {
    survival = pir_do_year();
  } while (((age % 4) != 2) && (survival == 0));
  if (survival != 0) return 1;
  if (branch == 1) survival = reenlist(0);
  if (survival != 0 || branch == 2) return 1; 
  drafted = 0;
  nv_anag = anag();
  return 0;
}


int pir_do_year()
{
  int   roll;

  age++;
  if (nv_anag == 0) appearent_age++;
  assignment = pir_asgn();
  printf("You were assigned to ");
  pir_asgn_name();
  printf(".\n");
  if (promo != 0) {
    roll = d12();
    if (dex >= 10) roll++;
    if (roll >= promo) {
      rank++;
      if (rank > 10) {
		rank = 1;
		rankeo = 'O';
		addskill(LEADER, 1);
      } else {
		if (rank == 8) addskill(PILOT, 1);
      }
      printf("You were promoted. ");
      getrank();
      pir_gen_skl();
    }
  }
  if (skil != 0) {
    roll = d12();
    if (edu > 8) roll++;
    if (roll < skil) roll = bp_skill(roll);
    if (roll >= (skil + 4)) {
      if (spec_skill != 0) {
		printf("Increasing your specialty skill. ");
		addskill(spec_skill, 1);
      } else {
		pir_gen_skl();
		pir_gen_skl();
      }
    } else {
      if (roll >= skil) pir_gen_skl();
    }
  }
  roll = d12();
  if (end >= 9) roll++;
  if (intl >= 9) roll++;
  return survive(roll, 0);
}


void pir_a_mot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
	  amt = 0;
      if (chk_skl(GAMBLING, 1) > 0) roll++;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 2000; break;
        case 3: amt = 5000; break;
        case 4: amt = 10000; break;
        case 5: amt = 25000; break;
        case 6: amt = 50000; break;
        default: amt = 80000; break;
      }
	  mot_cash(amt);
    }
	else
	{
      pir_a_bene();
    }
    term--;
  }
  while (term > 0)
  {
    pir_a_bene();
    term--;
  }
}


void pir_a_bene()
{
  int roll;

  roll = basic_bene();
  if (rankeo == 'O') roll++;
  switch (roll)
  {
    case 1: mot_midpsg(); break;
    case 2: mot_hipsg(); break;
    case 3: dropsoc(); break;
    case 4: mot_weapon(); break;
    case 5: mot_letter(); break;
    case 6: bumpintl(); break;
    default: mot_ship(); break;
  }
}


void solo_ship_life()
{
  int  roll;

  roll = d6();
  if (rankeo == 'O') roll++;
  if (terms >= 4) roll += 2;
  switch (roll)
  {
    case 1: gc(1); break;
    case 2: addskill(ENGINEERING, 1); break;
    case 3: addskill(TACTICS, 1); break;
    case 4: addskill(VACCSUIT, 1); break;
    case 5: addskill(NAVIGATION, 1); break;
    case 6: addskill(PILOT, 1); break;
    case 7: addskill(LEADER, 1); break;
    default: gunner(1); break;
  }
}


void squadron_life()
{
  int  roll;

  roll = d6();
  if (rankeo == 'O') roll++;
  if (terms >= 4) roll += 2;
  switch (roll)
  {
    case 1: addskill(ENGINEERING, 1); break;
    case 2: addskill(SHIPTAC, 1); break;
    case 3: addskill(FORGERY, 1); break;
    case 4: gc(1); break;
    case 5: addskill(TACTICS, 1); break;
    case 6: dropsoc(); break;
    case 7: bc(1); break;
    default: addskill(SHIPBOAT, 1); break;
  }
}


void org_crime_life()
{
  int  roll;

  roll = d6();
  if (rankeo == 'O') roll++;
  if (terms >= 4) roll += 2;
  switch (roll)
  {
    case 1: addskill(ELECTRONICS, 1); break;
    case 2: addskill(FORGERY, 1); break;
    case 3: addskill(TACTICS, 1); break;
    case 4: gc(1); break;
    case 5: addskill(SHIPTAC, 1); break;
    case 6: addskill(LEADER, 1); break;
    case 7: addskill(COMPUTER, 1); break;
    default: addskill(MEDICAL, 1); break;
  }
}


void pir_life()
{
  int  roll;

  roll = d6();
  switch (roll)
  {
    case 1: bumpstr(); break;
    case 2: bumpdex(); break;
    case 3: bumpend(); break;
    case 4: addskill(GAMBLING, 1); break;
    case 5: gc(1); break;
    case 6: bc(1); break;
  }
}


void pirate_tbl()
{
  pir_ship_life();
}


void pir_ship_life()
{
  int  roll;

  roll = d6();
  switch (roll) {
    case 1: addskill(PILOT, 1); break;
    case 2: addskill(NOGRAV, 1); break;
    case 3: addskill(SHIPTAC, 1); break;
    case 4: addskill(NAVIGATION, 1); break;
    case 5: addskill(MEDICAL, 1); break;
    case 6: bc(1); break;
  }
}


void pir_prison_life()
{
  int  roll;

  roll = d6();
  switch (roll) {
    case 1: bumpstr(); break;
    case 2: addskill(STREETWISE, 1); break;
    case 3: bumpend(); break;
    case 4: addskill(GAMBLING, 1); break;
    case 5: addskill(HANDYMAN, 1); break;
    case 6: addskill(CONCEALMENT, 1); break;
  }
}


void pir_crew()
{
  int  roll;

  roll = d6();
  switch (roll) {
    case 1: addskill(PILOT, 1); break;
    case 2: addskill(NAVIGATION, 1); break;
    case 3: gunner(1); break;
    case 4: addskill(ENGINEERING, 1); break;
    case 5: addskill(MECHANICAL, 1); break;
    case 6: addskill(ELECTRONICS, 1); break;
  }
}


void pir_boarder()
{
  int  roll;

  roll = d6();
  switch (roll) {
    case 1: bumpstr(); break;
    case 2: gc(1); break;
    case 3: addskill(BRAWLING, 1); break;
    case 4: addskill(SHIPBOAT, 1); break;
    case 5: bc(1); break;
    case 6: bumpdex(); break;
  }
}


void pir_slaver()
{
  int  roll;

  roll = d6();
  switch (roll)
  {
    case 1: bumpend(); break;
    case 2: bc(1); break;
    case 3: addskill(INSTRUCTION, 1); break;
    case 4: addskill(BROKER, 1); break;
    case 5: addskill(ADMIN, 1); break;
    case 6: addskill(STREETWISE, 1); break;
  }
}


void pir_guard()
{
  int  roll;

  roll = d6();
  switch (roll)
  {
    case 1: addskill(ADMIN, 1); break;
    case 2: gc(1); break;
    case 3: bumpstr(); break;
    case 4: addskill(INTERROGATE, 1); break;
    case 5: bc(1); break;
    case 6: bumpdex(); break;
  }
}


void pir_miner()
{
  int  roll;

  roll = d6();
  switch (roll)
  {
    case 1: bumpstr(); break;
    case 2: addskill(VACCSUIT, 1); break;
    case 3: addskill(BRAWLING, 1); break;
    case 4: addskill(GAMBLING, 1); break;
    case 5: dropsoc(); break;
    case 6: bumpend(); break;
  }
}


void pir_factory()
{
  int  roll;

  roll = d6();
  switch (roll)
  {
    case 1: addskill(ELECTRONICS, 1); break;
    case 2: addskill(FORGERY, 1); break;
    case 3: addskill(ADMIN, 1); break;
    case 4: addskill(COMPUTER, 1); break;
    case 5: addskill(MECHANICAL, 1); break;
    case 6: addskill(HANDYMAN, 1); break;
  }
}


void pir_branch_tbl()
{
  if (branch == 2)
  {
    pir_prison_life();
  }
  else
  {
    pir_ship_life();
  }
}


void pir_line_tbl()
{
  switch (line)
  {
    case 1: org_crime_life(); break;
    case 2: squadron_life(); break;
    default: solo_ship_life(); break;
  }
}

void pir_spcl_asgn()
{
  int special, roll;
  
  if (rankeo = 'O') special = d6();
  else special = d5();
  if (special == 1)
  {
    gotspcldty(INFILTRATEGRP);
    roll = bp_skill1(d6(), 5);
    if (roll >= 5) addskill(STEALTH, 1);
    roll = bp_skill1(d6(), 5);
    if (roll >= 5) addskill(RECON, 1);
    roll = bp_skill1(d6(), 5);
    if (roll >= 5) addskill(BRIBERY, 1);
    roll = bp_skill1(d6(), 5);
    if (roll >= 5) addskill(DISGUISE, 1);
    roll = bp_skill1(d6(), 5);
    if (roll >= 5) addskill(TACTICS, 1);
  }
  if (special == 2)
  {
    gotspcldty(MUTINY);
    roll = bp_skill1(d6(), 4);
    if (roll >= 4) addskill(STEALTH, 1);
    roll = bp_skill1(d6(), 4);
    if (roll >= 4) addskill(TACTICS, 1);
    roll = bp_skill1(d6(), 4);
    if (roll >= 4) addskill(LEADER, 1);
    roll = bp_skill1(d6(), 4);
    if (roll >= 4) gc(1);
  }
  if (special == 3)
  {
    gotspcldty(SABOTAGE);
    roll = bp_skill1(d6(), 4);
    if (roll >= 4) addskill(STEALTH, 1);
    roll = bp_skill1(d6(), 4);
    if (roll >= 4) addskill(CONCEALMENT, 1);
    roll = bp_skill1(d6(), 4);
    if (roll >= 4) addskill(DEMOLITIONS, 1);
    roll = bp_skill1(d6(), 4);
    if (roll >= 4) addskill(DISGUISE, 1);
  }
  if (special == 4)
  {
    gotspcldty(SHIPHEIST);
    roll = bp_skill1(d6(), 5);
    if (roll >= 5) addskill(CONCEALMENT, 1);
    roll = bp_skill1(d6(), 5);
    if (roll >= 5) addskill(FORGERY, 1);
    roll = bp_skill1(d6(), 5);
    if (roll >= 5) addskill(BRIBERY, 1);
    roll = bp_skill1(d6(), 5);
    if (roll >= 5) addskill(DISGUISE, 1);
    roll = bp_skill1(d6(), 5);
    if (roll >= 5) gc(1);
  }
  if (special == 5)
  {
    if (rankeo == 'O')
	{
      pir_spcl_asgn();
      return;
    }
	else 
	{
      gotspcldty(RIGHTHAND);
      roll = bp_skill1(d6(), 5);
      if (roll >= 5) addskill(LEADER, 1);
      roll = bp_skill1(d6(), 5);
      if (roll >= 5) gc(1);
      roll = bp_skill1(d6(), 5);
      if (roll >= 5) addskill(RECRUITING, 1);
      roll = bp_skill1(d6(), 5);
      if (roll >= 5) addskill(INTERROGATE, 1);
      roll = bp_skill1(d6(), 5);
      if (roll >= 5) addskill(LIAISON, 1);
    }
  }
  if (special == 6)
  {
    if (line == 1)
	{
      pir_spcl_asgn();
      return;
    }
    pir_get_line(1);
    org_crime_life();
  }
}


void pir_gen_skl()
{
  int roll;

  if (pick <= 2)
  {
    roll = pir_pick_tbl();
  }
  else
  {
    roll = d5();
    if (roll == 5) roll = 4;
  }
  if (roll == 1) pir_life();
  if (roll == 2) pir_line_tbl();
  if (roll == 3) pir_branch_tbl();
  if (roll == 4) pir_asgn_tbl();
}


int pir_pick_tbl()
{
  printf("\nPlease select the table you wish to use for your new skill.\n");
  printf("\n   1. pirate life\n");
  printf("   2. The table for %s\n", office);
  if (branch == 1)
  {
    printf("   3. ship life\n");
  }
  else
  {
    printf("   3. prison life\n");
  }
  printf("   4. ");
  pir_asgn_name();
  printf(" life\n");
  return getsel_int(1, 4);
}


int pir_asgn()
{
  int roll;

  roll = d6();
  if (roll == 6 && assignment != 0)
  {
    printf("You were allowed to repeat your last assignment.\n");
	if (assignment == 9) pir_spcl_asgn();
    return assignment;
  }
  if (branch == 2) return pir_asgn_prison();
  roll = d12();
  if (rankeo == 'E' && rank >= 7) roll++;
  if (rankeo == 'O') roll += 2;
  if (pick == 1 && brownie_points > 0)
	  roll = ask_adj_asgn(roll);
  else
  {
	  if (pick == 4 && roll == 10 && brownie_points > 3)
	  {
		  roll++;
		  bp_spcl_duty();
	  }
  }
  if (roll == 2)
  {
    skil = 4;
    surv = 6;
    promo = 6;
    return 2;
  }
  if (roll == 3 || roll == 5 || roll == 9)
  {
    surv = 4;
    skil = 6;
    promo = 7;
    return 1;
  }
  if (roll == 6 || roll == 7)
  {
    skil = 7;
    surv = 3;
    promo = 7;
    return 3;
  }
  if (roll <= 10)
  {
    skil = 5;
    surv = 5;
    promo = 8;
    return 4;
  }
  printf("This is special duty.\n");
  pir_spcl_asgn();
  skil = 0;
  surv = 0;
  promo = 0;
  return 9;
}


int pir_asgn_prison()
{
  int roll;

  roll = d12();
  if (rankeo == 'O') roll++;
  if (pick == 1 && brownie_points > 0)
	  roll = ask_adj_asgn(roll);
  else
  {
	  if (pick == 4 && roll == 10 && brownie_points > 3)
	  {
		  roll++;
		  brownie_points--;
		  printf("You used 1 brownie_point to get out of prison.\n");
	  }
  }
  if (roll == 2)
  {
    skil = 5;
    surv = 6;
    promo = 0;
    return 5;
  }
  if (roll == 3 || roll == 5 || roll == 9)
  {
    surv = 4;
    skil = 6;
    promo = 0;
    return 6;
  }
  if (roll == 6 || roll == 7)
  {
    skil = 0;
    surv = 0;
    promo = 0;
    return 8;
  }
  if (roll <= 10)
  {
    skil = 7;
    surv = 5;
    promo = 0;
    return 7;
  }
  printf("You were released from prison!\n");
  skil = 0;
  surv = 16;
  promo = 0;
  return 10;
}


void pir_asgn_name()
{
  switch (assignment)
  {
    case 1: printf("crew"); break;
    case 2: printf("boarders"); break;
    case 3: printf("slavers"); break;
    case 4: printf("guards"); break;
    case 5: printf("miners"); break;
    case 6: printf("detention camp"); break;
    case 7: printf("factory"); break;
    case 8: printf("solitary confinement"); break;
    case 9: printf("special duty"); break;
    case 10: printf("release from prison"); break;
  }
}


void pir_asgn_tbl()
{
  switch (assignment)
  {
    case 1: pir_crew(); break;
    case 2: pir_boarder(); break;
    case 3: pir_slaver(); break;
    case 4: pir_guard(); break;
    case 5: pir_miner(); break;
    case 6: pir_miner(); break;
    default: pir_factory(); break;
  }
}