/* ROGUE.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void rogue();
void roguemot(int term);
void roguebene();
void rogueskills(int skills);
void rogue_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void physicl(int skl_val);
extern void bumpdex();
extern void bumpend();
extern void bumpsoc();
extern void bumpedu();
extern void vc(int skl_val);
extern void hc(int skl_val);
extern void vhcl(int skl_val);
extern void techl(int skl_val);
extern void gc(int skl_val);
extern void interp(int skl_val);
extern void inbrn(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_hipsg();
extern void mot_tas();
extern void mot_weapon();

#include "chargen.h"

void rogue()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(5);
    newterm = basic_surv(7, intl, 9);
    if (newterm == 0) {
      skills += 2;
    }
    skills = specskl(skills);
    if (skills != 0) rogueskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(5);
  }
  terms = terms - anagathics;
  roguemot(terms);
}


void roguemot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: break;
        case 2: break;
        case 3: amt = 10000; break;
        case 4: amt = 10000; break;
        case 5: amt = 50000; break;
        case 6: amt = 100000; break;
        case 7: amt = 100000; break;
      }
    }
	else
	{
        roguebene();
        term--;
    }
  }
  while (term > 0)
  {
    roguebene();
    term--;
  }
}


void roguebene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpsoc(); break;
    case 3: mot_weapon(); break;
    case 4: mot_weapon(); break;
    case 5: mot_hipsg(); break;
    case 6: mot_tas(); break;
    case 7: mot_tas(); break;
  }
}


void rogueskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: vc(1); break;
        case 5: hc(1); break;
        case 6: addskill(CAROUSING, 1); break;
      }
    }
    if (table == 2) {
      rogue_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: vc(1); break;
        case 2: addskill(STREETWISE, 1); break;
        case 3: vc(1); break;
        case 4: addskill(TACTICS, 1); break;
        case 5: inbrn(1); break;
        case 6: interp(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: vc(1); break;
        case 2: addskill(MEDICAL, 1); break;
        case 3: vc(1); break;
        case 4: techl(1); break;
        case 5: inbrn(1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}


void rogue_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: hc(1); break;
        case 2: vhcl(1); break;
        case 3: gc(1); break;
        case 4: addskill(DEMOLITIONS, 1); break;
        case 5: vhcl(1); break;
        case 6: bumpedu(); break;
      }
}