/* SCOUT.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void scout();
void sc_get_office();
int sc_bur_ofc();
int sc_fld_ofc();
int sc_pickofc();
void sc_do_initial(int brnch);
int sc_doterms();
int sc_xfer();
void sc_ofc(int ofc_nbr);
int sc_do_year();
void scoutmot(int term);
void scoutbene();
void sc_clerk();
int sc_pick_promo();
void sc_ofc_tbl();
void sc_adm_rank();
void sc_war();
void sc_life();
void sc_surv();
void sc_comm();
void sc_expl();
void sc_fld_tbl();
void sc_admn();
void sc_oper();
void sc_tech();
void sc_duty();
void sc_bur_tbl();
void sc_school();
void sc_adm_sch();
void sc_spcl_sch();
void sc_cntct_sch();
void sc_fld_sch();
void sc_ship_sch();
void sc_int_sch();
void sc_tech_sch();
void sc_gen_skl(int assignment);
void sc_pick_tbl(int assignment);
int sc_fld_asgn();
int sc_bur_asgn();

extern int anag();
extern void adv_aging(int anags);
extern int getrank();
extern int survive(int adjust, int roll);
extern int basic_cash();
extern int bp_mot();
extern int basic_bene();
extern int d4();
extern int d5();
extern int d6();
extern int d7();
extern int d12();
extern int getsel_int(int min, int max);
extern char getche_y_n();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int find_skl(int skill);
extern int bp_skill(int roll);
extern int reenlist(int need_nbr);
extern void bumpstr();
extern void physicl(int skl_val);
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void gunner(int skl_val);
extern void animal(int skl_val);
extern void spac(int skl_val);
extern void acad(int skl_val);
extern void techl(int skl_val);
extern void spacetech(int skl_val);
extern void gc(int skl_val);
extern void acad(int skl_val);
extern void vc(int skl_val);
extern void env(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void inbrn(int skl_val);
extern void mentl(int skl_val);
extern void hc(int skl_val);
extern void zhopsiedu();
extern void gotspcldty(int spcldutynbr);
extern void bp_add(int amt);
extern int ask_adj_asgn(int roll);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_ship();
extern void mot_weapon();

#include "chargen.h"

int  sc_anag;

void scout()
{
  sc_get_office();
  sc_do_initial(branch);
  while (sc_doterms() == 0);
  terms = terms - anagathics;
  scoutmot(terms);
}


void sc_get_office()
{
  if (col <= 0 && tech_sch <= 0)
  {
    line = 1;
    printf("You were assigned to the field.\n");
    branch = sc_fld_ofc();
  }
  else
  {
    line = 2;
    printf("You were assigned to the bureaucracy.\n");
    if (col > 10)
	{
      branch = sc_pickofc();
    }
	else
	{
      branch = sc_bur_ofc();
    }
  }
  sc_ofc(branch);
  printf("You were assigned to the %s office.\n", office);
}


int sc_bur_ofc()
{
  int roll;
  roll = d12();
  if (roll == 4 && brownie_points > 0)
  {
	  roll--;
	  brownie_points--;
	  printf("You used 1 brownie point to get detached duty.\n");
  }
  if (roll <= 3) return 7;
  if (roll <= 5) return 6;
  if (roll <= 8) return 5;
  return 4;
}


int sc_fld_ofc()
{
  int roll;
  roll = d12();
  if (roll <= 5) return 1;
  if (roll <= 9) return 2;
  return 3;
}


int sc_pickofc()
{
  int choice;
  rankeo = 'O';
  if (pick == 4)
  {
    return sc_bur_ofc();
  }
  printf("As an honor student in college you have the option to choose\n");
  printf("the office you with to serve in within the Scout bureaucracy.\n");
  printf("\n   1. pick one at random\n   2. Administration\n");
  printf("   3. Operations\n   4. Technical\n   5. Detached Duty\n");
  choice = getsel_int(1, 5);
  if (choice == 1)
  {
    return sc_bur_ofc();
  }
  return (choice + 2);
}


void sc_do_initial(int brnch)
{
	if (race == ZHODANI && soc >= 10 && rankeo == 'E')
	{
		rankeo = 'O';
		rank = 0;
	}
	if (brnch < 1 || brnch > 7) brnch = branch;
	switch (brnch) {
	    case 1: addskill(PILOT, 1); break;
		case 2: addskill(PILOT, 1); break;
	    case 3: addskill(PILOT, 1); break;
		case 4: addskill(ADMIN, 1); break;
	    case 5: addskill(LEADER, 1); break;
		case 6: addskill(COMPUTER, 1); break;
	    case 7: addskill(ADMIN, 1); break;
	}
	age++;
	sc_anag = anag();
	if (sc_anag == 0) appearent_age++;
}


int sc_promo;

int sc_doterms()
{
  int survival;
  
  sc_promo = 0;
  adv_aging(sc_anag);
  do
  {
    survival = sc_do_year();
  } while (((age % 4) != 2) && (survival == 0));
  if (survival != 0) return 1;
  if (line == 1)
  {
	  rank++;
	  sc_promo = 1;
  }
  if (rank < terms && rankeo == 'E')
  {
    printf("You were refused reenlistment due to your lack of promotions.\n");
    printf("rank = %c%d, terms = %d\n", rankeo, rank, terms);
    return 1;
  }
  survival = reenlist(3);
  if (survival != 0) return 1; 
  drafted = 0;
  branch = sc_xfer();
  sc_anag = anag();
  return 0;
}


int sc_xfer()
{
  char choice;
  int  new_ofc, roll;

  if (line == 1)
  {
    new_ofc = sc_fld_ofc();
  }
  else
  {
    new_ofc = sc_bur_ofc();
  }
  if (new_ofc == branch) return branch;
  if (pick == 4)
  {
    roll = d6();
    if (roll <= 3)
	{
      sc_ofc(branch);
      printf("You are in the %s office.\n", office);
      return branch;
    }
	else
	{
      sc_ofc(new_ofc);
      printf("You are in the %s office.\n", office);
      return new_ofc;
    }
  }
  sc_ofc(new_ofc);
  printf("You have the option to transfer to the %s office.\n", office); 
  printf("Do you want to?");
  choice = getche_y_n();
  if (choice == 'Y' || choice == 'y') return new_ofc;
  return branch;
}


void sc_ofc(int ofc_nbr)
{
  switch (ofc_nbr) {
    case 1: strncpy(office,"Survey",7); break;
    case 2: strncpy(office,"Commo",6); break; 
    case 3: strncpy(office,"Exploration",12); break; 
    case 4: strncpy(office,"Administration",15); break; 
    case 5: strncpy(office,"Operations",11); break; 
    case 6: strncpy(office,"Technical",10); break; 
    case 7: strncpy(office,"Detached Duty",14); break; 
    default: strncpy(office,"unknown?",9); break;
  }
}


int sc_do_year()
{
  int     roll, assignment;
  
  age++;
  if (sc_anag == 0) appearent_age++;
  if (line == 1)
  {
    assignment = sc_fld_asgn();
  }
  else
  {
    assignment = sc_bur_asgn();
  }
  if (rank < 9 && line == 2)
  {
    if ((rankeo != 'O' || sc_promo == 0) && promo != 0)
	{
      roll = d12();
      if ((branch == 1 && terms >= 3) || (branch == 2 && find_skl(PILOT) >= 3)
        || ((branch == 3 || branch == 5) && intl >= 9)) roll++;
      if (roll >= promo)
	  {
        sc_promo++;
        rank++;
        printf("You were promoted. ");
        getrank();
        if (rankeo == 'O')
		{
          sc_adm_rank();
        }
		else
		{
          sc_clerk();
        }
      }
    }
  }
  if (assignment >= 5) sc_war();
  if (assignment == 1)
  {
    sc_school();
  }
  else
  {
    if (skil != 0)
	{
      roll = d12();
      if (roll < skil) roll = bp_skill(roll);
      if (roll >= (skil + 4))
	  {
        if (spec_skill != 0)
		{
          printf("Increasing your specialty skill. ");
          addskill(spec_skill, 1);
        }
		else
		{
          sc_gen_skl(assignment);
          sc_gen_skl(assignment);
        }
      }
	  else
	  {
        if (roll >= skil) sc_gen_skl(assignment);
      }
    }
  }
  if (line == 2 && assignment <= 3)
  {
    printf("You survived. ");
    return 0;
  }
  roll = d12();
  if (((branch <= 3) && (end >= 9)) || ((branch == 4) && (intl >= 9))
    || ((branch == 5) && (find_skl(PILOT) >= 2)) 
    || ((branch == 6) && (edu >= 10))
    || ((branch == 7) && (rankeo == 'O'))) roll++;
  return survive(roll, 0);
}


void scoutmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  printf("You are being mustered out.\n");
  cash = 3;
  if (anagathics >= 1) cash--;
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = d6();
      if (gambler != 0) roll++;
      term--;
	  amt = 0;
      if (brownie_points > 0) roll = bp_mot(roll);
      switch (roll)
	  {
        case 1: amt = 20000; break;
        case 2: amt = 20000; break;
        case 3: amt = 30000; break;
        case 4: amt = 30000; break;
        case 5: amt = 50000; break;
        case 6: amt = 50000; break;
        case 7: amt = 100000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        scoutbene();
        term--;
    }
  }
  while (term > 0)
  { 
    scoutbene();
    term--;
  }
}


void scoutbene()
{
  int roll;

  roll = d6();
  if (brownie_points > 0) roll = bp_mot(roll);
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 2: bumpintl(); bumpintl(); break;
    case 3: mot_weapon(); break;
    case 4: mot_weapon(); break;
    case 5: bumpedu(); bumpedu(); break;
    case 6: mot_ship(); break;
    case 7: mot_ship(); break;
  }
}


void sc_clerk()
{
  int table;
  if (pick <= 2) {
    table = sc_pick_promo();
  } else {
    table = (d6() % 2) + 1;
  }
  if (table == 1) sc_life();
  else
    sc_ofc_tbl();
}


int sc_pick_promo()
{
  int choice;
  printf("You get a skill for your promotion. Which table?\n\n");
  sc_ofc(branch);
  printf("   1. Scout Life\n   2. Table for %s\n", office);
  choice = getsel_int(1, 2);
  return choice;
}


void sc_ofc_tbl()
{
  switch (branch) {
    case 1: sc_surv(); break;
    case 2: sc_comm(); break;
    case 3: sc_expl(); break;
    case 4: sc_admn(); break;
    case 5: sc_oper(); break;
    case 6: sc_tech(); break;
    case 7: sc_duty(); break;
  }
}


void sc_adm_rank()
{
  int  roll;

  roll = d6();
  if (rank >= 3) roll += 4;
  switch (roll) {
    case 1: addskill(ADMIN, 1); break;
    case 2: addskill(ADMIN, 1); break;
    case 3: addskill(COMPUTER, 1); break;
    case 4: addskill(VACCSUIT, 1); break;
    case 5: spac(1); break;
    case 6: gc(1); break;
    case 7: addskill(LIAISON, 1); break;
    case 8: addskill(LEADER, 1); break;
    case 9: acad(1); break;
    case 10: bumpsoc(); break;
  }
}


void sc_war()
{
  int  roll;

  roll = d6();
  if (rankeo == 'O') roll += 4;
  if (race == DOLPHINS && (roll == 2)) roll++;
  switch (roll) {
    case 1: addskill(HUNTING, 1); break;
    case 2: addskill(BRIBERY, 1); break;
    case 3: addskill(ARTISAN, 1); break;
    case 4: animal(1); break;
    case 5: vc(1); break;
    case 6: addskill(LIAISON, 1); break;
    case 7: addskill(SURVIVAL, 1); break;
    case 8: gc(1); break;
    case 9: spac(1); break;
    case 10: bumpsoc(); break;
  }
}


void sc_life()
{
  int  roll;

  roll = d6();
  if (str >= 9) roll += 4;
  if (race == DOLPHINS && (roll == 2)) roll++;
  switch (roll) {
        case 1: bumpstr(); break;
        case 2: addskill(GAMBLING, 1); break;
        case 3: addskill(CAROUSING, 1); break;
        case 4: gc(1); break;
        case 5: gc(1); break;
        case 6: hc(1); break;
        case 7: bumpedu(); break;
        default: physicl(1); break;
  }
}


void sc_surv()
{
  int  roll;

  roll = d6();
  if (terms >= 3) roll += 4;
  switch (roll) {
        case 1: inbrn(1); break;
        case 2: addskill(PILOT, 1); break;
        case 3: addskill(VACCSUIT, 1); break;
        case 4: addskill(VACCSUIT, 1); break;
        case 5: addskill(SURVEY, 1); break;
        case 6: spac(1); break;
        case 7: env(1); break;
        case 8: addskill(NAVIGATION, 1); break;
        case 9: addskill(ENGINEERING, 1); break;
        case 10: addskill(SURVEY, 1); break;
  }
}


void sc_comm()
{
  int  roll;

  roll = d6();
  if (terms >= 3) roll += 4;
  switch (roll) {
        case 1: addskill(NOGRAV, 1); break;
        case 2: addskill(PILOT, 1); break;
        case 3: addskill(SHIPBOAT, 1); break;
        case 4: addskill(VACCSUIT, 1); break;
        case 5: addskill(COMMO, 1); break;
        case 6: spac(1); break;
        case 7: addskill(SURVIVAL, 1); break;
        case 8: addskill(PILOT, 1); break;
        case 9: addskill(NAVIGATION, 1); break;
        case 10: addskill(NAVIGATION, 1); break;
  }
}


void sc_expl()
{
  int  roll;

  roll = d6();
  if (terms >= 3) roll += 4;
  switch (roll) {
        case 1: addskill(GRAVVHCL, 1); break;
        case 2: vhcl(1); break;
        case 3: gc(1); break;
        case 4: addskill(VACCSUIT, 1); break;
        case 5: addskill(RECON, 1); break;
        case 6: spac(1); break;
        case 7: addskill(SURVIVAL, 1); break;
        case 8: inbrn(1); break;
        case 9: vhcl(1); break;
        case 10: gc(1); break;
  }
}


void sc_fld_tbl()
{
  int  roll;

  roll = d6();
  if (terms >= 3) roll += 4;
  if (race == DOLPHINS && (roll == 5)) roll++;
  switch (roll) {
        case 1: bumpedu(); break;
        case 2: techl(1); break;
        case 3: gc(1); break;
        case 4: addskill(CAROUSING, 1); break;
        case 5: addskill(GAMBLING, 1); break;
        case 6: gc(1); break;
        case 7: addskill(STREETWISE, 1); break;
        case 8: inbrn(1); break;
        case 9: mentl(1); break;
        case 10: bumpedu(); break;
  }
}


void sc_admn()
{
  int  roll;

  roll = d6();
  if (rankeo == 'O') roll += 4;
  if (race == DOLPHINS && (roll == 6)) roll--;
  switch (roll) {
        case 1: addskill(ELECTRONICS, 1); break;
        case 2: addskill(ADMIN, 1); break;
        case 3: addskill(COMMO, 1); break;
        case 4: addskill(COMPUTER, 1); break;
        case 5: addskill(ROBOTOPS, 1); break;
        case 6: addskill(BROKER, 1); break;
        case 7: bumpintl(); break;
        case 8: bumpedu(); break;
        case 9: addskill(LIAISON, 1); break;
        case 10: acad(1); break;
  }
}


void sc_oper()
{
  int  roll;

  roll = d6();
  if (rankeo == 'O') roll += 4;
  switch (roll) {
        case 1: addskill(MECHANICAL, 1); break;
        case 2: gc(1); break;
        case 3: vhcl(1); break;
        case 4: addskill(ENGINEERING, 1); break;
        case 5: addskill(COMPUTER, 1); break;
        case 6: addskill(NAVIGATION, 1); break;
        case 7: gunner(1); break;
        case 8: addskill(PILOT, 1); break;
        case 9: addskill(SHIPBOAT, 1); break;
        case 10: addskill(SHIPTAC, 1); break;
  }
}


void sc_tech()
{
  int  roll;

  roll = d6();
  if (edu >= 9) roll += 4;
  switch (roll) {
        case 1: addskill(SENSOROPS, 1); break;
        case 2: addskill(MECHANICAL, 1); break;
        case 3: vhcl(1); break;
        case 4: addskill(ELECTRONICS, 1); break;
        case 5: addskill(VACCSUIT, 1); break;
        case 6: techl(1); break;
        case 7: techl(1); break;
        case 8: acad(1); break;
        case 9: addskill(MEDICAL, 1); break;
        case 10: addskill(ENGINEERING, 1); break;
  }
}


void sc_duty()
{
  int  roll;

  roll = d6();
  if (rankeo == 'O') roll += 4;
  switch (roll) {
        case 1: addskill(ELECTRONICS, 1); break;
        case 2: addskill(ADMIN, 1); break;
        case 3: addskill(COMMO, 1); break;
        case 4: addskill(COMPUTER, 1); break;
        case 5: addskill(ROBOTOPS, 1); break;
        case 6: gc(1); break;
        case 7: vc(1); break;
        case 8: addskill(ARTISAN, 1); break;
        case 9: addskill(BRAWLING, 1); break;
        case 10: addskill(STREETWISE, 1); break;
  }
}


void sc_bur_tbl()
{
  int  roll;

  roll = d6();
  if (rankeo == 'O') roll += 4;
  if (race == DOLPHINS && (roll == 2)) roll++;
  switch (roll) {
        case 1: bumpintl(); break;
        case 2: addskill(GAMBLING, 1); break;
        case 3: addskill(CAROUSING, 1); break;
        case 4: bumpedu(); break;
        case 5: addskill(COMPUTER, 1); break;
        case 6: vhcl(1); break;
        case 7: bumpintl(); break;
        case 8: bumpedu(); break;
        case 9: bumpintl(); break;
        case 10: addskill(STREETWISE, 1); break;
  }
}


void sc_school()
{
  int roll;
  roll = d6();
  if (branch == 1) {
    if (roll <= 2) {
      sc_spcl_sch();
    } else {
      if (roll == 3) {
        sc_int_sch();
        sc_int_sch();
      } else {
        sc_fld_sch();
      }
    }
    return;
  }
  if (branch == 2) {
    if (roll <= 2) {
      sc_spcl_sch();
    } else {
      if (roll <= 4) {
        sc_cntct_sch();
        sc_cntct_sch();
      } else {
        sc_fld_sch();
      }
    }
    return;
  }
  if (branch == 3) {
    if (roll <= 2) {
      sc_spcl_sch();
    } else {
      if (roll <= 4) {
        sc_ship_sch();
        sc_ship_sch();
      } else {
        sc_fld_sch();
      }
    }
    return;
  }
  if (branch == 4) {
    if (roll <= 3) {
      sc_spcl_sch();
    } else {
      if (roll == 4) {
        sc_ship_sch();
        sc_ship_sch();
      } else {
        if (roll == 5) {
          sc_fld_sch();
        } else {
          if (drafted != 0 || rankeo == 'O') {
            sc_school();
          } else {
            sc_adm_sch();
          }
        }
      }
    }
    return;
  }
  if (branch == 5) {
    if (roll <= 2) {
      sc_spcl_sch();
    } else {
      if (roll <= 4) {
        sc_ship_sch();
        sc_ship_sch();
      } else {
        if (roll == 5) {
          sc_fld_sch();
        } else {
          if (drafted != 0 || rankeo == 'O') {
            sc_school();
          } else {
            sc_adm_sch();
          }
        }
      }
    }
    return;
  }
  if (branch == 6) {
    if (roll <= 2) {
      sc_spcl_sch();
    } else {
      if (roll <= 5) {
        sc_tech_sch();
      } else {
        if (drafted != 0 || rankeo == 'O') {
          sc_school();
        } else {
          sc_adm_sch();
        }
      }
    }
    return;
  }
  if (branch == 7) {
    if (roll <= 3) {
      sc_spcl_sch();
    } else {
      if (roll <= 5) {
        sc_int_sch();
        sc_int_sch();
      } else {
        sc_fld_sch();
      }
    }
  }
  return;
}


void sc_adm_sch()
{
  printf("You got admin School. Congratulations you are an officer.\n");
  rankeo = 'O';
  rank = 1;
  line = 2;
  branch = sc_bur_ofc();
  sc_ofc(branch);
  printf("Your new assignment is with the %s office of the Scout\n", office);
  printf("Bureaucracy.\n");
}


void sc_spcl_sch()
{
  int roll;

  printf("You went to Specialist School.\n");
  roll = d6();
  switch (roll) {
    case 1: addskill(MEDICAL, 1); break;
    case 2: addskill(MECHANICAL, 1); break;
    case 3: addskill(ROBOTOPS, 1); break;
    case 4: addskill(SENSOROPS, 1); break;
    case 5: gunner(1); break;
    case 6: acad(1); break;
  }
}


void sc_cntct_sch()
{
  int roll;

  printf("You went to Contact School.\n");
  roll = d6();
  switch (roll) {
    case 1: addskill(SURVEY, 1); break;
    case 2: addskill(LINGUISTICS, 1); break;
    case 3: addskill(LIAISON, 1); break;
    case 4: addskill(SURVIVAL, 1); break;
    case 5: addskill(STREETWISE, 1); break;
    case 6: gc(1); break;
  }
}


void sc_fld_sch()
{
  int roll;

  printf("You went to Field School.\n");
  roll = d6();
  switch (roll) {
    case 1: addskill(GRAVBELT, 1); break;
    case 2: addskill(NAVIGATION, 1); break;
    case 3: addskill(SURVEY, 1); break;
    case 4: addskill(SURVIVAL, 1); break;
    case 5: addskill(RECON, 1); break;
    case 6: vhcl(1); break;
  }
}


void sc_ship_sch()
{
  int roll;

  printf("You went to Ship School.\n");
  roll = d6();
  switch (roll) {
    case 1: addskill(PILOT, 1); break;
    case 2: addskill(NAVIGATION, 1); break;
    case 3: addskill(ENGINEERING, 1); break;
    case 4: spac(1); break;
    case 5: gunner(1); break;
    case 6: spac(1); break;
  }
}


void sc_int_sch()
{
  int roll;

  printf("You went to Intelligence School.\n");
  roll = d6();
  switch (roll) {
    case 1: addskill(DISGUISE, 1); break;
    case 2: addskill(STREETWISE, 1); break;
    case 3: addskill(SURVIVAL, 1); break;
    case 4: hc(1); break;
    case 5: gc(1); break;
    case 6: vc(1); break;
  }
}


void sc_tech_sch()
{
  int roll;

  printf("You went to Technical School.\n");
  roll = d6();
  switch (roll) {
    case 1: addskill(COMPUTER, 1); break;
    case 2: addskill(ELECTRONICS, 1); break;
    case 3: addskill(GRAVITICS, 1); break;
    case 4: addskill(MECHANICAL, 1); break;
    case 5: addskill(NAVALARCH, 1); break;
    case 6: techl(1); break;
  }
}


void sc_gen_skl(int assignment)
{
  int roll;
  if (pick <= 2) {
    sc_pick_tbl(assignment);
    return;
  }
  if (line == 1) {
    if (assignment >= 5) {
      roll = d6();
      if (roll == 5) roll = 2;
      if (roll == 6) roll = 4;
    } else {
      roll = d4();
      if (roll == 4) roll = 2;
    }
    switch (roll) {
      case 1: sc_life(); break;
      case 2: sc_ofc_tbl(); break;
      case 3: sc_fld_tbl(); break;
      case 4: sc_war(); break;
    }
  } else {
    if (rankeo == 'O') {
      if (assignment >= 5) {
        roll = d7();
        if (roll == 6) roll = 2;
        if (roll == 7) roll = 5;
      } else {
        roll = d5();
        if (roll == 5) roll = 2;
      }
      switch (roll) {
        case 1: sc_life(); break;
        case 2: sc_ofc_tbl(); break;
        case 3: sc_bur_tbl(); break;
        case 4: sc_adm_rank(); break;
        case 5: sc_war(); break;
      }
    } else {
      if (assignment >= 5) {
        roll = d6();
        if (roll == 5) roll = 2;
        if (roll == 6) roll = 4;
      } else {
        roll = d4();
        if (roll == 4) roll = 2;
      }
      switch (roll) {
        case 1: sc_life(); break;
        case 2: sc_ofc_tbl(); break;
        case 3: sc_bur_tbl(); break;
        case 4: sc_war(); break;
      }
    }
  }
}


void sc_pick_tbl(int assignment)
{
  int choice, max;

  max = 3;
  printf("\nPlease select the table you wish to use for your new skill.\n");
  sc_ofc(branch);
  printf("\n   1. Scout life\n   2. The table for %s\n", office); 
  if (line == 1) {
    printf("   3. Field service\n");
    if (assignment >= 5)
	{
		printf("   4. War/Special assignment table\n");
		max = 4;
	}
	if (race == ZHODANI && soc >= 10)
	{
		printf("   5. Noble/Intendent education\n");
		max = 5;
	}
    choice = getsel_int(1, max);
    if (assignment < 5 && choice == 4) {
      printf("Wrong - try again!\n");
      sc_pick_tbl(assignment);
      return;
    }
    switch (choice) {
      case 1: sc_life(); break;
      case 2: sc_ofc_tbl(); break;
      case 3: sc_fld_tbl(); break;
      case 4: sc_war(); break;
	  case 5: zhopsiedu(); break;
    }
  } else {
    printf("   3. Bureaucracy table\n");
    if (rankeo == 'O') {
      printf("   4. Administrative rank table\n");
	  max = 4;
      if (assignment >= 5)
	  {
		  printf("   5. War/Special assignment table\n");
		  max = 5;
	  }
	  if (race == ZHODANI && soc >= 10)
	  {
		  printf("   6. Noble/Intendent education\n");
		  max = 6;
	  }
      choice = getsel_int(1, max);
      if (assignment < 5 && choice == 5) {
        printf("Wrong - try again!\n");
        sc_pick_tbl(assignment);
        return;
      }
    } else {
      if (assignment >= 5)
	  {
		  printf("   4. War/Special assignment table\n");
		  max = 4;
	  }
	  if (race == ZHODANI && soc >= 10)
	  {
		  printf("   5. Noble/Intendent education\n");
		  max = 5;
	  }
      choice = getsel_int(1, max);
      if (assignment < 5 && choice == 4) {
        printf("Wrong - try again!\n");
        sc_pick_tbl(assignment);
        return;
      }
      if (choice >= 4) choice++;
    }
    switch (choice) {
      case 1: sc_life(); break;
      case 2: sc_ofc_tbl(); break;
      case 3: sc_bur_tbl(); break;
      case 4: sc_adm_rank(); break;
      case 5: sc_war(); break;
	  case 6: zhopsiedu(); break;
    }
  }
}


int sc_fld_asgn()
{
  int roll;
  promo = 0;
  roll = d12();
  if (pick == 1 && brownie_points > 0)
	  roll = ask_adj_asgn(roll);
  else
  {
	  if (pick == 4 && roll == 12 && brownie_points > 3)
	  {
		  roll--;
		  brownie_points--;
		  printf("You used 1 brownie point to avoid a desk job.\n");
	  }
	  if (pick == 4 && roll == 3 && brownie_points > 3)
	  {
		  roll--;
		  brownie_points--;
		  printf("You used 1 brownie point to get a war assignment.\n");
	  }
	  if (pick == 4 && roll == 9 && brownie_points > 3)
	  {
		  roll++;
		  brownie_points--;
		  printf("You used 1 brownie point to get a special mission.\n");
	  }
  }
  if (roll == 2)
  {
    gotspcldty(WARMIS);
    surv = 6;
    switch (branch)
	{
      case 1: skil = 7; break;
      case 2: skil = 6; break;
      case 3: skil = 6; break;
    }
    return 6;
  }
  if (roll <= 4) {
    printf("This is a training assignment.\n");
    surv = 3;
    skil = 0;
    return 1;
  }
  if (roll == 5) {
    printf("This is a base assignment.\n");
    skil = 0;
    switch (branch) {
      case 1: surv = 3; skil = 8; break;
      case 2: surv = 4; break;
      case 3: surv = 3; break;
    }
    return 2;
  }
  if (roll <= 7) {
    printf("This is a routine assignment.\n");
    switch (branch) {
      case 1: skil = 7; surv = 3; break; 
      case 2: skil = 7; surv = 4; break; 
      case 3: skil = 8; surv = 4; break; 
    }
    return 3;
  }
  if (roll <= 9) {
    printf("This is a mission assignment.\n");
    switch (branch) {
      case 1: skil = 6; surv = 4; break; 
      case 2: skil = 7; surv = 5; break; 
      case 3: skil = 7; surv = 5; break; 
    }
    return 4;
  }
  if (roll <= 11) {
    gotspcldty(SPECIALMIS);
    switch (branch) {
      case 1: skil = 6; surv = 5; break; 
      case 2: skil = 6; surv = 6; break; 
      case 3: skil = 5; surv = 7; break; 
    }
    return 5;
  }
  line = 2;
  printf("You have been transfered to administration.\n");
  branch = sc_bur_ofc();
  return sc_bur_asgn();
}


int sc_bur_asgn()
{
  int roll;
  surv = 0;
  roll = d12();
  if (pick == 1 && brownie_points > 0)
	  roll = ask_adj_asgn(roll);
  else
  {
	  if (pick == 4 && roll == 3 && brownie_points > 3)
	  {
		  roll--;
		  brownie_points--;
		  printf("You used 1 brownie point to get a war assignment.\n");
	  }
	  if (pick == 4 && roll == 8 && brownie_points > 3)
	  {
		  roll++;
		  brownie_points--;
		  printf("You used 1 brownie point to get a mission.\n");
	  }
	  if (pick == 4 && roll == 11 && brownie_points > 3)
	  {
		  roll++;
		  brownie_points--;
		  printf("You used 1 brownie point to get a special mission.\n");
	  }
  }
  if (roll == 2)
  {
    gotspcldty(WARMIS);
    switch (branch)
	{
      case 4: skil = 7; surv = 5; promo = 5; break;
      case 5: skil = 4; surv = 4; promo = 5; break;
      case 6: skil = 6; surv = 6; promo = 6; break;
      case 7: skil = 3; surv = 5; promo = 7; break;
    }
    return 6;
  }
  if (rankeo == 'O') roll += 2;
  if (roll == 4 || roll == 8)
  {
    printf("This is a base assignment.\n");
    switch (branch)
	{
      case 4: skil = 7; promo = 5; break;
      case 5: skil = 8; promo = 5; break;
      case 6: skil = 7; promo = 6; break;
      case 7: skil = 0; promo = 7; break;
    }
    return 2;
  }
  if (roll <= 5)
  {
    printf("This is a training assignment.\n");
    promo = 0;
    if (branch == 5) promo = 8;
    if (branch == 6) promo = 10;
    return 1;
  }
  if (roll <= 7)
  {
    printf("This is a routine assignment.\n");
    switch (branch)
	{
      case 4: skil = 7; promo = 7; break; 
      case 5: skil = 8; promo = 8; break; 
      case 6: skil = 7; promo = 9; break; 
      case 7: skil = 7; promo = 8; break; 
    }
    return 3;
  }
  if (roll <= 11)
  {
    printf("This is a mission assignment.\n");
    switch (branch)
	{
      case 4: skil = 7; surv = 3; promo = 7; break;
      case 5: skil = 6; surv = 3; promo = 7; break;
      case 6: skil = 6; surv = 3; promo = 8; break;
      case 7: skil = 6; surv = 4; promo = 7; break;
    }
    return 4;
  }
  gotspcldty(SPECIALMIS);
  switch (branch) {
    case 4: skil = 7; surv = 3; promo = 6; break;
    case 5: skil = 5; surv = 4; promo = 6; break;
    case 6: skil = 7; surv = 5; promo = 7; break;
    case 7: skil = 6; surv = 6; promo = 5; break;
  }
  return 5;
}

