/* SOLARMY.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void solarmy();
void solarmymot(int term);
void solarmybene();
void solarmyskills(int skills);
void solarmy_tbl(int roll);
void hmgdarmy(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void physicl(int skl_val);
extern void bumpdex();
extern void bumpend();
extern void bumpsoc();
extern void bumpedu();
extern void bumpintl();
extern void vc(int skl_val);
extern void hc(int skl_val);
extern void special(int skl_val);
extern void vhcl(int skl_val);
extern void techl(int skl_val);
extern void gc(int skl_val);
extern void interp(int skl_val);
extern void inbrn(int skl_val);
extern void milmed(int skl_val);
extern void env(int skl_val);
extern void explore(int skl_val);
extern void spacecmbt(int skl_val);
extern void spacetech(int skl_val);
extern void mot_cash(int amt);
extern void mot_voucher();
extern void mot_weapon();

#include "chargen.h"

void solarmy()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(6);
    newterm = basic_surv(5, dex, 9);
    if (newterm == 0) {
      skills += basic_comm(6, soc, 5);
      skills += basic_promo(7, intl, 9);
    }
    if (skills != 0) solarmyskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  terms = terms - anagathics;
  solarmymot(terms);
}


void solarmymot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c') 
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 4000; break;
        case 2: amt = 8000; break;
        case 3: amt = 10000; break;
        case 4: amt = 10000; break;
        case 5: amt = 10000; break;
        case 6: amt = 30000; break;
        case 7: amt = 50000; break;
      }
	  mot_cash(amt);
    }
	else 
	{
        solarmybene();
        term--;
    }
  }
  while (term > 0)
  {
    solarmybene();
    term--;
  }
}


void solarmybene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_voucher(); break;
    case 2: bumpedu(); bumpedu(); break;
    case 3: bumpintl(); break;
    case 4: mot_weapon(); break;
    case 5: mot_voucher(); break;
    case 6: if (soc < 6) soc = 6; break;
    case 7: bumpsoc(); break;
  }
}


void solarmyskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: vc(1); break;
        case 5: bumpedu(); break;
        case 6: hc(1); break;
      }
    }
    if (table == 2) {
      solarmy_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: vhcl(1); break;
        case 2: addskill(MECHANICAL, 1); break;
        case 3: addskill(ELECTRONICS, 1); break;
        case 4: addskill(TACTICS, 1); break;
        case 5: inbrn(1); break;
        case 6: gc(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: milmed(1); break;
        case 2: addskill(TACTICS, 1); break;
        case 3: addskill(LEADER, 1); break;
        case 4: techl(1); break;
        case 5: interp(1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}


void solarmy_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: addskill(GRAVVHCL, 1); break;
        case 2: addskill(ATV, 1); break;
        case 3: gc(1); break;
        case 4: gc(1); break;
        case 5: techl(1); break;
        case 6: special(1); break;
      }
}


void hmgdarmy(int roll)
{
  if (roll == 0) roll = d6();
  switch (roll) {
    case 1: explore(1); break;
    case 2: env(1); break;
    case 3: addskill(LEADER, 1); break;
    case 4: techl(1); break;
    case 5: spacecmbt(1); break;
    case 6: spacetech(1); break;
  }
}