/* SOLNAVY.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void solnavy();
void solnavymot(int term);
void solnavybene();
void solnavyskills(int skills);
void hmgdnavy(int roll);
void solnavy_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void physicl(int skl_val);
extern void bumpdex();
extern void bumpend();
extern void bumpsoc();
extern void bumpedu();
extern void bumpintl();
extern void mentl(int skl_val);
extern void spac(int skl_val);
extern void special(int skl_val);
extern void vhcl(int skl_val);
extern void techl(int skl_val);
extern void gc(int skl_val);
extern void interp(int skl_val);
extern void inbrn(int skl_val);
extern void milmed(int skl_val);
extern void env(int skl_val);
extern void spacecmbt(int skl_val);
extern void spacetech(int skl_val);
extern void mot_cash(int amt);
extern void mot_voucher();
extern void mot_weapon();

#include "chargen.h"

void solnavy()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(5);
    newterm = basic_surv(5, end, 9);
    if (newterm == 0) {
      skills += basic_comm(9, soc, 5);
      skills += basic_promo(8, edu, 8);
    }
    if (skills != 0) solnavyskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  terms = terms - anagathics;
  solnavymot(terms);
}


void solnavymot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 4000; break;
        case 2: amt = 8000; break;
        case 3: amt = 10000; break;
        case 4: amt = 10000; break;
        case 5: amt = 20000; break;
        case 6: amt = 40000; break;
        case 7: amt = 50000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        solnavybene();
        term--;
    }
  }
  while (term > 0)
  {
    solnavybene();
    term--;
  }
}


void solnavybene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_voucher(); break;
    case 2: bumpedu(); bumpedu(); break;
    case 3: bumpintl(); break;
    case 4: mot_weapon(); break;
    case 5: mot_voucher(); break;
    case 6: bumpintl(); break;
    case 7: bumpsoc(); bumpsoc(); break;
  }
}


void solnavyskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: mentl(1); break;
        case 5: mentl(1); break;
        case 6: bumpsoc(); break;
      }
    }
    if (table == 2) {
      solnavy_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(VACCSUIT, 1); break;
        case 2: addskill(MECHANICAL, 1); break;
        case 3: addskill(ELECTRONICS, 1); break;
        case 4: spac(1); break;
        case 5: spacecmbt(1); break;
        case 6: inbrn(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: addskill(NAVIGATION, 1); break;
        case 2: milmed(1); break;
        case 3: spacetech(1); break;
        case 4: techl(1); break;
        case 5: interp(1); break;
        case 6: spac(1); break;
      }
    }
    skills--;
  }
}


void hmgdnavy(int roll)
{
  if (roll == 0) roll = d6();
  switch (roll) {
    case 1: addskill(LEADER, 1); break;
    case 2: vhcl(1); break;
    case 3: gc(1); break;
    case 4: techl(1); break;
    case 5: env(1); break;
    case 6: special(1); break;
  }
}


void solnavy_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: addskill(FORWARDOBS, 1); break;
        case 2: addskill(VACCSUIT, 1); break;
        case 3: gc(1); break;
        case 4: vhcl(1); break;
        case 5: spacecmbt(1); break;
        case 6: spacetech(1); break;
      }
}