/* SOLPARTY.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void solparty();
void solpartymot(int term);
void solpartybene();
void solpartyskills(int skills);
void solparty_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void physicl(int skl_val);
extern void mentl();
extern void bumpsoc();
extern void bumpedu();
extern void bumpintl();
extern void vc(int skl_val);
extern void special(int skl_val);
extern void vhcl(int skl_val);
extern void techl(int skl_val);
extern void gc(int skl_val);
extern void interp(int skl_val);
extern void inbrn(int skl_val);
extern void acad(int skl_val);
extern void mot_cash(int amt);
extern void mot_voucher();
extern void mot_weapon();
extern void mot_ship();

#include "chargen.h"

void solparty()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(5);
    newterm = basic_surv(7, edu, 9);
    if (newterm == 0) {
      skills += basic_comm(8, soc, 5);
      skills += basic_promo(8, intl, 9);
    }
    if (skills != 0) solpartyskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  terms = terms - anagathics;
  solpartymot(terms);
}


void solpartymot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 10000; break;
        case 2: amt = 20000; break;
        case 3: amt = 30000; break;
        case 4: amt = 40000; break;
        case 5: amt = 50000; break;
        case 6: amt = 60000; break;
        case 7: amt = 70000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        solpartybene();
        term--;
    }
  }
  while (term > 0)
  {
    solpartybene();
    term--;
  }
}


void solpartybene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_voucher(); break;
    case 2: bumpedu(); bumpedu(); break;
    case 3: bumpintl(); bumpintl(); break;
    case 4: mot_weapon(); break;
    case 5: mot_weapon(); break;
    case 6: mot_voucher(); break;
    case 7: mot_ship(); break;
  }
}


void solpartyskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: mentl(1); break;
        case 2: bumpedu(); break;
        case 3: bumpsoc(); break;
        case 4: bumpsoc(); break;
        case 5: physicl(1); break;
        case 6: inbrn(1); break;
      }
    }
    if (table == 2) {
      solparty_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: vc(1); break;
        case 2: addskill(LEADER, 1); break;
        case 3: interp(1); break;
        case 4: techl(1); break;
        case 5: addskill(LEADER, 1); break;
        case 6: acad(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: techl(1); break;
        case 2: techl(1); break;
        case 3: special(1); break;
        case 4: techl(1); break;
        case 5: addskill(LEADER, 1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}


void solparty_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
  switch (roll) {
        case 1: vc(1); break;
        case 2: addskill(VACCSUIT, 1); break;
        case 3: vc(1); break;
        case 4: vhcl(1); break;
        case 5: gc(1); break;
        case 6: interp(1); break;
      }
}