/* SOLSEC.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void solsec();
void solsecmot(int term);
void solsecbene();
void solsecskills(int skills);
void solsec_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int d12();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void physicl(int skl_val);
extern void mentl();
extern void bumpdex();
extern void bumpedu();
extern void bumpintl();
extern void vc(int skl_val);
extern void mc(int skl_val);
extern void spac(int skl_val);
extern void vhcl(int skl_val);
extern void techl(int skl_val);
extern void env(int skl_val);
extern void econ(int skl_val);
extern void interp(int skl_val);
extern void inbrn(int skl_val);
extern void spacetech(int skl_val);
extern void mot_cash(int amt);
extern void mot_voucher();
extern void mot_weapon();
extern void mot_ship();

#include "chargen.h"

void solsec()
{
  int     roll, skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(4);
    newterm = basic_surv(7, intl, 10);
    if (newterm == 0) {
      skills += basic_comm(7, intl, 7);
      skills += basic_promo(7, intl, 8);
      if (branch == 2 || branch == 3) {
        roll = d12();
        if (roll > 10) {
          printf("Your cover has been blown! You are transfered to administration");
          if (rank < 4) {
            printf("\nand promoted to Lt Colonel.\n");
            rank = 4;
            rankeo = 'O';
          } else {
            printf(".\n");
          }
          branch = 4;
        }
      }
    }
    if (skills != 0) solsecskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(3);
  }
  terms = terms - anagathics;
  solsecmot(terms);
}


void solsecmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 10000; break;
        case 2: amt = 20000; break;
        case 3: amt = 30000; break;
        case 4: amt = 40000; break;
        case 5: amt = 50000; break;
        case 6: amt = 50000; break;
        case 7: amt = 50000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        solsecbene();
    }
    term--;
  }
  while (term > 0)
  {
    solsecbene();
    term--;
  }
}


void solsecbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_voucher(); break;
    case 2: bumpedu(); bumpedu(); break;
    case 3: bumpintl(); bumpintl(); break;
    case 4: mot_weapon(); break;
    case 5: mot_weapon(); break;
    case 6: mot_voucher(); break;
    case 7: mot_ship(); break;
  }
}


void solsecskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: physicl(1); break;
        case 4: mentl(1); break;
        case 5: mentl(1); break;
        case 6: mc(1); break;
      }
    }
    if (table == 2) {
      solsec_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: vhcl(1); break;
        case 2: vc(1); break;
        case 3: vc(1); break;
        case 4: techl(1); break;
        case 5: techl(1); break;
        case 6: addskill(LEADER, 1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: econ(1); break;
        case 2: spac(1); break;
        case 3: env(1); break;
        case 4: techl(1); break;
        case 5: interp(1); break;
        case 6: inbrn(1); break;
      }
    }
    skills--;
  }
}


void solsec_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: addskill(GRAVVHCL, 1); break;
        case 2: spac(1); break;
        case 3: mc(1); break;
        case 4: techl(1); break;
        case 5: spacetech(1); break;
        case 6: vc(1); break;
      }
}