/* TechPrst.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <string.h>

void techpriest();
void techprstmot(int term);
void techprstbene();
void techprstskills(int skills);
void techprst_tbl(int roll);
void gottechpriest();

#include "chargen.h"

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpdex();
extern void bumpedu();
extern void bumpend();
extern void bumpstr();
extern void bumpsoc();
extern void bumpintl();
extern void pc(int skl_val);
extern void vhcl(int skl_val);
extern void artillery(int skl_val);
extern void archaic(int skl_val);
extern void invest(int skl_val);
extern void env(int skl_val);
extern void vc(int skl_val);
extern void inbrn(int skl_val);
extern void airc(int skl_val);
extern void econ(int skl_val);
extern void influ(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_weapon();

void techpriest()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm == 0) {
    skills = basic_spec_duty(5);
    newterm = basic_surv(4, intl, 8);
    if (newterm == 0) {
      skills += basic_comm(7, soc, 10);
      skills += basic_promo(6, end, 7);
    }
    skills = specskl(skills);
    if (skills != 0) techprstskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(5);
  }
  terms = terms - anagathics;
  techprstmot(terms);
}


void techprstmot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 2000; break;
        case 3: amt = 5000; break;
        case 4: amt = 5000; break;
        case 5: amt = 5000; break;
        case 6: amt = 10000; break;
        case 7: amt = 20000; break;
      }
	  mot_cash(amt);
    }
	else
	{
      techprstbene();
      term--;
    }
  }
  while (term > 0)
  {
    techprstbene();
    term--;
  }
}


void techprstbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: bumpedu(); break;
    case 2: bumpintl(); break;
    case 3: mot_weapon(); break;
    case 4: mot_weapon(); break;
    case 5: mot_weapon(); break;
    case 6: bumpsoc(); break;
    case 7: mot_lopsg(); break;
  }
}


void techprstskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: archaic(1); break;
        case 2: bumpdex(); break;
        case 3: bumpstr(); break;
        case 4: vc(1); break;
        case 5: bumpend(); break;
        case 6: addskill(STREETWISE, 1); break;
      }
    }
    if (table == 2) {
      techprst_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(ELECTRONICS, 1); break;
        case 2: addskill(COMPUTER, 1); break;
        case 3: env(1); break;
        case 4: pc(1); break;
        case 5: vhcl(1); break;
        case 6: inbrn(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: addskill(PERCEPTION, 1); break;
        case 2: addskill(PSYCHOLOGY, 1); break;
        case 3: addskill(RESEARCH, 1); break;
        case 4: artillery(1); break;
        case 5: invest(1); break;
        case 6: airc(1); break;
      }
    }
    skills--;
  }
}


void techprst_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: econ(1); break;
        case 2: influ(1); break;
        case 3: addskill(ACTING, 1); break;
        case 4: env(1); break;
        case 5: archaic(1); break;
        case 6: addskill(RECRUITING, 1); break;
      }
}


void gottechpriest()
{
  careernbr = TECHNOPRIEST;
  strncpy(career,"Tech Priesthood",16);
  if ((col % 10) == 1) rankeo = 'O';
}