/* WEALTHY.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <string.h>

void wealthy();
void wealthymot(int term);
void wealthybene();
void wealthyskills(int skills);
void wealthy_tbl(int roll);
void gotwealthy();

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpsoc();
extern void bumpdex();
extern void bumpend();
extern void bumpedu();
extern void arts(int skl_val);
extern void airc(int skl_val);
extern void mc(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void spacvhcl(int skl_val);
extern void inbrn(int skl_val);
extern void boats(int skl_val);
extern void vc(int skl_val);
extern void pc(int skl_val);
extern void acad(int skl_val);
extern void animal(int skl_val);
extern void explore(int skl_val);
extern void influ(int skl_val);
extern void econ(int skl_val);
extern void env(int skl_val);
extern void sci(int skl_val);
extern void mot_cash(int amt);
extern void mot_tas();
extern void mot_weapon();
extern void mot_ship();


#include "chargen.h"

void wealthy()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm == 0)
  {
    skills = basic_spec_duty(6);
    newterm = basic_surv(5, edu, 8);
    if (newterm == 0) skills += 2;
    skills = specskl(skills);
    if (skills != 0) wealthyskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(5);
  }
  terms -= anagathics;
  wealthymot(terms);
}


void wealthymot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 5000; break;
        case 2: amt = 10000; break;
        case 3: amt = 20000; break;
        case 4: amt = 30000; break;
        case 5: amt = 50000; break;
        case 6: amt = 75000; break;
        case 7: amt = 100000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        wealthybene();
    }
  }
  while (term > 0)
  {
    wealthybene();
    term--;
  }
}


void wealthybene()
{
  int roll;

  roll = basic_bene();
  switch (roll) {
    case 1: bumpend(); break;
    case 2: bumpedu(); break;
    case 3: bumpsoc(); break;
    case 4: mot_weapon(); break;
    case 5: mot_tas(); break;
    case 6: mot_ship(); break;
    case 7: mot_ship(); break;
  }
}


void wealthyskills(int skills)
{
  int  table, roll;

  while (skills > 0)
  {
    table = picktable();
    roll = d6();
    if (table == 1)
	{
      switch (roll)
	  {
        case 1: bumpend(); break;
        case 2: bumpdex(); break;
        case 3: bumpedu(); break;
        case 4: vc(1); break;
        case 5: pc(1); break;
        case 6: arts(1); break;
      }
    }
    if (table == 2)
	{
      wealthy_tbl(roll);
    }
    if (table == 3)
	{
      switch (roll)
	  {
        case 1: addskill(LEADER, 1); break;
        case 2: env(1); break;
        case 3: airc(1); break;
        case 4: inbrn(1); break;
        case 5: vhcl(1); break;
        case 6: boats(1); break;
      }
    }
    if (table == 4)
	{
      switch (roll)
	  {
        case 1: addskill(LINGUISTICS, 1); break;
        case 2: spacvhcl(1); break;
        case 3: mc(1); break;
        case 4: vc(1); break;
        case 5: sci(1); break;
        case 6: acad(1); break;
      }
    }
    skills--;
  }
}


void wealthy_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll)
	  {
        case 1: animal(1); break;
        case 2: explore(1); break;
        case 3: influ(1); break;
        case 4: econ(1); break;
        case 5: addskill(VACCSUIT, 1); break;
        case 6: addskill(PERCEPTION, 1); break;
      }
}

void gotwealthy()
{
  strncpy(career,"wealthy traveller",18);
  careernbr = WEALTHTRAV;
}
