/* ZHONAVY.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void zhonavy();
int zhonv_set_branch();
int zhonv_doterms();
int zhonv_do_year();
int zhotechmos();
int zholn_mos();
void zhonavymot(int term);
void zhonavybene();
void zhonv_talent();
void zhonv_tech();
void zhonv_spcl_asgn();
void zhonv_ocs();
void zhonv_spcl_sch();
int zhonv_asgn();
int zhonv_asgnroll();
int zhonv_cmd();

extern int nv_get_branch();
extern int nv_do_initial();
extern int nv_adj();
extern int nv_xfer();
extern int anag();
extern void adv_aging(int anags);
extern int getrank();
extern int survive(int adjust, int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int d10();
extern int d12();
extern int getsel_int(int min, int max);
extern char getche_y_n();
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int chk_skl(int skill, int skl_val);
extern int bp_skill(int roll);
extern int reenlist(int need_nbr);
extern void decorate(int adjust);
extern int find_skl(int skill);
extern void nv_gen_skl();
extern int ln_mos();
extern void nv_attache();
extern void nv_gun_sch();
extern void nv_engr_sch();
extern void nv_intl_sch();
extern void bumpdex();
extern void nv_cmd_col();
extern void nv_staff_col();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void bc(int skl_val);
extern void nv_branch(int branch);
extern int zhoasgnroll();
extern void nv_branch_tbl(int roll);
extern void vhcl(int skl_val);
extern void gottelepath();
extern void gotaware();
extern void bumppsi();
extern void darfltsch();
extern void darnv_tech_sch();
extern void darnv_cross_train();
extern void bp_add(int amt);
extern void get_spcl_duty();
extern void merc_rcrtng();
extern int ask_adj_asgn(int roll);
extern void mot_cash(int amt);
extern void mot_hipsg();
extern void mot_weapon();
extern void mot_tas();

#include "chargen.h"


void zhonavy()
{
  int i;

  for (i = 1; i <= 9; i++)
    nv_cross[i] = 0;
  aide = 0;
  command = 0;
  combat = 0;
  assignment = 0;
  if (rankeo == 'O') darfltsch();
  nv_get_branch();
  nv_do_initial();
  while (zhonv_doterms() == 0);
  terms = terms - anagathics;
  zhonavymot(terms);
}


int zhonv_set_branch()
{
  int roll;

  if (branch != 0) return branch;
  if (tech_sch > 0 || med_sch > 0) return 6;
  roll = d6();
  if (soc < 10 && edu >= 6) roll--;
  if (psi >= 11) roll += 2;
  if (roll <= 2) return 4;
  if (roll == 3) return 3;
  if (roll == 4) return 6;
  if (roll >= 7) return 7;
  return 1;
}


int zhonv_doterms()
{
  int survival, need_nbr;
  
  adv_aging(nv_anag);
  do {
    survival = zhonv_do_year();
  } while (((age % 4) != 2) && (survival == 0));
  if (survival != 0) return 1;
  need_nbr = 5;
  if (rankeo == 'E') need_nbr -= 2;
  survival = reenlist(need_nbr);
  if (survival != 0) return 1; 
  drafted = 0;
  branch = nv_xfer();
  nv_anag = anag();
  return 0;
}


int zhonv_do_year()
{
  int   adjust, roll;
  
  age++;
  if (nv_anag == 0) appearent_age++;
  command = zhonv_cmd();
  assignment = zhonv_asgn();
  if (combat != 0 && command != 0) cmd++;
  if ((rank < 9 && rankeo == 'E') 
    || ((rankeo == 'O') && ((line == 1 && rank < 8)
    || (line == 2 && rank < 7)))) {
    if (promo != 0) {
      roll = d12();
      if ((branch == 1 && command == 1) || (branch >= 3 && dex >= 9)
        || (branch == 4 && find_skl(ENGINEERING) >= 4) 
        || (branch == 6 && zhotechmos() >= 3)) roll++;
      if (roll >= promo) {
        rank++;
        printf("You were promoted. ");
        getrank();
        nv_gen_skl();
      }
    }
  }
  adjust = nv_adj();
  decorate(adjust);
  if (assignment == 7) zhonv_spcl_asgn();
  if (skil != 0) {
    roll = d12();
    if (roll < skil) roll = bp_skill(roll);
    if (roll >= (skil + 4)) nv_gen_skl();
    if (roll >= skil) nv_gen_skl();
  }
  roll = d12();
  if (branch == 1 && ln_mos() != 0) roll++;
  if (branch == 2 && find_skl(PILOT) > 0) roll += find_skl(PILOT);
  return survive(roll, adjust);
}


int zhotechmos()
{
  int skl, highskl;

  highskl = 0;
  skl = find_skl(COMPUTER);
  if (skl > highskl) highskl = skl;
  skl = find_skl(HANDYMAN);
  if (skl > highskl) highskl = skl;
  skl = find_skl(GRAVITICS);
  if (skl > highskl) highskl = skl;
  skl = find_skl(ELECTRONICS);
  if (skl > highskl) highskl = skl;
  skl = find_skl(MECHANICAL);
  if (skl > highskl) highskl = skl;
  skl = find_skl(PSYCHOLOGY);
  if (skl > highskl) highskl = skl;
  return highskl;
}


int zholn_mos()
{
  int qual;

  qual = chk_skl(SHIPBOAT, 2);
  if (qual == 0) qual = chk_skl(MECHANICAL, 2);
  if (qual == 0) qual = chk_skl(STEWARD, 2);
  if (qual == 0) qual = chk_skl(GUNCMBT, 2);
  if (qual == 0) qual = chk_skl(COMPUTER, 2);
  if (qual == 0) qual = chk_skl(COMMO, 2);
  if (qual == 0) qual = chk_skl(LIAISON, 2);
  if (qual == 0) qual = chk_skl(NOGRAV, 2);
  if (qual == 0) qual = chk_skl(BATTLEDRESS, 2);
  if (qual != 0) return 1;
  return 0;
}


void zhonavymot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 1000; break;
        case 3: amt = 2000; break;
        case 4: amt = 5000; break;
        case 5: amt = 10000; break;
        case 6: amt = 20000; break;
        case 7: amt = 20000; break;
      }
	  mot_cash(amt);
    }
	else
	{
        term--;
        zhonavybene();
    }
  }
  while (term > 0)
  {
    zhonavybene();
    term--;
  }
}


void zhonavybene()
{
  int roll;

  roll = basic_bene();
  if (soc >= 11 || rank >= 5) roll++;
  switch (roll)
  {
    case 1: bumpsoc(); break;
    case 2: bumpintl(); break;
    case 3: bumpedu(); bumpedu(); break;
    case 4: mot_weapon(); break;
    case 5: mot_tas(); kitval = 0; break;
    case 6: mot_hipsg(); kitval = 0; break;
    case 7: bumpsoc(); bumpsoc(); break;
  }
}


void zhonv_talent()
{
  int  roll;

  roll = d6();
  if (line == 1) roll += 2;
  switch (roll) {
        case 1: addskill(ADMIN, 1); break;
        case 2: addskill(HANDYMAN, 1); break;
        case 3: bumppsi(); break;
        case 4: gottelepath(); break;
        case 5: addskill(MEDICAL, 1); break;
        case 6: addskill(COMPUTER, 1); break;
        case 7: gotaware(); break;
        case 8: bumppsi(); break;
  }
}


void zhonv_tech()
{
  int  roll;

  roll = d6();
  if (line == 1) roll += 2;
  if (line == 2) roll++;
  switch (roll) {
        case 1: addskill(MECHANICAL, 1); break;
        case 2: addskill(ELECTRONICS, 1); break;
        case 3: addskill(GRAVITICS, 1); break;
        case 7: addskill(HANDYMAN, 1); break;
        case 8: addskill(PSYCHOLOGY, 1); break;
        default: addskill(COMPUTER, 1); break;
  }
}


void zhonv_spcl_asgn()
{
  int roll;
  
  roll = d6();
  if (edu >= 7) roll += 2;
  if (roll == 1) {
    if (rankeo == 'E') 
      zhonv_spcl_sch();
    else
      nv_attache();
  }
  if (roll == 2) merc_rcrtng();
  if (rankeo == 'E') {
    if (roll == 3) nv_gun_sch();
    if (roll == 4) darnv_tech_sch();
    if (roll == 5) nv_engr_sch();
    if (roll == 6) darnv_cross_train();
    if (roll == 7) zhonv_ocs();
    if (roll == 8) zhonv_spcl_sch();
  } else {
    if (roll == 3) nv_intl_sch();
    if (roll == 4) nv_cmd_col();
    if (roll >= 7) darnv_cross_train();
    if (roll == 6 || roll == 5) nv_staff_col();
  }
}


void zhonv_ocs()
{
  char fleet[20];

  printf("You got Officer Candidate School. Congratulations!\n");
  rankeo = 'O';
  rank = 0;
  branch = nv_xfer();
  nv_branch(branch);
  if (line == 1) strncpy(fleet, "Consular Navy", 14);
  if (line == 2) strncpy(fleet, "Regional Navy", 14);
  if (line == 3) strncpy(fleet, "System Navy", 12);
  printf("Your new assignment is with the %s branch of the %s.\n", 
    office, fleet);
}


void zhonv_spcl_sch()
{
  int roll;

  printf("You went to Specialist School.\n");
  roll = d10();
  if (rankeo == 'O') roll += 4;
  switch (roll) {
      case 1: addskill(MEDICAL, 1); break;
      case 2: addskill(MECHANICAL, 1); break;
      case 3: addskill(LIAISON, 1); break;
      case 4: addskill(ADMIN, 1); break;
      case 5: addskill(ELECTRONICS, 1); break;
      case 6: addskill(GRAVITICS, 1); break;
      case 7: addskill(SHIPBOAT, 1); break;
      case 8: vhcl(1); break;
      case 9: addskill(NAVIGATION, 1); break;
      case 10: addskill(COMPUTER, 1); break;
  }
}


int zhonv_asgn()
{
  int roll;

  combat = 0;
  roll = d6();
  if (roll == 6 && assignment != 0)
  {
    printf("You were allowed to repeat your last assignment.\n");
    if (assignment > 3 && assignment < 7)
	{
      combat = 1;
      cmbt++;
    }
    return assignment;
  }
  skil = surv = decor = promo = 0;
  return zhoasgnroll();
}


int zhoasgnroll()
{
  int roll;

  roll = d12();
  if (rankeo == 'E' && edu >= 6) roll--; 
  if (soc >= 10) roll++;
  if (pick == 1 && brownie_points > 0)
	  roll = ask_adj_asgn(roll);
  if (pick == 4 && (roll == 2 || roll == 10) && brownie_points > 3)
  {
	  roll++;
	  get_spcl_duty();
  }
  printf("This is a ");
  if (roll >= 12)
  {
    printf("battle assignment.\n");
    cmbt++;
    combat = 1;
    switch (branch)
	{
      case 2: skil = 5; surv = 4; decor = 8; promo = 10; break;
      case 3: skil = 5; surv = 6; decor = 7; promo = 7; break;
      case 4: skil = 4; surv = 5; decor = 7; promo = 7; break;
      case 6: skil = 6; surv = 3; decor = 8; promo = 8; break;
      case 7: skil = 6; surv = 5; decor = 8; promo = 9; break;
      default: skil = 4; surv = 6; decor = 6; promo = 7; break;
    }
    return 6;
  }
  if (roll == 7) {
    printf("training assignment.\n");
    skil = 6;
    if (branch == 2) surv = 3;
    if (branch == 3) skil = 7;
	if (branch == 7)
	{
		skil = 8;
		promo = 12;
	}
    return 1;
  }
  if (roll <= 2 || roll == 10) {
    printf("shore duty assignment.\n");
    switch (branch) {
      case 2: surv = 3; promo = 12; break;
      case 3: surv = 3; decor = 12; break;
      case 4: skil = 7; break;
      case 6: surv = 3; skil = 7; promo = 9; break;
      case 7: surv = 3; skil = 6; promo = 9; break;
      default: surv = 4; skil = 6; decor = 12; break;
    }
    return 2;
  }
  if (roll == 4) {
    printf("seige assignment.\n");
    cmbt++;
    combat = 1;
    switch (branch) {
      case 2: skil = 6; surv = 3; promo = 11; decor = 9; break; 
      case 3: skil = 4; surv = 5; promo = 9; decor = 10; break; 
      case 4: skil = 6; surv = 4; decor = 11; promo = 9; break;
      case 6: skil = 6; surv = 3; promo = 9; break;
      case 7: surv = 4; skil = 7; promo = 9; decor = 10; break;
      default: skil = 5; surv = 5; promo = 9; decor = 10; break; 
    }
    return 4;
  }
  if (roll == 9 || roll == 5) {
    printf("strike assignment.\n");
    cmbt++;
    combat = 1;
    switch (branch) {
      case 2: skil = 6; surv = 3; promo = 10; decor = 9; break; 
      case 3: skil = 5; surv = 5; promo = 8; decor = 9; break; 
      case 4: skil = 5; surv = 5; promo = 7; decor = 7; break;
      case 6: skil = 6; surv = 3; promo = 8; decor = 9; break;
      case 7: skil = 7; surv = 5; promo = 9; decor = 9; break;
      default: skil = 4; surv = 6; promo = 8; decor = 7; break; 
    }
    return 5;
  }
  if (roll == 6 || roll == 8) {
    printf("patrol assignment.\n");
    switch (branch) {
      case 2: skil = 6; surv = 3; promo = 12; decor = 10; break; 
      case 3: skil = 6; surv = 4; promo = 9; decor = 11; break; 
      case 4: skil = 5; surv = 3; promo = 6; decor = 12; break;
      case 6: skil = 8; surv = 3; promo = 10; break;
      case 7: skil = 7; surv = 4; decor = 11; promo = 9; break;
      default: skil = 5; surv = 4; promo = 8; decor = 11; break; 
    }
    return 3;
  }
  printf("special duty assignment.\n");
  return 7;
}


int zhonv_cmd()
{
  int  roll, need_nbr;

  if (rankeo == 'E' || rank == 0) return 0;
  roll = d12();
  if (rank <= 2) roll -= 2;
  if (soc >= 11) roll += 2;
  if (edu >= 10) roll++;
  if (psi >= 11) roll++;
  switch (branch)
  {
  case 1: need_nbr = 7;
  case 2: need_nbr = 9;
  case 3: need_nbr = 10;
  case 4: need_nbr = 9;
  case 6: need_nbr = 11;
  default: need_nbr = 8;
  }
  if (roll >= need_nbr) return 1;
  else return 0;
}
