/* ZHOPROLE.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>

void zhoprole();
void zhoprolemot(int term);
void zhoprolebene();
void zhoproleskills(int skills);
void prole_tbl();

#include "chargen.h"

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int basic_cash();
extern int basic_mot();
extern int basic_bene();
extern int d6();
extern int d8();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern int specskl(int skill);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int picktable();
extern void bumpdex();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void bumpstr();
extern void bumpend();
extern void vhcl(int skl_val);
extern void mot_cash(int amt);
extern void mot_lopsg();
extern void mot_hipsg();
extern void mot_midpsg();
extern void mot_tas();

void zhoprole()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm == 0) {
    skills = basic_spec_duty(6);
    newterm = basic_surv(5, intl, 9);
    if (newterm == 0) {
      skills += basic_comm(8, intl, 7);
      skills += basic_promo(8, edu, 8);
    }
    skills = specskl(skills);
    if (skills != 0) zhoproleskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(5);
  }
  terms = terms - anagathics;
  zhoprolemot(terms);
}


void zhoprolemot(int term)
{
  int  cash, roll, amt;
  char choice;
  
  cash = basic_mot();
  while ((term > 0) && (cash > 0))
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 1000; break;
        case 2: amt = 2000;break;
        case 3: amt = 5000; break;
        case 4: amt = 5000; break;
        case 5: amt = 5000; break;
        case 6: amt = 10000; break;
        case 7: amt = 30000; break;
      }
	  mot_cash(amt);
    }
	else
	{
      zhoprolebene();
      term--;
    }
  }
  while (term > 0)
  {
    zhoprolebene();
    term--;
  }
}


void zhoprolebene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: bumpsoc(); break;
    case 2: bumpintl(); break;
    case 3: bumpedu(); break;
    case 4: mot_lopsg(); break;
    case 5: mot_midpsg(); break;
    case 6: mot_hipsg(); break;
    case 7: mot_tas(); break;
  }
}


void prole_tbl()
{
    int roll;
    roll = d8();
    switch (roll) {
        case 1: addskill(ADMIN, 1); break;
        case 2: addskill(BROKER, 1); break;
        case 3: addskill(COMPUTER, 1); break;
        case 4: addskill(ELECTRONICS, 1); break;
        case 5: addskill(MECHANICAL, 1); break;
        case 6: addskill(MEDICAL, 1); break;
        case 7: addskill(STEWARD, 1); break;
        case 8: addskill(TRADER, 1); break;
    }
}


void zhoproleskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = picktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: bumpstr(); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: addskill(BRAWLING, 1); break;
        case 5: bumpedu(); break;
        case 6: prole_tbl(); break;
      }
    }
    if (table == 2) {
      switch (roll) {
        case 1: vhcl(1); break;
        case 2: addskill(MECHANICAL, 1); break;
        case 3: addskill(BRAWLING, 1); break;
        case 4: prole_tbl(); break;
        case 5: prole_tbl(); break;
        case 6: prole_tbl(); break;
      }
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(COMPUTER, 1); break;
        case 2: addskill(BRAWLING, 1); break;
        case 3: addskill(HANDYMAN, 1); break;
        case 4: prole_tbl(); break;
        case 5: prole_tbl(); break;
        case 6: prole_tbl(); break;
      }
    }
    skills--;
  }
}
