/* KREFLEET.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void krefleet();
void kreflt_get_branch();
int kreflt_set_branch();
void kreflt_do_initial();
int kreflt_doterms();
void kreflt_branch(int branch_nbr);
int kreflt_do_year();
void kreflt_branch_tbl(int brnch);
void kreflt_wlbrn_off();
void kreflt_noble_off();
void kreflt_cmd_off();
void kreflt_life();
void kreflt_line();
void kreflt_flt();
void kreflt_gun();
void kreflt_staff_off();
void kreflt_engr();
void kreflt_med();
void kreflt_tech();
void kreflt_shore_duty();
void kreflt_ship_duty();
void kreflt_spcl_asgn();
void kreflt_attache();
void kreflt_flt_sch();
void kreflt_spcl_sch();
void kreflt_gun_sch();
void kreflt_engr_sch();
void kreflt_staff_col();
void kreflt_gen_skl();
void kreflt_duty();
void kreflt_pick_tbl();
int kreflt_asgn();
int kreflt_promo(int promo);
int kreflt_surv(int surv);
int kreln_mos();
int kreflt_cmd();
void kreflt_cross_train();

extern int anag();
extern int getrank();
extern int survive(int adjust, int roll);
extern int d3();
extern int d4();
extern int d6();
extern int d12();
extern int getsel_int(int min, int max);
extern void addskill(int skill, int skl_val);
extern int find_skl(int skill);
extern int chk_skl(int skill, int skl_val);
extern int bp_skill(int roll);
extern int bp_skill1(int roll, int need_nbr);
extern void bp_cmbt();
extern void nv_intl_sch();
extern void nv_gun_sch();
extern void nv_cmd_col();
extern void kredfltwar();
extern void bumpdex();
extern void bumpstr();
extern void bumpend();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();
extern void gunner(int skl_val);
extern void gc(int skl_val);
extern void vhcl(int skl_val);
extern void bp_add(int amt);
extern int ask_adj_asgn(int roll);
extern void gotspcldty(int spcldutynbr);

#include "chargen.h"

extern int aide, nv_anag;

void krefleet()
{
  int term;

  aide = 0;
  if (branch == 1) addskill(LEADER, 1);
  kredfltwar();  
  kreflt_get_branch();
  kreflt_do_initial();
  term = terms;
  while (term >= 1) {
    term--;
    if (kreflt_doterms() != 0) term = 0;
    else 
      if (term > 0) nv_anag = anag();
  }
}


void kreflt_get_branch()
{
  branch = kreflt_set_branch();
  kreflt_branch(branch);
  printf("You were assigned to the %s branch.\n", office);
}


int kreflt_set_branch()
{
  int roll;

  roll = d6();
  if (roll <= 2) return 1;
  if (roll == 3) return 3;
  if (roll == 4) return 4;
  if (roll == 5) return 5;
  return 6;
}


void kreflt_do_initial()
{
  if (rank == 0) rank++;
  kreflt_branch_tbl(branch);
  kreflt_branch_tbl(branch);
  age++;
  nv_anag = anag();
  if (nv_anag == 0) appearent_age++;
}


extern int assignment, command, combat;

int kreflt_doterms()
{
  int survival;
  
  command = 0;
  combat = 0;
  assignment = 0;
  do {
    survival = kreflt_do_year();
  } while (((age % 6) != 2) && (survival == 0));
  if (survival != 0) return 1;
  drafted = 0;
  return 0;
}


void kreflt_branch(int branch_nbr)
{
  switch (branch_nbr) {
    case 1: strncpy(office,"Line/Crew",10); break;
    case 2: strncpy(office,"Flight",7); break; 
    case 3: strncpy(office,"Gunnery",8); break; 
    case 4: strncpy(office,"Engineering",12); break; 
    case 5: strncpy(office,"Medical",8); break; 
    case 6: strncpy(office,"Technical",10); break; 
    default: strncpy(office,"unknown?",9); break;
  }
}


int kreflt_do_year()
{
  int   roll;
  
  age++;
  if (nv_anag == 0) appearent_age++;
  command = kreflt_cmd();
  assignment = kreflt_asgn();
  if (combat != 0 && command == 1) cmd++;
  if (promo != 0) {
    roll = d12();
    if (roll >= promo) {
      if (rank == 1) {
        if (line == 1) rank = soc - 1;
        else rank = soc;
      } else {
        if (soc > rank) {
          rank++;
          printf("You were promoted. ");
          getrank();
        } else bumpsoc();
      }
      if (line == 2 && rank >= 7) rankeo = 'O';
    }
  }
  if (assignment == 7) kreflt_spcl_asgn();
  if (skil != 0) {
    roll = d12();
    if (roll < skil) roll = bp_skill(roll);
    if (roll >= (skil + 4)) kreflt_gen_skl();
    if (roll >= skil) kreflt_gen_skl();
  }
  roll = d12();
  return survive(roll, 0);
}


void kreflt_branch_tbl(int brnch)
{
  switch (brnch) {
    case 1: kreflt_line(); break;
    case 2: kreflt_flt(); break;
    case 3: kreflt_gun(); break;
    case 4: kreflt_engr(); break;
    case 5: kreflt_med(); break;
    case 6: kreflt_tech(); break;
  }
}


void kreflt_wlbrn_off()
{
  int  roll;

  roll = d6();
  if (rank >= 7) roll += 4;
  switch (roll) {
    case 1: addskill(GAMBLING, 1); break;
    case 2: bumpdex(); break;
    case 3: addskill(CAROUSING, 1); break;
    case 4: addskill(GAMBLING, 1); break;
    case 5: addskill(ENCLOSURE, 1); break;
    case 6: bumpsoc(); break;
    case 7: bumpintl(); break;
    case 8: bumpedu(); break;
    case 9: addskill(ADMIN, 1); break;
    case 10: bumpend(); break;
  }
}


void kreflt_noble_off()
{
  int  roll;

  roll = d6();
  if (rank >= 7) roll += 4;
  switch (roll) {
    case 1: addskill(ADMIN, 1); break;
    case 2: bumpedu(); break;
    case 3: addskill(CAROUSING, 1); break;
    case 4: addskill(GAMBLING, 1); break;
    case 5: addskill(ENCLOSURE, 1); break;
    case 6: bumpsoc(); break;
    case 7: bumpintl(); break;
    case 8: addskill(LEADER, 1); break;
    case 9: addskill(ADMIN, 1); break;
    case 10: addskill(TOLERANCE, 1); break;
  }
}


void kreflt_cmd_off()
{
  int  roll;

  roll = d6();
  if (rank >= 7) roll += 4;
  switch (roll) {
    case 1: gc(1); break;
    case 2: bumpsoc(); break;
    case 3: addskill(SHIPBOAT, 1); break;
    case 4: addskill(ELECTRONICS, 1); break;
    case 5: addskill(ENCLOSURE, 1); break;
    case 6: addskill(SHIPTAC, 1); break;
    case 7: addskill(LEADER, 1); break;
    case 8: addskill(PILOT, 1); break;
    case 9: addskill(FLEETTAC, 1); break;
    case 10: addskill(SHIPTAC, 1); break;
  }
}


void kreflt_life()
{
  int  roll;

  roll = d6();
  if (rank >= 7) roll += 4;
  switch (roll) {
        case 1: bumpstr(); break;
        case 2: addskill(GAMBLING, 1); break;
        case 3: addskill(CAROUSING, 1); break;
        case 4: addskill(CLOSECMBT, 1); break;
        case 5: addskill(ENCLOSURE, 1); break;
        case 6: bumpdex(); break;
        case 7: bumpend(); break;
        case 8: bumpedu(); break;
        case 9: addskill(CLOSECMBT, 1); break;
        case 10: addskill(VACCSUIT, 1); break;
  }
}


void kreflt_line()
{
  int  roll;

  roll = d6();
  if (line == 1) roll += 2;
  if (line == 2) roll++;
  switch (roll) {
        case 1: addskill(MECHANICAL, 1); break;
        case 2: addskill(ELECTRONICS, 1); break;
        case 3: gc(1); break;
        case 4: addskill(NAVIGATION, 1); break;
        case 5: addskill(COMPUTER, 1); break;
        case 6: addskill(NOGRAV, 1); break;
        case 7: addskill(LIAISON, 1); break;
        case 8: addskill(SHIPTAC, 1); break;
  }
}


void kreflt_flt()
{
  int  roll;

  roll = d6();
  if (line == 1) roll += 2;
  if (line == 2) roll++;
  switch (roll) {
        case 1: addskill(VACCSUIT, 1); break;
        case 2: addskill(ENCLOSURE, 1); break;
        case 3: addskill(ENCLOSURE, 1); break;
        case 4: addskill(ENCLOSURE, 1); break;
        case 5: addskill(NAVIGATION, 1); break;
        case 6: addskill(PILOT, 1); break;
        case 7: addskill(PILOT, 1); break;
        case 8: addskill(PILOT, 1); break;
  }
}


void kreflt_gun()
{
  int  roll;

  roll = d6();
  if (line == 1) roll += 2;
  if (line == 2) roll++;
  switch (roll) {
      case 1: addskill(FORWARDOBS, 1); break;
      case 2: gc(1); break;
      case 3: addskill(COMMO, 1); break;
      case 4: addskill(COMPUTER, 1); break;
      default: gunner(1); break;
  }
}


void kreflt_staff_off()
{
  int  roll;

  roll = d6();
  if (rank >= 7) roll += 4;
  switch (roll) {
      case 1: addskill(COMPUTER, 1); break;
      case 2: addskill(ELECTRONICS, 1); break;
      case 3: gc(1); break;
      case 4: addskill(ADMIN, 1); break;
      case 5: addskill(TOLERANCE, 1); break;
      case 6: addskill(ENCLOSURE, 1); break;
      case 7: addskill(SHIPTAC, 1); break;
      case 8: addskill(FLEETTAC, 1); break;
      case 9: addskill(FLEETTAC, 1); break;
      case 10: addskill(COMPUTER, 1); break;
  }
}


void kreflt_engr()
{
  int  roll;

  roll = d6();
  if (line == 1) roll += 2;
  if (line == 2) roll++;
  switch (roll) {
      case 1: addskill(MECHANICAL, 1); break;
      case 2: addskill(VACCSUIT, 1); break;
      case 3: addskill(ENCLOSURE, 1); break;
      case 4: addskill(ELECTRONICS, 1); break;
      default: addskill(ENGINEERING, 1); break;
  }
}


void kreflt_med()
{
  int  roll;

  roll = d6();
  if (line == 1) roll += 2;
  if (line == 2) roll++;
  switch (roll) {
        case 1: addskill(STEWARD, 1); break;
        case 2: addskill(ADMIN, 1); break;
        case 3: addskill(ELECTRONICS, 1); break;
        case 4: addskill(COMPUTER, 1); break;
        default: addskill(MEDICAL, 1); break;
        case 8: addskill(ADMIN, 1); break;
  }
}


void kreflt_tech()
{
  int  roll;

  roll = d6();
  if (line == 1) roll += 2;
  if (line == 2) roll++;
  switch (roll) {
      case 1: addskill(MECHANICAL, 1); break;
      case 2: addskill(MECHANICAL, 1); break;
      case 3: addskill(ELECTRONICS, 1); break;
      case 4: addskill(ELECTRONICS, 1); break;
      case 5: addskill(GRAVITICS, 1); break;
      case 6: addskill(HANDYMAN, 1); break;
      case 7: addskill(COMPUTER, 1); break;
      case 8: addskill(COMPUTER, 1); break;
  }
}


void kreflt_shore_duty()
{
  int  roll;

  roll = d6();
  if (rank >= 7) roll += 4;
  switch (roll) {
        case 1: addskill(ENCLOSURE, 1); break;
        case 2: addskill(VACCSUIT, 1); break;
        case 3: addskill(FORWARDOBS, 1); break;
        case 4: addskill(POLEARM, 1); break;
        case 5: addskill(SURVIVAL, 1); break;
        case 6: addskill(VACCSUIT, 1); break;
        case 7: addskill(ENCLOSURE, 1); break;
        case 8: addskill(LIAISON, 1); break;
        case 9: gc(1); break;
        case 10: addskill(BATTLEDRESS, 1); break;
  }
}


void kreflt_ship_duty()
{
  int  roll;

  roll = d6();
  if (rank >= 7) roll += 4;
  switch (roll) {
        case 1: addskill(ENCLOSURE, 1); break;
        case 2: addskill(VACCSUIT, 1); break;
        case 7: addskill(MECHANICAL, 1); break;
        case 5: addskill(COMMO, 1); break;
        case 4: addskill(SHIPBOAT, 1); break;
        case 6: addskill(HANDYMAN, 1); break;
        case 3: addskill(NOGRAV, 1); break;
        case 8: addskill(ENCLOSURE, 1); break;
        case 9: addskill(VACCSUIT, 1); break;
        case 10: addskill(ADMIN, 1); break;
  }
}


void kreflt_spcl_asgn()
{
  int roll, encl;
  
  roll = d6();
  printf("Special duty roll = %d, ", roll);
  encl = find_skl(ENCLOSURE);
  printf("enclosure = %d.\n", encl);
  if (encl > 3) encl = 3;
  roll += encl;
  if (roll == 4) kreflt_cross_train();
  if (rankeo == 'E')
  {
    if (roll == 1) kreflt_spcl_sch();
    if (roll == 2) nv_gun_sch();
    if (roll == 3) kreflt_engr_sch();
    if (roll >= 5) kreflt_flt_sch();
  }
  else
  {
    if (roll == 1) kreflt_attache();
    if (roll == 2) nv_intl_sch();
    if (roll == 3) nv_cmd_col();
    if (roll == 5) kreflt_staff_col();
    if (roll >= 6) kreflt_flt_sch();
  }
}


void kreflt_attache()
{
  int roll;

  gotspcldty(ATTACHE);
  roll = bp_skill1(d6(), 6);
  if (roll >= 6) bumpsoc();
  roll = bp_skill1(d6(), 6);
  if (roll >= 6) addskill(LIAISON, 1);
  roll = bp_skill1(d6(), 6);
  if (roll >= 6) addskill(ENCLOSURE, 1);
  roll = bp_skill1(d6(), 6);
  if (roll >= 6) addskill(TOLERANCE, 1);
  roll = bp_skill1(d6(), 6);
  if (roll >= 6) addskill(SHIPTAC, 1);
}


void kreflt_flt_sch()
{
  int roll, encl;

  printf("You got Flight School. Congratulations!\n");
  bp_add(1);
  flt_sch = 1;
  roll = bp_skill1(d6(), 6);
  if (roll >= 6)
	  addskill(ENCLOSURE, 1);
  encl = find_skl(ENCLOSURE);
  if (encl >= 1)
  {
    kreflt_flt();
    kreflt_flt();
  }
  branch = 2;
  kreflt_branch(branch);
  printf("Your new assignment is with the %s branch.\n", office);
}


void kreflt_spcl_sch()
{
  int roll;

  gotspcldty(SPECIALISTSCH);
  roll = d6();
  if (line == 2) roll += 3;
  if (line == 3) roll--;
  switch (roll) {
    case 0: addskill(STEWARD, 1); break;
    case 1: addskill(MEDICAL, 1); break;
    case 2: vhcl(1); break;
    case 3: addskill(COMMO, 1); break;
    case 4: addskill(GRAVITICS, 1); break;
    case 5: addskill(MECHANICAL, 1); break;
    case 6: addskill(ELECTRONICS, 1); break;
    case 7: addskill(COMPUTER, 1); break;
    case 8: addskill(ADMIN, 1); break;
    case 9: addskill(LEADER, 1); break;
  }
}


void kreflt_gun_sch()
{
  int i, roll;

  gotspcldty(GUNNERYSCH);
  for (i = 1; i <= 4; i++)
  {
    roll = bp_skill1(d6(), 5);
    if (roll >= 5) gunner(1);
  }
}


void kreflt_engr_sch()
{
  int roll;

  gotspcldty(ENGINEERINGSCH);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(MECHANICAL, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(ELECTRONICS, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(COMPUTER, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(GRAVITICS, 1);
  roll = bp_skill1(d6(), 5);
  if (roll >= 5) addskill(ENGINEERING, 1);
}


void kreflt_staff_col()
{
  int roll;

  gotspcldty(STAFFCOL);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(ADMIN, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(COMMO, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(INSTRUCTION, 1);
  roll = bp_skill1(d6(), 4);
  if (roll >= 4) addskill(COMPUTER, 1);
}


void kreflt_gen_skl()
{
  int roll;

  if (pick <= 2) {
    kreflt_pick_tbl();
    return;
  }
  if (rankeo == 'O') {
    roll = d4();
  } else {
    roll = d3();
  }
  if (roll == 1) kreflt_life();
  if (roll == 2) kreflt_duty();
  if (roll == 3) kreflt_branch_tbl(branch);
  if (roll == 4) {
    if (command == 1) kreflt_cmd_off();
    else kreflt_staff_off();
  }
}


void kreflt_duty()
{
  if (assignment <= 2) kreflt_shore_duty();
  else kreflt_ship_duty();
}


void kreflt_pick_tbl()
{
  int choice;
  printf("\nPlease select the table you wish to use for your new skill.\n");
  if (line == 3 || (line == 2 && rank < 7)) printf("\n   1. Navy life\n");   
  if (line == 1) printf("\n   1. Noble Officers life\n");   
  if (line == 2 && rank >= 7) printf("\n   1. Well Born Officers life\n");   
  kreflt_branch(branch);
  printf("   2. The table for %s\n", office); 
  if (assignment <= 2) printf("   3. Shore duty\n");
  else printf("   3. Shipboard duty\n");
  if (rankeo == 'O') {
    if (command == 1) printf("   4. Command Officer\n");
    else printf("   4. Staff Officer\n");
  }
  choice = getsel_int(1, 4);
  if (rankeo == 'E' && choice == 4) {
    printf("Wrong - try again!\n");
    kreflt_pick_tbl();
    return;
  }
  switch (choice) {
    case 1: kreflt_life(); break;
    case 2: kreflt_branch_tbl(branch); break;
    case 3: kreflt_duty(); break;
    case 4: {
        if (command == 1) kreflt_cmd_off();
        else kreflt_staff_off();
      }
      break;
  }
}


int kreflt_asgn()
{
  int roll;

  combat = 0;
  skil = surv = promo = 0;
  roll = d12();
  if (line == 1) roll += 3;
  if (line == 2) roll++;
//  printf("adj roll = %d. ", roll);
  if (pick == 1)
	  roll = ask_adj_asgn(roll);
  else
  {
	  if (pick == 4 && (roll == 4 || roll == 6) && brownie_points > 3)
	  {
		  roll--;
		  bp_cmbt();
	  }
	  if (pick == 4 && (roll == 8 || roll == 10 || roll == 14)
		  && brownie_points > 3)
	  {
		  roll++;
		  bp_cmbt();
	  }
  }
  printf("This is a ");
  if (roll == 3 || roll >= 15)
  {
    printf("battle assignment.\n");
    cmbt++;
    combat = 1;
    switch (branch)
	{
      case 1: skil = 5; surv = 6; promo = 11; break;
      case 2: skil = 6; surv = 6; promo = 13; break;
      case 3: skil = 6; surv = 6; promo = 12; break;
      case 4: skil = 5; surv = 5; promo = 16; break;
      case 5: skil = 6; surv = 4; promo = 17; break;
      default: skil = 7; surv = 3; promo = 16; break;
    }
    promo = kreflt_promo(promo);
    surv = kreflt_surv(surv);
    return 6;
  }
  if (col > 0 && rankeo == 'E' && rank >= 4) roll++;
  if (roll == 7)
  {
    printf("training assignment.\n");
    if (branch == 2) surv = 3;
    skil = 7;
    if (branch == 3 || branch == 5) skil = 8;
    if (branch != 2) promo = 20;
    if (branch == 1 || branch == 3) promo = 18;
    return 1;
  }
  if (roll == 4 || roll == 10)
  {
    printf("shore duty assignment.\n");
    switch (branch)
	{
      case 1: skil = 7; surv = 4; promo = 18; break;
      case 2: surv = 3; promo = 18; break;
      case 3: surv = 3; promo = 17; break;
      case 4: skil = 8; promo = 19; break;
      case 5: skil = 6; promo = 19; break;
      default: skil = 8; surv = 3; promo = 19; break;
    }
    promo = kreflt_promo(promo);
    surv = kreflt_surv(surv);
    return 2;
  }
  if (roll == 5 || roll == 13) {
    printf("seige assignment.\n");
    cmbt++;
    combat = 1;
    switch (branch) {
      case 1: skil = 6; surv = 5; promo = 15; break;
      case 2: skil = 7; surv = 5; promo = 15; break;
      case 3: skil = 5; surv = 5; promo = 17; break;
      case 4: skil = 7; surv = 4; promo = 18; break;
      default: skil = 7; surv = 3; promo = 18; break;
    }
    promo = kreflt_promo(promo);
    surv = kreflt_surv(surv);
    return 4;
  }
  if (roll <= 2 || roll == 9) {
    printf("strike assignment.\n");
    cmbt++;
    combat = 1;
    switch (branch) {
      case 1: skil = 5; surv = 6; promo = 12; break;
      case 2: skil = 6; surv = 5; promo = 14; break;
      case 3: skil = 6; surv = 5; promo = 12; break;
      case 4: skil = 6; surv = 5; promo = 17; break;
      default: skil = 7; surv = 3; promo = 17; break;
    }
    promo = kreflt_promo(promo);
    surv = kreflt_surv(surv);
    return 5;
  }
  if (roll == 6 || roll == 8 || roll == 14) {
    printf("patrol assignment.\n");
    switch (branch) {
      case 1: skil = 6; surv = 4; promo = 16; break;
      case 2: skil = 7; surv = 4; promo = 16; break;
      case 3: skil = 7; surv = 4; promo = 17; break;
      case 4: skil = 6; surv = 3; promo = 18; break;
      case 5: skil = 7; surv = 3; promo = 18; break;
      default: skil = 9; surv = 3; promo = 19; break;
    }
    promo = kreflt_promo(promo);
    surv = kreflt_surv(surv);
    return 3;                
  }
  printf("special duty assignment (roll=%d).\n", roll);
  return 7;
}


int kreflt_promo(int promo)
{
  if (promo == 0) return 0;
  if (rank != 1) return promo;
  if (branch <= 3) return (promo - 6);
  return (promo - 8);
}


int kreflt_surv(int surv)
{
  if (surv == 0) return 0;
  if (branch == 2) return (surv + find_skl(ENCLOSURE));
  if (branch == 1 && kreln_mos() != 0) return (surv + 1);
  return surv;
}


int kreln_mos()
{
  int qual;
  qual = chk_skl(MECHANICAL, 2);
  if (qual == 0) qual = chk_skl(ELECTRONICS, 2);
  if (qual == 0) qual = chk_skl(GUNCMBT, 2);
  if (qual == 0) qual = chk_skl(NAVIGATION, 2);
  if (qual == 0) qual = chk_skl(COMPUTER, 2);
  if (qual == 0) qual = chk_skl(NOGRAV, 2);
  if (qual == 0) qual = chk_skl(LIAISON, 2);
  if (qual == 0) qual = chk_skl(SHIPTAC, 2);
  return qual;
}


int kreflt_cmd()
{
  int  roll;

  if (rankeo == 'E') return 0;
  roll = d12();
  if (line == 1) roll += 2;
  if (line == 2) roll -= 3;
  roll += rank;
  if (roll >= (14 + branch)) {
    return 1;
  }
  return 0;
}


void kreflt_cross_train()
{
  int  roll;

  printf("You got cross-training.\n");
  bp_add(1);
  if (pick >= 3)
  {
    roll = d6();
    if (roll == 2) roll--;
  }
  else
  {
    printf("You have the option to get cross-training in any field. Pick one.\n");
    printf("\n   1. line/crew");
    printf("\n   2. gunnery");
    printf("\n   3. engineering");
    printf("\n   4. medical");
    printf("\n   5. technical\n");
    roll = getsel_int(1, 5);
  }
  if (roll >= 2) roll++;
  kreflt_branch_tbl(roll);
  branch = roll;
}

