/* KRENOBLE.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void kregovern();
void kre_end_term();
void kregovtskills(int skills);
void kreadm();
void kreadmskills(int skills);
void kre_nbl_pd(int roll);
void kre_nbl_gs(int roll);

extern int anag();
extern int krepickarm();
extern int kremerc_get_branch();
extern int kremerc_do_initial();
extern int kremerc_doterms();
extern int kreflt_get_branch();
extern int kreflt_do_initial();
extern int kreflt_doterms();
extern void addskill(int skill, int skl_val);
extern int kre_caste_skill();
extern int d6();
extern int d12();
extern int krepicktable();
extern void krebenny();
extern void bumpsoc();
extern void bumpintl();
extern void bumpedu();

#include "chargen.h"

extern int  aide, nv_anag;

void kregovern()
{
  int  skills, term;
  
  skills = 1;
  term = terms;
  aide = 0;
  if (branch == 1) addskill(LEADER, 1);
  if (alt_career == 0) krepickarm();
  if (alt_career == 1) {
    kremerc_get_branch();
    kremerc_do_initial();
    while ((term > 1 && (d12() >= 10)) || term == terms) {
      term--;
      if (kremerc_doterms() != 0) term = 0;
      else 
        if (term > 0) nv_anag = anag();
    }
  } else {
    kreflt_get_branch();
    kreflt_do_initial();
    while ((term > 1 && (d12() >= 10)) || term == terms) {
      term--;
      if (kreflt_doterms() != 0) term = 0;
      else 
        if (term > 0) nv_anag = anag();
    }
  }
  while (term > 0) {
    printf("Government term.\n");
    skills += kre_caste_skill();
    if (skills != 0) kregovtskills(skills);
    kre_end_term();
    term--;
    skills = 0;
  }
}


void kre_end_term()
{
  int roll;
  age += 6;
  appearent_age += 6;
  if (nv_anag == 0 && appearent_age >= 50)
  {
    roll = d12();    
    if (roll > 8) str--;
    roll = d12();
    if (roll > 8) dex--;
    roll = d12();
    if (roll > 8) end--;
  }
  printf("That completes this term!\n");
}


void kregovtskills(int skills)
{
  int  roll, table;

  while (skills > 0) {
    roll = d6();
    table = krepicktable();
    if (table == 1) {
      kre_nbl_pd(roll);
    } else {
      if (table == 2) {
        kre_nbl_gs(roll);
      } else {
        switch (roll) {
          case 1: addskill(ADMIN, 1); break;
          case 2: addskill(STREETWISE, 1); break;
          case 3: addskill(BRIBERY, 1); break;
          case 4: addskill(BROKER, 1); break;
          case 5: krebenny(1); break;
          case 6: addskill(FORGERY, 1); break;
        }
      }
    }
    skills--;
  }
}


void kreadm()
{
  int  skills, term;
  
  skills = 1;
  term = terms;
  aide = 0;
  if (branch == 1) addskill(LEADER, 1);
  if (alt_career == 0) krepickarm();
  if (alt_career == 1) {
    kremerc_get_branch();
    kremerc_do_initial();
    while ((term > 1 && (d12() >= 10)) || term == terms) {
      term--;
      if (kremerc_doterms() != 0) term = 0;
      else 
        if (term > 0) nv_anag = anag();
    }
  } else {
    kreflt_get_branch();
    kreflt_do_initial();
    while ((term > 1 && (d12() >= 10)) || term == terms) {
      term--;
      if (kreflt_doterms() != 0) term = 0;
      else 
        if (term > 0) nv_anag = anag();
    }
  }
  while (term > 0) {
    printf("Administrative term.\n");
    skills += kre_caste_skill();
    if (skills != 0) kreadmskills(skills);
    kre_end_term();
    term--;
    skills = 0;
  }
}


void kreadmskills(int skills)
{
  int  roll, table;

  while (skills > 0) {
    roll = d6();
    table = krepicktable();
    if (table == 1) {
      kre_nbl_pd(roll);
    } else {
      if (table == 2) {
        kre_nbl_gs(roll);
      } else {
        switch (roll) {
          case 1: addskill(ELECTRONICS, 1); break;
          case 2: addskill(ENGINEERING, 1); break;
          case 3: addskill(COMPUTER, 1); break;
          case 4: addskill(MEDICAL, 1); break;
          case 5: krebenny(); break;
          case 6: addskill(HANDYMAN, 1); break;
        }
      }
    }
    skills--;
  }
}


void kre_nbl_pd(int roll)
{
  switch (roll) {
    case 1: addskill(ENCLOSURE, 1); break;
    case 2: addskill(TOLERANCE, 1); break;
    case 3: addskill(GAMBLING, 1); break;
    case 4: bumpintl(); break;
    case 5: bumpsoc(); break;
    case 6: bumpedu(); break;
  }
}


void kre_nbl_gs(int roll)
{
  switch (roll) {
    case 1: addskill(ADMIN, 1); break;
    case 2: addskill(STREETWISE, 1); break;
    case 3: addskill(ADMIN, 1); break;
    case 4: addskill(HANDYMAN, 1); break;
    case 5: addskill(COMPUTER, 1); break;
    case 6: addskill(TOLERANCE, 1); break;
  }
}
