/* KRESRVNT.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void krelabor();
void krelaborskills(int skills);
void kreworkr();
void kreworkerskills(int skills);
void kre_serv_pd(int roll);
void kre_serv_gs(int roll);
void krepickarm();
void kredfltwar();

extern int anag();
extern int kre_end_term();
extern int kremerc_get_branch();
extern int kremerc_do_initial();
extern int kremerc_doterms();
extern int kreflt_get_branch();
extern int kreflt_do_initial();
extern int kreflt_doterms();
extern void addskill(int skill, int skl_val);
extern int kre_caste_skill();
extern int d6();
extern int d12();
extern int krepicktable();
extern void krebenny();
extern void bumpsoc();
extern void bumpdex();
extern void bumpedu();
extern void bumpstr();
extern void bumpend();
extern void vhcl(int skl_val);
extern int getsel_int(int min, int max);

#include "chargen.h"

extern int nv_anag, aide;

void krelabor()
{
  int  skills, term;
  
  skills = 1;
  term = terms;
  addskill(STEWARD, 1);
  aide = 0;
  if (alt_career == 0) krepickarm();
  if (alt_career == 1) {
    kremerc_get_branch();
    kremerc_do_initial();
    while ((term > 1 && (d12() >= 10)) || term == terms) {
      term--;
      if (kremerc_doterms() != 0) term = 0;
      else 
        if (term > 0) nv_anag = anag();
    }
  } else {
    kreflt_get_branch();
    kreflt_do_initial();
    while ((term > 1 && (d12() >= 10)) || term == terms) {
      term--;
      if (kreflt_doterms() != 0) term = 0;
      else 
        if (term > 0) nv_anag = anag();
    }
  }
  while (term > 0) {
    printf("Laborer term.\n");
    skills += kre_caste_skill();
    if (skills != 0) krelaborskills(skills);
    kre_end_term();
    term--;
    skills = 0;
  }
}


void krelaborskills(int skills)
{
  int  roll, table;

  while (skills > 0) {
    roll = d6();
    table = krepicktable();
    if (table == 1) {
      kre_serv_pd(roll);
    } else {
      if (table == 2) {
        kre_serv_gs(roll);
      } else {
        switch (roll) {
          case 1: addskill(STEWARD, 1); break;
          case 2: addskill(STREETWISE, 1); break;
          case 3: addskill(STEWARD, 1); break;
          case 4: bumpstr(); break;
          case 5: vhcl(1); break;
          case 6: addskill(HANDYMAN, 1); break;
        }
      }
    }
    skills--;
  }
}


void kreworkr()
{
  int  skills, term;
  
  skills = 1;
  term = terms;
  addskill(HANDYMAN, 1);
  aide = 0;
  if (alt_career == 0) krepickarm();
  if (alt_career == 1) {
    kremerc_get_branch();
    kremerc_do_initial();
    while ((term > 1 && (d12() >= 10)) || term == terms) {
      term--;
      if (kremerc_doterms() != 0) term = 0;
      else 
        if (term > 0) nv_anag = anag();
    }
  } else {
    kreflt_get_branch();
    kreflt_do_initial();
    while ((term > 1 && (d12() >= 10)) || term == terms) {
      term--;
      if (kreflt_doterms() != 0) term = 0;
      else 
        if (term > 0) nv_anag = anag();
    }
  }
  while (term > 0) {
    printf("Worker term.\n");
    skills += kre_caste_skill();
    if (skills != 0) kreworkerskills(skills);
    kre_end_term();
    term--;
    skills = 0;
  }
}


void kreworkerskills(int skills)
{
  int  roll, table;

  while (skills > 0) {
    roll = d6();
    table = krepicktable();
    if (table == 1) {
      kre_serv_pd(roll);
    } else {
      if (table == 2) {
        kre_serv_gs(roll);
      } else {
        switch (roll) {
          case 1: addskill(ELECTRONICS, 1); break;
          case 2: addskill(MECHANICAL, 1); break;
          case 3: addskill(HANDYMAN, 1); break;
          case 4: bumpdex(); break;
          case 5: bumpedu(); break;
          case 6: addskill(HANDYMAN, 1); break;
        }
      }
    }
    skills--;
  }
}


void kre_serv_pd(int roll)
{
  switch (roll) {
    case 1: addskill(ENCLOSURE, 1); break;
    case 2: bumpstr(); break;
    case 3: addskill(GAMBLING, 1); break;
    case 4: bumpdex(); break;
    case 5: bumpsoc(); break;
    case 6: bumpend(); break;
  }
}


void kre_serv_gs(int roll)
{
  switch (roll) {
    case 1: addskill(STEWARD, 1); break;
    case 2: addskill(STREETWISE, 1); break;
    case 3: addskill(STEWARD, 1); break;
    case 4: addskill(HANDYMAN, 1); break;
    case 5: vhcl(1); break;
    case 6: addskill(CLOSECMBT, 1); break;
  }
}


void krepickarm()
{
  int  choice;

  if (edu < 7) {
    alt_career  = 1;
  } else {
    printf("You have the option to join the surface or space branch\n"); 
    printf("of the K'kree military.\n");
    printf("\n   1. surface\n   2. space\n");
    choice = getsel_int(1, 2);
    alt_career = choice;
  }
  kredfltwar();
}


void kredfltwar()
{
  if (line == 1) {
    if (careernbr == 1 || alt_career == 1) {
      addskill(TACTICS, 1);
    } else {
      addskill(SHIPTAC, 1);
    }
  } else {
    if (line == 2) {
      addskill(LEADER, 1);
    } else {
      addskill(POLEARM, 1);
    }
  }
}
