/* KREWLBRN.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void kretradr();
void kretraderskills(int skills);
void kretechy();
void kretechyskills(int skills);
void kre_wb_pd(int roll);
void kre_wb_gs(int roll);

extern int anag();
extern int kre_end_term();
extern int krepickarm();
extern int kremerc_get_branch();
extern int kremerc_do_initial();
extern int kremerc_doterms();
extern int kreflt_get_branch();
extern int kreflt_do_initial();
extern int kreflt_doterms();
extern void addskill(int skill, int skl_val);
extern int kre_caste_skill();
extern int d6();
extern int d12();
extern int krepicktable();
extern void krebenny();
extern void bumpsoc();
extern void bumpintl();
extern void bumpdex();
extern void bumpedu();
extern void bumpstr();
extern void bumpend();
extern void vhcl(int skl_val);
extern int getsel_int(int min, int max);

#include "chargen.h"

extern int nv_anag, aide;

void kretradr()
{
  int  skills, term;
  
  skills = 1;
  term = terms;
  if (branch == 1) addskill(ADMIN, 1);
  aide = 0;
  if (alt_career == 0) krepickarm();
  if (alt_career == 1) {
    kremerc_get_branch();
    kremerc_do_initial();
    while ((term > 1 && (d12() >= 10)) || term == terms) {
      term--;
      if (kremerc_doterms() != 0) term = 0;
      else 
        if (term > 0) nv_anag = anag();
    }
  } else {
    kreflt_get_branch();
    kreflt_do_initial();
    while ((term > 1 && (d12() >= 10)) || term == terms) {
      term--;
      if (kreflt_doterms() != 0) term = 0;
      else 
        if (term > 0) nv_anag = anag();
    }
  }
  while (term > 0) {
    printf("Trader term.\n");
    skills += kre_caste_skill();
    if (skills != 0) kretraderskills(skills);
    kre_end_term();
    term--;
    skills = 0;
  }
}


void kretraderskills(int skills)
{
  int  roll, table;

  while (skills > 0) {
    roll = d6();
    table = krepicktable();
    if (table == 1) {
      kre_wb_pd(roll);
    } else {
      if (table == 2) {
        kre_wb_gs(roll);
      } else {
        switch (roll) {
          case 1: addskill(ADMIN, 1); break;
          case 2: addskill(STREETWISE, 1); break;
          case 3: addskill(BRIBERY, 1); break;
          case 4: addskill(BROKER, 1); break;
          case 5: krebenny(1); break;
          case 6: addskill(FORGERY, 1); break;
        }
      }
    }
    skills--;
  }
}


void kretechy()
{
  int  skills, term;
  
  skills = 1;
  term = terms;
  if (branch == 1) addskill(ADMIN, 1);
  aide = 0;
  if (alt_career == 0) krepickarm();
  if (alt_career == 1) {
    kremerc_get_branch();
    kremerc_do_initial();
    while ((term > 1 && (d12() >= 10)) || term == terms) {
      term--;
      if (kremerc_doterms() != 0) term = 0;
      else 
        if (term > 0) nv_anag = anag();
    }
  } else {
    kreflt_get_branch();
    kreflt_do_initial();
    while ((term > 1 && (d12() >= 10)) || term == terms) {
      term--;
      if (kreflt_doterms() != 0) term = 0;
      else 
        if (term > 0) nv_anag = anag();
    }
  }
  while (term > 0) {
    printf("Technical term.\n");
    skills += kre_caste_skill();
    if (skills != 0) kretechyskills(skills);
    kre_end_term();
    term--;
    skills = 0;
  }
}


void kretechyskills(int skills)
{
  int  roll, table;

  while (skills > 0) {
    roll = d6();
    table = krepicktable();
    if (table == 1) {
      kre_wb_pd(roll);
    } else {
      if (table == 2) {
        kre_wb_gs(roll);
      } else {
        switch (roll) {
          case 1: addskill(ELECTRONICS, 1); break;
          case 2: addskill(ENGINEERING, 1); break;
          case 3: addskill(COMPUTER, 1); break;
          case 4: addskill(MEDICAL, 1); break;
          case 5: krebenny(); break;
          case 6: addskill(HANDYMAN, 1); break;
        }
      }
    }
    skills--;
  }
}


void kre_wb_pd(int roll)
{
  switch (roll) {
    case 1: addskill(ENCLOSURE, 1); break;
    case 2: addskill(TOLERANCE, 1); break;
    case 3: addskill(GAMBLING, 1); break;
    case 4: bumpintl(); break;
    case 5: bumpsoc(); break;
    case 6: bumpedu(); break;
  }
}


void kre_wb_gs(int roll)
{
  switch (roll) {
    case 1: addskill(ADMIN, 1); break;
    case 2: addskill(STREETWISE, 1); break;
    case 3: addskill(ADMIN, 1); break;
    case 4: addskill(HANDYMAN, 1); break;
    case 5: addskill(COMPUTER, 1); break;
    case 6: addskill(TOLERANCE, 1); break;
  }
}

