/*

 MTCHRGEN.C is a MegaTraveller (c) aid for character generation 

 It is based on the rules and tables in the MegaTraveller Players
 Handbook, articles from Challenge Magazine and other Traveller
 material.

 Traveller and MegaTraveller are registered trademarks of Far Future
 Enterprises. Portions of this material are Copyright 1977-2005
 Far Future Enterprises.

	Copyright 1994-2005 Gregory N. Svenson

	This notice and any statement of authorship must be reproduced
	on all copies.  The author does not make any warranty expressed
	or implied, or assumes any liability or responsiblity for the
	use of this software.

	Any distributor of copies of this software shall grant the
	recipient permission for further redistribution as permitted
	by this notice.	 Any distributor must distribute this software
	without any fee or other monetary gains, unless expressed written
	permission is granted by the author.

	This software or its use shall not be: sold, rented, leased,
	traded, or otherwise marketed without the expressed written
	permission of the author.

	If the software is modified in a manner creating derivative
	copyrights, appropriate legends may be placed on derivative
	work in addition to that set forth above.

	Permission is hereby granted to copy, reproduce, redistribute or
	otherwise use this software as long as the conditions above
	are met.

	All rights not granted by this notice are reserved.

*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>

/*
#ifndef UNIX
#include <process.h>
#include <conio.h>
#endif
*/

int main(int ac, char **av);
void pickrace();
void pickminor();
int get_bigint();
int getche_int();
int getsel_int(int minval, int maxval);
int getsel_bigint(int minval, int maxval);
void clrscr();
int c;

int main(int ac, char **av)
{
	if (ac <= 1)
	{
		clrscr();
		printf("Welcome to MTCG version 1.18.1, a MegaTraveller (c) character\n");
		printf("generation program written by Greg Svenson.\n\nThis is a public ");
		printf("domain program.\n\nYou are welcome to copy this and give it to your ");
		printf("friends.\nIf you have any suggestions or concerns feel free to write");
		printf(" me at:\n\n    gnsvenson@yahoo.com\n\n");
		printf("Traveller and MegaTraveller are registered trademarks of Far Future\n");
		printf("Enterprises. Portions of this material are Copyright 1977-2005\n");
		printf("Far Future Enterprises.");
		printf("\n\nPress any key to continue\n");
		/*
#ifndef UNIX
		getch();
#endif
#ifdef UNIX
*/
		while ((getchar()) != '\n') {
	    }
//#endif
		printf("\n");
	}
	pickrace();
	return 0;
}


void pickrace()
{
	int choice;

	clrscr();
	printf("You have the option to pick your characters race. These are your options:\n\n");
	printf("   1. don't care\n");
	printf("   2. Humaniti\n");
	printf("   3. Aslan\n");
	printf("   4. Vargr\n");
	printf("   5. K'kree\n");
	printf("   6. Droyne\n");
	printf("   7. Hiver\n");
	printf("   8. minor alien races");
	choice = getsel_int(1, 8);
	switch (choice)
	{
//#ifndef UNIX
//		case 1: execl("human.exe", "human", "1", NULL); break; /* Imperial */
//		case 2: execl("human.exe", "human", "0", NULL); break;
//		case 3: execl("aslan.exe", "aslan", "5", NULL); break;
//		case 4: execl("vargr.exe", "vargr", "6", NULL); break;
//		case 5: execl("kkree.exe", "kkree", "11", NULL); break;
//		case 6: execl("droyne.exe", "droyne", "8", NULL); break;
//		case 7: execl("hiver.exe", "hiver", "9", NULL); break;
//		case 8: pickminor(); break;
//#endif
//#ifdef UNIX
		case 1: execl("human", "human", "1", NULL); break; /* Imperial */
		case 2: execl("human", "human", "0", NULL); break;
		case 3: execl("aslan", "aslan", "5", NULL); break;
		case 4: execl("vargr", "vargr", "6", NULL); break;
		case 5: execl("kkree", "kkree", "11", NULL); break;
		case 6: execl("droyne", "droyne", "8", NULL); break;
		case 7: execl("hiver", "hiver", "9", NULL); break;
		case 8: pickminor(); break;
//#endif
	}
}


void pickminor()
{
	int choice;

	clrscr();
	printf("These are your minor race options:\n\n");
	printf("   1. none, return to major races\n");
	printf("   2. Dolphins\n");
	printf("   3. Tirrils\n");
	printf("   4. Newts\n");
	printf("   5. Llellewyloly\n");
	printf("   6. Githiaskio\n");
	printf("   7. Girug'kagh\n");
	printf("   8. Hhkar\n");
	printf("   9. Llamiya\n");
	printf("   10. Vegan\n");
	printf("   11. Ithklur *\n\n");
	printf("* = not working\n");
	choice = getsel_bigint(1, 11);
	switch (choice)
	{
		/*
#ifndef UNIX
		case 1: pickrace(); break;
		case 2: execl("human.exe", "human", "17", NULL); break;
		case 3: execl("vargr.exe", "vargr", "18", NULL); break;
		case 4: execl("human.exe", "human", "19", NULL); break;
		case 5: execl("human.exe", "human", "12", NULL); break;
		case 6: execl("human.exe", "human", "21", NULL); break;
		case 7: execl("kkree.exe", "kkree", "20", NULL); break;
		case 8: execl("human.exe", "human", "29", NULL); break;
		case 9: execl("human.exe", "human", "30", NULL); break;
		case 10: execl("human.exe", "human", "15", NULL); break;
		case 11: execl("hiver.exe", "hiver", "32", NULL); break;
#endif
#ifdef UNIX
*/
		case 1: pickrace(); break;
		case 2: execl("human", "human", "17", NULL); break;
		case 3: execl("vargr", "vargr", "18", NULL); break;
		case 4: execl("human", "human", "19", NULL); break;
		case 5: execl("human", "human", "12", NULL); break;
		case 6: execl("human", "human", "21", NULL); break;
		case 7: execl("kkree", "kkree", "20", NULL); break;
		case 8: execl("human", "human", "29", NULL); break;
		case 9: execl("human", "human", "30", NULL); break;
		case 10: execl("human", "human", "15", NULL); break;
		case 11: execl("hiver", "hiver", "32", NULL); break;
//#endif
	}
}


int getche_int()
{
  int ch;
  int choice;

  printf("\n->");

  while ((ch=getchar()) != '\n') {
  choice=ch;
  }
  printf("\n");
  if ((iscntrl(choice)) != 0)
  {
    if (choice == 13)
	{
      choice = '0';
    }
	else
	{
      if (choice == 27) exit(-1);
    }
  }
  if ((isdigit(choice)) != 0)
  {
    choice -= 48;
  }
  else
  {
    printf("Please enter a number - try again!");
    return getche_int();
  }
  return choice;
}


int getsel_int(int minval, int maxval)
{
  int choice;

  printf("\nPlease enter your selection.");
  choice = getche_int();
  if (choice < minval || choice > maxval)
  {
    printf("Value is outside of range - try again!");
    return getsel_int(minval, maxval);
  }
  return choice;
}


int get_bigint()
{
	unsigned i;
	char choice[8];

	printf("\n->");
	fgets(choice,7,stdin);
	if (choice[strlen(choice) - 1] == '\n')
		choice[strlen(choice) - 1] = '\0';
	if (iscntrl(choice[0]) != 0)
	{
		if (choice == '\0')
		{
			choice[0] = '0';
			choice[1] = '\0';
		}
		else
		{
			if (choice[0] == 0x1b)
				exit(-1);
		}
	}
  /* printf("entered string %s (length %d)\n", choice, strlen(choice)); */
	for (i = 0; i < strlen(choice); i++)
	{
		if ((isdigit(choice[i])) != 0)
			/* printf("digit %c", choice[i]) */;
		else
		{
			if (i == 0 && choice[i] == '-')
				/* printf("sign %c", choice[i]) */;
			else
			{
				/* printf("neither %c", choice[i]); */
				printf("Please enter a number - try again!");
				return get_bigint();
			}
		}
	}
	i = atoi(choice);
/*  printf(" entered int %d\n", i); */
	return i;
}


int getsel_bigint(int minval, int maxval)
{
	int choice;

	printf("\nPlease enter your selection.");
	choice = get_bigint();
	if (choice < minval || choice > maxval)
	{
		printf("Value is outside of range - try again!");
		return getsel_int(minval, maxval);
	}
	return choice;
}

void clrscr()
{
	int i;

	for (i=0; i < 24; i++) printf("\n");
}
