/* VARCARER.C is part of the MegaTraveller (C) character generation */
/* program. It is used to select the Vargr characters career. */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
  
void careers();
void getcareer();
void varpickcareer();
void tirpickcareer();
void vardraft();
void varrandcareer();
void vartrymilitia();
void gotmilitia();
void vartryraider();
void vartrynavy();
void gotraider();
void vartrycop();
void vartryemissary();
void gotemissary();
void vartryexplorer();
void gotexplorer();
void vartrydoc();
void gotcorsair();
void vartryscient();
void vartryadmin();
void vartryloner();
void vartryaristocrat();
void vartrybelter();
void vartryleader();
void vartrymerch();
void vartrycorsair();
void vartryrogue();
void vartryhunter();
void vartrybarbarian();
int varpicktable();
void altcareertbl();

extern int d3();
extern int d4();
extern int d6();
extern int d12();
extern char getche_y_n();
extern int getsel_int(int min, int max);
extern int getsel_bigint();
extern int bp_adj(int enlist, int roll);
extern void varmilitia();
extern void cascades();
extern void background();
extern void dfltech();
extern void dfltcareer();
extern void vararmy();
extern void varnavy();
extern void varraider();
extern void varexplorer();
extern void varloner();
extern void varleader();
extern void varcop();
extern void vardoc();
extern void varemissary();
extern void varadmin();
extern void varscient();
extern void vararistocrat();
extern void varmerch();
extern void varbelter();
extern void varcorsair();
extern void varrogue();
extern void varhunter();
extern void varbarbarian();
extern void gotnoble();
extern void gotsolsec();
extern void tryiris();
extern void trymerchant();
extern void trybelter();
extern void prntupp();
extern void gotnavy();
extern void gotbarbarian();
extern void gotcop();
extern void gotdoc();
extern void gotscient();
extern void gotrogue();
extern void gotleader();
extern void gotmerch();
extern void gothunter();
extern void gotbelter();

#include "chargen.h"
  
void careers()  
{
  cascades();
  dfltech();
  background();
  if (careernbr == 0) getcareer();
  printf("Career = %s (%d)\n", career, careernbr);
  dfltcareer();
  switch (careernbr) {
      case ARMY: varmilitia(); break;
      case NAVY: varnavy(); break;
      case RAIDER: varraider(); break;
      case SCOUT: varexplorer(); break;
      case COP: varcop(); break;
      case DOCTOR: vardoc(); break;
      case DIPLOMAT: varemissary(); break;
      case BUREAUCRAT: varadmin(); break;
      case SCIENTIST: varscient(); break;
      case NOBLE: vararistocrat(); break;
      case MERCHANT: varmerch(); break;
      case BELTER: varbelter(); break;
      case PIRATE: varcorsair(); break;
      case ROGUE: varrogue(); break;
      case HUNTER: varhunter(); break;
      case BARBARIAN: varbarbarian(); break;
      case WANDERER: varloner(); break;
      case PARTY: varleader(); break;
      default: printf("\nCareer unknown\n");
  }
}


void getcareer()
{
  int choice;

  if (race == TIRRILS) {
    tirpickcareer();
    return;
  }
  printf("Career selection can be random or you can try to pick your\n");
  printf("characters career. Do you want to try to pick your characters career?");
  choice = getche_y_n();
  if (choice == 'Y' || choice == 'y') {
    varpickcareer();
  } else {
    varrandcareer();
  }
}


void varpickcareer()
{
	int choice, max;

	prntupp();
	printf("\nWhat career do you want? Remember, if you fail\n");
	printf("your enlistment, you will be drafted.\n\n");
	printf("   1. pick one at random\n");
	max = 1;
	if (tech >= TLPRESTEL)
	{
		printf("   2. militia (roll 5, end 6+, str 10+)\n");
		printf("   3. raider (roll 9, str 8+, int 8+)\n");
		printf("   4. navy (roll 5, end 5+, dex 6+))\n");
		max = 4;
	}
	if (tech >= TLIND)
	{
		printf("   5. law enforcer (roll 7, str 8+, int 6+)\n");
		max = 5;
	}
	if (law >= LAWLO && tech >= TLIND)
	{
		printf("   6. emissary (roll 6, dex 9+, str 7+)\n");
		max = 6;
	}
	if (tech >= TLEARSTEL)
	{
	    printf("   7. explorer (roll 6, str 8+, end 10+)\n");
		printf("   8. loner (roll 7, soc 6+, edu 7+\n");
		max = 8;
	}
	if (pop >= POPMID && law >= LAWLO)
	{
		printf("   9. administrator (roll 11, str 8-, edu 8+)\n");
		max = 9;
	}
	if (tech >= TLIND)
	{
	    printf("   10. doctor (roll 9, dex 7+, int 8+)\n");
		printf("   11. leader (roll 7, end 9+, int 10+)\n");
		max = 11;
	}
	if (tech >= TLPRESTEL)
	{
		printf("   12. scientist (roll 6, edu 10+, int 9+)\n");
		max = 12;
	}
	if (tech >= TLEARSTEL)
	{
		printf("   13. merchant (roll 5, int 8+, dex 8+)\n");
		printf("   14. belter (roll 8, int 6+, dex 9+)\n");
		printf("   15. corsair (roll 6, dex 7+, end 9+)\n");
		max = 15;
	}
	if (tech >= TLIND)
	{
		printf("   16. rogue (roll 6, end 7+, soc 8-)\n");
		max = 16;
	}
	if (atmos >= ATMTHN)
	{
		printf("   17. hunter (roll 9, end 9+, dex 10+)\n");
		max = 17;
	}
	if (soc >= 10)
	{
		printf("   18. aristocrat (automatic)\n");
		max = 18;
	}
	if (tech == TLPREIND)
	{
		printf("   19. barbarian (roll 5, str 9+, end 10+)\n");
		max = 19;
	}
	choice = getsel_bigint(1, max);
	if ((choice <= 4 && tech < TLPRESTEL)
		|| (choice == 5 && tech < TLIND)
		|| (choice == 6 && (tech < TLIND || law < LAWLO)) 
		|| ((choice == 8 || choice == 7) && tech < TLEARSTEL)
		|| (choice == 9 && (pop < POPMID || law < LAWLO)) 
		|| ((choice == 10 || choice == 11) && tech < TLIND) 
		|| (choice == 12 && tech < TLPRESTEL) 
		|| ((choice == 13 || choice == 14 || choice == 15) && tech < TLEARSTEL) 
		|| (choice == 16 && tech < TLIND) 
		|| (choice == 17 && atmos < ATMTHN) 
		|| (choice == 18 && soc < 10) 
		|| (choice == 19 && tech != TLPREIND))
	{
		printf("Please enter a valid number - try again.\n");
		varpickcareer();
		return;
	}
	switch (choice)
	{
    case 1: varrandcareer(); break;
    case 2: vartrymilitia(); break;
    case 3: vartryraider(); break;
    case 4: vartrynavy(); break;
    case 5: vartrycop(); break;
    case 6: vartryemissary(); break;
    case 7: vartryexplorer(); break;
    case 8: vartryloner(); break;
    case 9: vartryadmin(); break;
    case 10: vartrydoc(); break;
    case 11: vartryleader(); break;
    case 12: vartryscient(); break;
    case 13: vartrymerch(); break;
    case 14: vartrybelter(); break;
    case 15: vartrycorsair(); break;
    case 16: vartryrogue(); break;
    case 17: vartryhunter(); break;
    case 18: vartryaristocrat(); break;
    case 19: vartrybarbarian(); break;
	}
	if (careernbr == 0)
		vardraft();
}


void tirpickcareer()
{
  int choice;

  printf("\nWhat career do you want? Remember, if you fail\n");
  printf("your enlistment, you will be drafted.\n\n");
  printf("   1. pick one at random\n");
  printf("   2. navy\n");
  printf("   3. explorer\n");
  printf("   4. merchant\n");
  printf("   5. hunter\n");
  choice = getsel_int(1, 5);
  if (choice == 1)
    choice = d4() + 1;
  switch (choice) {
    case 2: gotnavy(); break;
    case 3: gotexplorer(); break;
    case 4: gotmerch(); break;
    case 5: gothunter(); break;
  }
}


void vardraft()
{
  int  roll;

  printf("You failed your enlistment. You will be drafted!\n");
  roll = d6();
  switch (roll) {
    case 1: gotmilitia(); break;
    case 2: gotraider(); break;
    case 3: gotnavy(); break;
    case 4: gotcop(); break;
    case 5: gotemissary(); break;
    case 6: gotexplorer(); break;
  }
}


void varrandcareer()
{
  int  roll;

  roll = d3();
  if (roll == 1) {
    roll = d6();
    if ((roll == 1) && (tech >= 3)) vartrymilitia();
    else {
      if ((roll == 2) && (tech >= 3)) vartryraider();
      else {
        if ((roll == 3) && (tech >= 3)) vartrynavy();
        else {
          if ((roll == 4) && (tech >= 2)) vartrycop();
          else {
            if ((roll == 5) && (tech >= 2 && law >= 2)) vartryemissary();
            else {
              if (roll == 6 && tech >= 4) vartryexplorer();
            }
          }
        }
      }
    }
  } else {
    if (roll == 2) {
      roll = d6();
      if ((roll == 1) && (pop >= 2 && law >= 2)) vartryadmin();
      else {
        if (roll == 2 && tech >= 2) vartrydoc();
        else {
          if ((roll == 3) && tech >= 4) vartryloner();
          else {
            if (roll == 4 && tech >= 3) vartryscient();
            else {
              if (roll == 5 && tech >= 2) vartryleader();
              else {
                if (roll == 6 && soc >= 10) vartryaristocrat();
              }
            }
          }
        }
      }
    } else {
      roll = d6();
      if (roll == 1 && tech >= 4) vartrymerch();
      else {
        if (roll == 2 && tech >= 4) vartrybelter();
        else {
          if (roll == 3 && tech >= 4) vartrycorsair();
          else {
            if (roll == 4 && tech == 1) vartrybarbarian();
            else {
              if (roll == 5 && tech >= 2) vartryrogue();
              else {
                if (roll == 6 && atmos >= 2) vartryhunter();
              }
            }
          }
        }
      }
    }
  }
  if (careernbr == 0) varrandcareer();
}


void vartrymilitia()
{
  int  enlist;

  enlist = d12();
  if (str >= 10) enlist++;
  if (end >= 6) enlist += 2;
  if (enlist >= 5) gotmilitia();
}


void gotmilitia()
{
  strncpy(career,"Militia",8);
  careernbr = ARMY;
}


void vartryraider()
{
  int  enlist;

  enlist = d12();
  if (intl >= 8) enlist++;
  if (str >= 8) enlist += 2;
  if (enlist >= 9) gotraider();
}


void vartrynavy()
{
  int  enlist;

  enlist = d12();
  if (dex >= 6) enlist++;
  if (end >= 5) enlist += 2;
  if (enlist >= 5) gotnavy();
}


void gotraider()
{
  strncpy(career,"Raider",7);
  careernbr = RAIDER;
}


void vartrycop()
{
  int  enlist;

  enlist = d12();
  if (intl >= 6) enlist++;
  if (str >= 8) enlist += 2;
  if (enlist >= 7) gotcop();
}


void vartryemissary()
{
  int  enlist;

  enlist = d12();
  if (str >= 7) enlist++;
  if (dex >= 9) enlist += 2;
  if (enlist >= 6) gotemissary();
}


void gotemissary()
{
  strncpy(career,"Emissary",9);
  careernbr = DIPLOMAT;
}


void vartryexplorer()
{
  int  enlist;

  enlist = d12();
  if (end >= 10) enlist++;
  if (str >= 8) enlist += 2;
  if (enlist >= 6) gotexplorer();
}


void gotexplorer()
{
  strncpy(career,"Explorer",9);
  careernbr = SCOUT;
}


void vartrydoc()
{
  int  enlist;

  enlist = d12();
  if (intl >= 8) enlist++;
  if (dex >= 7) enlist += 2;
  if (enlist >= 9) gotdoc();
}


void gotcorsair()
{
  strncpy(career,"Corsair",8);
  careernbr = PIRATE;
}


void vartryscient()
{
  int  enlist;

  enlist = d12();
  if (intl >= 9) enlist++;
  if (edu >= 10) enlist += 2;
  if (enlist >= 6) gotscient();
}


void vartryadmin()
{
  int  enlist;

  enlist = d12();
  if (edu >= 8) enlist++;
  if (str <= 8) enlist += 2;
  if (enlist >= 11) {
    strncpy(career,"Admin",6);
    careernbr = BUREAUCRAT;
  }
}


void vartryloner()
{
  int  enlist;

  enlist = d12();
  if (edu >= 7) enlist++;
  if (soc >= 6) enlist += 2;
  if (enlist >= 7) {
    strncpy(career,"Loner",6);
    careernbr = WANDERER;
  }
}


void vartryaristocrat()
{
  strncpy(career,"Aristocrat",11);
  careernbr = NOBLE;
}


void vartrybelter()
{
  int  enlist;

  enlist = d12();
  if (dex >= 9) enlist++;
  if (intl >= 6) enlist += 2;
  if (enlist >= 8) gotbelter();
}


void vartryleader()
{
  int  enlist;

  enlist = d12();
  if (intl >= 10) enlist++;
  if (end >= 9) enlist += 2;
  if (enlist >= 7) gotleader();
}


void vartrymerch()
{
  int  enlist;

  enlist = d12();
  if (dex >= 8) enlist++;
  if (intl >= 8) enlist += 2;
  if (enlist >= 5) gotmerch();
}


void vartrycorsair()
{
  int  enlist;

  enlist = d12();
  if (end >= 9) enlist++;
  if (dex >= 7) enlist += 2;
  if (enlist >= 6) gotcorsair();
}


void vartryrogue()
{
  int  enlist;

  enlist = d12();
  if (soc <= 8) enlist++;
  if (end >= 7) enlist += 2;
  if (enlist >= 6) gotrogue();
}


void vartryhunter()
{
  int  enlist;

  enlist = d12();
  if (dex >= 10) enlist++;
  if (end >= 9) enlist += 2;
  if (enlist >= 9) gothunter();
}


void vartrybarbarian()
{
  int  enlist;

  enlist = d12();
  if (end >= 9) enlist++;
  if (str >= 10) enlist += 2;
  if (enlist >= 5) gotbarbarian();
}


int varpicktable()
{
  int choice;

  if (pick > 2) {
    if (soc < 8) {
      return (d3());
    } else {
      return (d4());
    }
  }
  printf("\nWhich table do you wish to take your new skill on?\n\n");
  printf("   1. personal development table\n   2. service skills table\n");
  printf("   3. education table\n");
  if (soc >= 8) {
    printf("   4. high charisma table\n\n");
  }
  choice = getsel_int(1, 4);
  if (soc < 8 && choice == 4) {
      printf("Please enter a valid number - try again.\n");
      return varpicktable();
  }
  return choice;
}


void altcareertbl()
{
}