/* VAREXPLR.C is a MegaTraveller (c) aid for character generation */

#include <stdio.h>

void varexplorer();
void varexplorermot(int term);
void varexplorerbene();
void varexplorerskills(int skills);
void varexplorer_tbl(int roll);

extern int basic_comm(int need_nbr, int skill, int skl_val);
extern int basic_surv(int need_nbr, int skill, int skl_val);
extern int basic_spec_duty(int roll);
extern int var_success();
extern int basic_cash();
extern int var_mot();
extern int basic_bene();
extern int d6();
extern int basic_promo(int need_nbr, int skill, int skl_val);
extern char getche_mot();
extern void addskill(int skill, int skl_val);
extern int reenlist(int need_nbr);
extern int varpicktable();
extern void bumpdex();
extern void bumpintl();
extern void bumpsoc();
extern void bumpedu();
extern void bumpend();
extern void physicl(int skl_val);
extern void mentl(int skl_val);
extern void techl(int skl_val);
extern void explore(int skl_val);
extern void vhcl(int skl_val);
extern void interp(int skl_val);
extern void econ(int skl_val);
extern void spacetech(int skl_val);
extern void inbrn(int skl_val);
extern void special(int skl_val);
extern void milmed(int skl_val);
extern void vc(int skl_val);
extern void spac(int skl_val);
extern void gc(int skl_val);
extern void mot_cash(int amt);
extern void mot_weapon();
extern void mot_ship();
extern void mot_lopsg();

#include "chargen.h"

void varexplorer()
{
  int     skills, newterm;
  
  newterm = 0;
  while (newterm != 1) {
    skills = basic_spec_duty(6);
    newterm = basic_surv(5, end, 8);
    if (newterm == 0) {
      skills += 2;
      printf("skills=%d\n", skills);
      newterm = var_success(edu, 8, soc, 6, &skills);
      printf("skills=%d\n", skills);
    }
    if (skills != 0) varexplorerskills(skills);
    printf("This ends the term.\n");
    if (newterm == 0) newterm = reenlist(6);
  }
  terms = terms - anagathics;
  varexplorermot(terms);
}


void varexplorermot(int term)
{

  int  cash, roll, amt;
  char choice;
  
  cash = 3;
  term = var_mot(term);
  while ((term > 0) && (cash > 0)) 
  {
    choice = getche_mot();
    if (choice == 'C' || choice == 'c')
	{
      cash--;
      roll = basic_cash();
      term--;
	  amt = 0;
      switch (roll)
	  {
        case 1: amt = 5000; break;
        case 2: amt = 10000; break;
        case 3: amt = 20000; break;
        case 4: amt = 30000; break;
        case 5: amt = 50000; break;
        case 6: amt = 70000; break;
        case 7: amt = 90000; break;
      }
	  mot_cash(amt);
    } 
	else
	{
        varexplorerbene();
        term--;
    }
  }
  while (term > 0)
  {
    varexplorerbene();
    term--;
  }
}


void varexplorerbene()
{
  int roll;

  roll = basic_bene();
  switch (roll)
  {
    case 1: mot_lopsg(); break;
    case 3: bumpedu(); bumpedu(); break;
    case 2: bumpintl(); bumpintl(); break;
    case 4: mot_weapon(); break;
    case 5: mot_weapon(); break;
    default: mot_ship(); break;
  }
}


void varexplorerskills(int skills)
{
  int  table, roll;

  while (skills > 0) {
    table = varpicktable();
    roll = d6();
    if (table == 1) {
      switch (roll) {
        case 1: physicl(1); break;
        case 2: bumpdex(); break;
        case 3: bumpend(); break;
        case 4: vc(1); break;
        case 5: gc(1); break;
        case 6: mentl(1); break;
      }
    }
    if (table == 2) {
      varexplorer_tbl(roll);
    }
    if (table == 3) {
      switch (roll) {
        case 1: addskill(MECHANICAL, 1); break;
        case 2: {
                if (race == TIRRILS) addskill(FLYING, 1);
                else vhcl(1);
                break;
              }
        case 3: addskill(ELECTRONICS, 1); break;
        case 4: special(1); break;
        case 5: inbrn(1); break;
        case 6: milmed(1); break;
      }
    }
    if (table == 4) {
      switch (roll) {
        case 1: explore(1); break;
        case 2: spacetech(1); break;
        case 3: spac(1); break;
        case 4: techl(1); break;
        case 5: interp(1); break;
        case 6: bumpsoc(); break;
      }
    }
    skills--;
  }
}


void varexplorer_tbl(int roll)
{
  if (roll < 1 || roll > 6) roll = d6();
      switch (roll) {
        case 1: {
                if (race == TIRRILS) addskill(FLYING, 1);
                else addskill(GRAVVHCL, 1);
                break;
              }
        case 2: addskill(VACCSUIT, 1); break;
        case 3: spac(1); break;
        case 4: addskill(MECHANICAL, 1); break;
        case 5: addskill(ELECTRONICS, 1); break;
        case 6: inbrn(1); break;
      }
}
