/* VARPRINT.C is part of the MEGATRAVELER (c) character generation
   program written by Greg Svenson. It prints out the resulting character. */

#include <stdio.h>

void printhim();
void pension();
void secondhand();
void scrounge();
void cntngncy_exprt();
void getbranch();
void getrankp();
void sailorank();
void coprank();
void bureaurank();
void noblerank();
void barbarank();
void solarmyrank();
void solmarrank();
void solmerrank();
void varcorsairrank();
void prntstuf();

extern void prntskil(int end);
extern void anykey();
extern void clrscr();
extern void prntrace();
extern void prntsex();
extern void prtsch();
extern void prtgrad();
extern void getline();
extern int chk_skl(int skill, int skl_val);
extern void loan();

#include "chargen.h"

void printhim()  
{
  if (race == TIRRILS) credits = terms * 100;
  printf("Here is a review of your characters skills.\n");
  prntskil(1);
  anykey();
  clrscr();
  printf("                         Character Description\n");        
  printf("\nName: _________________________ ");
  if (careernbr == DOCTOR) printf("D.O.");
  printf("    ");
  prntrace();
  printf(" ");
  prntsex();
  printf("\n");    
  printf(" str dex end int ");
  printf("edu "); 
  printf("cha");
  printf(" Home World: star port = %c\n", starport);
  printf("  %2d  %2d  %2d  %2d  %2d  %2d            ", 
    str, dex, end, intl, edu, soc);
  printf("      size = %s\n", size_descr);
  printf("         age: %2d                    ", age);
  printf("atmosphere = %s\n", atmos_descr);
  printf("apparent age: %2d                    ", appearent_age);
  printf("     hydro = %s\n", hydro_descr);
  printf("                                    ");
  printf("population = %s\n", pop_descr);              
  prtsch();
  printf("      law = %s\n", law_descr);
  prtgrad();
  printf("  tech lvl = %s\n", tech_descr);
  printf("Career: %s", career);
  if (line != 0) getline();
  if (medic != 0 && careernbr != DOCTOR) { 
    printf(" medic");
  }
  secondhand();
  scrounge();
  cntngncy_exprt();
  if ((rank != 0 || careernbr == MERCHANT) && careernbr != DOCTOR && careernbr != SCIENTIST) {
      printf("\n");
      getrankp();
  }
  if (terms >= 5 && race != TIRRILS) pension();
  printf("\nSkills:\n");
  prntskil(2);
  printf("\nProperty:               Credits: %ld", credits);
  prntstuf();
}


void pension()
{
  printf("     Pension: %d (roll 4+ annually to keep)", (terms * 2000));
}


void secondhand()
{
  if (chk_skl(SCROUNGE, 2) == 1
    && chk_skl(TRADER, 2) == 1
    && chk_skl(ADMIN, 2) == 1)
    printf(" second-hand merchant");
}


void scrounge()
{
  if (chk_skl(SCROUNGE, 4) == 1) printf(" scrounger");
}


void cntngncy_exprt()
{
  if (chk_skl(LEGAL, 2) == 1
    && chk_skl(TRADER, 2) == 1
    && chk_skl(BROKER, 4) == 1
    && intl >= 10 && edu >= 10
    && chk_skl(ADMIN, 2) == 1)
    printf(" contingency expert");
}


void getrankp()
{
  if (careernbr == SCIENTIST || careernbr == DOCTOR || careernbr == BELTER
    || careernbr == ROGUE || careernbr == HUNTER) {
    rank = (terms / 2) + 1;
  }
  printf("  Rank: %c%d ", rankeo, rank);
  switch (careernbr) {
    case ARMY: solarmyrank(); break;
    case NAVY: sailorank(); break;
    case RAIDER: solmarrank(); break;
    case SCOUT: break;
    case COP: coprank(); break;
    case DOCTOR: break;
    case DIPLOMAT: break;
    case BUREAUCRAT: bureaurank(); break;
    case SCIENTIST: break;
    case NOBLE: noblerank(); break;
    case MERCHANT: solmerrank();break;
    case BELTER: break;
    case PIRATE: varcorsairrank(); break;
    case ROGUE: break;
    case HUNTER: break;
    case BARBARIAN: barbarank(); break;
    case WANDERER: break;
    case PARTY: break;
    default: printf("rank?"); break;
  }
}


void sailorank()
{
  switch (rank) {
    case 0: printf("enlisted"); break; 
    case 1: printf("Ensign"); break;
    case 2: printf("Lieutenant"); break;
    case 3: printf("Lieutenant Commander"); break;
    case 4: printf("Commander"); break;
    case 5: printf("Captain"); break;
    case 6: printf("Admiral"); break;
  }
}


void coprank()
{
  switch (rank) {
    case 1: printf("Corporal"); break;
    case 2: printf("Sergeant"); break;
    case 3: printf("Lieutenant"); break;
    case 4: printf("Detective"); break;
    case 5: printf("Chief"); break;
    case 6: printf("Commissioner"); break;
  }
}


void bureaurank()
{
  switch (rank) {
    case 1: printf("Clerk"); break;
    case 2: printf("Supervisor"); break;
    case 3: printf("Assistant Manager"); break;
    case 4: printf("Manager"); break;
    case 5: printf("Executive"); break;
    case 6: printf("Director"); break;
  }
}


void noblerank()
{
  switch (rank) {
    case 1: printf("Knight"); break;
    case 2: printf("Baron"); break;
    case 3: printf("Marquis"); break;
    case 4: printf("Count"); break;
    case 5: printf("Duke"); break;
    case 6: printf("Archduke"); break;
  }
}


void barbarank()
{
  switch (rank) {
    case 1: printf("Brave"); break;
    case 2: printf("Warrior"); break;
    case 3: printf("Leader"); break;
    case 4: printf("Chieftain"); break;
    case 5: printf("Chief"); break;
    case 6: printf("Elder"); break;
  }
}


void solarmyrank()
{
  switch (rank) {
    case 0: printf("enlisted"); break;
    case 1: printf("Lieutenant"); break;
    case 2: printf("Captain"); break;
    case 3: printf("Major"); break;
    case 4: printf("Lt Colonel"); break;
    case 5: printf("Colonel"); break;
    case 6: printf("General"); break;
  }
}


void solmarrank()
{
  switch (rank) {
    case 0: printf("enlisted"); break;
    case 1: printf("Lieutenant"); break;
    case 2: printf("Captain"); break;
    case 3: {
	  if (race == VARGR) printf("Force Commander");
	  else printf("Major");
      }
      break;
    case 4: printf("Lt Colonel"); break;
    case 5: printf("Colonel"); break;
    case 6: printf("Brigadier"); break;
  }
}


void solmerrank()
{
  switch (rank) {
    case 0: printf("swabbie"); break;
    case 1: printf("4th Officer"); break;
    case 2: printf("3rd Officer"); break;
    case 3: printf("2nd Officer"); break;
    case 4: printf("1st Officer"); break;
    default: printf("Captain"); break;
  }
}


void varcorsairrank()
{
  switch (rank) {
    case 0: printf("buccaneer"); break;
    case 1: printf("Lieutenant"); break;
    case 2: printf("Force Leader"); break;
    case 3: printf("Staff Major"); break;
    case 4: printf("Group Leader"); break;
    case 5: printf("Commodore"); break;
    case 6: printf("Leader"); break;
  }
}


void prntstuf()
{
  printf("\n");
  if (ship > 0) {
    if (careernbr == SCOUT) printf("Scout");
    if (careernbr == SCIENTIST) printf("Lab Ship");
    if (careernbr == NOBLE || careernbr == PARTY) printf("Yacht");
    if (careernbr == MERCHANT) printf("Free Trader");
    if (careernbr == BELTER) printf("Seeker");
    if (careernbr == PIRATE) printf("Corsair");
    if (careernbr == HUNTER) printf("Safari Ship");
    loan();
  }
  if (kit > 0) {
    switch (careernbr)
	{
	case COP: printf("Forensic Kit"); break;
	case SCIENTIST: printf("Scientific Equipment"); break;
	case DOCTOR: printf("Medical Instruments"); break;
	case BUREAUCRAT: printf("Watch"); break;
	default: printf("Voucher"); break;
    }
    if (kitval > 0) printf(" (value %d)", kitval);
    else if (kit > 1) printf("x%d", kit);
    printf(", ");
  }
  if (weapons > 0)
  {
    printf("Weapon");
    if (weapons > 1) printf("x%d", weapons);
    printf(", ");
  }
  printf("\n");
  if (tas > 0) {
    printf("Travellers Aid Society, ");
  }
  if (hipsg > 0) {
    printf("High Passage");
    if (hipsg > 1) printf("x%d", hipsg);
    printf(", ");
  }
  if (midpsg > 0) {
    printf("Middle Passage");
    if (midpsg > 1) printf("x%d", midpsg);
    printf(", ");
  }
  if (lopsg > 0) {
    printf("Low Passage");
    if (lopsg > 1) printf("x%d", lopsg);
    printf(", ");
  }
}
